'From Squeak 2.4c of May 10, 1999 on 20 September 2000 at 5:38:16 pm'!
Morph subclass: #JuliaExplorer
	instanceVariableNames: 'offset points numPoints offsetTextMorph numPointsTextMorph '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JuliaExplorer'!

!JuliaExplorer methodsFor: 'initialization' stamp: 'ls 9/20/2000 17:36'!
initialize
	super initialize.
	offsetTextMorph := StringMorph new.
	self addMorph: offsetTextMorph.

	numPointsTextMorph := StringMorph new.
	numPointsTextMorph position: (0@15).
	self addMorph: numPointsTextMorph.
	numPointsTextMorph on: #mouseDown send: #setNumPoints to: self.

	self numPoints: 500.
	self offset: 0.0 @ 0.0.

	self extent: 500@400.! !

!JuliaExplorer methodsFor: 'offset' stamp: 'ls 9/20/2000 17:03'!
handlesMouseDown: evt
	^true! !

!JuliaExplorer methodsFor: 'offset' stamp: 'ls 9/20/2000 17:04'!
handlesMouseOver: evt
	^true! !

!JuliaExplorer methodsFor: 'offset' stamp: 'ls 9/20/2000 17:15'!
mouseDown: evt
	evt redButtonPressed ifTrue: [
		self setOffsetFromMorphicPoint: evt cursorPoint ].
! !

!JuliaExplorer methodsFor: 'offset' stamp: 'ls 9/20/2000 17:14'!
mouseMove: evt
	evt redButtonPressed ifTrue: [
		self setOffsetFromMorphicPoint: evt cursorPoint ].! !

!JuliaExplorer methodsFor: 'offset' stamp: 'ls 9/20/2000 17:28'!
numPoints: newNumPoints
	numPoints := newNumPoints.
	numPointsTextMorph contents: 'NumPoints: ', numPoints printString.
	self recalculatePoints.! !

!JuliaExplorer methodsFor: 'offset' stamp: 'ls 9/20/2000 17:28'!
offset: newOffset
	"change the offset being drawn"
	offset := newOffset.
	self recalculatePoints.
	
	self changed.

	offsetTextMorph contents: 'Offset: ', offset printString! !

!JuliaExplorer methodsFor: 'offset' stamp: 'ls 9/20/2000 17:36'!
recalculatePoints
	offset ifNil: [ ^self ].
	points := JuliaExplorer juliaPoints: numPoints withOffset: offset.
! !

!JuliaExplorer methodsFor: 'offset' stamp: 'ls 9/20/2000 17:25'!
setNumPoints
	|asciiNumPoints |
	asciiNumPoints := FillInTheBlank request: 'Number of Points to Use' initialAnswer: numPoints storeString.
	asciiNumPoints isEmpty ifTrue: [ ^self ].
	self numPoints:  (Integer readFromString: asciiNumPoints)! !

!JuliaExplorer methodsFor: 'offset' stamp: 'ls 9/20/2000 17:05'!
setOffsetFromMorphicPoint: morphicPoint
	self offset: (self convertFromMorphic: morphicPoint)! !

!JuliaExplorer methodsFor: 'drawing' stamp: 'ls 9/20/2000 17:25'!
convertFromMorphic: aPoint
	"convert a point from the morphic screen to the math world"
	| point |
	point := (aPoint - self center) / self extent * 4.
	^point x asFloat  @  point y asFloat! !

!JuliaExplorer methodsFor: 'drawing' stamp: 'ls 9/20/2000 17:01'!
convertToMorphic: aPoint
	"convert a point from the math world to the morphic screen"
	^ self center + (aPoint / 4 * self extent) rounded! !

!JuliaExplorer methodsFor: 'drawing' stamp: 'ls 9/20/2000 17:04'!
drawOn: aCanvas
	| c |
	aCanvas fillRectangle: self bounds color: Color white.

	c := aCanvas copyClipRect: self bounds.

	points do: [ :point |
		c point: (self center + (point / 4 * self extent) rounded) color: Color black ].

	c fillOval: (((self convertToMorphic: offset) extent: 0@0) insetBy: -5) color: Color cyan
! !

!JuliaExplorer methodsFor: 'stepping' stamp: 'ls 9/20/2000 17:29'!
step
	self extent: World extent! !

!JuliaExplorer methodsFor: 'stepping' stamp: 'ls 9/20/2000 17:30'!
stepTime
	^0! !


!JuliaExplorer class methodsFor: 'julia sets' stamp: 'ls 9/20/2000 17:00'!
juliaPoints: numPoints withOffset: offset
	| points random point |
	point _ offset + (1.0 @ 1.0).
	30 timesRepeat: [point _ self pointBefore: point usingOffset: offset].
	random _ Random new.
	random seed: 100.
	points _ OrderedCollection new: numPoints.
	
	numPoints timesRepeat: [points add: point.
	point _ self pointBefore: point usingOffset: offset.
	random next > 0.5 ifTrue: [point _ point negated]].


	^points! !

!JuliaExplorer class methodsFor: 'julia sets' stamp: 'ls 9/20/2000 16:50'!
pointBefore: point usingOffset: offset
	"return one of the two points that preceded point, for a Julia Set with the given offset.  The other of the two points is the negation of the returned point"
	^ (point - offset) complexSqrt! !


!Point methodsFor: 'private' stamp: 'ls 9/20/2000 16:54'!
setR: rho theta: radians
	x _ rho asFloat * radians cos.
	y _ rho asFloat * radians sin.! !

!Point methodsFor: 'complex arithmetic' stamp: 'ls 9/20/2000 16:54'!
complexSqrt
	"return a squareroot of the receiver, with the receiver treated as a complex number"
	^Point r: self r sqrt theta: self theta / 2! !


!Point class methodsFor: 'instance creation' stamp: 'ls 9/20/2000 16:55'!
r: r theta: theta
	^self new setR: r theta: theta! !


JuliaExplorer removeSelector: #mouseOver:!
JuliaExplorer removeSelector: #mouseUp:!
JuliaExplorer class removeSelector: #calculateJuliaPoints:withOffset:!
