'From Squeak3.3alpha of 24 January 2002 [latest update: #4889] on 16 June 2002 at 2:47:07 am'!
ListItemWrapper subclass: #ClassDependencyWrapper
	instanceVariableNames: 'methodRefs module '
	classVariableNames: ''
	module: #(Squeak MABrowser)!

!ClassDependencyWrapper commentStamp: '<historical>' prior: 0!
Represents the dependency of module Foo from some class Bar. It's contents is the "reason" for the dependency, e.g., any method that refers to Bar from Foo.!

Exception subclass: #CompilerException
	instanceVariableNames: ''
	classVariableNames: ''
	module: #(Squeak Technology Compiler)!
ListItemWrapper subclass: #MethodDependencyWrapper
	instanceVariableNames: 'module '
	classVariableNames: ''
	module: #(Squeak MABrowser)!
Browser subclass: #ModuleAgeBrowser
	instanceVariableNames: 'module codePane infoPane depSelected '
	classVariableNames: ''
	module: #(Squeak MABrowser)!
ListItemWrapper subclass: #ModuleAgeBrowserWrapper
	instanceVariableNames: ''
	classVariableNames: ''
	module: #(Squeak MABrowser)!

!ModuleAgeBrowserWrapper commentStamp: '<historical>' prior: 0!
The root for the module age browser to display module dependencies.!

ListItemWrapper subclass: #ModuleDependencyWrapper
	instanceVariableNames: 'unused declared classes '
	classVariableNames: ''
	module: #(Squeak MABrowser)!

!ModuleDependencyWrapper commentStamp: '<historical>' prior: 0!
Represents the dependency of module Foo from some other module Bar. It's contents is the "reason" for the dependency, e.g., the classes/methods used by Bar from Foo.!

CompilerException subclass: #UndefinedVariableReference
	instanceVariableNames: ''
	classVariableNames: ''
	module: #(Squeak Technology Compiler)!

!UndefinedVariableReference commentStamp: '<historical>' prior: 0!
UndefinedVariableReference signal: 'foo'!

!UndefinedVariableReference methodsFor: 'as yet unclassified' stamp: 'ar 6/14/2002 14:45'!
defaultAction
	^nil! !

!UndefinedVariableReference methodsFor: 'as yet unclassified' stamp: 'ar 6/14/2002 15:00'!
isResumable
	^true! !

!UndefinedVariableReference methodsFor: 'as yet unclassified' stamp: 'ar 6/14/2002 14:47'!
varName
	^self messageText! !

!Object methodsFor: 'testing' stamp: 'ar 6/14/2002 16:30'!
isModule
	^false! !

!Behavior methodsFor: 'creating method dictionary' stamp: 'ar 6/15/2002 16:54'!
removeSelector: selector module: aModule
	"Assuming that the argument, selector (a Symbol), is a message selector 
	in my method dictionary, remove it and its method."
	| prior |
	prior := self methodDict at: selector ifAbsent:[nil].
	self removeSelectorSimply: selector.
	aModule ifNotNil:[aModule changeSelector: selector inClass: self from: prior to: nil].! !


!ClassBuilder methodsFor: 'class definition' stamp: 'ar 6/13/2002 22:32'!
name: className inModule: moduleOrPath subclassOf: newSuper type: type instanceVariableNames: instVarString classVariableNames: classVarString poolDictionaries: poolString category: category unsafe: unsafe
	"Define a new class in the given module. 
	If module is nil then this is an old-style creation message with no module supplied,
	and if category is nil then it is a new-style message.
	If unsafe is true do not run any validation checks.
	This facility is provided to implement important system changes."
	| oldClass newClass instVars classVars force |
	module _ moduleOrPath 
		ifNil: [Module moduleForCategory: category forceCreate: true]
		ifNotNil:[
			(moduleOrPath isKindOf: Module)
				ifTrue: [moduleOrPath]
				ifFalse: [Module fromPath: moduleOrPath forceCreate: true]].
	instVars _ Scanner new scanFieldNames: instVarString.
	classVars _ (Scanner new scanFieldNames: classVarString) collect: [:x | x asSymbol].

	"Validate the proposed name"
	(unsafe or: [self validateClassName: className]) ifFalse:[^nil].

	oldClass _ module localValueFor: className ifAbsent:[nil].
	oldClass isBehavior 
		ifFalse:[oldClass _ nil]. "Already checked in #validateClassName:"

	unsafe ifFalse:[
		"Run validation checks so we know that we have a good chance for recompilation"
		(self validateSuperclass: newSuper forSubclass: oldClass) ifFalse:[^nil].
		(self validateInstvars: instVars from: oldClass forSuper: newSuper) ifFalse:[^nil].
		(self validateClassvars: classVars from: oldClass forSuper: newSuper) ifFalse:[^nil].
		(self validateSubclassFormat: type from: oldClass forSuper: newSuper extra: instVars size) ifFalse:[^nil]].

	"Create a template for the new class (will return oldClass when there is no change)"
	newClass _ self 
		newSubclassOf: newSuper 
		type: type 
		instanceVariables: instVars
		from: oldClass
		unsafe: unsafe.

	newClass == nil ifTrue:[^nil]. "Some error"

	newClass == oldClass ifFalse:[newClass setName: className].

	"Install the class variables and pool dictionaries... "
	force _ (newClass declare: classVarString) | (newClass sharing: poolString).

	"support old-style classification somewhat ..."
	module organization 
		classify: newClass name under: (category ifNil: [module simulatedCategory]) asSymbol.
	newClass module: module.

	"... recompile ..."
	newClass _ self recompile: force from: oldClass to: newClass mutate: false.

	[module redefineName: newClass name as: newClass export: true]
			on: AttemptToWriteReadOnlyGlobal do:[:ex| ex resume: true].
	Smalltalk flushClassNameCache.

	self doneCompiling: newClass.
	^newClass
! !


!ClassDependencyWrapper methodsFor: 'accessing' stamp: 'ar 6/14/2002 18:03'!
addMethodReference: mref
	methodRefs ifNil:[methodRefs := OrderedCollection new].
	methodRefs add: mref! !

!ClassDependencyWrapper methodsFor: 'accessing' stamp: 'ar 6/16/2002 02:07'!
contents
	methodRefs ifNil:[^#()].
	^(methodRefs asArray collect:[:ref| (MethodDependencyWrapper with: ref model: model) module: module]) sort:[:m1 :m2| m1 asString <= m2 asString]! !

!ClassDependencyWrapper methodsFor: 'accessing' stamp: 'ar 6/15/2002 15:03'!
getMenu: shifted
	| mm |
	mm := MenuMorph new defaultTarget: self.
	mm addList: #(
		('go to class' gotoClass)
	).
	^mm! !

!ClassDependencyWrapper methodsFor: 'accessing' stamp: 'ar 6/15/2002 15:03'!
gotoClass
	model setClass: item selector: nil! !

!ClassDependencyWrapper methodsFor: 'accessing' stamp: 'ar 6/14/2002 18:03'!
hasContents
	^methodRefs notNil! !

!ClassDependencyWrapper methodsFor: 'accessing' stamp: 'ar 6/16/2002 02:07'!
module
	^module! !

!ClassDependencyWrapper methodsFor: 'accessing' stamp: 'ar 6/16/2002 02:07'!
module: aModule
	module := aModule! !

!ClassDependencyWrapper methodsFor: 'accessing' stamp: 'ar 6/15/2002 15:03'!
perform: selector orSendTo: otherTarget
	^self perform: selector! !


!ClassDescription methodsFor: 'method dictionary' stamp: 'ar 6/15/2002 16:56'!
removeSelector: selector module: aModule
	| priorMethod | 
	"Remove the message whose selector is given from the method 
	dictionary of the receiver, if it is there. Answer nil otherwise."

	(self methodDict includesKey: selector) ifFalse: [^ nil].
	priorMethod _ self compiledMethodAt: selector.
	Smalltalk changes removeSelector: selector class: self
		priorMethod: priorMethod
		lastMethodInfo: {priorMethod sourcePointer.
						(self whichCategoryIncludesSelector: selector)}.
	super removeSelector: selector module: aModule.
	self organization removeElement: selector.
	self acceptsLoggingOfCompilation ifTrue:
		[Smalltalk logChange: self name , ' removeSelector: #' , selector]! !

!ClassDescription methodsFor: 'compiling' stamp: 'ar 6/13/2002 23:54'!
compile: text module: aModule classified: category notifying: requestor
	| stamp |
	stamp _ self acceptsLoggingOfCompilation ifTrue: [Utilities changeStamp] ifFalse: [nil].
	^ self compile: text module: aModule classified: category
		withStamp: stamp notifying: requestor

 ! !

!ClassDescription methodsFor: 'compiling' stamp: 'ar 6/13/2002 23:54'!
compile: text module: aModule classified: category withStamp: changeStamp notifying: requestor
	^ self compile: text module: aModule classified: category withStamp: changeStamp notifying: requestor logSource: self acceptsLoggingOfCompilation! !

!ClassDescription methodsFor: 'compiling' stamp: 'ar 6/13/2002 23:55'!
compile: text module: aModule classified: category withStamp: changeStamp notifying: requestor logSource: logSource
	| selector priorMethod method methodNode newText |
	method _ self
		compile: text asString
		module: aModule
		notifying: requestor
		trailer: #(0 0 0 0)
		ifFail: [^nil]
		elseSetSelectorAndNode: 
			[:sel :node | selector _ sel.
			priorMethod _ self methodDict at: selector ifAbsent: [nil].
			methodNode _ node].
	logSource ifTrue:
		[newText _ ((requestor == nil or: [requestor isKindOf: SyntaxError]) not
						and: [Preferences confirmFirstUseOfStyle])
			ifTrue: [text askIfAddStyle: priorMethod req: requestor]
			ifFalse: [text].
		 method putSource: newText
				fromParseNode: methodNode
				class: self category: category withStamp: changeStamp 
				inFile: 2 priorMethod: priorMethod].
	self organization classify: selector under: category.
	self theNonMetaClass noteCompilationOf: selector meta: self isMeta.
	^ selector! !

!ClassDescription methodsFor: 'compiling' stamp: 'ar 6/13/2002 23:51'!
compile: code module: aModule notifying: requestor trailer: bytes 
		ifFail: failBlock
		elseSetSelectorAndNode: selAndNodeBlock
	"Intercept this message in order to remember system changes.
	 5/15/96 sw: modified so that if the class does not wish its methods logged in the changes file, then they also won't be accumulated in the current change set.
	7/12/96 sw: use wantsChangeSetLogging to determine whether to put in change set"

	| methodNode selector newMethod priorMethodOrNil |
	methodNode _ self compilerClass new
				compile: code
				in: self
				notifying: requestor
				ifFail: failBlock.
	selector _ methodNode selector.
	selAndNodeBlock value: selector value: methodNode.
	requestor ifNotNil:
		["Note this change for recent submissions list"
		Utilities noteMethodSubmission: selector forClass: self].
	methodNode encoder requestor: requestor.  "Why was this not preserved?"
	newMethod _ methodNode generate: bytes.
	priorMethodOrNil _ (self methodDict includesKey: selector)
		ifTrue: [self compiledMethodAt: selector]
		ifFalse: [nil].
	Smalltalk changes noteNewMethod: newMethod forClass: self
		selector: selector priorMethod: priorMethodOrNil.
	self addSelector: selector withMethod: newMethod.
	aModule ifNotNil:[aModule changeSelector: selector inClass: self from: priorMethodOrNil to: newMethod].
	^ newMethod! !

!Browser class methodsFor: 'instance creation' stamp: 'ar 6/14/2002 00:36'!
openBrowser
	"Create and schedule a BrowserView with default browser label. The
	view consists of five subviews, starting with the list view of system
	categories of SystemOrganization. The initial text view part is empty."

	| br |
	br := Preferences browseToolClass new.
	self
		openBrowserView: (br openEditString: nil)
		label: br defaultBrowserTitle
! !


!CompiledMethod methodsFor: 'literals' stamp: 'ar 6/14/2002 17:27'!
variableBindingsDo: aBlock
	| lit |
	1 to: self numLiterals do:[:i|
		lit := self literalAt: i.
		lit isVariableBinding ifTrue:[aBlock value: lit].
	].! !


!DeltaClass methodsFor: 'as yet unclassified' stamp: 'ar 6/14/2002 00:16'!
changeSelector: selector withMethod: methodOrNil previousVersion: oldMethodOrNil  
	"For incremental development. Don't dump any old stuff we've assembled but only update to the current state of affairs."
	| assoc |
	assoc := self methodDict associationAt: selector ifAbsent:[nil].
	assoc ifNotNil:[^assoc value: methodOrNil].
	^self redefineSelector: selector withMethod: methodOrNil previousVersion: oldMethodOrNil! !


!Encoder methodsFor: 'encoding' stamp: 'ar 6/14/2002 16:34'!
encodeVariable: name sourceRange: range ifUnknown: action
	| varNode |
	varNode _ scopeTable at: name ifAbsent:[nil].
	varNode ifNil:[
		self lookupInPools: name 
			ifFound: [:assoc | varNode _ self global: assoc name: name]].
	varNode ifNil:[
		(UndefinedVariableReference signal: name) 
			ifNotNilDo:[:assoc|varNode := self global: assoc name: name]].
	varNode ifNil:[varNode := action value].
	range ifNotNil: [
		name first isUppercase ifTrue:
			[globalSourceRanges addLast: { name. range. false }]. ].

	(varNode isTemp and: [varNode scope < 0]) ifTrue: [
		OutOfScopeNotification signal ifFalse: [ ^self notify: 'out of scope'].
	].
	^ varNode! !


!MethodDependencyWrapper methodsFor: 'accessing' stamp: 'ar 6/16/2002 02:09'!
assignToModule
	module changeSelector: item methodSymbol inClass: item actualClass from: nil to: (item actualClass compiledMethodAt: item methodSymbol)! !

!MethodDependencyWrapper methodsFor: 'accessing' stamp: 'ar 6/16/2002 02:05'!
getMenu: shifted
	| mm |
	mm := MenuMorph new defaultTarget: self.
	mm addList: #(
		('go to method' gotoMethod)
		('assign to module' assignToModule)
	).
	^mm! !

!MethodDependencyWrapper methodsFor: 'accessing' stamp: 'ar 6/15/2002 15:02'!
gotoMethod
	model setClass: item actualClass selector: item methodSymbol.! !

!MethodDependencyWrapper methodsFor: 'accessing' stamp: 'ar 6/16/2002 02:08'!
module
	^module! !

!MethodDependencyWrapper methodsFor: 'accessing' stamp: 'ar 6/16/2002 02:08'!
module: aModule
	module := aModule! !

!MethodDependencyWrapper methodsFor: 'accessing' stamp: 'ar 6/15/2002 15:01'!
perform: selector orSendTo: otherTarget
	^self perform: selector! !


!Module methodsFor: 'accessing' stamp: 'ar 6/14/2002 20:03'!
firstEmptyParentModule
	self allClasses isEmpty ifTrue:[^self].
	^parentModule firstEmptyParentModule! !

!Module methodsFor: 'testing' stamp: 'ar 6/14/2002 20:10'!
hasParent: aModule
	self == aModule ifTrue:[^true].
	parentModule ifNotNil:[^parentModule hasParent: aModule].
	^false! !

!Module methodsFor: 'testing' stamp: 'ar 6/14/2002 16:32'!
isModule
	^true! !

!Module methodsFor: 'strong name lookup' stamp: 'ar 6/14/2002 17:16'!
allClassesAndMetaClassesDo: aBlock
	"Evaluate the argument, aBlock, for each class in this module."

	self definedNames valuesDo: [:value | 
		(value isBehavior) ifTrue: [
			aBlock value: value.
			(value isKindOf: DeltaClass)
				ifTrue:[aBlock value: value deltaForMetaclass]
				ifFalse:[aBlock value: value class].
		]]
! !

!Module methodsFor: 'strong name lookup' stamp: 'ar 6/13/2002 22:32'!
localValueFor: aString ifAbsent: aBlock
	"look up assoc for the given name. only look locally in this module"

	^self definedNames at: aString asSymbol ifAbsent: aBlock
! !

!Module methodsFor: 'code analysis' stamp: 'ar 6/14/2002 21:01'!
fullDependencies
	"Answer all the dependencies of my code from other modules. The returned dictionary contains the literals and the places they are referenced from. NOTE: Later we should include selectors here as well."
	| dependencies deltas excluded dc |
	deltas := DeltaModule allInstances select:[:d| d baseModuleRef module == self].
	dependencies := IdentityDictionary new.
	self allClassesAndMetaClassesDo:[:cls|
		excluded := IdentitySet new.
		deltas do:[:dm|
			dc := dm deltaClassFor: cls forceCreate: false.
			dc ifNotNil:[excluded addAll: dc selectors].
		].
		cls methodDict keysAndValuesDo:[:sel :cm|
			(excluded includes: sel) ifFalse:[
				cm variableBindingsDo:[:lit|
					(dependencies at: lit ifAbsentPut: [OrderedCollection new]) add:
						(MethodReference new setStandardClass: cls  methodSymbol: sel).
				].
			].
		].
	].
	^dependencies! !

!Module methodsFor: 'the basic stuff' stamp: 'ar 6/16/2002 00:34'!
importModule: aModule
	"Take the given module and make it a prerequsite of mine"
	(self == aModule or:[self hasNeighborModule: aModule]) ifFalse:[
		self externalModule: aModule alias: nil version: aModule version importNames: true
	].! !

!Module methodsFor: 'the basic stuff' stamp: 'ar 6/16/2002 01:22'!
importName: varName interactive: aBool
	"Import the given symbol."
	| definers choice import varAssoc |
	self definesName: varName usingScheme: #lenient ifTrue:[:a| varAssoc := a].
	varAssoc ifNil:[^nil].
	definers := Module root modulesDefining: varAssoc key.
	definers := definers reject:[:x| x isModule].
	definers := definers keys asArray.
	definers := definers reject:[:x| x isDeltaModule].
	definers := definers sort:[:m1 :m2| m1 asString <= m2 asString].
	definers size > 1 ifTrue:[
		aBool ifFalse:[^nil]. "Ambigous choice"
		choice := PopUpMenu withCaption: varAssoc key,
'is defined in multiple modules.
Please choose the one you wish to use'
		chooseFrom: (definers collect:[:m| m asString]).
		choice = 0 ifTrue:[^nil].
		import := definers at: choice.
	] ifFalse:[import := definers first].
	self importModule: import.
	^import localAssocFor: varAssoc key ifAbsent:[nil]! !

!Module methodsFor: 'delta support' stamp: 'ar 6/14/2002 16:43'!
changeSelector: aSelector inClass: aClass from: priorMethod to: newMethod
	| aClassModule deltaModule deltaClass |
	aClassModule := aClass module.
	aClassModule == self ifTrue:[
		"Both are in the same module.
		NOTE: This needs to check if any delta is installed for this selector 
		and update IT rather than returning - it's probably the delta we
		want to modify."
		^self].
	deltaModule := self deltaModuleForBase: aClassModule forceCreate: true asActive: true.
	deltaClass := deltaModule deltaClassFor: aClass forceCreate: true.
	deltaClass changeSelector: aSelector 
		withMethod: (newMethod ifNil:[DeltaModule valueForUndefined])
		previousVersion: (priorMethod ifNil:[DeltaModule valueForUndefined])
! !

!Module methodsFor: 'delta support' stamp: 'ar 6/14/2002 20:18'!
selectorsAtClass: aClass
	"Return all the selectors redefined for the given class"
	| aClassModule deltaModule deltaClass |
	aClassModule := aClass module.
	aClassModule == self ifTrue:[
		"Both are in the same module.
		NOTE: This needs to check if any delta is installed for this selector 
		and update IT rather than returning - it's probably the delta we
		want to modify."
		^aClass selectors].
	deltaModule := self deltaModuleForBase: aClassModule forceCreate: false asActive: true.
	deltaModule ifNil:[^#()].
	deltaClass := deltaModule deltaClassFor: aClass forceCreate: false.
	deltaClass ifNil:[^#()].
	^deltaClass selectors! !


!ModuleAgeBrowser methodsFor: 'initialize-release' stamp: 'ar 6/14/2002 16:23'!
addLowerPanesTo: window at: nominalFractions with: editString
	super addLowerPanesTo: window at: nominalFractions with: editString.
	self buildMorphicInfoPane.
	systemCategoryListIndex = 0 ifTrue:[
		infoPane show; unlock.
		codePane hide; lock.
	] ifFalse:[
		infoPane hide; lock.
		codePane show; unlock.
	].! !

!ModuleAgeBrowser methodsFor: 'initialize-release' stamp: 'ar 6/14/2002 16:23'!
buildMorphicCodePaneWith: editString
	codePane := super buildMorphicCodePaneWith: editString.
	^codePane! !

!ModuleAgeBrowser methodsFor: 'initialize-release' stamp: 'ar 6/14/2002 16:23'!
buildMorphicInfoPane
	| lbls maxW maxH frame edit description color |
	color := Color white.
	infoPane := BorderedMorph new.
	infoPane on: #mouseDown send: #yourself to: infoPane.
	infoPane layoutFrame: codePane layoutFrame.
	infoPane hResizing: #spaceFill; vResizing: #spaceFill.
	infoPane layoutPolicy: ProportionalLayout new.
	infoPane color: color; borderWidth: 0.
	codePane owner addMorph: infoPane.
	lbls := #('Project:' 'Author:' 'Location:') collect:[:s| StringMorph contents: s].
	maxW := lbls inject: 0 into:[:w :m| w max: m fullBounds width].
	maxW := maxW + 8.
	maxH := lbls inject: 0 into:[:w :m| w max: m fullBounds height].
	maxH := maxH + 8.
	lbls keysAndValuesDo:[:i :m|
		m layoutFrame: (frame := LayoutFrame new).
		frame rightFraction: 0 offset: maxW.
		frame topFraction: 0 offset: maxH * (i-1) + 4.
		frame bottomFraction: 0 offset: maxH * i.
		infoPane addMorph: m.
		edit := TextMorph new.
		edit margins: (2@2 corner: 2@2).
		edit borderStyle: ((BorderStyle inset width: 2) baseColor: color).
		edit hResizing: #spaceFill; vResizing: #spaceFill.
		edit layoutFrame: (frame := LayoutFrame new).
		frame leftFraction: 0 offset: maxW+4.
		frame topFraction: 0 offset: maxH * (i-1) + 4.
		frame rightFraction: 0.5 offset: -4.
		frame bottomFraction: 0 offset: maxH * i.
		infoPane addMorph: edit.
	].
	maxH := maxH * lbls size.
	description := TextMorph new contents:'Please describe your project here'.
	description hResizing: #spaceFill; vResizing: #spaceFill.
	description margins: (4@4 corner: 4@4).
	description autoFitOnOff. "OFF"
	description borderStyle: ((BorderStyle inset width: 2) baseColor: color).
	description layoutFrame: (frame := LayoutFrame new).
	frame leftFraction: 0 offset: maxW+4.
	frame topFraction: 0 offset: maxH + 10.
	frame rightFraction: 0.5 offset: -4.
	frame bottomFraction: 1 offset: -4.
	infoPane addMorph: description.
	infoPane addMorph: self dependencyHolder frame: (0.5@0 corner: 1@1).! !

!ModuleAgeBrowser methodsFor: 'initialize-release' stamp: 'ar 6/15/2002 14:56'!
dependencyHolder
	^(SimpleHierarchicalListMorph
		on: self
		list: #moduleDependencyWrapper
		selected: #depSelected
		changeSelected: #depSelected:
		menu: #dependencyMenu:
		keystroke: nil)
		borderWidth: 0;
		autoDeselect: true;
		retractableOrNot;
		yourself! !

!ModuleAgeBrowser methodsFor: 'initialize-release' stamp: 'ar 6/14/2002 16:24'!
highlightClassList: list with: morphList
	"NOTE: THIS IS BROKEN!!!!!! We cannot assume that just because a class name matches we actually have this class defined in our module. It's broken!!!!!!"
	| classNames |
	classNames := IdentitySet new.
	self module allClassesDo:[:cls| classNames add: cls name].
	list with: morphList do:[:className :morph|
		(classNames includes: className)
			ifTrue:[morph emphasis: 1].
	].! !

!ModuleAgeBrowser methodsFor: 'initialize-release' stamp: 'ar 6/14/2002 20:20'!
highlightMessageList: list with: morphList
	| deltas |
	deltas := self module selectorsAtClass: self selectedClassOrMetaClass.
	deltas size = 0 ifTrue:[^self]. "none belong there"
	deltas := IdentitySet withAll: deltas.
	list with: morphList do:[:sel :morph|
		(deltas includes: sel)
			ifTrue:[morph emphasis: 1].
	].! !

!ModuleAgeBrowser methodsFor: 'initialize-release' stamp: 'ar 6/14/2002 16:24'!
moduleDependencyWrapper
	^Array with: (ModuleAgeBrowserWrapper with: self module model: self)! !

!ModuleAgeBrowser methodsFor: 'accessing' stamp: 'ar 6/16/2002 01:26'!
classListMenu: aMenu shifted: shifted
	shifted ifFalse:[
		aMenu add: 'modules' subMenu: self moduleClassMenu.
	].
	^super classListMenu: aMenu shifted: shifted! !

!ModuleAgeBrowser methodsFor: 'accessing' stamp: 'ar 6/14/2002 16:24'!
defaultBrowserTitle
	^ 'Module Age Browser'! !

!ModuleAgeBrowser methodsFor: 'accessing' stamp: 'ar 6/15/2002 16:49'!
defineClass: defString notifying: aController  
	"The receiver's textual content is a request to define a new class. The
	source code is defString. If any errors occur in compilation, notify
	aController."
	| oldClass class |
	oldClass _ self selectedClassOrMetaClass.
	"ar 8/29/1999: Use oldClass superclass for defining oldClass
	since oldClass superclass knows the definerClass of oldClass."
	oldClass ifNotNil:[oldClass _ oldClass superclass].
	[class _ oldClass subclassDefinerClass
				evaluate: defString
				notifying: aController
				logged: true] on: UndefinedVariableReference do:[:ex| 
		ex resume: (self module importName: ex varName interactive: true).
	].
	(class isKindOf: Behavior) ifTrue: [
		self changed: #classList.
		self classListIndex: (self classList indexOf: 
						((class isKindOf: Metaclass)
							ifTrue: [class soleInstance name]
							ifFalse: [class name])).
		self clearUserEditFlag; editClass.
		^ true]
	ifFalse: [^ false]
! !

!ModuleAgeBrowser methodsFor: 'accessing' stamp: 'ar 6/15/2002 16:50'!
defineMessageFrom: aString notifying: aController
	"Compile the expressions in aString. Notify aController if a syntax error occurs. Install the compiled method in the selected class classified under  the currently selected message category name. Answer the selector obtained if compilation succeeds, nil otherwise."
	| selectedMessageName selector category oldMessageList |
	selectedMessageName _ self selectedMessageName.
	oldMessageList _ self messageList.
	contents _ nil.
	selector _ (Parser new parseSelector: aString).
	(self metaClassIndicated
		and: [(self selectedClassOrMetaClass includesSelector: selector) not
		and: [Metaclass isScarySelector: selector]])
		ifTrue: ["A frist-time definition overlaps the protocol of Metaclasses"
				(self confirm: ((selector , ' is used in the existing class system.
Overriding it could cause serious problems.
Is this really what you want to do?') asText makeBoldFrom: 1 to: selector size))
				ifFalse: [^nil]].
	[selector _ self selectedClassOrMetaClass
				compile: aString
				module: self module
				classified: (category _ self selectedMessageCategoryName)
				notifying: aController] on: UndefinedVariableReference do:[:ex| 
		ex resume: (self module importName: ex varName interactive: true).
	].
	selector == nil ifTrue: [^ nil].
	contents _ aString copy.
	selector ~~ selectedMessageName
		ifTrue: 
			[category = ClassOrganizer nullCategory
				ifTrue: [self changed: #classSelectionChanged.
						self changed: #classList.
						self messageCategoryListIndex: 1].
			self setClassOrganizer.  "In case organization not cached"
			(oldMessageList includes: selector)
				ifFalse: [self changed: #messageList].
			self messageListIndex: (self messageList indexOf: selector)].
	^ selector! !

!ModuleAgeBrowser methodsFor: 'accessing' stamp: 'ar 6/14/2002 16:24'!
importBinding: varAssoc
	"Import the given binding"
	| definers choice import |
	definers := Module root modulesDefining: varAssoc key.
	definers := definers reject:[:x| x isModule].
	definers := definers keys asArray.
	definers := definers sort:[:m1 :m2| m1 asString <= m2 asString].
	definers size > 1 ifTrue:[
		choice := PopUpMenu withCaption: varAssoc key,
'is defined in multiple modules.
Please choose the one you wish to use'
		chooseFrom: (definers collect:[:m| m asString]).
		choice = 0 ifTrue:[^nil].
		import := definers at: choice.
	] ifFalse:[import := definers first].

	self module importModule: import.
	^import localAssocFor: varAssoc key ifAbsent:[nil]! !

!ModuleAgeBrowser methodsFor: 'accessing' stamp: 'ar 6/16/2002 01:28'!
includeClass
	"Include the current class in my module"
	| refClass |
	refClass := self selectedClass ifNil:[^self].
	refClass module moveName: refClass name toModule: self module.! !

!ModuleAgeBrowser methodsFor: 'accessing' stamp: 'ar 6/14/2002 20:26'!
includeSelector
	| refClass refSel |
	refClass := self selectedClassOrMetaClass ifNil:[^self].
	refSel := self selectedMessageName ifNil:[^self].
	self module changeSelector: refSel inClass: refClass from: nil to: (refClass compiledMethodAt: refSel).
	self changed: #messageList. "highlight"! !

!ModuleAgeBrowser methodsFor: 'accessing' stamp: 'ar 6/14/2002 20:22'!
messageListMenu: aMenu shifted: shifted
	shifted ifFalse:[
		aMenu addList: #(
			('include in module'		includeSelector)
			-
		).
	].
	^super messageListMenu: aMenu shifted: shifted! !

!ModuleAgeBrowser methodsFor: 'accessing' stamp: 'ar 6/14/2002 16:24'!
module
	^module ifNil:[module := Module default].! !

!ModuleAgeBrowser methodsFor: 'accessing' stamp: 'ar 6/14/2002 16:24'!
module: aModule
	module := aModule! !

!ModuleAgeBrowser methodsFor: 'accessing' stamp: 'ar 6/16/2002 01:22'!
moduleClassMenu
	| menu |
	menu := MenuMorph new defaultTarget: self.
	menu addList:#(
		('switch to class module'			switchToModuleFromClass)
		('include class'					includeClass)
	).
	^menu! !

!ModuleAgeBrowser methodsFor: 'accessing' stamp: 'ar 6/14/2002 16:24'!
removeMessage
	"If a message is selected, create a Confirmer so the user can verify that 
	the currently selected message should be removed from the system. If so, 
	remove it.  If the Preference 'confirmMethodRemoves' is set to false, the 
	confirmer is bypassed."
	| messageName confirmation |

	messageListIndex = 0 ifTrue: [^ self].
	self okToChange ifFalse: [^ self].
	messageName _ self selectedMessageName.
	confirmation _ self selectedClassOrMetaClass confirmRemovalOf: messageName.
	confirmation == 3 ifTrue: [^ self].

	self selectedClassOrMetaClass removeSelector: self selectedMessageName module: self module.
	self messageListIndex: 0.
	self changed: #messageList.
	self setClassOrganizer.  "In case organization not cached"

	confirmation == 2 ifTrue:
		[Smalltalk browseAllCallsOn: messageName]
! !

!ModuleAgeBrowser methodsFor: 'accessing' stamp: 'ar 6/14/2002 19:57'!
switchToModule: aModule
	self module: aModule.
	self changed: #systemCategoryList. "highlight"
	self changed: #classList. "highlight"
	self changed: #messageCategoryList. "highlight"
	self changed: #messageList. "highlight"
	self changed: #moduleDependencyWrapper. "update"
! !

!ModuleAgeBrowser methodsFor: 'accessing' stamp: 'ar 6/15/2002 16:52'!
switchToModuleFromCategory
	| catName |
	catName := self selectedSystemCategoryName ifNil:[^self].
	self switchToModule: (systemOrganizer moduleFromCategory: catName).! !

!ModuleAgeBrowser methodsFor: 'accessing' stamp: 'ar 6/14/2002 19:46'!
switchToModuleFromClass
	| modClass |
	modClass := self selectedClass ifNil:[^self].
	self switchToModule: modClass module.! !

!ModuleAgeBrowser methodsFor: 'accessing' stamp: 'ar 6/14/2002 16:24'!
systemCategoryListIndex: anInteger
	super systemCategoryListIndex: anInteger.
	infoPane ifNil:[^self].
	systemCategoryListIndex = 0 ifTrue:[
		infoPane show; unlock.
		codePane hide; lock.
	] ifFalse:[
		infoPane hide; lock.
		codePane show; unlock.
	].! !

!ModuleAgeBrowser methodsFor: 'accessing' stamp: 'ar 6/15/2002 16:53'!
systemCategoryMenu: aMenu

	aMenu addList:#(
		('switch to module'			switchToModuleFromCategory)
		-
	).
	^super systemCategoryMenu: aMenu! !

!ModuleAgeBrowser methodsFor: 'dependencies' stamp: 'ar 6/15/2002 14:57'!
depSelected
	^depSelected! !

!ModuleAgeBrowser methodsFor: 'dependencies' stamp: 'ar 6/15/2002 14:57'!
depSelected: aWrapper
	depSelected := aWrapper.
	self changed: #depSelected.! !

!ModuleAgeBrowser methodsFor: 'dependencies' stamp: 'ar 6/15/2002 14:58'!
dependencyMenu: shifted
	^depSelected ifNotNil:[depSelected getMenu: shifted].! !


!ModuleAgeBrowser class methodsFor: 'class initialization' stamp: 'ar 6/14/2002 17:03'!
initialize
	"ModuleAgeBrowser initialize"
	Preferences 
		addPreference: #modularBrowser 
		categories: #(browsing modules) 
		default: true "heh, heh"
		balloonHelp: 'If true, a new modular browser will be used by default'! !


!ModuleAgeBrowserWrapper methodsFor: 'accessing' stamp: 'ar 6/14/2002 20:10'!
contents
	| modules deps mm smartGrouping |
	smartGrouping := true.
	modules := IdentityDictionary new.
	deps := item fullDependencies.
	deps keysAndValuesDo:[:lit :refList|
		lit value isBehavior ifTrue:[
			mm := lit value module.
			(mm hasParent: item) ifFalse:[
				smartGrouping ifTrue:[mm := mm firstEmptyParentModule].
				mm := modules at: mm 
						ifAbsentPut:[ModuleDependencyWrapper with: mm model: model].
				refList do:[:ref| mm addMethodReference: ref for: lit value].
			].
		] ifFalse:[
			"uh ... oh ... how do we find out???"
		].
	].
	item neighborModuleRefs do:[:ref| 
		mm := ref module.
		(mm hasParent: item) ifFalse:[
			smartGrouping ifTrue:[mm := mm firstEmptyParentModule].
			mm := modules at: mm ifAbsentPut:[
				(ModuleDependencyWrapper with: mm model: model) unused: true.
			].
			mm declared: true.
		].
	].
	modules removeKey: item ifAbsent:[].
	^modules values asArray sort:[:m1 :m2| m1 asString <= m2 asString]! !

!ModuleAgeBrowserWrapper methodsFor: 'accessing' stamp: 'ar 6/15/2002 14:58'!
getMenu: shifted
	^nil! !

!ModuleAgeBrowserWrapper methodsFor: 'accessing' stamp: 'ar 6/14/2002 02:14'!
hasContents
	^true! !


!ModuleDependencyWrapper methodsFor: 'accessing' stamp: 'ar 6/16/2002 02:07'!
addMethodReference: ref for: aClass
	classes ifNil:[classes := IdentityDictionary new].
	(classes at: aClass ifAbsentPut:[(ClassDependencyWrapper with: aClass model: model) module: item]) 
		addMethodReference: ref.! !

!ModuleDependencyWrapper methodsFor: 'accessing' stamp: 'ar 6/14/2002 18:07'!
contents
	^classes values asArray sort:[:m1 :m2| m1 asString <= m2 asString]! !

!ModuleDependencyWrapper methodsFor: 'accessing' stamp: 'ar 6/14/2002 18:00'!
declared
	^declared ifNil:[false]! !

!ModuleDependencyWrapper methodsFor: 'accessing' stamp: 'ar 6/14/2002 18:00'!
declared: aBool
	declared := aBool! !

!ModuleDependencyWrapper methodsFor: 'accessing' stamp: 'ar 6/14/2002 18:01'!
hasContents
	^classes notNil! !

!ModuleDependencyWrapper methodsFor: 'accessing' stamp: 'ar 6/14/2002 18:00'!
isUsed
	^self unused not! !

!ModuleDependencyWrapper methodsFor: 'accessing' stamp: 'ar 6/14/2002 18:00'!
isUsed: aBool
	^self unused: aBool not! !

!ModuleDependencyWrapper methodsFor: 'accessing' stamp: 'ar 6/14/2002 17:59'!
unused
	^unused ifNil:[false]! !

!ModuleDependencyWrapper methodsFor: 'accessing' stamp: 'ar 6/14/2002 18:00'!
unused: aBool
	unused := aBool! !


!Morph methodsFor: 'submorphs-add/remove' stamp: 'ar 6/14/2002 02:12'!
addMorph: aMorph frame: relFrame
	| frame |
	frame _ LayoutFrame new.
	frame 
		leftFraction: relFrame left; 
		rightFraction: relFrame right; 
		topFraction: relFrame top; 
		bottomFraction: relFrame bottom.
	self addMorph: aMorph fullFrame: frame.

! !


!MenuMorph methodsFor: 'construction' stamp: 'ar 6/16/2002 01:25'!
add: aString subMenu: aMenuMorph
	"Append the given submenu with the given label."

	| item |
	item _ MenuItemMorph new.
	item contents: aString;
		subMenu: aMenuMorph.
	item arguments: #(foo bar).
	self addMorphBack: item.
! !


!ParagraphEditor methodsFor: 'do-its' stamp: 'ar 6/16/2002 00:26'!
evaluateSelection
	"Treat the current selection as an expression; evaluate it and return the result"
	| result rcvr ctxt varAssoc |
	self lineSelectAndEmptyCheck: [^ ''].

	(model respondsTo: #doItReceiver) 
		ifTrue: [FakeClassPool adopt: model selectedClass.  "Include model pool vars if any"
				rcvr _ model doItReceiver.
				ctxt _ model doItContext]
		ifFalse: [rcvr _ ctxt _ nil].
	result _ [
		[rcvr class evaluatorClass new 
			evaluate: self selectionAsStream
			in: ctxt
			to: rcvr
			notifying: self
			ifFail: [FakeClassPool adopt: nil. ^ #failedDoit]
		] on: UndefinedVariableReference do:[:ex|
			Module default definesName: ex varName usingScheme: #lenient ifTrue:[:a| varAssoc := a].
			ex resume: varAssoc.
		].
	] 
		on: OutOfScopeNotification 
		do: [ :ex | ex resume: true].
	FakeClassPool adopt: nil.
	Smalltalk logChange: self selection string.
	^ result! !


!PluggableListMorph methodsFor: 'initialization' stamp: 'ar 6/14/2002 19:57'!
list: listOfStrings 
	"Set the receiver's list as specified"

	| morphList h loc index converter item aSelector |
	scroller removeAllMorphs.
	list _ listOfStrings ifNil: [Array new].
	list isEmpty ifTrue: [self setScrollDeltas.  ^ self selectedMorph: nil].
	"NOTE: we will want a quick StringMorph init message, possibly even
		combined with event install and positioning"
	font ifNil: [font _ Preferences standardListFont].
	converter _ self valueOfProperty: #itemConversionMethod.
	converter ifNil: [converter _ #asStringOrText].
	morphList _ list collect: [:each |
		item _ each.
		item _ item perform: converter.
		item isText
			ifTrue: [StringMorph contents: item font: font emphasis: (item emphasisAt: 1)]
			ifFalse: [StringMorph contents: item font: font]].
	(aSelector _ self valueOfProperty: #balloonTextSelectorForSubMorphs)
		ifNotNil:
			[morphList do: [:m | m balloonTextSelector: aSelector]].

	self highlightSelector ifNotNil:
		[model perform: self highlightSelector with: list with: morphList].

	"Lay items out vertically and install them in the scroller"
	h _ morphList first height "self listItemHeight".
	loc _ 0@0.
	morphList do: [:m | m bounds: (loc extent: 9999@h).  loc _ loc + (0@h)].
	scroller addAllMorphs: morphList.

	index _ self getCurrentSelectionIndex.
	self selectedMorph: ((index = 0 or: [index > morphList size]) ifTrue: [nil] ifFalse: [morphList at: index]).
	self setScrollDeltas.
	"scrollBar setValue: 0.0"! !


!PositionableStream methodsFor: 'fileIn/Out' stamp: 'ar 6/15/2002 16:50'!
fileInAnnouncing: announcement
	"This is special for reading expressions from text that has been formatted 
	with exclamation delimitors. The expressions are read and passed to the 
	Compiler. Answer the result of compilation.  Put up a progress report with
     the given announcement as the title."
	| val chunk |
	announcement displayProgressAt: Sensor cursorPoint from: 0 to: self size during:[:bar |
		[[self atEnd] whileFalse:[
			bar value: self position.
			self skipSeparators.
			[val _ (self peekFor: $!!) 
				ifTrue: [(Compiler evaluate: self nextChunk logged: false) scanFrom: self]
				ifFalse:[	chunk _ self nextChunk.
						self checkForPreamble: chunk.
						Compiler evaluate: chunk logged: true].
			] on: InMidstOfFileinNotification do: [ :ex | ex resume: true].
			self skipStyleChunk.
		]] on: UndefinedVariableReference do:[:ex| 
			ex resume: (Module default importName: ex varName interactive: false).
	].

		self close
	].
	"Note:  The main purpose of this banner is to flush the changes file."
	Smalltalk logChange: '----End fileIn of ' , self name , '----'.
	Smalltalk allBehaviorsDo: [ :cl | 
		cl removeSelectorSimply: #DoIt; removeSelectorSimply: #DoItIn:
	].
	^ val! !


!Preferences class methodsFor: 'hard-coded prefs' stamp: 'ar 6/14/2002 00:35'!
browseToolClass
	Preferences modularBrowser ifTrue:[^ModuleAgeBrowser].
	^ Preferences browserShowsPackagePane
		ifTrue:
			[PackagePaneBrowser]
		ifFalse:
			[Browser]! !


!Project methodsFor: 'accessing' stamp: 'ar 6/13/2002 22:50'!
module
	"this is the 'home' module of this project, which should be used as default for name lookups, e.g. in doIts in workspaces and so on"

	| path i |
	^ module ifNil: [
		path := #(Project) copyWith: self name.
		i := 0.
		[module := Module fromPath: path forceCreate: false.
		module == nil] 
			whileFalse:[path last: (path last withoutTrailingDigits, (i := i+1) printString)].
		module := Module fromPath: path forceCreate: true.
	].! !

SystemWindow removeSelector: #addMorph:frame:!
ModuleAgeBrowser initialize!

!Behavior methodsFor: 'creating method dictionary' stamp: 'ar 6/15/2002 17:02'!
removeSelector: selector 
	"Assuming that the argument, selector (a Symbol), is a message selector 
	in my method dictionary, remove it and its method."
	^self removeSelector: selector module: Module default.
! !

!ClassDescription methodsFor: 'compiling' stamp: 'ar 6/15/2002 17:02'!
compile: code notifying: requestor trailer: bytes ifFail: failBlock elseSetSelectorAndNode: selAndNodeBlock
	^self compile: code module: Module default notifying: requestor trailer: bytes ifFail: failBlock elseSetSelectorAndNode: selAndNodeBlock
! !
