'From Squeak3.3alpha of 30 January 2002 [latest update: #4889] on 9 July 2002 at 12:18:45 pm'!
FileList subclass: #ModuleFileList
	instanceVariableNames: 'model '
	classVariableNames: ''
	module: #(People Ab ModuleTool)!
Morph subclass: #ModuleRemoteLoader
	instanceVariableNames: 'model buttonPanel listPanel serverDirectory moduleSelectedIndex currentModule rootModuleDirectory '
	classVariableNames: ''
	module: #(People Ab ModuleTool)!
Model subclass: #ModuleTool
	instanceVariableNames: 'helpPanel buttonPanel initialModuleList statePanel statePanelButtonsList moduleSelectedIndex fileList serverDirectory remoteLoader '
	classVariableNames: ''
	module: #(People Ab ModuleTool)!
SimpleButtonDelayedMenuMorph subclass: #ModuleToolButton
	instanceVariableNames: 'help moduleTool '
	classVariableNames: ''
	module: #(People Ab ModuleTool)!
Model subclass: #ModuleToolPopup
	instanceVariableNames: 'listItem listIndex frame actions actionWithoutSelection target '
	classVariableNames: ''
	module: #(People Ab ModuleTool)!
TestCase subclass: #ModuleToolTest
	instanceVariableNames: ''
	classVariableNames: ''
	module: #(People Ab ModuleTool)!

!Module methodsFor: 'changing defined names' stamp: 'ab 7/6/2002 21:18'!
validateName: aString forValue: anObject 
	"Validate the name for a new binding"
	| oldAssoc |
	aString first isUppercase
		ifFalse: [self error: 'The name must be capitalized'.
			^ false].
	oldAssoc _ self
				localAssocFor: aString
				ifAbsent: [].
	oldAssoc
		ifNil: ["check if name already used in a different module"
			(Module root moduleDefining: aString)
				ifNotNilDo: [:defModule | "self notify: ('The name ' , aString asText allBold , ' is already defined in module ' , defModule pathAsMessages , '.\Proceed will create a second definition with this name in module ' , self pathAsMessages , '.') withCRs"]]
		ifNotNil: ["don't protest if e.g. the new value is a new class and the old 
			value was a class too"
			(oldAssoc value isKindOf: anObject class)
				ifFalse: [self notify: 'The name ' , aString asText allBold , ' is already used in module ' , self pathAsMessages , '!!\Proceed will store over it.' withCRs]].
	^ true!
]style[(14 7 11 8 3 37 3 9 4 7 31 4 8 30 7 5 4 8 3 4 20 7 20 8 11 50 5 6 22 7 19 11 3 4 10 11 3 7 18 32 3 9 18 69 3 4 18 3 26 90 5 8 17 8 22 4 9 11 3 7 18 29 3 4 18 31 15 4)f1b,f1cblue;b,f1b,f1cblue;b,f1,f1c138036000,f1,f1cblue;i,f1,f1cblue;i,f1,f1cmagenta;,f1,f1c188188112,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cblue;i,f1,f1c138036000,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cred;,f1,f1cmagenta;,f1,f1c188188112,f1,f1cblue;i,f1,f1c188188112,f1,f1cblue;i,f1,f1c188188112,f1,f1cmagenta;,f1,f1c188188112,f1,f1c138036000,f1,f1cblue;i,f1,f1cblue;i,f1,f1cmagenta;,f1,f1c188188112,f1,f1cblue;i,f1,f1c188188112,f1,f1cmagenta;,f1,f1c188188112,f1,f1cmagenta;! !

!Module methodsFor: 'module composition' stamp: 'ab 7/5/2002 18:38'!
importModule: aModule 
	"Take the given module and make it a prerequsite of mine"
	(self == aModule
			or: [self hasNeighborModule: aModule])
		ifFalse: [self
				externalModule: aModule
				alias: nil
				version: aModule version
				importNames: true]! !

!Module methodsFor: 'module composition' stamp: 'ab 7/7/2002 22:37'!
importName: varName interactive: aBool 
	"Import the given symbol."
	| definers choice import varAssoc |
	self
		definesName: varName
		usingScheme: #lenient
		ifTrue: [:a | varAssoc _ a].
	varAssoc
		ifNil: [^ nil].
	definers _ Module root modulesDefining: varAssoc key.
	definers _ definers
				reject: [:x | x isKindOf: Module].
	definers _ definers keys asArray.
	definers _ definers
				reject: [:x | x isDeltaModule].
	definers _ definers
				sort: [:m1 :m2 | m1 asString <= m2 asString].
	definers size > 1
		ifTrue: [aBool
				ifFalse: [^ nil].
			"Ambigous choice"
			choice _ PopUpMenu
						withCaption: varAssoc key , 'is defined in multiple modules.
Please choose the one you wish to use'
						chooseFrom: (definers
								collect: [:m | m asString]).
			choice = 0
				ifTrue: [^ nil].
			import _ definers at: choice]
		ifFalse: [import _ definers first].
	(import path = #(InterimSmalltalk )) ifTrue: [Transcript show: 'WARNING : ', varName asString, ' is refered !!';cr].
	self importModule: import.
	^ import
		localAssocFor: varAssoc key
		ifAbsent: []! !

!Module methodsFor: 'module composition' stamp: 'ab 7/6/2002 20:02'!
importNameForModule: aModule 
	(self refForNeighborModule: aModule) importNames: true! !


!ModuleFileList methodsFor: 'as yet unclassified' stamp: 'AB 1/11/2002 15:30'!
fileSelectedMenu: aMenu

	^(MenuMorph new defaultTarget: self; add: 'import' action: #import)! !

!ModuleFileList methodsFor: 'as yet unclassified' stamp: 'AB 2/4/2002 18:43'!
import
	model import: self fullName! !

!ModuleFileList methodsFor: 'initialize' stamp: 'AB 2/4/2002 18:48'!
setModel: aModel 
	model _ aModel! !


!ModuleFileList class methodsFor: 'as yet unclassified' stamp: 'AB 2/4/2002 18:48'!
createWithAppModel: aModel 
	| t |
	t _ self open.
	t model setModel: aModel.
	^ t! !


!ModuleInstaller class methodsFor: 'start operations' stamp: 'ab 6/27/2002 21:58'!
fullyInstallFromPath: pathAndVersion 
	self halt.
	^ self
		do: #fullyInstallModule
		forModuleRef: (ModuleReference onPath: pathAndVersion)!
]style[(22 14 17 4 7 19 18 15 9 14 1)f1b,f1cblue;b,f1,f1cmagenta;,f1,f1c174174098,f1,f1cmagenta;,f1,f1cblue;i,f1! !


!ModuleRemoteLoader methodsFor: 'as yet unclassified' stamp: 'AB 2/4/2002 18:40'!
buildButtonTarget: aTarget label: aLabel selector: aSelector
	^ self rowForButtons addMorph: (ModuleToolButton new setModuleTool: self;
			 target: aTarget;
			 label: aLabel;
			 actionSelector: aSelector;
			 borderColor: #raised;
			 borderWidth: 2;
			 color: Color gray)! !

!ModuleRemoteLoader methodsFor: 'as yet unclassified' stamp: 'AB 2/6/2002 14:37'!
buildButtonTarget: aTarget label: aLabel selector: aSelector menu: aMenu 
	^ self rowForButtons addMorph: (ModuleToolButton new setModuleTool: self;
			 target: aTarget;
			 menu: aMenu;
			 label: aLabel;
			 actionSelector: aSelector;
			 borderColor: #raised;
			 borderWidth: 2;
			 color: Color gray)! !

!ModuleRemoteLoader methodsFor: 'as yet unclassified' stamp: 'AB 2/6/2002 18:32'!
extent: b 
	"Method called when user try to resize the window."
	| width height |
	width _ b x.
	height _ b y.
	width _ self minimalSize x max: width.
	height _ self minimalSize y max: height.
	super extent: width @ height.
	self doHackLayout! !

!ModuleRemoteLoader methodsFor: 'as yet unclassified' stamp: 'AB 2/4/2002 18:43'!
minimalSize
	^ 300 @ 150! !

!ModuleRemoteLoader methodsFor: 'as yet unclassified' stamp: 'AB 2/4/2002 18:00'!
model: aModel
	model_aModel! !

!ModuleRemoteLoader methodsFor: 'as yet unclassified' stamp: 'AB 2/4/2002 19:33'!
setHelp: aString! !

!ModuleRemoteLoader methodsFor: 'panel - list' stamp: 'AB 2/13/2002 21:30'!
changeDirectory
	self showActivity.
	currentModule add: self entrySelected.
	serverDirectory directory: serverDirectory directory , serverDirectory pathNameDelimiter asString , self entrySelected.
	self updateListPanel.
	self showWaiting.! !

!ModuleRemoteLoader methodsFor: 'panel - list' stamp: 'AB 2/4/2002 23:31'!
entrySelected
	^listPanel getList at: moduleSelectedIndex! !

!ModuleRemoteLoader methodsFor: 'panel - list' stamp: 'AB 2/4/2002 23:45'!
entrySelectedIsDef
	^ self entrySelected first = $-
		and: [self entrySelected second = $>]! !

!ModuleRemoteLoader methodsFor: 'panel - list' stamp: 'AB 2/4/2002 23:45'!
entrySelectedIsModule
	^ self entrySelectedIsDef not! !

!ModuleRemoteLoader methodsFor: 'panel - list' stamp: 'AB 2/4/2002 23:50'!
getEntryFor: aName

	(aName endsWith: '.src') ifTrue: [^nil].
	(aName endsWith: '.def') ifTrue: [^'-> ', aName].
	"aName is a name of a module"
	^aName! !

!ModuleRemoteLoader methodsFor: 'panel - list' stamp: 'AB 2/6/2002 18:57'!
getModulesList
	| t l stream |
	t _ OrderedCollection new.
	serverDirectory isNil
		ifTrue: [^ t].
	[stream _ serverDirectory getFileList]
		on: Exception
		do: [^#()].
	[l _ stream nextLine.
	l isNil
		ifFalse: [l _ l
						select: [:c | c ~= 10 asCharacter]].
	l isNil
		ifFalse: [l size = 0
				ifFalse: [| y | 
					y _ self getEntryFor: l.
					y notNil
						ifTrue: [t add: y]]].
	l isNil] whileFalse.
	^ t asArray asSortedArray! !

!ModuleRemoteLoader methodsFor: 'panel - list' stamp: 'AB 2/4/2002 18:44'!
makeDisplayLists
	^ PluggableListMorph
		on: self
		list: #getModulesList
		selected: #modulesSelected
		changeSelected: #modulesSelected:! !

!ModuleRemoteLoader methodsFor: 'panel - list' stamp: 'AB 2/4/2002 19:30'!
modulesSelected
	^ moduleSelectedIndex! !

!ModuleRemoteLoader methodsFor: 'panel - list' stamp: 'AB 2/4/2002 23:43'!
modulesSelected: index 
	index = 0
		ifTrue: [moduleSelectedIndex _ 1]
		ifFalse: [moduleSelectedIndex _ index].
	listPanel update: #modulesSelected.
	self entrySelectedIsModule
		ifTrue: [
			self changeDirectory.
]! !

!ModuleRemoteLoader methodsFor: 'panel - list' stamp: 'AB 2/4/2002 19:30'!
nbModuleListed
	^ self getModulesList size! !

!ModuleRemoteLoader methodsFor: 'panel - list' stamp: 'AB 2/4/2002 18:44'!
updateListPanel
	listPanel update: #getModulesList! !

!ModuleRemoteLoader methodsFor: 'panel - button' stamp: 'AB 2/6/2002 15:35'!
makeControlButtons
	^ self rowForButtons
		addMorph: (self
				buildButtonTarget: self
				label: 'Prev'
				selector: #prev);
		
		addMorph: (self
				buildButtonTarget: self
				label: 'Load'
				selector: #load);
		
		addMorph: (self
				buildButtonTarget: self
				label: 'Load in Rep'
				selector: #loadInRep);
		
		addMorph: (self
				buildButtonTarget: self
				label: 'Refresh'
				selector: #refresh);
		
		addMorph: (self
				buildButtonTarget: self
				label: 'Cancel'
				selector: #cancel)! !

!ModuleRemoteLoader methodsFor: 'panel - button' stamp: 'AB 2/13/2002 21:17'!
rowForButtons
	^ AlignmentMorph newRow! !

!ModuleRemoteLoader methodsFor: 'layout' stamp: 'AB 2/4/2002 18:42'!
doHackLayout
	"This is perhaps the ugliest way for defining a GUI, I will to do better  
	next time (-:"
	| width height buttonPanelHeight listPanelHeight top left |
	left _ self left.
	top _ self top.
	width _ self width.
	height _ self height.
	buttonPanelHeight _ 30.
	listPanelHeight _ height - buttonPanelHeight.
	buttonPanel isNil
		ifTrue: [^ false].
	buttonPanel
		bounds: (left @ top extent: width @ buttonPanelHeight).
	listPanel
		bounds: (left @ (top + buttonPanelHeight) extent: width @ listPanelHeight)! !

!ModuleRemoteLoader methodsFor: 'layout' stamp: 'AB 2/13/2002 21:41'!
layout
	self
		bounds: (self position extent: self minimalSize).
	buttonPanel _ self makeControlButtons.
	listPanel _ self makeDisplayLists.
	self doHackLayout.
	self addMorph: buttonPanel;
		 addMorph: listPanel! !

!ModuleRemoteLoader methodsFor: 'layout' stamp: 'AB 2/6/2002 18:40'!
show
	super show.
	self updateListPanel.! !

!ModuleRemoteLoader methodsFor: 'layout' stamp: 'AB 2/13/2002 21:49'!
showActivity
	buttonPanel color: Color red.
	self flash.
	self flash! !

!ModuleRemoteLoader methodsFor: 'layout' stamp: 'AB 2/13/2002 21:28'!
showWaiting
	buttonPanel color: Color green.
	self flash.! !

!ModuleRemoteLoader methodsFor: 'initialize' stamp: 'AB 2/13/2002 21:43'!
initialize
	super initialize.
	self layout.
	self color: Color lightGray.
	self reset! !

!ModuleRemoteLoader methodsFor: 'initialize' stamp: 'AB 2/13/2002 21:43'!
reset
	moduleSelectedIndex _ 1.
	"Actually we are in the root module, ie : #()"
	currentModule _ OrderedCollection new! !

!ModuleRemoteLoader methodsFor: 'initialize' stamp: 'AB 2/6/2002 18:34'!
serverDirectory: aServerDirectory 
	serverDirectory _ aServerDirectory.
	rootModuleDirectory _ aServerDirectory directory! !

!ModuleRemoteLoader methodsFor: 'callback' stamp: 'AB 2/13/2002 21:46'!
cancel
	serverDirectory quit.
	self hide.
! !

!ModuleRemoteLoader methodsFor: 'callback' stamp: 'AB 2/13/2002 21:25'!
createDirectory: aModulePath 
	| d |
	self showActivity.
	d _ FileDirectory default pathName , FileDirectory pathNameDelimiter asString , 'RepositoryCache'.
	aModulePath
		do: [:p | 
			| tmp | 
			tmp _ FileDirectory on: d.
			(tmp directoryExists: p asString)
				ifFalse: [tmp createDirectory: p asString].
			d _ d , FileDirectory pathNameDelimiter asString , p asString].
	self showWaiting.! !

!ModuleRemoteLoader methodsFor: 'callback' stamp: 'AB 2/5/2002 19:32'!
getDefinitionFileName
	| s |
	s _ self entrySelected.
	^ s copyFrom: 4 to: s size! !

!ModuleRemoteLoader methodsFor: 'callback' stamp: 'AB 2/5/2002 19:38'!
getSourceFileName
	| s |
	s _ self entrySelected.
	^ (s copyFrom: 4 to: s size - 4) , '.src'!
]style[(17 3 2 4 1 3 4 20 1 11 1 5 1 8 2 3 6)f1b,f1,f1cblue;i,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c170170085,f1,f1cblue;i,f1,f1c170170085,f1,f1c170170085! !

!ModuleRemoteLoader methodsFor: 'callback' stamp: 'AB 2/18/2002 17:58'!
load
	self loadInRep.
	ModuleInstaller fullyInstallFromPath: currentModule asArray.
	model updateView! !

!ModuleRemoteLoader methodsFor: 'callback' stamp: 'AB 2/13/2002 21:25'!
loadInRep
	| stream d stream2 |
	self showActivity.
	self createDirectory: currentModule.
	d _ FileDirectory default pathName , FileDirectory pathNameDelimiter asString , 'RepositoryCache'.
	currentModule
		do: [:p | d _ d , FileDirectory pathNameDelimiter asString , p asString].
	stream _ serverDirectory getFileNamed: self getDefinitionFileName.
	stream isNil
		ifTrue: [serverDirectory inspect.
			Transcript show: 'ERROR';
				 cr.
			^ false].
	stream2 _ FileStream fileNamed: d , FileDirectory pathNameDelimiter asString , self getDefinitionFileName.
	[| t | 
	t _ stream next.
	t notNil
		ifTrue: [stream2 nextPut: t].
	t notNil] whileTrue.
	stream2 close.
	stream close.
	"The code is really ugly, to modify it later..."
	stream _ serverDirectory getFileNamed: self getSourceFileName.
	stream2 _ FileStream fileNamed: d , FileDirectory pathNameDelimiter asString , self getSourceFileName.
	[| t | 
	t _ stream next.
	t notNil
		ifTrue: [stream2 nextPut: t].
	t notNil] whileTrue.
	stream2 close.
	stream close.
	self showWaiting! !

!ModuleRemoteLoader methodsFor: 'callback' stamp: 'AB 2/13/2002 21:37'!
prev
	| d |
	currentModule isEmpty
		ifTrue: [^ false].
	self showActivity.
	currentModule removeLast.
	d _ rootModuleDirectory.
	currentModule
		do: [:p | d _ d , serverDirectory pathNameDelimiter asString , p asString].
	serverDirectory directory: d.
	self updateListPanel.
	self showWaiting! !

!ModuleRemoteLoader methodsFor: 'callback' stamp: 'AB 2/13/2002 21:26'!
refresh
	self showActivity.
	self updateListPanel.
	self showWaiting.! !


!ModuleRemoteLoader class methodsFor: 'as yet unclassified' stamp: 'AB 2/6/2002 18:35'!
createWithAppModel: aModel serverDirectory: aServerDirectory 
	| t |
	t _ self new.
	t model: aModel.
	t serverDirectory: aServerDirectory.
	^ t! !


!ModuleTool methodsFor: 'as yet unclassified' stamp: 'ab 6/28/2002 17:55'!
addToInitialModuleList: aModulePath 
	initialModuleList add: aModulePath.
	self updateListPanel! !

!ModuleTool methodsFor: 'as yet unclassified' stamp: 'AB 1/11/2002 15:50'!
askAModuleName

	^FillInTheBlankMorph request: 'Enter a module''s name (ie : mod submod1 ... submodn)'.! !

!ModuleTool methodsFor: 'as yet unclassified' stamp: 'AB 1/14/2002 12:01'!
buildButtonStateTarget: aTarget label: aLabel selector: aSelector help: aString 
	^ self rowForButtons addMorph: (SimpleButtonMorph new target: aTarget;
			 label: aLabel;
			 actionSelector: aSelector;
			 borderColor: #raised;
			 borderWidth: 2;
			 color: Color veryLightGray)!
]style[(24 7 8 6 11 9 7 7 5 4 26 17 13 7 13 6 22 9 19 7 19 1 13 5 15)f1b,f1cblue;b,f1b,f1cblue;b,f1b,f1cblue;b,f1b,f1cblue;b,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cblue;i,f1,f1cblue;i,f1,f1c170170085,f1,f1c170170085,f1,f1cmagenta;,f1! !

!ModuleTool methodsFor: 'as yet unclassified' stamp: 'AB 1/16/2002 16:21'!
buildButtonTarget: aTarget label: aLabel selector: aSelector help: aString 
	^ self rowForButtons addMorph: (ModuleToolButton new
			setModuleTool: self;
			target: aTarget;
			 label: aLabel;
			 actionSelector: aSelector;
			 borderColor: #raised;
			 borderWidth: 2;
			help: aString;
			 color: Color gray)!
]style[(19 7 8 6 11 9 7 7 5 4 82 7 13 6 22 9 19 7 19 1 31 5 6)f1b,f1cblue;b,f1b,f1cblue;b,f1b,f1cblue;b,f1b,f1cblue;b,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cblue;i,f1,f1cblue;i,f1,f1c170170085,f1,f1c170170085,f1,f1cmagenta;,f1! !

!ModuleTool methodsFor: 'as yet unclassified' stamp: 'AB 2/6/2002 15:17'!
buildButtonTarget: aTarget label: aLabel selector: aSelector help: aString menu: aMenu 
	^ self rowForButtons addMorph: (ModuleToolButton new setModuleTool: self;
			 target: aTarget;
			 label: aLabel;
			 actionSelector: aSelector;
			 borderColor: #raised;
			 borderWidth: 2;
			 help: aString;
			 color: Color gray)!
]style[(19 7 8 6 11 9 7 7 7 5 5 4 26 16 20 4 14 7 13 6 22 9 19 7 19 1 12 7 13 5 6)f1b,f1cblue;b,f1b,f1cblue;b,f1b,f1cblue;b,f1b,f1cblue;b,f1b,f1cblue;b,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cblue;i,f1,f1cblue;i,f1,f1c170170085,f1,f1c170170085,f1,f1cblue;i,f1,f1cmagenta;,f1! !

!ModuleTool methodsFor: 'as yet unclassified' stamp: 'AB 2/4/2002 18:09'!
extent: b 
	"Method called when user try to resize the window."
	| width height |
	width _ b x.
	height _ b y.
	width _ self minimalSize x max: width.
	height _ self minimalSize y max: height.
	super extent: width @ height.
	self doHackLayout! !

!ModuleTool methodsFor: 'as yet unclassified' stamp: 'ab 6/28/2002 17:56'!
getModuleFromListIndex
	^ Module
		fromPath: (self
				transformeStringToPath: (self getModulesList at: moduleSelectedIndex))!
]style[(22 4 6 14 4 35 14 5 19 2)f1b,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1b,f1,f1cmagenta;,f1! !

!ModuleTool methodsFor: 'as yet unclassified' stamp: 'AB 2/1/2002 23:41'!
nbModuleListed
	^ self getModulesList size.! !

!ModuleTool methodsFor: 'as yet unclassified' stamp: 'ab 7/7/2002 22:34'!
openAsMorph
	| topWindow model moduleList buttons |
	model _ self.
	topWindow _ (SystemWindow labelled: self windowLabel)
				model: model.
	moduleList _ PluggableListMorph
				on: model
				list: #getModulesList
				selected: #modulesSelected
				changeSelected: #modulesSelected:
				menu: #defineMenuList:.
	moduleList autoDeselect: false.
	moduleList addDependent: model.
	topWindow
		addMorph: moduleList
		frame: (0.0 @ 0.2 extent: 1.0 @ 0.6).
	buttons _ self defineButtonsActionOn: model.
	buttons
		inject: 0.0
		into: [:offset :button | 
			| t | 
			t _ 1 / buttons size.
			topWindow
				addMorph: button
				frame: (offset @ 0.0 extent: t @ 0.2).
			offset + t].
	statePanelButtonsList _ self defineButtonsStateOn: model.
	statePanelButtonsList
		inject: 0.0
		into: [:offset :button | 
			| t | 
			t _ 1 / statePanelButtonsList size.
			topWindow
				addMorph: button
				frame: (offset @ 0.8 extent: t @ 0.2).
			offset + t].
	topWindow openInWorldExtent: self minimalSize.
	self changed: #getModulesList.
	^ topWindow! !

!ModuleTool methodsFor: 'as yet unclassified' stamp: 'AB 1/16/2002 17:22'!
panelForHelp
	^ BorderedMorph new! !

!ModuleTool methodsFor: 'as yet unclassified' stamp: 'AB 1/16/2002 17:34'!
rowForButtons
	^ AlignmentMorph newRow!
]style[(13 4 14 7)f1b,f1,f1cmagenta;,f1! !

!ModuleTool methodsFor: 'as yet unclassified' stamp: 'AB 2/13/2002 21:32'!
serverDirectory
	serverDirectory isNil
		ifTrue: [self changeServerToSqF].
	^ serverDirectory! !

!ModuleTool methodsFor: 'as yet unclassified' stamp: 'ab 6/27/2002 22:10'!
windowLabel
	^'ModuleTool'! !

!ModuleTool methodsFor: 'callbacks -- menu' stamp: 'AB 2/19/2002 11:05'!
changeServerToCustom
	| ftpServer user pass homeDir |
	serverDirectory _ ServerDirectory new.
	ftpServer _ FillInTheBlankMorph request: 'Enter ftp server name'.
	ftpServer isNil
		ifTrue: [^ nil].
	user _ FillInTheBlankMorph request: 'Enter user name'.
	user isNil
		ifTrue: [^ nil].
	pass _ FillInTheBlankMorph requestPassword: 'Enter password'.
	pass isNil
		ifTrue: [^ nil].
	homeDir _ FillInTheBlankMorph request: 'Home RepositoryCache Directory'.
	serverDirectory server: ftpServer;
		 user: user;
		 type: #ftp;
		 password: pass.
	homeDir notNil
		ifTrue: [serverDirectory directory: homeDir]! !

!ModuleTool methodsFor: 'callbacks -- menu' stamp: 'AB 2/13/2002 21:12'!
changeServerToSqF
	serverDirectory _ ServerDirectory new.
	serverDirectory server: 'modules.squeakfoundation.org';
		 user: 'anonymous';
		 password: 'anonymous@anonymous.com';
		 directory: '/';
		 type: #ftp! !

!ModuleTool methodsFor: 'callbacks' stamp: 'ab 6/28/2002 17:51'!
addAModule
	| ans arr |
	ans _ self askAModuleName.
	arr _ self transformeStringToPath: ans.
	arr notEmpty
		ifTrue: [(Module fromPath: arr) notNil
				ifTrue: [self addToInitialModuleList: arr]
				ifFalse: [self setHelp: 'Module not found !!']].
	"self updateView"!
]style[(10 3 8 4 3 3 4 18 3 3 4 25 3 3 3 22 6 11 3 22 4 25 3 16 4 10 20 6 4 12)f1b,f1,f1cblue;i,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cmagenta;,f1,f1c176176100,f1,f1cmagenta;,f1! !

!ModuleTool methodsFor: 'callbacks' stamp: 'ab 6/28/2002 12:38'!
createMenuForServer
	^ MenuMorph new defaultTarget: self;
		 title: 'Choose a server';
		 add: 'Custom Definition' action: #changeServerToCustom;
		 add: 'Module SqF' action: #changeServerToSqF! !

!ModuleTool methodsFor: 'callbacks' stamp: 'AB 1/16/2002 17:26'!
doNothing
! !

!ModuleTool methodsFor: 'callbacks' stamp: 'AB 1/11/2002 15:44'!
import
	"Called by the 'Import' Button"

	fileList_(ModuleFileList createWithAppModel: self).
	fileList openInWorld.! !

!ModuleTool methodsFor: 'callbacks' stamp: 'AB 2/1/2002 23:34'!
import: aFileName 
	"Called by ModuleFileList"
	| t |
	fileList delete.
	t _ self askAModuleName.
	t _ self transformeStringToPath: t.
	Repository importChangesFromFileNamed: aFileName intoModuleAt: t.
	initialModuleList add: t.
	self updateListPanel! !

!ModuleTool methodsFor: 'callbacks' stamp: 'ab 7/7/2002 22:33'!
inspectMethodFor: aString 
	"aString follow the pattern 'Class in AClass>>aSelector'"
	| s class selector |
	s _ aString substrings at: 3.
	class _ s copyFrom: 1 to: (s indexOf: $>)
					- 1.
	selector _ s copyAfterLast: $>.
	Browser
		newOnClass: (self getModuleFromListIndex at: class asSymbol) "(Smalltalk at: class asSymbol)"
		selector: selector asSymbol! !

!ModuleTool methodsFor: 'callbacks' stamp: 'ab 6/28/2002 17:53'!
inspectModule
	self getModuleFromListIndex inspect! !

!ModuleTool methodsFor: 'callbacks' stamp: 'AB 1/16/2002 14:35'!
load
	| ans arr |
	ans _ self askAModuleName.
	arr _ self transformeStringToPath: ans.
	arr notEmpty
		ifTrue: [ModuleInstaller fullyInstallFromPath: arr.
			moduleSelectedIndex_0.
			self addToInitialModuleList: arr].
	self updateView!
]style[(4 3 8 4 3 3 4 18 3 3 4 25 3 3 3 21 15 23 3 31 4 25 3 4 4 11)f1b,f1,f1cblue;i,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cmagenta;,f1! !

!ModuleTool methodsFor: 'callbacks' stamp: 'AB 1/11/2002 12:59'!
modulesSelected

	^moduleSelectedIndex
! !

!ModuleTool methodsFor: 'callbacks' stamp: 'ab 6/28/2002 18:51'!
modulesSelected: index 
	index = 0
		ifTrue: [moduleSelectedIndex _ 1]
		ifFalse: [moduleSelectedIndex _ index].
	self changed: #modulesSelected.
	self updateStatePanel! !

!ModuleTool methodsFor: 'callbacks' stamp: 'AB 1/14/2002 12:03'!
notYetImplemented
	self notify: 'Function not implement yet'!
]style[(17 2 4 9 28)f1b,f1,f1cmagenta;,f1,f1c170170085! !

!ModuleTool methodsFor: 'callbacks' stamp: 'AB 2/6/2002 19:08'!
publish
	| module repository oldDirectory|
	module _ self getModuleFromListIndex.
	repository _ module repository.
	oldDirectory_repository directory.
	repository directory: self serverDirectory.
	self class createDirectoryOnServerForModule: module serverDirectory: serverDirectory.
	repository ensureUpload.
	repository directory: oldDirectory.! !

!ModuleTool methodsFor: 'callbacks' stamp: 'AB 2/13/2002 21:44'!
server
	remoteLoader isNil
		ifTrue: [self serverDirectory openFTP.
			remoteLoader _ ModuleRemoteLoader createWithAppModel: self serverDirectory: self serverDirectory clone.
			remoteLoader position: self position x @ (self position y + self bounds height + 5)].
	remoteLoader serverDirectory: self serverDirectory clone.
	remoteLoader show.
	remoteLoader reset.
	remoteLoader openInWorld! !

!ModuleTool methodsFor: 'callbacks' stamp: 'AB 1/14/2002 21:51'!
setModuleAlone
	"Callback from 'Alone' state button."
	| mod |
	mod _ self getModuleFromListIndex.
	mod repository standaloneOn: mod.
	self updateView.!
]style[(14 2 37 3 4 4 3 3 4 26 3 26 22)f1b,f1,f1c096000000,f1,f1cblue;i,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cblue;i! !

!ModuleTool methodsFor: 'callbacks' stamp: 'ab 6/28/2002 12:38'!
showMenuFor: aSelector event: evt 
	"Called from button on RemoteLoader"
	| menu |
	menu _ self createMenuForServer.
	menu position: World currentHand position.
	menu openInWorld.
	^ true! !

!ModuleTool methodsFor: 'callbacks' stamp: 'AB 3/19/2002 21:48'!
store
        |module unresolvedRefs |
        module_self getModuleFromListIndex.
        unresolvedRefs_module deepUnresolvedRefs value inject: #() into: [:all 
:refs | all, refs].
        (unresolvedRefs size = 0)
                ifTrue: [ModuleInstaller upload: module.]
                ifFalse: [self notify: 'There is some unresolved references, so
, you have to set up external dependencies, anyway, I can do it for you.'. module deepDeclareExternalRefs. ModuleInstaller upload: module.]
! !

!ModuleTool methodsFor: 'callbacks' stamp: 'AB 2/5/2002 19:41'!
unload
	| p |
	p _ self getModuleFromListIndex path.
	ModuleInstaller unload: self getModuleFromListIndex.
	(initialModuleList includes: p)
		ifTrue: [initialModuleList remove: p.].
	self updateView!
]style[(6 3 2 4 1 3 4 31 15 9 4 27 30 12 17 9 1 5 4 11)f1b,f1,f1cblue;i,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cmagenta;,f1! !

!ModuleTool methodsFor: 'initialization' stamp: 'AB 1/11/2002 11:24'!
initInitialModuleList

	initialModuleList_OrderedCollection new.! !

!ModuleTool methodsFor: 'initialization' stamp: 'ab 6/28/2002 12:56'!
initialize
	self initInitialModuleList.
	"self layout."
	moduleSelectedIndex _ 1!
]style[(10 2 4 25 14 2 19 3 1)f1b,f1,f1cmagenta;,f1,f1c126024000,f1,f1cmagenta;,f1,f1c176176100! !

!ModuleTool methodsFor: 'layout' stamp: 'AB 2/4/2002 19:09'!
minimalSize
	^ 440 @ 150! !

!ModuleTool methodsFor: 'layout' stamp: 'AB 1/14/2002 20:12'!
updateView

	self updateListPanel.
	self updateStatePanel! !

!ModuleTool methodsFor: 'panel - button' stamp: 'ab 6/27/2002 22:47'!
buttonState
	^true! !

!ModuleTool methodsFor: 'panel - list' stamp: 'ab 7/6/2002 23:01'!
addDependency
	| ans arr |
	ans _ self askAModuleName.
	arr _ self transformeStringToPath: ans.
	arr notEmpty
		ifTrue: [(Module fromPath: arr) notNil
				ifTrue: [self getModuleFromListIndex
						importModule: (Module fromPath: arr). self updateModule: self getModuleFromListIndex with: (Module fromPath: arr) ]
				ifFalse: [self notify: 'Module not found !!']]! !

!ModuleTool methodsFor: 'panel - list' stamp: 'ab 7/3/2002 15:06'!
defineButtonsActionOn: model 
	| listButton updateButton storeButton importButton unloadButton loadButton publishButton r serverButton |
	listButton _ PluggableButtonMorph
				on: model
				getState: #buttonState
				action: #addAModule
				label: #buttonLabelList.
	updateButton _ PluggableButtonMorph
				on: model
				getState: #buttonState
				action: #updateView
				label: #buttonLabelUpdate.
	storeButton _ PluggableButtonMorph
				on: model
				getState: #buttonState
				action: #store
				label: #buttonLabelStore.
	importButton _ PluggableButtonMorph
				on: model
				getState: #buttonState
				action: #import
				label: #buttonLabelImport.
	unloadButton _ PluggableButtonMorph
				on: model
				getState: #buttonState
				action: #unload
				label: #buttonLabelUnload.
	loadButton _ PluggableButtonMorph
				on: model
				getState: #buttonState
				action: #load
				label: #buttonLabelLoad.
	publishButton _ PluggableButtonMorph
				on: model
				getState: #buttonState
				action: #publish
				label: #buttonLabelPublish.
	serverButton _ PluggableButtonMorph
				on: model
				getState: #buttonState
				action: #server
				label: #buttonLabelServer.
	r _ {listButton. updateButton. storeButton. importButton. unloadButton. loadButton. publishButton. serverButton}.
	r
		do: [:b | b
				color: (Color colorFrom: #(0.736 0.92 0.552 ))].
	^ r! !

!ModuleTool methodsFor: 'panel - list' stamp: 'ab 7/1/2002 15:42'!
defineButtonsStateOn: model 
	| aloneButton abstractButton stateButton implicitButton r |
	aloneButton _ PluggableButtonMorph
				on: model
				getState: #buttonState
				action: #setModuleAlone
				label: #buttonStateLabelAlone.
	abstractButton _ PluggableButtonMorph
				on: model
				getState: #buttonState
				action: #doNothing
				label: #buttonStateLabelAbstract.
	stateButton _ PluggableButtonMorph
				on: model
				getState: #buttonState
				action: #doNothing
				label: #buttonStateLabelCache.
	implicitButton _ PluggableButtonMorph
				on: model
				getState: #buttonState
				action: #doNothing
				label: #buttonStateLabelImplicit.
	r _ {aloneButton. abstractButton. stateButton. implicitButton}.
	r
		do: [:b | b color: Color gray].
	^ r!
]style[(22 5 4 56 4 11 3 20 9 5 15 12 13 15 12 22 3 14 3 20 9 5 15 12 13 10 12 25 3 11 3 20 9 5 15 12 13 10 12 22 3 14 3 20 9 5 15 12 13 10 12 25 3 1 4 11 2 14 2 11 2 14 4 1 8 3 2 1 8 5 11 1)f1b,f1cblue;b,f1,f1cblue;i,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c180180104,f1,f1c180180104,f1,f1c180180104,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c180180104,f1,f1c180180104,f1,f1c180180104,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c180180104,f1,f1c180180104,f1,f1c180180104,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c180180104,f1,f1c180180104,f1,f1c180180104,f1,f1cblue;i,f1,f1cblue;i,f1,f1cblue;i,f1,f1cblue;i,f1,f1cblue;i,f1,f1cblue;i,f1,f1cred;,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cblue;i! !

!ModuleTool methodsFor: 'panel - list' stamp: 'ab 7/7/2002 14:38'!
defineMenuList: aMenu 
	aMenu defaultTarget: self.
	aMenu add: 'show unresolved references' action: #showUnresolvedReferences.
	aMenu add: 'show dependencies' action: #showDependencies.
	aMenu add: 'show external referencies' action: #showExternalReferencies.
	aMenu add: 'show delta module refered' action: #showDeltaModules.
	aMenu addLine.
	aMenu add: 'add dependency' action: #addDependency.
	aMenu addLine.
	aMenu add: 'inspect it' action: #inspectModule.
	^ aMenu! !

!ModuleTool methodsFor: 'panel - list' stamp: 'ab 7/8/2002 23:51'!
getModulesList
	| t mod |
	t _ OrderedCollection new.
	initialModuleList
		do: [:path | 
			| s | 
			s _ self translatePathToString: path.
			(t includes: s)
				ifFalse: [t add: s].
			mod _ Module fromPath: path.
			mod notNil
				ifTrue: [mod deepSubmodules
						do: [:m | |aze| aze _ (self translatePathToString: m path). (t includes: aze)
								ifFalse: [t
										add: aze]]]].
	^ t asArray asSortedArray! !

!ModuleTool methodsFor: 'panel - list' stamp: 'ab 7/1/2002 16:04'!
getModulesListOLDTODEL
	| t mod |
	t _ OrderedCollection new.
	initialModuleList
		do: [:path | 
			| s | 
			s _ self translatePathToString: path.
			(t includes: s)
				ifFalse: [t add: s].
			mod _ Module fromPath: path.
			mod notNil
				ifTrue: [self getModulesListOn: mod on: t]].
	^ t asArray asSortedArray! !

!ModuleTool methodsFor: 'panel - list' stamp: 'AB 1/11/2002 14:46'!
getModulesListOn: aModule on: aCollection

	| t |
	t_aModule neighborModules.

	"(aCollection size > 20) ifTrue: [self halt.]." "For Debug"

	"aCollection add: (self translatePathToString: aModule path)."

	(t notNil)
		ifTrue: [ t do: [:mod| |p|
			p_(self translatePathToString: mod path).
			(aCollection includes: p)
				ifFalse:[
					aCollection add: p.
					self getModulesListOn: mod on: aCollection. 
				]
		].
	].
! !

!ModuleTool methodsFor: 'panel - list' stamp: 'ab 7/1/2002 15:40'!
perform: selector orSendTo: notUsed
	^ self perform: selector! !

!ModuleTool methodsFor: 'panel - list' stamp: 'ab 7/7/2002 14:42'!
showDeltaModules
	| module d |
	module _ self getModuleFromListIndex.
	d _ DeltaModule allInstances
				select: [:dm | dm baseModule == module].
	d size = 0
		ifTrue: [self beep.
			^ false].
	ModuleToolPopup
		openWithAList: (d
				collect: [:dm | dm asString])
		andTitle: 'Dependencies for ' , module path asString! !

!ModuleTool methodsFor: 'panel - list' stamp: 'ab 7/8/2002 12:07'!
showDependencies
	| module |
	module _ self getModuleFromListIndex.
	ModuleToolPopup
		openWithAList: module importedModules
		andTitle: 'Dependencies for ' , module path asString
		andAction: #(#('remove' #removeDependency:) #('replace' #replaceDependency:) )
		andTarget: self! !

!ModuleTool methodsFor: 'panel - list' stamp: 'ab 7/6/2002 23:47'!
showExternalReferencies
	| module r |
	module _ self getModuleFromListIndex.
	r _ OrderedCollection new.
	(self externalSymbolForModule: module)
				associationsDo: [:assoc | r add: (assoc key asString , ' -> ' , assoc value asString)].
	ModuleToolPopup openWithAList: r andTitle: 'External Referencies for ' , module path asString!
]style[(23 3 7 6 6 3 4 55 4 26 6 23 7 10 5 16 6 3 5 20 15 28 27 3 6 14)f1b,f1,f1cblue;i,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cred;,f1,f1cblue;i,f1,f1c188188112,f1,f1cblue;i,f1,f1cmagenta;,f1,f1c188188112,f1,f1cblue;i,f1! !

!ModuleTool methodsFor: 'panel - list' stamp: 'ab 7/7/2002 15:58'!
showUnresolvedReferences
	| module d d2 |
	module _ self getModuleFromListIndex.
	d _ self unreferencedSymbolForModule: module.
	d size = 0
		ifTrue: [self beep.
			^ false].
	d2 _ OrderedCollection new.
	d
		associationsDo: [:assoc | d2 add: assoc key asString , ' in ' , assoc value asString].
	ModuleToolPopup
		openWithAList: d2 asSortedCollection
		andTitle: 'Unresolved references for ' , module path asString
		andAction: #(#('automatic resolve' #automaticResolveDependency:) #('inspect method' #inspectMethodFor:) )
		actionWithoutSelection: #(#('resolve automaticaly all symbols' automaticResolveDependencies:))
		andTarget: self! !

!ModuleTool methodsFor: 'panel - list' stamp: 'ab 7/5/2002 17:55'!
showUnresolvedReferencesOLD
	| module d |
	module _ self getModuleFromListIndex.
	d _ module deepUnresolvedRefsWithScheme: #strong.
	d size = 0
		ifTrue: [self beep.
			^ false].
	d _ d at: module.
	ModuleToolPopup
		openWithAList: d
		andTitle: 'Unresolved references'
		andAction: #(#('automatic resolve' #automaticResolveDependency:) )
		andTarget: self! !

!ModuleTool methodsFor: 'panel - list' stamp: 'AB 1/11/2002 14:52'!
transformeStringToPath: aString

	^aString substrings! !

!ModuleTool methodsFor: 'panel - list' stamp: 'AB 1/11/2002 14:42'!
translatePathToString: aPath

	|t|
	t_''.
	aPath do: [:s| t_t, s, ' '.].
	^ t.! !

!ModuleTool methodsFor: 'panel - list' stamp: 'ab 6/28/2002 12:33'!
updateListPanel
	self changed: #getModulesList! !

!ModuleTool methodsFor: 'pane - help' stamp: 'AB 1/16/2002 17:23'!
makeHelpPanel
	helpPanel _ TextMorph new.
	helpPanel contents: ' ', 'Here is some help !!'.
	^ self panelForHelp addMorph: helpPanel;
		 color: Color veryLightGray!
]style[(13 2 9 3 9 32 21 5 4 24 9 12 5 14)f1b,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1c170170085,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1cmagenta;,f1! !

!ModuleTool methodsFor: 'pane - help' stamp: 'AB 1/16/2002 17:23'!
setHelp: aString 
	(helpPanel submorphs at: 1)
		contents: ' ',aString!
]style[(9 7 4 9 15 1 18 7)f1b,f1cblue;b,f1,f1cmagenta;,f1,f1c170170085,f1,f1cblue;i! !

!ModuleTool methodsFor: 'panel - state' stamp: 'AB 1/16/2002 17:33'!
makeStatePanel
	| b1 b2 b3 b4 |
	b1 _ self
				buildButtonStateTarget: self
				label: 'Alone'
				selector: #setModuleAlone
				help: 'Does the module selected could be saved ? '.
	b2 _ self
				buildButtonStateTarget: self
				label: 'Abstract'
				selector: #doNothing
				help: ''.
	b3 _ self
				buildButtonStateTarget: self
				label: 'Cache'
				selector: #doNothing
				help: ''.
	b4 _ self
				buildButtonStateTarget: self
				label: 'Implicit'
				selector: #doNothing
				help: ''.
	statePanelButtonsList _ Array
				with: b1
				with: b2
				with: b3
				with: b4.
	^ self rowForButtons addMorph: b1;
		 addMorph: b2;
		 addMorph: b3;
		 addMorph: b4;
		 color: Color veryLightGray!
]style[(14 3 12 4 2 3 4 29 4 12 7 15 15 11 44 3 2 3 4 29 4 12 10 15 10 11 2 3 2 3 4 29 4 12 7 15 10 11 2 3 2 3 4 29 4 12 10 15 10 11 2 3 21 3 5 11 2 11 2 11 2 11 2 5 4 25 2 15 2 15 2 15 2 12 5 14)f1b,f1,f1cblue;i,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1c170170085,f1,f1c170170085,f1,f1c170170085,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1c170170085,f1,f1c170170085,f1,f1c170170085,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1c170170085,f1,f1c170170085,f1,f1c170170085,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1c170170085,f1,f1c170170085,f1,f1c170170085,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cblue;i,f1,f1cblue;i,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cblue;i,f1,f1cblue;i,f1,f1cblue;i,f1,f1cmagenta;,f1! !

!ModuleTool methodsFor: 'panel - state' stamp: 'ab 6/28/2002 19:09'!
setStateAbstract: aBoolean 
	| t |
	t _ statePanelButtonsList at: 2.
	aBoolean
		ifTrue: [t color: self stateOn]
		ifFalse: [t color: self stateOff]! !

!ModuleTool methodsFor: 'panel - state' stamp: 'ab 6/28/2002 19:09'!
setStateAlone: aBoolean 
	| t |
	t _ statePanelButtonsList at: 1.
	aBoolean
		ifTrue: [t color: self stateOn]
		ifFalse: [t color: self stateOff]! !

!ModuleTool methodsFor: 'panel - state' stamp: 'ab 6/28/2002 19:09'!
setStateCache: aBoolean 
	| t |
	t _ statePanelButtonsList at: 3.
	aBoolean
		ifTrue: [t color: self stateOn]
		ifFalse: [t color: self stateOff]! !

!ModuleTool methodsFor: 'panel - state' stamp: 'ab 6/28/2002 19:09'!
setStateImplicit: aBoolean 
	| t |
	t _ statePanelButtonsList at: 4.
	aBoolean
		ifTrue: [t color: self stateOn]
		ifFalse: [t color:self stateOff]! !

!ModuleTool methodsFor: 'panel - state' stamp: 'ab 6/28/2002 19:09'!
stateOff
	^ Color gray! !

!ModuleTool methodsFor: 'panel - state' stamp: 'ab 6/28/2002 19:08'!
stateOn
	^Color lightGray! !

!ModuleTool methodsFor: 'panel - state' stamp: 'ab 6/28/2002 17:56'!
updateStatePanel
	| mod rep |
	(moduleSelectedIndex = 0
			or: [moduleSelectedIndex > self nbModuleListed])
		ifTrue: [^ false].
	"listPanel getList size = 0
		ifTrue: [^ false]."
	mod _ self getModuleFromListIndex.
	rep _ mod repository.
	rep isAbstract
		ifTrue: [self setStateAbstract: true]
		ifFalse: [self setStateAbstract: false].
	rep isCache
		ifTrue: [self setStateCache: true]
		ifFalse: [self setStateCache: false].
	rep isImplicit
		ifTrue: [self setStateImplicit: true]
		ifFalse: [self setStateImplicit: false].
	rep isStandalone
		ifTrue: [self setStateAlone: true]
		ifFalse: [self setStateAlone: false]!
]style[(16 3 8 5 19 3 1 9 19 3 4 31 5 5 9 16 1 14 5 5 3 3 4 26 3 3 3 14 3 23 4 19 4 14 4 19 5 4 3 20 4 16 4 14 4 16 5 4 3 23 4 19 4 14 4 19 5 4 3 25 4 16 4 14 4 16 5 1)f1b,f1,f1cblue;i,f1,f1cmagenta;,f1,f1c176176100,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1c176176100,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cblue;i,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1cmagenta;,f1! !

!ModuleTool methodsFor: 'labels' stamp: 'ab 6/27/2002 22:46'!
buttonLabelImport
	^ 'Import'! !

!ModuleTool methodsFor: 'labels' stamp: 'ab 6/27/2002 22:45'!
buttonLabelInspect
	^ 'Inspect'! !

!ModuleTool methodsFor: 'labels' stamp: 'ab 6/27/2002 22:45'!
buttonLabelList
	^'List'! !

!ModuleTool methodsFor: 'labels' stamp: 'ab 6/27/2002 22:46'!
buttonLabelLoad
	^ 'Load'! !

!ModuleTool methodsFor: 'labels' stamp: 'ab 6/27/2002 22:46'!
buttonLabelPublish
	^ 'Publish'! !

!ModuleTool methodsFor: 'labels' stamp: 'ab 6/27/2002 22:46'!
buttonLabelQuit
	^ 'Quit'! !

!ModuleTool methodsFor: 'labels' stamp: 'ab 6/27/2002 22:46'!
buttonLabelServer
	^ 'Server'! !

!ModuleTool methodsFor: 'labels' stamp: 'ab 6/27/2002 22:45'!
buttonLabelStore
	^ 'Store'! !

!ModuleTool methodsFor: 'labels' stamp: 'ab 6/27/2002 22:46'!
buttonLabelUnload
	^ 'Unload'! !

!ModuleTool methodsFor: 'labels' stamp: 'ab 6/27/2002 22:45'!
buttonLabelUpdate
	^ 'Update'! !

!ModuleTool methodsFor: 'labels' stamp: 'ab 6/28/2002 12:46'!
buttonStateLabelAbstract
	^ 'Abstract'! !

!ModuleTool methodsFor: 'labels' stamp: 'ab 6/28/2002 12:46'!
buttonStateLabelAlone
	^'Alone'! !

!ModuleTool methodsFor: 'labels' stamp: 'ab 6/28/2002 12:46'!
buttonStateLabelCache
	^ 'Cache'! !

!ModuleTool methodsFor: 'labels' stamp: 'ab 6/28/2002 12:46'!
buttonStateLabelImplicit
	^ 'Implicit'! !

!ModuleTool methodsFor: 'modules operations' stamp: 'ab 7/7/2002 22:36'!
automaticResolveDependencies: aCollectionOfString 
	(aCollectionOfString includes: #Smalltalk)
		ifTrue: [self notify: 'This module contains reference to Smalltalk dictionary. Please, try to remove that'].
	aCollectionOfString
		do: [:reference | 
			reference _ reference substrings first asSymbol.
			self getModuleFromListIndex importName: reference interactive: true]!
]style[(30 19 4 19 11 10 13 4 9 84 4 19 8 11 6 9 3 9 31 4 36 9 14 4 1)f1b,f1cblue;b,f1,f1cblue;i,f1,f1c198198122,f1,f1cmagenta;,f1,f1c198198122,f1,f1cblue;i,f1,f1cred;,f1,f1cblue;i,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cmagenta;,f1! !

!ModuleTool methodsFor: 'modules operations' stamp: 'ab 7/5/2002 18:46'!
automaticResolveDependency: aString 
	| reference |
	reference _ aString substrings first asSymbol.
	self getModuleFromListIndex importName: reference interactive: true!
]style[(28 7 4 10 4 9 3 7 29 4 36 9 14 4)f1b,f1cblue;b,f1,f1cblue;i,f1,f1cblue;i,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cmagenta;! !

!ModuleTool methodsFor: 'modules operations' stamp: 'ab 7/5/2002 22:57'!
changeAssociationInClass: aClass for: aDictionary 
	aClass methodDictionary do: [:assoc| 
		self changeAssociationInCompiledMethod: assoc value for: aDictionary]! !

!ModuleTool methodsFor: 'modules operations' stamp: 'ab 7/6/2002 22:32'!
changeAssociationInCompiledMethod: cm for: aDictionary 
	| assoc |
	1
		to: cm numLiterals
		do: [:i | 
			assoc _ cm literalAt: i.
			(assoc isKindOf: LookupKey) ifTrue: [
			aDictionary
				at: assoc key
				ifPresent: [:v | cm
						literalAt: i
						put: (Association key: assoc key value: v)]]]!
]style[(35 2 6 11 4 6 4 1 7 2 20 3 6 5 3 2 12 1 46 11 9 5 21 3 2 2 18 1 13 11 6 5 12 1 4)f1b,f1cblue;b,f1b,f1cblue;b,f1,f1cblue;i,f1,f1c188188112,f1,f1cblue;i,f1,f1cred;,f1,f1cblue;i,f1,f1cblue;i,f1,f1cblue;i,f1,f1cblue;i,f1,f1cblue;i,f1,f1cred;,f1,f1cblue;i,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cblue;i,f1! !

!ModuleTool methodsFor: 'modules operations' stamp: 'ab 7/5/2002 22:58'!
changeAssociationInModule: aModule for: aDictionary 
	aModule allClassesDo: [:cls| self changeAssociationInClass: cls for: aDictionary]! !

!ModuleTool methodsFor: 'modules operations' stamp: 'ab 7/7/2002 00:05'!
externalSymbolForClass: aClass 
	"get external referencies for a class. ie : binding not defined into the  
	module (without regarding modules dependencies)"
	"WARNING : We assume that a class uses always the same reference for  
	the same class  
	for instance, two symbols #AClass design the same class"
	"Perhaps we have to provide some checking"
	| r d |
	r _ Dictionary new.
	aClass methodDictionary
		associationsDo: [:assoc | 
			d _ self unreferencedSymbolForCompiledMethod: assoc value.
			d
				associationsDo: [:asso | (aClass module
							localAssocFor: asso key
							ifAbsent: [true])
							= true
						ifTrue: [
							r
								at: asso key
								put: (MethodReference new setStandardClass: aClass methodSymbol: assoc key)]]].
	^ r!
]style[(24 6 3 316 3 4 4 1 3 10 7 6 37 7 6 1 3 4 38 5 11 1 22 6 3 6 30 4 23 4 12 4 24 1 13 4 19 15 23 6 15 5 13 1)f1b,f1cblue;b,f1,f1c138036000,f1,f1cblue;i,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cred;,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cblue;i,f1,f1cred;,f1,f1cblue;i,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cblue;i,f1,f1cblue;i! !

!ModuleTool methodsFor: 'modules operations' stamp: 'ab 7/7/2002 00:05'!
externalSymbolForModule: aModule 
	| result |
	result _ Dictionary new.
	aModule
		allClassesDo: [:cls | 
			(self externalSymbolForClass: cls)
				associationsDo: [:assoc | result add: assoc]].
	^ result!
]style[(25 7 4 7 4 6 3 10 7 7 18 5 7 4 25 3 23 7 2 6 6 5 7 6)f1b,f1cblue;b,f1,f1cblue;i,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cred;,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cred;,f1,f1cblue;i,f1,f1cblue;i,f1,f1cblue;i! !

!ModuleTool methodsFor: 'modules operations' stamp: 'ab 7/8/2002 16:21'!
intersectionDefinedNamesBetween: m1 and: m2
	^ m1 definedNames intersection: m2 definedNames! !

!ModuleTool methodsFor: 'modules operations' stamp: 'ab 7/8/2002 12:31'!
removeDependency: aModule 
	self removeDependency: aModule forModule: self getModuleFromListIndex!
]style[(18 7 3 4 19 7 12 4 23)f1b,f1cblue;b,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cmagenta;,f1! !

!ModuleTool methodsFor: 'modules operations' stamp: 'ab 7/8/2002 12:14'!
removeDependency: aModule forModule: module
	|  d |
	d _ Dictionary new.
	aModule definedNames
		associationsDo: [:assoc | d at: assoc key put: nil].
	self changeAssociationInModule: module for: d.
	module removeNeighborModule: aModule! !

!ModuleTool methodsFor: 'modules operations' stamp: 'ab 7/7/2002 21:51'!
unreferencedSymbolForClass: aClass 
	"get referencies neither defined in the aClass module and neither in  
	imported module of these"
	"WARNING : We assume that a class uses always the same reference for  
	the same class  
	for instance, two symbols #AClass design the same class"
	"Perhaps we have to provide some checking"
	| r d mods caches cacheDefiningBinding |
	cacheDefiningBinding _ [:key | [:cache | cache
				includesKey: key
				]].
	r _ Dictionary new.
	mods _ aClass module importedModules , {aClass module}.
	caches _ mods
				collect: [:m | m definedNames].
	aClass methodDictionary
		associationsDo: [:assoc | 
			d _ self unreferencedSymbolForCompiledMethod: assoc value.
			d
				associationsDo: [:asso | mods
						do: [:m | 
							| p | 
							p _ caches
										select: (cacheDefiningBinding value: asso key).
							p isEmpty
								ifTrue: [r
										at: asso key
										put: (MethodReference new setStandardClass: aClass methodSymbol: assoc key)]]]].
	(caches
			select: (cacheDefiningBinding value: aClass superclass name)) isEmpty
		ifTrue: [r
				at: aClass superclass name
				put: (MethodReference new setStandardClass: aClass methodSymbol: #'<class creation>')].
	^ r!
]style[(28 6 3 289 3 37 4 20 4 5 3 7 2 5 18 3 10 1 3 10 7 4 3 6 27 6 11 6 3 4 15 3 2 1 17 6 37 7 6 1 3 4 38 5 11 1 22 6 2 4 12 3 12 1 11 1 3 6 20 20 8 4 14 1 26 1 15 4 21 15 23 6 15 5 13 6 13 20 8 6 38 1 9 6 27 15 23 6 15 19 7 1)f1b,f1cblue;b,f1,f1c144042000,f1,f1cblue;i,f1,f1cblue;i,f1,f1cred;,f1,f1cred;,f1,f1cblue;i,f1,f1cblue;i,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cblue;i,f1,f1cblue;i,f1,f1cblue;i,f1,f1cblue;i,f1,f1cred;,f1,f1cblue;i,f1,f1cblue;i,f1,f1cred;,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cblue;i,f1,f1cred;,f1,f1cblue;i,f1,f1cred;,f1,f1cblue;i,f1,f1cblue;i,f1,f1cblue;i,f1,f1cblue;i,f1,f1cblue;i,f1,f1cblue;i,f1,f1cblue;i,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cblue;i,f1,f1cblue;i,f1,f1cblue;i,f1,f1cblue;i,f1,f1cblue;i,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c194194118,f1,f1cblue;i! !

!ModuleTool methodsFor: 'modules operations' stamp: 'ab 7/7/2002 21:24'!
unreferencedSymbolForClassNOTEFFICIENT: aClass 
	"get referencies neither defined in the aClass module and neither in  
	imported module of these"
	"WARNING : We assume that a class uses always the same reference for  
	the same class  
	for instance, two symbols #AClass design the same class"
	"Perhaps we have to provide some checking"
	| r d mods moduleDefiningBinding |
	moduleDefiningBinding _ [:key | [:module | module
				definesName: key
				usingScheme: #strong
				ifTrue: [:o | o]]].
	r _ Dictionary new.
	mods _ aClass module importedModules , {aClass module}.
	aClass methodDictionary
		associationsDo: [:assoc | 
			d _ self unreferencedSymbolForCompiledMethod: assoc value.
			d
				associationsDo: [:asso | mods
						do: [:m | 
							| p | 
							p _ mods
										select: (moduleDefiningBinding value: asso key).
							p isEmpty
								ifTrue: [r
										at: asso key
										put: (MethodReference new setStandardClass: aClass methodSymbol: assoc key)]]]].
	(mods
			select: (moduleDefiningBinding value: aClass superclass name)) isEmpty
		ifTrue: [r
				at: aClass superclass name
				put: (MethodReference new setStandardClass: aClass methodSymbol: #'<class creation>')].
	^ r! !

!ModuleTool methodsFor: 'modules operations' stamp: 'ab 7/7/2002 00:07'!
unreferencedSymbolForCompiledMethod: cm 
	"Get a dictionary of all class referencies of a compiled method"
	"the result is a dictionary, this implies a same classname refer the same  
	class within the method"
	| r |
	r _ Dictionary new.
	cm literals
		do: [:s | (s isKindOf: LookupKey)
				ifTrue: [s key asString first isUppercase
						ifTrue: [((s value) isKindOf: Behavior) 
									ifTrue: [r at: s key put: s value module]
									ifFalse:[r at: s key put: s value class module]]]].
	^ r!
]style[(37 2 3 167 3 2 4 1 3 10 7 2 17 3 3 1 11 9 15 1 97 1 5 1 10 1 79 1)f1b,f1cblue;b,f1,f1c138036000,f1,f1cblue;i,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cred;,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cblue;i,f1,f1cblue;i,f1,f1cblue;i,f1,f1cblue;i! !

!ModuleTool methodsFor: 'modules operations' stamp: 'ab 7/5/2002 18:29'!
unreferencedSymbolForCompiledMethodFROMHenrikCode: cm 
	"Get a dictionary of all class referencies of a compiled method"
	"the result is a dictionary, this implies a same classname refer the same  
	class within the method"
	| cache results |
	cache _ IdentityDictionary new: 500.
	cm == DeltaModule valueForUndefined
		ifTrue: [^ false].
	results _ Set new.
	cm literals
		do: [:lit | (lit isVariableBinding
					and: [lit key notNil]
					and: [((cm who first
								definesName: lit key
								lookInSuper: true
								ifTrue: [:a | a])
							or: [self
									doesLookupOf: lit key
									withScheme: #strong
									giveTheAssoc: lit
									useCache: cache]) not])
				ifTrue: [results add: lit key]].
	^ results! !

!ModuleTool methodsFor: 'modules operations' stamp: 'ab 7/7/2002 22:30'!
unreferencedSymbolForModule: aModule 
	"get referencies neither defined in the module and neither in  
	imported module of these"
	| r |
	r _ Dictionary new.
	aModule
		allClassesDo: [:cls | 
			"cls name = #ModuleToolTest
				ifTrue: [self halt]."
			(self unreferencedSymbolForClass: cls)
				associationsDo: [:a | r add: a]].
	^ r!
]style[(29 7 3 90 3 2 4 1 3 10 7 7 18 5 7 3 8 15 14 4 13 4 29 3 23 3 2 1 6 1 7 1)f1b,f1cblue;b,f1,f1c148046000,f1,f1cblue;i,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cred;,f1,f1cblue;i,f1,f1c198198122,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cred;,f1,f1cblue;i,f1,f1cblue;i,f1,f1cblue;i! !

!ModuleTool methodsFor: 'modules operations' stamp: 'ab 7/6/2002 22:04'!
updateModule: m1 with: m2 
	self changeAssociationInModule: m1 for: m2 definedNames! !


!ModuleTool class methodsFor: 'as yet unclassified' stamp: 'AB 2/5/2002 00:12'!
createDirectoryOnServerForModule: aModule serverDirectory: serverDirectory 
	| path d |
	path _ aModule path.
	d _ serverDirectory directory.
	path
		do: [:p | 
			d _ d , serverDirectory pathNameDelimiter asString , p asString.
			(serverDirectory localPathExists: p asString)
				ifFalse: [serverDirectory createDirectory: p asString].
			serverDirectory directory: d]! !

!ModuleTool class methodsFor: 'as yet unclassified' stamp: 'ab 6/28/2002 12:42'!
open
	self new initialize openAsMorph! !


!ModuleToolButton methodsFor: 'as yet unclassified' stamp: 'AB 1/16/2002 16:48'!
handlesMouseOver: evt
	^true! !

!ModuleToolButton methodsFor: 'as yet unclassified' stamp: 'AB 1/16/2002 16:10'!
help: aString
	help_aString.! !

!ModuleToolButton methodsFor: 'as yet unclassified' stamp: 'AB 2/6/2002 14:48'!
mouseEnter: evt 
	super mouseEnter: evt.
	moduleTool setHelp: help! !

!ModuleToolButton methodsFor: 'as yet unclassified' stamp: 'AB 2/6/2002 14:48'!
mouseLeave: evt 
	super mouseLeave: evt.
	moduleTool setHelp: ''! !

!ModuleToolButton methodsFor: 'as yet unclassified' stamp: 'AB 1/16/2002 16:14'!
setModuleTool: aModuleTool
	moduleTool_aModuleTool.! !


!ModuleToolPopup methodsFor: 'as yet unclassified' stamp: 'ab 7/7/2002 15:54'!
actionWithoutSelection: listOfActions
	actionWithoutSelection _ listOfActions! !

!ModuleToolPopup methodsFor: 'as yet unclassified' stamp: 'ab 7/2/2002 12:16'!
actions: someActions 
	"someActions -> #(#('label1' #msg1) #('label2' #msg2)  ... )
	performed on target"
	actions _ someActions! !

!ModuleToolPopup methodsFor: 'as yet unclassified' stamp: 'ab 6/28/2002 19:20'!
buttonLabelCloseWindow
	^'Close'! !

!ModuleToolPopup methodsFor: 'as yet unclassified' stamp: 'ab 6/28/2002 22:23'!
buttonState
	^true! !

!ModuleToolPopup methodsFor: 'as yet unclassified' stamp: 'ab 6/28/2002 23:10'!
deleteFrame
	frame delete! !

!ModuleToolPopup methodsFor: 'as yet unclassified' stamp: 'ab 7/2/2002 11:46'!
initialize
	listIndex _ 0.! !

!ModuleToolPopup methodsFor: 'as yet unclassified' stamp: 'ab 6/28/2002 22:17'!
list
	^ listItem! !

!ModuleToolPopup methodsFor: 'as yet unclassified' stamp: 'ab 7/8/2002 12:31'!
list: anOrderedCollection 
	listItem _ SortedCollection
				sortBlock: [:a :b | a asString <= b asString].
	listItem addAll: anOrderedCollection! !

!ModuleToolPopup methodsFor: 'as yet unclassified' stamp: 'ab 7/8/2002 12:29'!
listForDisplay
	^ listItem
		collect: [:item | item asString]! !

!ModuleToolPopup methodsFor: 'as yet unclassified' stamp: 'ab 7/8/2002 12:05'!
listSelected
	^ listIndex! !

!ModuleToolPopup methodsFor: 'as yet unclassified' stamp: 'ab 7/2/2002 11:45'!
listSelected: anInteger 
	listIndex _ anInteger.
	self changed: #listSelected! !

!ModuleToolPopup methodsFor: 'as yet unclassified' stamp: 'ab 7/7/2002 16:03'!
menu: menu 
	self listSelected ~= 0
		ifTrue: [actions
				do: [:action | menu
						add: action first
						target: target
						selector: action second
						argument: (listItem at: self listSelected)]]
		ifFalse: [actionWithoutSelection
				ifNotNil: [actionWithoutSelection
						do: [:action | menu
								add: action first
								target: target
								selector: action second
								argument: listItem]]].
	^ menu! !

!ModuleToolPopup methodsFor: 'as yet unclassified' stamp: 'ab 7/8/2002 12:06'!
openWithAList: anOrderedCollection andTitle: aString 
	| model list closeButton buttons |
	model _ self.
	model list: anOrderedCollection.
	(frame _ SystemWindow labelled: aString) model: self.
	list _ PluggableListMorph
				on: model
				list: #listForDisplay
				selected: #listSelected
				changeSelected: #listSelected:.
	list color: Color green.
	closeButton _ PluggableButtonMorph
				on: self
				getState: #buttonState
				action: #deleteFrame
				label: #buttonLabelCloseWindow.
	closeButton
		color: (Color colorFrom: #(0.736 0.92 0.552 )).
	frame
		addMorph: list
		frame: (0.0 @ 0.2 extent: 1.0 @ 0.8).
	buttons _ {closeButton}.
	buttons
		inject: 0.0
		into: [:offset :button | 
			| t | 
			t _ 1 / buttons size.
			frame
				addMorph: button
				frame: (offset @ 0.0 extent: t @ 0.2).
			offset + t].
	frame openInWorldExtent: 350 @ 200.
	self changed: #test.
	^ frame! !

!ModuleToolPopup methodsFor: 'as yet unclassified' stamp: 'ab 7/8/2002 12:06'!
openWithAList: anOrderedCollection andTitle: aString andAction: listOfActions actionWithoutSelection: listOfActions2 andTarget: aTarget 
	"anOrderedCollection -> collection of item  
	aString -> Title of the frame  
	listOfActions -> #(#('label' #msg) ... )  
	#msg defined in the listOfAction are performed on aTarget"
	| model list closeButton buttons |
	model _ self.
	model list: anOrderedCollection.
	(frame _ SystemWindow labelled: aString) model: self.
	model actions: listOfActions.
	model actionWithoutSelection: listOfActions2.
	model target: aTarget.
	list _ PluggableListMorph
				on: model
				list: #listForDisplay
				selected: #listSelected
				changeSelected: #listSelected:
				menu: #menu:.
	list color: Color green.
	closeButton _ PluggableButtonMorph
				on: self
				getState: #buttonState
				action: #deleteFrame
				label: #buttonLabelCloseWindow.
	closeButton
		color: (Color colorFrom: #(0.736 0.92 0.552 )).
	frame
		addMorph: list
		frame: (0.0 @ 0.2 extent: 1.0 @ 0.8).
	buttons _ {closeButton}.
	buttons
		inject: 0.0
		into: [:offset :button | 
			| t | 
			t _ 1 / buttons size.
			frame
				addMorph: button
				frame: (offset @ 0.0 extent: t @ 0.2).
			offset + t].
	frame openInWorldExtent: 350 @ 200.
	self changed: #test.
	^ frame! !

!ModuleToolPopup methodsFor: 'as yet unclassified' stamp: 'ab 7/8/2002 12:06'!
openWithAList: anOrderedCollection andTitle: aString andAction: listOfActions andTarget: aTarget 
	"anOrderedCollection -> collection of item  
	aString -> Title of the frame  
	listOfActions -> #(#('label' #msg) ... )  
	#msg defined in the listOfAction are performed on aTarget"
	| model list closeButton buttons |
	model _ self.
	model list: anOrderedCollection.
	(frame _ SystemWindow labelled: aString) model: self.
	model actions: listOfActions.
	model target: aTarget.
	list _ PluggableListMorph
				on: model
				list: #listForDisplay
				selected: #listSelected
				changeSelected: #listSelected:
				menu: #menu:.
	list color: Color green.
	closeButton _ PluggableButtonMorph
				on: self
				getState: #buttonState
				action: #deleteFrame
				label: #buttonLabelCloseWindow.
	closeButton
		color: (Color colorFrom: #(0.736 0.92 0.552 )).
	frame
		addMorph: list
		frame: (0.0 @ 0.2 extent: 1.0 @ 0.8).
	buttons _ {closeButton}.
	buttons
		inject: 0.0
		into: [:offset :button | 
			| t | 
			t _ 1 / buttons size.
			frame
				addMorph: button
				frame: (offset @ 0.0 extent: t @ 0.2).
			offset + t].
	frame openInWorldExtent: 350 @ 200.
	self changed: #test.
	^ frame! !

!ModuleToolPopup methodsFor: 'as yet unclassified' stamp: 'ab 7/2/2002 12:16'!
target: aTarget
	target _ aTarget! !


!ModuleToolPopup class methodsFor: 'as yet unclassified' stamp: 'ab 6/28/2002 19:23'!
example1
	"self example1"
	^ self openWithAList: #('a' 'b' 'c' ) andTitle: 'An example !!'! !

!ModuleToolPopup class methodsFor: 'as yet unclassified' stamp: 'ab 7/2/2002 11:58'!
example2
	"self example2"
	^ self openWithAList: #('a' 'b' 'c' ) andTitle: 'An example !!' andAction: #(#('foo' #foo) #('bar' #bar)) andTarget: self new! !

!ModuleToolPopup class methodsFor: 'as yet unclassified' stamp: 'ab 6/28/2002 22:47'!
openWithAList: anOrderedCollection andTitle: aString 

	^ ModuleToolPopup new initialize openWithAList: anOrderedCollection andTitle: aString 
! !

!ModuleToolPopup class methodsFor: 'as yet unclassified' stamp: 'ab 7/7/2002 15:52'!
openWithAList: anOrderedCollection andTitle: aString andAction: actions actionWithoutSelection: actions2 andTarget: aTarget 
	^ ModuleToolPopup new initialize
		openWithAList: anOrderedCollection
		andTitle: aString
		andAction: actions
		actionWithoutSelection: actions2
		andTarget: aTarget! !

!ModuleToolPopup class methodsFor: 'as yet unclassified' stamp: 'ab 7/2/2002 11:58'!
openWithAList: anOrderedCollection andTitle: aString andAction: actions  andTarget: aTarget
	^ ModuleToolPopup new initialize
		openWithAList: anOrderedCollection
		andTitle: aString
		andAction: actions andTarget: aTarget! !


!ModuleToolTest methodsFor: 'helper methods' stamp: 'ab 7/5/2002 13:41'!
createClass: className onModule: aModule
	^Object
		subclass: className asSymbol
		instanceVariableNames: ''
		classVariableNames: ''
		module: aModule.! !

!ModuleToolTest methodsFor: 'helper methods' stamp: 'ab 7/5/2002 13:42'!
module: aString 
	"aString represent a path: could be 'aba' for instance, 
	it refers #(Temporary #ModuleTest #Modulea #Moduleb #Modulea)"
	| path |
	path _ self path: aString.
	^ Module fromPath: path forceCreate: true! !

!ModuleToolTest methodsFor: 'helper methods' stamp: 'ab 7/5/2002 13:46'!
path: aString 
	"aString represent a path: could be 'aba' for instance,  
	it refers #(Temporary #ModuleTest #Modulea #Moduleb #Modulea)"
	| r |
	r _ OrderedCollection new.
	r add: #Temporary;
		 add: #ModuleTest.
	aString
		do: [:m | r add: ('Module' , m asString) asSymbol].
	^ r asArray!
]style[(6 7 3 121 3 2 4 1 3 17 7 1 6 10 10 11 3 7 8 3 2 1 7 8 3 1 25 1 8)f1b,f1cblue;b,f1,f1c136034000,f1,f1cblue;i,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c186186110,f1,f1c186186110,f1,f1cblue;i,f1,f1cred;,f1,f1cblue;i,f1,f1c186186110,f1,f1cblue;i,f1,f1cblue;i,f1! !

!ModuleToolTest methodsFor: 'helper methods' stamp: 'ab 7/5/2002 14:42'!
removes: aCollectionOfPath 
	| mod |
	aCollectionOfPath
		do: [:m | 
			mod _ Module @ m.
			mod
				ifNotNil: [ModuleInstaller unload: mod]]!
]style[(9 17 4 4 4 17 8 3 6 3 3 6 3 1 5 3 16 15 9 3 2)f1b,f1cblue;b,f1,f1cblue;i,f1,f1cblue;i,f1,f1cred;,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cblue;i,f1! !

!ModuleToolTest methodsFor: 'tests' stamp: 'ab 7/6/2002 22:19'!
testChangeAssociationInCompiledMethodFor
	| mod dic cm |
	mod _ self module: 'toto'.
	self createClass: #Toto onModule: mod.
	"-----------------------------"
	(mod at: #Toto)
		compile: 'toto
	^AZER'
		classified: 'toto'.
	self assert: ((mod at: #Toto) new perform: #toto)
			= nil.
	"-----------------------------"
	dic _ Dictionary new.
	dic at: #AZER put: String.
	"-----------------------------"
	cm _ (mod at: #Toto) methodDictionary at: #toto.
	ModuleTool new changeAssociationInCompiledMethod: cm for: dic.
	"-----------------------------"
	self assert: ((mod at: #Toto) new
			perform: #toto)
			= String.
	"-----------------------------"
	self removes: {mod path}!
]style[(40 3 11 4 3 3 4 9 6 3 4 14 5 11 3 3 31 3 3 5 5 13 13 15 6 3 4 11 3 5 5 15 5 7 3 3 31 2 3 3 10 7 3 5 5 6 6 3 31 2 2 4 3 5 5 23 5 3 10 40 2 6 3 3 31 2 4 11 3 5 5 18 5 7 6 3 31 2 4 11 3 6)f1b,f1,f1cblue;i,f1,f1cblue;i,f1,f1cmagenta;,f1,f1c188188112,f1,f1cmagenta;,f1,f1c188188112,f1,f1cblue;i,f1,f1c138036000,f1,f1cblue;i,f1,f1c188188112,f1,f1c188188112,f1,f1c188188112,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c188188112,f1,f1c188188112,f1,f1cmagenta;,f1,f1c138036000,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c188188112,f1,f1cmagenta;,f1,f1c138036000,f1,f1cblue;i,f1,f1cblue;i,f1,f1c188188112,f1,f1c188188112,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cblue;i,f1,f1c138036000,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c188188112,f1,f1c188188112,f1,f1cmagenta;,f1,f1c138036000,f1,f1cmagenta;,f1,f1cblue;i,f1! !

!ModuleToolTest methodsFor: 'tests' stamp: 'ab 7/8/2002 17:47'!
testExternalSymbol
	| m r |
	self removes: {self path: 'a'}.
	m _ self module: 'a'.
	self createClass: #Dummy onModule: m.
	"-------------------"
	(m at: #Dummy)
		compile: 'foo
	Bar new. Dummy new . Foo new.'
		classified: 'foo'.
	"-------------------"
	r _ ModuleTool new
				externalSymbolForClass: (m at: #Dummy).
	self assert: r size = 2.
	self assert: (r at: #Bar) asString = 'Dummy>>foo'.
	self assert: (r at: #Foo) asString = 'Dummy>>foo'.
	"-------------------"
	r _ ModuleTool new externalSymbolForModule: m.
	self assert: r size = 2.
	self assert: (r at: #Bar) asString = 'Dummy>>foo'.
	self assert: (r at: #Foo) asString = 'Dummy>>foo'.
	"-------------------"
	self removes: {m path}!
]style[(18 3 4 37 1 3 4 9 3 3 4 14 6 11 1 3 21 3 1 5 6 13 36 15 5 3 21 2 1 3 10 34 1 5 6 4 4 9 1 8 1 3 4 10 1 5 4 13 12 3 4 10 1 5 4 13 12 3 21 2 1 3 10 30 1 3 4 9 1 8 1 3 4 10 1 5 4 13 12 3 4 10 1 5 4 13 12 3 21 2 4 11 1 6)f1b,f1,f1cblue;i,f1,f1cblue;i,f1,f1cmagenta;,f1,f1c200200124,f1,f1cmagenta;,f1,f1c200200124,f1,f1cblue;i,f1,f1c150048000,f1,f1cblue;i,f1,f1c200200124,f1,f1c200200124,f1,f1c200200124,f1,f1c150048000,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c200200124,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c200200124,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c200200124,f1,f1c200200124,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c200200124,f1,f1c200200124,f1,f1c150048000,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c200200124,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c200200124,f1,f1c200200124,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c200200124,f1,f1c200200124,f1,f1c150048000,f1,f1cmagenta;,f1,f1cblue;i,f1! !

!ModuleToolTest methodsFor: 'tests' stamp: 'ab 7/8/2002 18:16'!
testIntersectionDefinedNamesBetween
	| ma mb r |
	self removes: {self path: 'a'. self path: 'b'}.
	ma _ self module: 'a'.
	mb _ self module: 'b'.
	"--------------------"
	mb
		defineName: #Foo
		as: 'Foo'
		export: true.
	mb
		defineName: #Bar
		as: 'Foo'
		export: true.
	mb
		defineName: #Baz
		as: 'Foo'
		export: true.
	"--------------------"
	ma
		defineName: #Foo
		as: 'Foo'
		export: true.
	ma
		defineName: #Baz
		as: 'Foo'
		export: true.
	"--------------------"
	r _ ModuleTool new intersectionDefinedNamesBetween: ma and: mb.
	self assert: r size = 2.
	"--------------------"
	self removes: {ma path. mb path}! !

!ModuleToolTest methodsFor: 'tests' stamp: 'ab 7/8/2002 18:16'!
testIntersectionDefinedNamesBetweenBUG
	| ma mb r |
	self removes: {self path: 'a'. self path: 'b'}.
	ma _ self module: 'a'.
	mb _ self module: 'b'.
	"--------------------"
	mb
		defineName: #Foo
		as: 'Foo'
		export: true.
	mb
		defineName: #Bar
		as: 'Foo'
		export: true.
	mb
		defineName: #Baz
		as: 'Foo'
		export: true.
	"--------------------"
	ma
		defineName: #Foo
		as: 'Foo'
		export: false.
	ma
		defineName: #Baz
		as: 'Foo'
		export: false.
	"--------------------"
	self assert: ma definedNames isEmpty.
	ma exportName: #Foo.
	self assert: ma definedNames size = 1.
	"--------------------"
	r _ ModuleTool new intersectionDefinedNamesBetween: ma and: mb.
	self assert: r size = 1.
	"--------------------"
	ma exportName: #Baz.
	self assert: ma definedNames size = 2.
	"--------------------"
	r _ ModuleTool new intersectionDefinedNamesBetween: ma and: mb.
	self assert: r size = 2.
	"--------------------"
	self removes: {ma path. mb path}! !

!ModuleToolTest methodsFor: 'tests' stamp: 'ab 7/8/2002 17:42'!
testRemoveDependency
	| ma mc mb |
	self removes: {self path: 'a' . self path: 'b' . self path: 'c'}.
	ma _ self module: 'a'.
	mb _ self module: 'b'.
	mc _ self module: 'c'.
	self createClass: #Foo onModule: ma.
	self createClass: #Bar onModule: mb.
	self createClass: #Baz onModule: mc.
	"---------------------------------------------"
	(ma at: #Foo)
		compile: 'bar
	Bar new. Baz new'
		classified: 'foo'.
	"---------------------------------------------"
	ma importModule: Object module.
	ma importModule: mb.
	ma importModule: mc.
	ModuleTool new updateModule: ma with: Object module.
	ModuleTool new updateModule: ma with: mb.
	ModuleTool new updateModule: ma with: mc.
	self assert: (ModuleTool new unreferencedSymbolForModule: ma) isEmpty.
	self assert: ma importedModules size = 3.
	self
		assert: (ma importedModules includes: Object module).
	self
		assert: (ma importedModules includes: mb).
	self
		assert: (ma importedModules includes: mc).
	"---------------------------------------------"
	ModuleTool new removeDependency: mb forModule: ma.
	self assert: (ModuleTool new unreferencedSymbolForModule: ma) size = 1.
	self
		assert: ((ModuleTool new unreferencedSymbolForModule: ma) keys includes: #Bar).
	self assert: ma importedModules size = 2.
	self
		assert: (ma importedModules includes: Object module).
	self
		assert: (ma importedModules includes: mc).
	"---------------------------------------------"
	ModuleTool new removeDependency: mc forModule: ma.
	self assert: (ModuleTool new unreferencedSymbolForModule: ma) size = 2.
	self
		assert: ((ModuleTool new unreferencedSymbolForModule: ma) keys includes: #Bar).
	self
		assert: ((ModuleTool new unreferencedSymbolForModule: ma) keys includes: #Baz).
	self assert: ma importedModules size = 1.
	self
		assert: (ma importedModules includes: Object module).
	"---------------------------------------------"
	self removes: {ma path. mb path. mc path}!
]style[(20 3 9 71 2 3 4 9 3 3 2 3 4 9 3 3 2 3 4 9 3 3 4 14 4 11 2 3 4 14 4 11 2 3 4 14 4 11 2 3 47 3 2 5 4 13 23 15 5 3 47 2 2 15 6 10 2 15 2 3 2 15 2 3 10 19 2 7 6 10 10 19 2 7 2 3 10 19 2 7 2 3 4 10 10 34 2 12 4 9 2 24 1 3 4 12 2 27 6 11 4 12 2 27 2 4 4 12 2 27 2 4 47 2 10 23 2 12 2 3 4 10 10 34 2 9 1 3 4 13 10 34 2 17 4 4 4 9 2 24 1 3 4 12 2 27 6 11 4 12 2 27 2 4 47 2 10 23 2 12 2 3 4 10 10 34 2 9 1 3 4 13 10 34 2 17 4 4 4 13 10 34 2 17 4 4 4 9 2 24 1 3 4 12 2 27 6 11 47 2 4 11 2 7 2 7 2 6)f1b,f1,f1cblue;i,f1,f1cblue;i,f1,f1cmagenta;,f1,f1c200200124,f1,f1cblue;i,f1,f1cmagenta;,f1,f1c200200124,f1,f1cblue;i,f1,f1cmagenta;,f1,f1c200200124,f1,f1cmagenta;,f1,f1c200200124,f1,f1cblue;i,f1,f1cmagenta;,f1,f1c200200124,f1,f1cblue;i,f1,f1cmagenta;,f1,f1c200200124,f1,f1cblue;i,f1,f1c150048000,f1,f1cblue;i,f1,f1c200200124,f1,f1c200200124,f1,f1c200200124,f1,f1c150048000,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cblue;i,f1,f1cblue;i,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c200200124,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cblue;i,f1,f1c150048000,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c200200124,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c200200124,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c200200124,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cblue;i,f1,f1c150048000,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c200200124,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c200200124,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c200200124,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c200200124,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cmagenta;,f1,f1c150048000,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cblue;i,f1,f1cblue;i,f1! !

!ModuleToolTest methodsFor: 'tests' stamp: 'ab 7/7/2002 21:55'!
testUnreferencedSymbolForClass
	| cm r ma mb mc |
	self removes: {self path: 'a'. self path: 'b'. self path: 'c'}.
	ma _ self module: 'a'.
	mb _ self module: 'b'.
	mc _ self module: 'c'.
	self createClass: #A onModule: ma.
	self createClass: #B onModule: mb.
	self createClass: #C onModule: mc.
	"-------------------"
	"We compile two method for A"
	(ma at: #A)
		compile: 'foo
	A new. B new . C new.'
		classified: 'foo'.
	(ma at: #A)
		compile: 'bar
	ABCDEFG new.'
		classified: 'foo'.
	"-------------------"
	"We check if the methods are well compiled"
	self
		assert: ((ma at: #A)
				canUnderstand: #foo).
	cm _ (ma at: #A) methodDictionary at: #foo.
	self assert: cm literals size = 3.
	self assert: cm messages ~= 0.
	"-------------------"
	r _ ModuleTool new unreferencedSymbolForCompiledMethod: cm.
	self assert: r size = 3.
	self assert: (r at: #A)
			= ma.
	self assert: (r at: #B)
			= mb.
	self assert: (r at: #C)
			= mc.
	"-------------------"
	"We check if the methods are well compiled"
	self
		assert: ((ma at: #A)
				canUnderstand: #bar).
	cm _ (ma at: #A) methodDictionary at: #bar.
	self assert: cm literals size = 1.
	self assert: cm messages ~= 0.
	"-------------------"
	r _ ModuleTool new unreferencedSymbolForCompiledMethod: cm.
	self assert: r size = 1.
	self
		assert: (r keys includes: #ABCDEFG).
	"We cannot guess about the value of the association = Module @  
	#(InterimSmalltalk)"
	"-------------------"
	"We get unresolved references"
	r _ ModuleTool new
				unreferencedSymbolForClass: (ma at: #A).
	self assert: r notNil.
	self assert: r size = 4.
	self assert: (r at: #B) asString = 'A>>foo'.
	self assert: (r at: #C) asString = 'A>>foo'.
	self assert: (r at: #ABCDEFG) asString = 'A>>bar'.
	self assert: (r at: #Object) asString = 'A>><class creation>'.
	"-------------------"
	ma
		externalModule: mb
		alias: nil
		version: nil
		importNames: true.
	ma
		externalModule: Object module
		alias: nil
		version: nil
		importNames: true.
	r _ ModuleTool new
				unreferencedSymbolForClass: (ma at: #A).
	self assert: r notNil.
	self assert: r size = 2.
	self assert: (r at: #C) asString = 'A>>foo'.
	self assert: (r at: #ABCDEFG) asString = 'A>>bar'.
	"-------------------"
	ma
		externalModule: mc
		alias: nil
		version: nil
		importNames: true.
	r _ ModuleTool new
				unreferencedSymbolForClass: (ma at: #A).
	self assert: r notNil.
	self assert: r size = 1.
	self assert: (r at: #ABCDEFG) asString = 'A>>bar'.
	"-------------------"
	self removes: {ma path. mb path. mc path}!
]style[(30 3 14 4 4 11 4 7 3 2 4 7 3 2 4 7 3 4 2 3 4 9 3 3 2 3 4 9 3 3 2 3 4 9 3 3 4 14 2 11 2 3 4 14 2 11 2 3 4 14 2 11 2 3 52 3 2 5 2 13 28 15 5 4 2 5 2 13 19 15 5 3 66 2 4 13 2 5 2 21 4 4 2 4 2 5 2 23 4 3 4 9 2 17 1 3 4 9 2 13 1 3 21 2 1 3 10 42 2 3 4 9 1 8 1 3 4 10 1 5 2 7 2 3 4 10 1 5 2 7 2 3 4 10 1 5 2 7 2 3 66 2 4 13 2 5 2 21 4 4 2 4 2 5 2 23 4 3 4 9 2 17 1 3 4 9 2 13 1 3 21 2 1 3 10 42 2 3 4 9 1 8 1 3 4 12 1 16 8 4 141 2 1 3 10 38 2 5 2 4 4 9 1 10 4 9 1 12 4 10 1 5 2 13 8 3 4 10 1 5 2 13 8 3 4 10 1 5 8 13 8 3 4 10 1 5 7 13 1 19 1 3 21 2 2 19 2 10 3 12 3 16 4 3 2 42 3 12 3 16 4 3 1 3 10 38 2 5 2 4 4 9 1 10 4 9 1 8 1 3 4 10 1 5 2 13 8 3 4 10 1 5 8 13 8 3 21 2 2 19 2 10 3 12 3 16 4 3 1 3 10 38 2 5 2 4 4 9 1 10 4 9 1 8 1 3 4 10 1 5 8 13 8 3 21 2 4 11 2 7 2 7 2 6)f1b,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1c194194118,f1,f1cmagenta;,f1,f1c194194118,f1,f1cmagenta;,f1,f1c194194118,f1,f1cblue;i,f1,f1cmagenta;,f1,f1c194194118,f1,f1cblue;i,f1,f1cmagenta;,f1,f1c194194118,f1,f1cblue;i,f1,f1cmagenta;,f1,f1c194194118,f1,f1cmagenta;,f1,f1c194194118,f1,f1cblue;i,f1,f1cmagenta;,f1,f1c194194118,f1,f1cblue;i,f1,f1cmagenta;,f1,f1c194194118,f1,f1cblue;i,f1,f1c144042000,f1,f1cblue;i,f1,f1c194194118,f1,f1c194194118,f1,f1c194194118,f1,f1cblue;i,f1,f1c194194118,f1,f1c194194118,f1,f1c194194118,f1,f1c144042000,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c194194118,f1,f1c194194118,f1,f1cblue;i,f1,f1cblue;i,f1,f1c194194118,f1,f1c194194118,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c194194118,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c194194118,f1,f1c144042000,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c194194118,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c194194118,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c194194118,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c194194118,f1,f1cblue;i,f1,f1c144042000,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c194194118,f1,f1c194194118,f1,f1cblue;i,f1,f1cblue;i,f1,f1c194194118,f1,f1c194194118,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c194194118,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c194194118,f1,f1c144042000,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c194194118,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c194194118,f1,f1c144042000,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c194194118,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c194194118,f1,f1c194194118,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c194194118,f1,f1c194194118,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c194194118,f1,f1c194194118,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c194194118,f1,f1c194194118,f1,f1c194194118,f1,f1c144042000,f1,f1cblue;i,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c194194118,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c194194118,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c194194118,f1,f1c194194118,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c194194118,f1,f1c194194118,f1,f1c144042000,f1,f1cblue;i,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c194194118,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c194194118,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c194194118,f1,f1c194194118,f1,f1c144042000,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cblue;i,f1,f1cblue;i,f1! !

!ModuleToolTest methodsFor: 'tests' stamp: 'ab 7/5/2002 17:22'!
testUnreferencedSymbolForCompiledMethod
	| m cm r dict |
	m _ self module: 'a'.
	self createClass: #Dummy onModule: m.
	self createClass: #Bar onModule: m.
	self createClass: #Foo onModule: m.
	"-------------------"
	(m at: #Dummy)
		compile: 'foo
	Bar new. Dummy new . Foo new.'
		classified: 'foo'.
	"-------------------"
	self
		assert: ((m at: #Dummy)
				canUnderstand: #foo).
	cm _ (m at: #Dummy) methodDictionary at: #foo.
	self assert: cm literals size = 3.
	self assert: cm messages ~= 0.
	dict _ Dictionary new.
	cm literals
		do: [:a | dict add: a].
	self assert: dict size = 3.
	self
		assert: (dict keys includes: #Dummy).
	self
		assert: (dict keys includes: #Foo).
	self
		assert: (dict keys includes: #Bar).
	"-------------------"
	r _ ModuleTool new unreferencedSymbolForCompiledMethod: cm.
	self assert: r notNil.
	self assert: r size = 3.
	self
		assert: (r keys includes: #Dummy).
	self
		assert: (r keys includes: #Foo).
	self
		assert: (r keys includes: #Bar).
	"-------------------"
	self removes: {m path}!
]style[(39 3 12 4 1 3 4 9 3 3 4 14 6 11 1 3 4 14 4 11 1 3 4 14 4 11 1 3 21 3 1 5 6 13 36 15 5 3 21 2 4 13 1 5 6 21 4 4 2 4 1 5 6 23 4 3 4 9 2 17 1 3 4 9 2 13 1 3 4 3 10 7 2 17 3 2 4 6 1 4 4 9 4 8 1 3 4 12 4 16 6 4 4 12 4 16 4 4 4 12 4 16 4 4 21 2 1 3 10 42 2 3 4 9 1 10 4 9 1 8 1 3 4 12 1 16 6 4 4 12 1 16 4 4 4 12 1 16 4 4 21 2 4 11 1 6)f1b,f1,f1cblue;i,f1,f1cblue;i,f1,f1cmagenta;,f1,f1c186186110,f1,f1cmagenta;,f1,f1c186186110,f1,f1cblue;i,f1,f1cmagenta;,f1,f1c186186110,f1,f1cblue;i,f1,f1cmagenta;,f1,f1c186186110,f1,f1cblue;i,f1,f1c136034000,f1,f1cblue;i,f1,f1c186186110,f1,f1c186186110,f1,f1c186186110,f1,f1c136034000,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c186186110,f1,f1c186186110,f1,f1cblue;i,f1,f1cblue;i,f1,f1c186186110,f1,f1c186186110,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c186186110,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c186186110,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cred;,f1,f1cblue;i,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c186186110,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c186186110,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c186186110,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c186186110,f1,f1c136034000,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c186186110,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c186186110,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c186186110,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c186186110,f1,f1c136034000,f1,f1cmagenta;,f1,f1cblue;i,f1! !

!ModuleToolTest methodsFor: 'tests' stamp: 'ab 7/6/2002 21:56'!
testUpdateModuleWith
	| ma mc mb |
	ma _ self module: 'a'.
	mb _ self module: 'b'.
	mc _ self module: 'c'.
	self createClass: #Foo onModule: ma.
	self createClass: #Bar onModule: mb.
	self createClass: #Bar onModule: mc.
	"---------------------------------------------"
	(mb at: #Bar)
		compile: 'bar
	^ 10'
		classified: 'bar'.
	(mc at: #Bar)
		compile: 'bar
	^ 20'
		classified: 'bar'.
	"---------------------------------------------"
	(ma at: #Foo)
		compile: 'foo
	^ Bar new bar'
		classified: 'foo'.
	"---------------------------------------------"
	ModuleTool new updateModule: ma with: mb.
	self assert: ((ma at: #Foo) new perform: #foo) = 10. 
	"---------------------------------------------"
	ModuleTool new updateModule: ma with: mc.
	self assert: ((ma at: #Foo) new perform: #foo) = 20. 
	"---------------------------------------------"
	self removes: {ma path . mb path . mc path}! !


!ModuleToolTest reorganize!
('helper methods' createClass:onModule: module: path: removes:)
('tests' testChangeAssociationInCompiledMethodFor testExternalSymbol testIntersectionDefinedNamesBetween testIntersectionDefinedNamesBetweenBUG testRemoveDependency testUnreferencedSymbolForClass testUnreferencedSymbolForCompiledMethod testUpdateModuleWith)
!

