'From Squeak3.3alpha of 30 January 2002 [latest update: #4889] on 9 July 2002 at 11:36:36 am'!
TestCase subclass: #SimpleTestModule
	instanceVariableNames: ''
	classVariableNames: ''
	module: #(Squeak Language Modules Tests)!

!Module methodsFor: 'changing defined names' stamp: 'ab 7/6/2002 21:18'!
validateName: aString forValue: anObject 
	"Validate the name for a new binding"
	| oldAssoc |
	aString first isUppercase
		ifFalse: [self error: 'The name must be capitalized'.
			^ false].
	oldAssoc _ self
				localAssocFor: aString
				ifAbsent: [].
	oldAssoc
		ifNil: ["check if name already used in a different module"
			(Module root moduleDefining: aString)
				ifNotNilDo: [:defModule | "self notify: ('The name ' , aString asText allBold , ' is already defined in module ' , defModule pathAsMessages , '.\Proceed will create a second definition with this name in module ' , self pathAsMessages , '.') withCRs"]]
		ifNotNil: ["don't protest if e.g. the new value is a new class and the old 
			value was a class too"
			(oldAssoc value isKindOf: anObject class)
				ifFalse: [self notify: 'The name ' , aString asText allBold , ' is already used in module ' , self pathAsMessages , '!!\Proceed will store over it.' withCRs]].
	^ true!
]style[(14 7 11 8 3 37 3 9 4 7 31 4 8 30 7 5 4 8 3 4 20 7 20 8 11 50 5 6 22 7 19 11 3 4 10 11 3 7 18 32 3 9 18 69 3 4 18 3 26 90 5 8 17 8 22 4 9 11 3 7 18 29 3 4 18 31 15 4)f1b,f1cblue;b,f1b,f1cblue;b,f1,f1c138036000,f1,f1cblue;i,f1,f1cblue;i,f1,f1cmagenta;,f1,f1c188188112,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cblue;i,f1,f1c138036000,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cred;,f1,f1cmagenta;,f1,f1c188188112,f1,f1cblue;i,f1,f1c188188112,f1,f1cblue;i,f1,f1c188188112,f1,f1cmagenta;,f1,f1c188188112,f1,f1c138036000,f1,f1cblue;i,f1,f1cblue;i,f1,f1cmagenta;,f1,f1c188188112,f1,f1cblue;i,f1,f1c188188112,f1,f1cmagenta;,f1,f1c188188112,f1,f1cmagenta;! !

!Module methodsFor: 'module composition' stamp: 'ab 7/5/2002 18:38'!
importModule: aModule 
	"Take the given module and make it a prerequsite of mine"
	(self == aModule
			or: [self hasNeighborModule: aModule])
		ifFalse: [self
				externalModule: aModule
				alias: nil
				version: aModule version
				importNames: true]! !

!Module methodsFor: 'module composition' stamp: 'ab 7/7/2002 22:37'!
importName: varName interactive: aBool 
	"Import the given symbol."
	| definers choice import varAssoc |
	self
		definesName: varName
		usingScheme: #lenient
		ifTrue: [:a | varAssoc _ a].
	varAssoc
		ifNil: [^ nil].
	definers _ Module root modulesDefining: varAssoc key.
	definers _ definers
				reject: [:x | x isKindOf: Module].
	definers _ definers keys asArray.
	definers _ definers
				reject: [:x | x isDeltaModule].
	definers _ definers
				sort: [:m1 :m2 | m1 asString <= m2 asString].
	definers size > 1
		ifTrue: [aBool
				ifFalse: [^ nil].
			"Ambigous choice"
			choice _ PopUpMenu
						withCaption: varAssoc key , 'is defined in multiple modules.
Please choose the one you wish to use'
						chooseFrom: (definers
								collect: [:m | m asString]).
			choice = 0
				ifTrue: [^ nil].
			import _ definers at: choice]
		ifFalse: [import _ definers first].
	(import path = #(InterimSmalltalk )) ifTrue: [Transcript show: 'WARNING : ', varName asString, ' is refered !!';cr].
	self importModule: import.
	^ import
		localAssocFor: varAssoc key
		ifAbsent: []! !

!Module methodsFor: 'module composition' stamp: 'ab 7/6/2002 20:02'!
importNameForModule: aModule 
	(self refForNeighborModule: aModule) importNames: true! !

!Module methodsFor: 'code analysis' stamp: 'ab 7/5/2002 18:13'!
localUnresolvedRefsWithScheme: bindingScheme 
	"check that all used globals (global literals in CompiledMethods) will be  
	bound to the exact same association object if recompiled (this is stronger 
	than just the same name or value). Return the bad ones as  
	MethodReferences."
	| badRefs isBad isUninterestingClass classAndMeta theSuperClass isOK assocForSuperClassName isCorrectlyDeclared |
	badRefs _ OrderedCollection new.
	self resetOutOfScopeCache.
	self
		allClassesDo: [:c | 
			classAndMeta _ {c. (c isKindOf: DeltaClass)
						ifTrue: [c deltaForMetaclass]
						ifFalse: [c class]}.
			classAndMeta
				do: [:class | class methodDict
						keysAndValuesDo: [:selector :cm | 
							isBad _ cm ~~ DeltaModule valueForUndefined
										and: [cm literals
												anySatisfy: [:lit | lit isVariableBinding
														and: [lit key notNil]
														and: [((c
																	definesName: lit key
																	lookInSuper: true
																	ifTrue: [:a | a])
																or: [self
																		doesLookupOf: lit key
																		withScheme: bindingScheme
																		giveTheAssoc: lit
																		useCache: OutOfScopeCache]) not]]].
							isBad
								ifTrue: [badRefs
										add: (MethodReference new setStandardClass: class methodSymbol: selector)]]]].
	self
		allClassesDo: [:class | 
			theSuperClass _ class superclass.
			isUninterestingClass _ class isObsolete | theSuperClass isNil.
			isUninterestingClass
				ifFalse: [assocForSuperClassName _ theSuperClass module
								localAssocFor: theSuperClass name
								ifAbsent: [].
					isCorrectlyDeclared _ self
								doesLookupOf: theSuperClass name
								withScheme: bindingScheme
								giveTheAssoc: assocForSuperClassName
								useCache: OutOfScopeCache].
			isOK _ isUninterestingClass
						or: [isCorrectlyDeclared].
			isOK
				ifFalse: [badRefs
						add: (MethodReference new setStandardClass: class methodSymbol: #'<classCreation>')]].
	^ badRefs! !


!SimpleTestModule methodsFor: 'tests' stamp: 'ab 6/27/2002 15:36'!
testAccessRemoteReference
	"The scenario of this test is to create two module, m1 and m2.  
	First contains a class Foo which refers (from a method foo) a class Bar  
	defined in m2"
	"First we check dependencies missing (between m1 and m2, and between  
	m1 and 'Class module')"
	"Then we resolve dependencies"
	| m1 m2 r ref |
	self deleteIfExistsModule1.
	self deleteIfExistsModule2.
	m1 _ self createModule1.
	m2 _ self createModule2.
	self createDummyClassForModule: m1.
	self createDummy2ClassForModule: m2.
	"method foo refer Bar"
	(m1 at: self dummyClassName)
		compile: self methodSourceFoo
		classified: 'foo'.
	(m1 at: self dummyClassName)
		compile: self methodSourceWithoutAnyReference
		classified: 'bar'.
	(m2 at: self dummy2ClassName)
		compile: self methodSourceBar
		classified: 'bar'.
	"We test if the method is correctly defined, this assertion is not related to 
	the module"
	self assert: ((m1 at: self dummyClassName) new perform: #foo)
			= 10.
	"We get all the references unresolved"
	r _ m1 deepUnresolvedRefs.
	"We get a dictionary with the module m1 as an unique entry"
	self assert: r size = 1.
	r _ r at: m1.
	"Two things are unresolved with the module m1  
	- dependencies with the module of superclass  
	- Dependencies of the foo method (which refer to Bar)"
	self assert: r size = 2.
	self assert: (r at: 1) asString = 'MyDummyClass>>foo'.
	self assert: (r at: 2) asString = 'MyDummyClass>><classCreation>'.
	"--------------"
	"As expected, there is some reference unresolved, now we will add  
	dependencies for resolve them"
	"m1 need to refer to m2, and to 'Class module' (for the superclass)"
	m1
		externalModule: Class module
		alias: nil
		version: nil
		importNames: true.
	"Now, there is only one ref unresolved"
	r _ m1 deepUnresolvedRefs.
	self assert: r size = 1.
	r _ r at: m1.
	self assert: r size = 1.
	self assert: (r at: 1) asString = 'MyDummyClass>>foo'.
	"--------------"
	"We add the dependencie with m2"
	m1
		externalModule: m2
		alias: nil
		version: nil
		importNames: true.
	"Now, there is no more ref unresolved"
	r _ m1 deepUnresolvedRefs.
	self assert: r size = 0.

	"--------------"
	"We test now m1 import two modules"
	ref _ m1 refForNeighborModule: m2.
	ref importNames: true.
	r _ m1 importedModules.
	self assert: r size = 2.
	self
		assert: (r includes: m2).
	self
		assert: (r includes: Class module).
	"--------------"
	"We test now m1 import two modules"
	ref _ m1 refForNeighborModule: m2.
	ref importNames: false.
	r _ m1 importedModules.
	self assert: r size = 1.
	self
		assert: (r includes: Class module).
	"--------------"
	self deleteModule1.
	self deleteModule2! !

!SimpleTestModule methodsFor: 'tests' stamp: 'ab 7/6/2002 20:46'!
testAccessRemoteReference2
	| m1 m2 m11 r |
	self deleteIfExistsModule1.
	self deleteIfExistsModule11.
	self deleteIfExistsModule2.
	m1 _ self createModule1.
	m11 _ self createModule11.
	m2 _ self createModule2.
	self createDummyClassForModule: m1.
	self createDummy3ClassForModule: m11.
	self createDummy2ClassForModule: m2.
	"------------------"
	(m2 at: self dummy2ClassName)
		compile: 'foo1
	MyDummyClass new'
		classified: 'foo'.
	(m2 at: self dummy2ClassName)
		compile: 'foo2
	MyDummyClass2 new'
		classified: 'foo'.
	(m2 at: self dummy2ClassName)
		compile: 'foo3
	MyDummy3Class new.'
		classified: 'foo'.
	self
		assert: ((m2 at: self dummy2ClassName)
				canUnderstand: #foo1).
	self
		assert: ((m2 at: self dummy2ClassName)
				canUnderstand: #foo2).
	self
		assert: ((m2 at: self dummy2ClassName)
				canUnderstand: #foo3).
	"------------------"
	"There is no dependency, so we have a lot of reference unresolved"
	r _ m2 deepUnresolvedRefs at: m2.
	self assert: r size = 3.
	self assert: (r at: 1) asString = 'MyDummyClass2>>foo3'.
	self assert: (r at: 2) asString = 'MyDummyClass2>>foo1'.
	self assert: (r at: 3) asString = 'MyDummyClass2>><classCreation>'.
	"------------------"
	m2
		externalModule: Class module
		alias: nil
		version: nil
		importNames: true.
	r _ m2 deepUnresolvedRefs at: m2.
	self assert: r size = 2.
	self assert: (r at: 1) asString = 'MyDummyClass2>>foo3'.
	self assert: (r at: 2) asString = 'MyDummyClass2>>foo1'.
	"------------------"
	m2
		externalModule: m1
		alias: nil
		version: nil
		importNames: true.
	r _ m2 deepUnresolvedRefs at: m2.
	self assert: r size = 1.
	self assert: (r at: 1) asString = 'MyDummyClass2>>foo3'.
	"------------------"
	m2
		externalModule: m11
		alias: nil
		version: nil
		importNames: true.
	r _ m2 deepUnresolvedRefs.
	self assert: r size = 0.
	"------------------"
	"self deleteModule11."
	self deleteModule1.
	self deleteModule2!
]style[(26 3 12 4 4 25 4 26 4 25 2 3 4 17 3 3 4 18 2 3 4 17 4 28 2 3 4 29 3 3 4 29 2 3 20 3 2 5 4 29 24 15 5 4 2 5 4 29 25 15 5 4 2 5 4 29 26 15 5 3 4 13 2 5 4 37 5 4 4 13 2 5 4 37 5 4 4 13 2 5 4 37 5 4 88 2 1 3 2 24 2 3 4 9 1 8 1 3 4 10 1 5 1 13 21 3 4 10 1 5 1 13 21 3 4 10 1 5 1 13 32 3 20 2 2 19 5 17 3 12 3 16 4 3 1 3 2 24 2 3 4 9 1 8 1 3 4 10 1 5 1 13 21 3 4 10 1 5 1 13 21 3 20 2 2 19 2 10 3 12 3 16 4 3 1 3 2 24 2 3 4 9 1 8 1 3 4 10 1 5 1 13 21 3 20 2 2 19 3 10 3 12 3 16 4 3 1 3 2 22 4 9 1 8 1 3 44 2 4 17 4 14)f1b,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c150048000,f1,f1cblue;i,f1,f1cmagenta;,f1,f1c200200124,f1,f1c200200124,f1,f1cblue;i,f1,f1cmagenta;,f1,f1c200200124,f1,f1c200200124,f1,f1cblue;i,f1,f1cmagenta;,f1,f1c200200124,f1,f1c200200124,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cmagenta;,f1,f1c200200124,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cmagenta;,f1,f1c200200124,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cmagenta;,f1,f1c200200124,f1,f1c150048000,f1,f1cblue;i,f1,f1cblue;i,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c200200124,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c200200124,f1,f1c200200124,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c200200124,f1,f1c200200124,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c200200124,f1,f1c200200124,f1,f1c150048000,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cblue;i,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c200200124,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c200200124,f1,f1c200200124,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c200200124,f1,f1c200200124,f1,f1c150048000,f1,f1cblue;i,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cblue;i,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c200200124,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c200200124,f1,f1c200200124,f1,f1c150048000,f1,f1cblue;i,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c200200124,f1,f1c150048000,f1,f1cmagenta;,f1,f1cmagenta;,f1! !

!SimpleTestModule methodsFor: 'tests' stamp: 'ab 6/27/2002 15:39'!
testAccessRemoteReferenceBUG
	"The scenario of this test is to create two module, m1 and m2.  
	First contains a class Foo which refers (from a method foo) a class Bar  
	defined in m2"
	"First we check dependencies missing (between m1 and m2, and between  
	m1 and 'Class module')"
	"Then we resolve dependencies"
	| m1 m2 r ref |
	self deleteIfExistsModule1.
	self deleteIfExistsModule2.
	m1 _ self createModule1.
	m2 _ self createModule2.
	self createDummyClassForModule: m1.
	self createDummy2ClassForModule: m2.
	"method foo refer Bar"
	(m1 at: self dummyClassName)
		compile: self methodSourceFoo
		classified: 'foo'.
	(m1 at: self dummyClassName)
		compile: self methodSourceWithoutAnyReference
		classified: 'bar'.
	(m2 at: self dummy2ClassName)
		compile: self methodSourceBar
		classified: 'bar'.
	"We test if the method is correctly defined, this assertion is not related to 
	the module"
	self assert: ((m1 at: self dummyClassName) new perform: #foo)
			= 10.
	"We get all the references unresolved"
	r _ m1 deepUnresolvedRefs.
	"We get a dictionary with the module m1 as an unique entry"
	self assert: r size = 1.
	r _ r at: m1.
	"Two things are unresolved with the module m1  
	- dependencies with the module of superclass  
	- Dependencies of the foo method (which refer to Bar)"
	self assert: r size = 2.
	self assert: (r at: 1) asString = 'MyDummyClass>>foo'.
	self assert: (r at: 2) asString = 'MyDummyClass>><classCreation>'.
	"--------------"
	"As expected, there is some reference unresolved, now we will add  
	dependencies for resolve them"
	"m1 need to refer to m2, and to 'Class module' (for the superclass)"
	m1
		externalModule: Class module
		alias: nil
		version: nil
		importNames: true.
	"Now, there is only one ref unresolved"
	r _ m1 deepUnresolvedRefs.
	self assert: r size = 1.
	r _ r at: m1.
	self assert: r size = 1.
	self assert: (r at: 1) asString = 'MyDummyClass>>foo'.
	"--------------"
	"We add the dependencie with m2"
	m1
		externalModule: m2
		alias: nil
		version: nil
		importNames: true.
	"Now, there is no more ref unresolved"
	r _ m1 deepUnresolvedRefs.
	self assert: r size = 0.
	"--------------"
	"We get a reference between m1 and m2"
	ref _ m1 refForNeighborModule: m2.
	"We have changed nothing, so, there is no unresolved reference"
	r _ m1 deepUnresolvedRefs.
	self assert: r size = 0.
	ref importNames: false.
	"We should have some unresolved references : Bar is referenced into foo method,
	but we do not import names"
	(m1 at: self dummyClassName)
		compile: self methodSourceFoo
		classified: 'foo'.
	r _ m1 deepUnresolvedRefs.
	self assert: r size = 1.
	"--------------"
	self deleteModule1.
	self deleteModule2! !

!SimpleTestModule methodsFor: 'tests' stamp: 'ab 6/27/2002 15:45'!
testAccessRemoteReferenceBUG2
	| m1 m2 r ref |
	self deleteIfExistsModule1.
	self deleteIfExistsModule2.
	m1 _ self createModule1.
	m2 _ self createModule2.
	self createDummyClassForModule: m1.
	self createDummy2ClassForModule: m2.
	"method foo refer Bar"
	(m1 at: self dummyClassName)
		compile: self methodSourceFoo
		classified: 'foo'.
	(m1 at: self dummyClassName)
		compile: self methodSourceWithoutAnyReference
		classified: 'bar'.
	(m2 at: self dummy2ClassName)
		compile: self methodSourceBar
		classified: 'bar'.
	"We test if the method is correctly defined, this assertion is not related to 
	the module"
	self assert: ((m1 at: self dummyClassName) new perform: #foo)
			= 10.
	"We get all the references unresolved"
	r _ m1 deepUnresolvedRefs.
	"We get a dictionary with the module m1 as an unique entry"
	self assert: r size = 1.
	r _ r at: m1.
	"Two things are unresolved with the module m1  
	- dependencies with the module of superclass  
	- Dependencies of the foo method (which refer to Bar)"
	self assert: r size = 2.
	self assert: (r at: 1) asString = 'MyDummyClass>>foo'.
	self assert: (r at: 2) asString = 'MyDummyClass>><classCreation>'.
	"--------------"
	"As expected, there is some reference unresolved, now we will add  
	dependencies for resolve them"
	"m1 need to refer to m2, and to 'Class module' (for the superclass)"
	m1
		externalModule: Class module
		alias: nil
		version: nil
		importNames: true.
	"Now, there is only one ref unresolved"
	r _ m1 deepUnresolvedRefs.
	self assert: r size = 1.
	r _ r at: m1.
	self assert: r size = 1.
	self assert: (r at: 1) asString = 'MyDummyClass>>foo'.
	"--------------"
	ref _ m1 refForNeighborModule: Class module.
	ref importNames: false.
	"Now, there is only one ref unresolved"
	r _ m1 deepUnresolvedRefs.
	self assert: r size = 1.
	r _ r at: m1.
	self assert: r size = 2.
	self assert: (r at: 1) asString = 'MyDummyClass>>foo'.
	self assert: (r at: 2) asString = 'MyDummyClass>><classCreation>'.
	ref importNames: true.
	"--------------"
	self deleteModule1.
	self deleteModule2! !

!SimpleTestModule methodsFor: 'tests' stamp: 'ab 7/5/2002 16:14'!
testAccessRemoteReferenceWithExport
	| m1 m2 |
	self deleteIfExistsModule1.
	self deleteIfExistsModule2.
	m1 _ self createModule1.
	m2 _ self createModule2.
	self createDummyClassForModule: m1.
	"--------------"
	"method foo refer Bar"
	(m1 at: self dummyClassName)
		compile: self methodSourceFoo2
		classified: 'refer to bar'.
	"Into the methodSourceFoo2 method, there is a reference to Bar, but it is  
	defined nowhere,  
	the compiler do not cry for that, and simply put nil for the missing  
	reference"
	self assert: ((m1 at: self dummyClassName) new perform: #foo)
			= nil.
	"--------------"
	m1
		externalModule: m2
		alias: nil
		version: nil
		importNames: true.
	m2
		addAssoc: (Association key: #Bar value: 'ABC')
		export: false.
	(m1 at: self dummyClassName)
		compile: self methodSourceFoo2
		classified: 'refer to bar'.
	"Still nil because we do not have exported the #Bar association"
	self assert: ((m1 at: self dummyClassName) new perform: #foo)
			= nil.
	"--------------"
	m2 exportName: #Bar.
	(m1 at: self dummyClassName) 
	removeSelector: #foo. 
	(m1 at: self dummyClassName) 
	compile: self methodSourceFoo2 
	classified: 'refer to bar'.
	self assert: ((m1 at: self dummyClassName) new perform: #foo)
			= 'ABC'.
	"--------------"
	self deleteModule1.
	self deleteModule2! !

!SimpleTestModule methodsFor: 'tests' stamp: 'ab 6/25/2002 12:40'!
testDeepUnresolvedRefs
	| m1 m2 r |
	self deleteIfExistsModule1.
	self deleteIfExistsModule2.
	m1 _ self createModule1.
	m2 _ self createModule2.
	self createDummyClassForModule: m1.
	self createDummy2ClassForModule: m2.
	"method foo refer Bar"
	(m1 at: self dummyClassName)
		compile: self methodSourceFoo
		classified: 'foo'.
	(m1 at: self dummyClassName)
		compile: self methodSourceWithoutAnyReference
		classified: 'bar'.
	(m2 at: self dummy2ClassName)
		compile: self methodSourceBar
		classified: 'bar'.
	"We test if the method is correctly defined, this assertion is not related to 
	the module"
	self assert: ((m1 at: self dummyClassName) new perform: #foo)
			= 10.
	"We get all the references unresolved"
	r _ m1 deepUnresolvedRefs.
	"We get a dictionary for the module m1"
	self assert: r size = 1.
	r _ r at: m1.
	"Two things are unresolved with the module m1  
	- dependencies with the module of superclass  
	- Dependencies of the foo method (which refer to Bar)"
	self assert: r size = 2.
	self assert: (r at: 1) asString = 'MyDummyClass>>foo'.
	self assert: (r at: 2) asString = 'MyDummyClass>><classCreation>'.
	self deleteModule1.
	self deleteModule2! !

!SimpleTestModule methodsFor: 'tests' stamp: 'ab 6/24/2002 12:16'!
testDefinedNames
	| m r |
	self deleteIfExistsModule1.
	m _ self createModule1.
	m
		addAssoc: (Association key: #foo value: 'Foo')
		export: false.
	m
		addAssoc: (Association key: #bar value: #Bar)
		export: false.
	r _ m definedNames.
	self assert: r size = 2.
	self assert: (r at: #foo)
			= 'Foo'.
	self assert: (r at: #bar)
			= #Bar.
	self deleteModule1.! !

!SimpleTestModule methodsFor: 'tests' stamp: 'ab 6/24/2002 13:44'!
testDefinedNames2
	| m r |
	self deleteIfExistsModule1.
	m _ self createModule1.
	self createDummyClassForModule: m.
	r _ m definedNames.
	self assert: r size = 1.
	self assert: ((r at: self dummyClassName) isKindOf: Behavior).
	self assert: ((r at: self dummyClassName) name =  self dummyClassName).
	self deleteModule1! !

!SimpleTestModule methodsFor: 'tests' stamp: 'ab 7/3/2002 13:38'!
testDefinedNames3
	| m1 m2 |
	self deleteIfExistsModule1.
	self deleteIfExistsModule2.
	m1 _ self createModule1.
	m2 _ self createModule2.
	self createDummyClassForModule: m1.
	self createDummy2ClassForModule: m2.
	"------------------"
	(m1 at: self dummyClassName)
		compile: self methodSourceFoo
		classified: 'foo'.
	self
		assert: ((m1 at: self dummyClassName)
				canUnderstand: #foo).
	"------------------"
	self
		assert: (m1
				definesName: self dummy2ClassName
				usingScheme: #lenient
				ifTrue: [:assoc | true]).
	"------------------"
	self assert: (m1
			definesName: self dummy2ClassName
			usingScheme: #strong
			ifTrue: [:assoc | true]) not.
	"------------------"
	self deleteModule1.
	self deleteModule2! !

!SimpleTestModule methodsFor: 'tests' stamp: 'ab 7/3/2002 12:47'!
testDefinesNameLookInSuperIfTrue
	"method defined in the class Class"
	| m |
	self deleteIfExistsModule1.
	m _ self createModule1.
	Object
		subclass: #FooBar
		instanceVariableNames: 'var1 var2'
		classVariableNames: 'ClsVar1'
		module: m.
	"-----------------------"
	"Some simple test"
	self
		assert: (m definedNames keys includes: #FooBar).
	self
		assert: ((m at: #FooBar)
				isKindOf: Class).
	self assert: (m at: #FooBar) name = #FooBar.
	self assert: (m at: #FooBar) module = m.
	"-----------------------"
	"specific tests"
	self assert: ((m at: #FooBar)
			definesName: #var1
			lookInSuper: false
			ifTrue: [:assoc | 
		
				true]) not.
	self assert: ((m at: #FooBar)
			definesName: #var2
			lookInSuper: false
			ifTrue: [:assoc | 
			
				true]) not.
	self assert: ((m at: #FooBar)
			definesName: #ClsVar1
			lookInSuper: false
			ifTrue: [:assoc | 
			
				true]).
	"-----------------------"
	self deleteModule1! !

!SimpleTestModule methodsFor: 'tests' stamp: 'ab 6/26/2002 21:45'!
testDeltaModules
	| m1 m2 dm12 dcls12 method |
	self deleteIfExistsModule1.
	self deleteIfExistsModule1.
	m1 _ self createModule1.
	m2 _ self createModule2.
	self createDummyClassForModule: m1.
	self createDummy2ClassForModule: m2.
	(m2 at: self dummy2ClassName)
		compile: 'foo
^10'
		classified: 'bar'.
	self assert: ((m2 at: self dummy2ClassName) new perform: #foo)
			= 10.
	"-------------"
	"When we create empty modules, there is no delta modules"
	self assert: m1 deltaModules size = 0.
	self assert: m2 deltaModules size = 0.
	"-------------"
	"We create an empty delta module"
	dm12 _ m1
				deltaModuleForBase: m2
				forceCreate: true
				asActive: true.
	self assert: dm12 baseModule = m2.
	self assert: dm12 parentModule = m1.
	"-------------"
	"Because the delta module is active, it defines all values of the base  
	modules"
	self assert: dm12 isActive.
	self assert: dm12 definedNames size = m2 definedNames size.
	self
		assert: (dm12 definedNames includesAllOf: m2 definedNames).
	self assert: m1 deltaModules size = 1.
	self
		assert: (m1 deltaModules includes: dm12).
	"-------------"
	dm12 markAsActive: true.
	"We define DeltaClass between module 1 and 2"
	dcls12 _ dm12
				deltaClassFor: (m2 at: self dummy2ClassName)
				forceCreate: true.
	self assert: dcls12 baseClass
			= (m2 at: self dummy2ClassName).
	method _ (m2 at: self dummy2ClassName)
				compiledMethodAt: #foo.
	dcls12 addSelector: #foo withMethod: method.
	self assert: ((m2 at: self dummy2ClassName) new perform: #foo)
			= 10.
	"-------------"
	"We desactive the Delta module"
	dm12 simplyEffectChanges: false.
	self assert: ((m2 at: self dummy2ClassName)
			canUnderstand: #foo) not.
	"-------------"
	"Bug : cf testDeltaModulesBUG"
	"We reactive the Delta module"
	"dm12 simplyEffectChanges: true.
	self
		assert: ((m2 at: self dummy2ClassName)
				canUnderstand: #foo)."
	"-------------"
	self deleteModule1.
	self deleteModule2! !

!SimpleTestModule methodsFor: 'tests' stamp: 'ab 6/27/2002 17:00'!
testDeltaModulesBUG
	| m1 m2 dm12 dcls12 method |
	self deleteIfExistsModule1.
	self deleteIfExistsModule1.
	m1 _ self createModule1.
	m2 _ self createModule2.
	self createDummyClassForModule: m1.
	self createDummy2ClassForModule: m2.
	(m2 at: self dummy2ClassName)
		compile: 'foo
^10'
		classified: 'bar'.
	self assert: ((m2 at: self dummy2ClassName) new perform: #foo)
			= 10.
	"-------------"
	"When we create empty modules, there is no delta modules"
	self assert: m1 deltaModules size = 0.
	self assert: m2 deltaModules size = 0.
	"-------------"
	"We create an empty delta module"
	dm12 _ m1
				deltaModuleForBase: m2
				forceCreate: true
				asActive: true.
	self assert: dm12 baseModule = m2.
	self assert: dm12 parentModule = m1.
	"-------------"
	"Because the delta module is active, it defines all values of the base  
	modules"
	self assert: dm12 isActive.
	self assert: dm12 definedNames size = m2 definedNames size.
	self
		assert: (dm12 definedNames includesAllOf: m2 definedNames).
	self assert: m1 deltaModules size = 1.
	self
		assert: (m1 deltaModules includes: dm12).
	"-------------"
	dm12 markAsActive: true.
	"We define DeltaClass between module 1 and 2"
	dcls12 _ dm12
				deltaClassFor: (m2 at: self dummy2ClassName)
				forceCreate: true.
	self assert: dcls12 baseClass
			= (m2 at: self dummy2ClassName).
	method _ (m2 at: self dummy2ClassName)
				compiledMethodAt: #foo.
	dcls12 addSelector: #foo withMethod: method.
	self assert: ((m2 at: self dummy2ClassName) new perform: #foo)
			= 10.
	"-------------"
	"We desactive the Delta module"
	dm12 simplyEffectChanges: false.
	self assert: ((m2 at: self dummy2ClassName)
			canUnderstand: #foo) not.
	"-------------"
	"We reactive the Delta module"
	"dm12 simplyEffectChanges: true."
	dm12 objectsBeforeAndAfter: true.
	self
		assert: ((m2 at: self dummy2ClassName)
				canUnderstand: #foo).
	"-------------"
	"We reactive the Delta module"
	"dm12 simplyEffectChanges: false."
	dm12 objectsBeforeAndAfter: false.
	"dm12 effectMethodChangesConservatively: true."
	self assert: ((m2 at: self dummy2ClassName)
			canUnderstand: #foo) not.
	"-------------"
	self deleteModule1.
	self deleteModule2! !

!SimpleTestModule methodsFor: 'tests' stamp: 'ab 7/6/2002 21:28'!
testDynamicDependency
	| m1 m2 m3 m4 |
	self
		deleteIfExistsModuleFromPath: (self path: 'a').
	self
		deleteIfExistsModuleFromPath: (self path: 'b').
	self
		deleteIfExistsModuleFromPath: (self path: 'c').
	self
		deleteIfExistsModuleFromPath: (self path: 'd').
	m1 _ self createModule: 'a'.
	m2 _ self createModule: 'b'.
	m3 _ self createModule: 'c'.
	m4 _ self createModule: 'd'.
	self createClassNamed: #Foo ForModule: m1.
	self createClassNamed: #Foo ForModule: m4.
	self createClassNamed: #Bar ForModule: m2.
	self createClassNamed: #Bar ForModule: m3.
	"--------------"
	(m2 at: #Bar)
		compile: 'bar
	^10'
		classified: 'bar'.
	(m3 at: #Bar)
		compile: 'bar
	^20'
		classified: 'bar'.
	"--------------"
	"We set dependencies"
	m1 importModule: m2.
	self
		assert: (m1 importedModules includes: m2).
	"--------------"
	"method foo refer Bar"
	(m1 at: #Foo)
		compile: 'foo
	^ Bar new bar'
		classified: 'foo'.
	"--------------"
	self assert: ((m1 at: #Foo) new perform: #foo)
			= 10.
	"--------------"
	"We set dependencies"
	m4 importModule: m3.
	self
		assert: (m4 importedModules includes: m3).
	"--------------"
	"method foo refer Bar"
	(m4 at: #Foo)
		compile: 'foo
	^ Bar new bar'
		classified: 'foo'.
	"--------------"
	self assert: ((m4 at: #Foo) new perform: #foo)
			= 20.
	"--------------"
	self
		deleteIfExistsModuleFromPath: (self path: 'a').
	self
		deleteIfExistsModuleFromPath: (self path: 'b').
	self
		deleteIfExistsModuleFromPath: (self path: 'c')! !

!SimpleTestModule methodsFor: 'tests' stamp: 'ab 7/9/2002 11:35'!
testDynamicDependencyChanged
	"Wrong test, need to be redefined"
	| m1 m2 m3 |
	self
		deleteIfExistsModuleFromPath: (self path: 'a').
	self
		deleteIfExistsModuleFromPath: (self path: 'b').
	self
		deleteIfExistsModuleFromPath: (self path: 'c').
	m1 _ self createModule: 'a'.
	m2 _ self createModule: 'b'.
	m3 _ self createModule: 'c'.
	self createClassNamed: #Foo ForModule: m1.
	self createClassNamed: #Bar ForModule: m2.
	self createClassNamed: #Bar ForModule: m3.
	"--------------"
	(m2 at: #Bar)
		compile: 'bar
	^10'
		classified: 'bar'.
	(m3 at: #Bar)
		compile: 'bar
	^20'
		classified: 'bar'.
	"--------------"
	"We set dependencies"
	m1 importModule: m2.
	self
		assert: (m1 importedModules includes: m2).
	"--------------"
	"method foo refer Bar"
	(m1 at: #Foo)
		compile: 'foo
	^ Bar new bar'
		classified: 'foo'.
	"--------------"
	self assert: ((m1 at: #Foo) new perform: #foo)
			= 10.
	"--------------"
	m1 importModule: m3.
	self
		assert: (m1 importedModules includes: m3).
	"--------------"
	"method foo refer Bar"
	(m1 at: #Foo)
		compile: 'foo
	^ Bar new bar'
		classified: 'foo'.
	"--------------"
	self assert: ((m1 at: #Foo) new perform: #foo)
			= 20.
	"--------------"
	self
		deleteIfExistsModuleFromPath: (self path: 'a').
	self
		deleteIfExistsModuleFromPath: (self path: 'b').
	self
		deleteIfExistsModuleFromPath: (self path: 'c')!
]style[(64 3 9 4 4 34 4 7 3 4 4 34 4 7 3 4 4 34 4 7 3 4 2 3 4 15 3 3 2 3 4 15 3 3 2 3 4 15 3 3 4 19 4 12 2 3 4 19 4 12 2 3 4 19 4 12 2 3 16 3 2 5 4 13 10 15 5 4 2 5 4 13 10 15 5 3 39 2 2 15 2 3 4 12 2 27 2 4 40 3 2 5 4 13 20 15 5 3 16 2 4 11 2 5 4 15 4 7 2 3 16 2 2 15 2 3 4 12 2 27 2 4 40 3 2 5 4 13 20 15 5 3 16 2 4 11 2 5 4 15 4 7 2 3 16 2 4 34 4 7 3 4 4 34 4 7 3 4 4 34 4 7 3 1)f1b,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1c202202126,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1c202202126,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1c202202126,f1,f1cblue;i,f1,f1cmagenta;,f1,f1c202202126,f1,f1cblue;i,f1,f1cmagenta;,f1,f1c202202126,f1,f1cblue;i,f1,f1cmagenta;,f1,f1c202202126,f1,f1cmagenta;,f1,f1c202202126,f1,f1cblue;i,f1,f1cmagenta;,f1,f1c202202126,f1,f1cblue;i,f1,f1cmagenta;,f1,f1c202202126,f1,f1cblue;i,f1,f1c152050000,f1,f1cblue;i,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1cblue;i,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c152050000,f1,f1cblue;i,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cblue;i,f1,f1c152050000,f1,f1cblue;i,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c152050000,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c152050000,f1,f1cblue;i,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cblue;i,f1,f1c152050000,f1,f1cblue;i,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c152050000,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c202202126,f1,f1c202202126,f1,f1c202202126,f1,f1c152050000,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1c202202126,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1c202202126,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1c202202126,f1! !

!SimpleTestModule methodsFor: 'tests' stamp: 'ab 6/25/2002 14:09'!
testExportsNameBUG
	| m1 |
	self deleteIfExistsModule1.
	m1 _ self createModule1.
	m1
		addAssoc: (Association key: #Bar value: 'ABC')
		export: false.
	self assert: (m1 exportedNames includes: #Bar) not.
	m1 exportsName: #Bar.
	self
		assert: (m1 exportedNames includes: #Bar).
	self deleteModule2! !

!SimpleTestModule methodsFor: 'tests' stamp: 'ab 7/3/2002 13:21'!
testExternalMethodReference
	| m1 m2 m11 r |
	self deleteIfExistsModule1.
	self deleteIfExistsModule2.
	m1 _ self createModule1.
	m11 _ self createModule11.
	m2 _ self createModule2.
	self createDummyClassForModule: m1.
	self
		createClass: self dummy3ClassName
		extending: (m1 at: self dummyClassName)
		ForModule: m11.
	self createDummy2ClassForModule: m2.
	"--------------"
	(m1 at: self dummyClassName)
		compile: self methodSourceBar
		classified: 'bar'.
	self assert: ((m1 at: self dummyClassName) new perform: #bar)
			= 10.
	"--------------"
	(m2 at: self dummy2ClassName)
		compile: (self methodSourceFooForAClassNamed: self dummyClassName)
		classified: 'bar'.
	self
		assert: ((m2 at: self dummy2ClassName)
				canUnderstand: #foo).
	"--------------"
	"Some very simples assertion"
	self assert: m1 definedNames size = 1.
	self assert: (m1 definedNames at: self dummyClassName) name = self dummyClassName.
	self assert: m2 definedNames size = 1.
	self assert: (m2 definedNames at: self dummy2ClassName) name = self dummy2ClassName.
	self assert: m1 submodules size = 1.
	self
		assert: (m1 submodules includes: m11).
	"--------------"
	"We get all the references unresolved"
	r _ m1 deepUnresolvedRefs.
	"There is some reference into module m1 and m11"
	self assert: r size = 2.
	r _ r at: m1.
	"Two things are unresolved with the module m1  
	- dependencies with the module of superclass"
	self assert: r size = 1.
	self assert: (r at: 1) asString = 'MyDummyClass>><classCreation>'.
	"--------------"
	r _ m11 deepUnresolvedRefs.
	self assert: r size = 1.
	self
		assert: (r keys includes: m11).
	r _ r at: m11.
	self assert: r size = 1.
	self assert: (r at: 1) asString = 'MyDummy3Class>><classCreation>'.
	"--------------"
	r _ m2 deepUnresolvedRefs.
	self assert: r size = 1.
	r _ r at: m2.
	self assert: r size = 2.
	self assert: (r at: 1) asString = 'MyDummyClass2>>foo'.
	self assert: (r at: 2) asString = 'MyDummyClass2>><classCreation>'.
	"--------------"
	self deleteModule11.
	self deleteModule1.
	self deleteModule2!
]style[(27 3 12 4 4 25 4 25 2 3 4 17 3 3 4 18 2 3 4 17 4 28 2 3 4 16 4 31 2 5 4 30 3 3 4 29 2 3 16 3 2 5 4 28 4 31 5 3 4 11 2 5 4 30 4 7 2 3 16 3 2 5 4 30 4 32 4 31 5 3 4 13 2 5 4 37 4 4 47 2 4 9 2 21 1 3 4 10 2 18 4 24 4 18 4 9 2 21 1 3 4 10 2 18 4 25 4 19 4 9 2 19 1 3 4 12 2 22 3 4 56 2 1 3 2 22 48 2 4 9 1 8 1 3 1 3 1 5 2 3 94 2 4 9 1 8 1 3 4 10 1 5 1 13 31 3 16 2 1 3 3 22 4 9 1 8 1 3 4 12 1 16 3 4 1 3 1 5 3 3 4 9 1 8 1 3 4 10 1 5 1 13 32 3 16 2 1 3 2 22 4 9 1 8 1 3 1 3 1 5 2 3 4 9 1 8 1 3 4 10 1 5 1 13 20 3 4 10 1 5 1 13 1 30 1 3 16 2 4 18 4 17 4 14)f1b,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c146044000,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1c196196120,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cmagenta;,f1,f1c196196120,f1,f1c196196120,f1,f1c146044000,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1c196196120,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cmagenta;,f1,f1c196196120,f1,f1c146044000,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c196196120,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c196196120,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c196196120,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cblue;i,f1,f1c146044000,f1,f1cblue;i,f1,f1cblue;i,f1,f1c146044000,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c196196120,f1,f1cblue;i,f1,f1cblue;i,f1,f1cblue;i,f1,f1c146044000,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c196196120,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c196196120,f1,f1c196196120,f1,f1c146044000,f1,f1cblue;i,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c196196120,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cblue;i,f1,f1cblue;i,f1,f1cblue;i,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c196196120,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c196196120,f1,f1c196196120,f1,f1c146044000,f1,f1cblue;i,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c196196120,f1,f1cblue;i,f1,f1cblue;i,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c196196120,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c196196120,f1,f1c196196120,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c196196120,f1,f1c196196120,f1,f1c196196120,f1,f1c146044000,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1cmagenta;,f1! !

!SimpleTestModule methodsFor: 'tests' stamp: 'ab 7/6/2002 20:52'!
testImportModule
	| m1 m2 |
	self deleteIfExistsModule1.
	self deleteIfExistsModule2.
	m1 _ self createModule1.
	m2 _ self createModule2.
	self createDummyClassForModule: m1.
	self createDummy2ClassForModule: m2.
	"---------------------------"
	self assert: m1 importedModules isEmpty.
	self assert: m2 importedModules isEmpty.
	"---------------------------"
	m1 importModule: m2.
	self assert: (m1 refForNeighborModule: m2) importNames.
	"---------------------------"
	self
		assert: (m1 importedModules includes: m2).
	"---------------------------"
	self assert: m2 importedModules isEmpty.
	m2 externalModule: m1
				alias: nil
				version: nil
				importNames: false.
	self
		assert: (m2 importedModules includes: m1) not.
	"---------------------------"
	m2 importNameForModule: m1.
	self
		assert: (m2 importedModules includes: m1).
	"---------------------------"
	self deleteModule1.
	self deleteModule2! !

!SimpleTestModule methodsFor: 'tests' stamp: 'ab 7/3/2002 13:52'!
testLocalUnresolvedRefsWithScheme
	| m1 m2 |
	self deleteIfExistsModule1.
	self deleteIfExistsModule2.
	m1 _ self createModule1.
	m2 _ self createModule2.
	self createDummyClassForModule: m1.
	self createDummy2ClassForModule: m2.
	"------------------"
	(m1 at: self dummyClassName)
		compile: self methodSourceFoo
		classified: 'foo'.
	self
		assert: ((m1 at: self dummyClassName)
				canUnderstand: #foo).
	"------------------"
	self assert: (m1 localUnresolvedRefsWithScheme: #lenient) size = 0.
	"------------------"
	self assert: (m1 localUnresolvedRefsWithScheme: #strong) size = 2.
	"------------------"
	self deleteModule1.
	self deleteModule2!
]style[(33 3 6 4 4 25 4 25 2 3 4 17 2 3 4 17 4 28 2 3 4 29 2 3 20 3 2 5 4 28 4 31 5 3 4 13 2 5 4 36 4 4 20 2 4 10 2 32 8 9 1 3 20 2 4 10 2 32 7 9 1 3 20 2 4 17 4 14)f1b,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c146044000,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1c196196120,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cmagenta;,f1,f1c196196120,f1,f1c146044000,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c196196120,f1,f1c196196120,f1,f1c146044000,f1,f1cmagenta;,f1,f1cblue;i,f1,f1c196196120,f1,f1c196196120,f1,f1c146044000,f1,f1cmagenta;,f1,f1cmagenta;,f1! !

!SimpleTestModule methodsFor: 'tests' stamp: 'ab 6/25/2002 12:29'!
testMoveNameToModule
	| m1 m2 |
	self deleteIfExistsModule1.
	self deleteIfExistsModule2.
	m1 _ self createModule1.
	m2 _ self createModule2.
	m1
		defineName: #BarString
		as: 'BarString'
		export: false.
	self assert: (m1
			definesName: #BarString
			ifTrue: [:a | true])
			= true.
	"Possible bug ?"
	"self assert: (m2 
	definesName: #BarString 
	ifTrue: [:a | true]) 
	~= true."
	m1 moveName: #BarString toModule: m2.
	"Possible bug ?"
	"self assert: (m1
			definesName: #BarString
			ifTrue: [:a | true])
			~= true."
	self assert: (m2
			definesName: #BarString
			ifTrue: [:a | true])
			= true.
	self deleteModule1.
	self deleteModule2! !

!SimpleTestModule methodsFor: 'tests' stamp: 'ab 6/27/2002 14:07'!
testMoveNameToModule2
	| m1 m2 |
	self deleteIfExistsModule1.
	self deleteIfExistsModule2.
	m1 _ self createModule1.
	m2 _ self createModule2.
	m1
		defineName: #BarString
		as: 'BarString'
		export: false.
	self assert: (m1
			definesName: #BarString
			usingScheme: #lenient
			ifTrue: [:a | true])
			= true.
	self assert: (m2
			definesName: #BarString
			usingScheme: #lenient
			ifTrue: [:a | true])
			= true.
	m1 moveName: #BarString toModule: m2.
	self assert: (m1
			definesName: #BarString
			usingScheme: #lenient
			ifTrue: [:a | true])
			= true.
	self assert: (m2
			definesName: #BarString
			usingScheme: #lenient
			ifTrue: [:a | true])
			= true.
	self deleteModule1.
	self deleteModule2! !

!SimpleTestModule methodsFor: 'tests' stamp: 'ab 6/27/2002 15:23'!
testSubModuleAccess
	| m1 m11 m2 |
	self deleteIfExistsModule11.
	self deleteIfExistsModule1.
	self deleteIfExistsModule2.
	m1 _ self createModule1.
	m11 _ self createModule11.
	m2 _ self createModule2.
	"-----------------------"
	"Some simple tests"
	self assert: m1 name = self path1 last.
	self assert: m11 name = self path11 last.
	self assert: m2 name = self path2 last.
	"-----------------------"
	"We test if 'm1 Module11 = Module @ self path11'"
	self assert: (m1 perform: self path11 last)
			= m11.
	"-----------------------"
	self deleteIfExistsModule11.
	self deleteIfExistsModule1.
	self deleteIfExistsModule2! !

!SimpleTestModule methodsFor: 'as yet unclassified' stamp: 'ab 7/2/2002 14:54'!
createClass: name extending: aClass ForModule: mod 
	^ aClass
		subclass: name
		instanceVariableNames: ''
		classVariableNames: ''
		module: mod!
]style[(13 4 30 3 5 6 13 4 26 2 23 2 11 3)f1b,f1cblue;b,f1b,f1cblue;b,f1,f1b,f1,f1cblue;b,f1,f1c194194118,f1,f1c194194118,f1,f1cblue;i! !

!SimpleTestModule methodsFor: 'as yet unclassified' stamp: 'ab 7/6/2002 21:04'!
createClassNamed: aClassName ForModule: m 
	Object
		subclass: aClassName
		instanceVariableNames: ''
		classVariableNames: ''
		module: m! !

!SimpleTestModule methodsFor: 'as yet unclassified' stamp: 'ab 6/24/2002 18:08'!
createDummy2ClassForModule: m 
	Class
		subclass: self dummy2ClassName
		instanceVariableNames: ''
		classVariableNames: ''
		module: m! !

!SimpleTestModule methodsFor: 'as yet unclassified' stamp: 'ab 7/5/2002 14:59'!
createDummy3ClassForModule: m 
	Class
		subclass: self dummy3ClassName
		instanceVariableNames: ''
		classVariableNames: ''
		module: m! !

!SimpleTestModule methodsFor: 'as yet unclassified' stamp: 'ab 6/24/2002 12:19'!
createDummyClassForModule: m 
	Class
		subclass: self dummyClassName
		instanceVariableNames: ''
		classVariableNames: ''
		module: m.! !

!SimpleTestModule methodsFor: 'as yet unclassified' stamp: 'ab 6/24/2002 12:15'!
createModule1
	| m |
	m _ Module fromPath: self path1 forceCreate: true.
	self assert: m notNil.
	^ m! !

!SimpleTestModule methodsFor: 'as yet unclassified' stamp: 'ab 6/27/2002 15:05'!
createModule11
	| m |
	m _ Module fromPath: self path11 forceCreate: true.
	self assert: m notNil.
	^ m! !

!SimpleTestModule methodsFor: 'as yet unclassified' stamp: 'ab 6/24/2002 18:19'!
createModule2
	| m |
	m _ Module fromPath: self path2 forceCreate: true.
	self assert: m notNil.
	^ m! !

!SimpleTestModule methodsFor: 'as yet unclassified' stamp: 'ab 7/6/2002 21:01'!
createModule3
	| m |
	m _ Module fromPath: self path3 forceCreate: true.
	self assert: m notNil.
	^ m! !

!SimpleTestModule methodsFor: 'as yet unclassified' stamp: 'ab 7/6/2002 21:16'!
createModule: aString 
	| m |
	m _ Module fromPath: (self path: aString) forceCreate: true.
	self assert: m notNil.
	^ m! !

!SimpleTestModule methodsFor: 'as yet unclassified' stamp: 'ab 6/24/2002 12:02'!
deleteIfExistsModule1
	| m |
	m _ self module1.
	m ifNotNil: [self deleteModule1].
	self assert: (self module1 isNil).! !

!SimpleTestModule methodsFor: 'as yet unclassified' stamp: 'ab 6/27/2002 15:05'!
deleteIfExistsModule11
	| m |
	m _ self module11.
	m
		ifNotNil: [self deleteModule11].
	self assert: self module11 isNil! !

!SimpleTestModule methodsFor: 'as yet unclassified' stamp: 'ab 6/24/2002 18:22'!
deleteIfExistsModule2
	| m |
	m _ self module2.
	m
		ifNotNil: [self deleteModule2].
	self assert: self module2 isNil!
]style[(21 3 2 4 1 3 4 11 1 14 4 18 4 9 4 14)f1b,f1,f1cblue;i,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cblue;i,f1,f1cmagenta;,f1,f1cmagenta;,f1,f1cmagenta;,f1! !

!SimpleTestModule methodsFor: 'as yet unclassified' stamp: 'ab 7/6/2002 21:00'!
deleteIfExistsModule3
	| m |
	m _ self module3.
	m
		ifNotNil: [self deleteModule3].
	self assert: self module3 isNil! !

!SimpleTestModule methodsFor: 'as yet unclassified' stamp: 'ab 7/6/2002 21:12'!
deleteIfExistsModuleFromPath: aPath
	| m |
	m _ Module @ aPath.
	m
		ifNotNil: [self deleteModule: m].
	self assert: (Module @ aPath) isNil! !

!SimpleTestModule methodsFor: 'as yet unclassified' stamp: 'ab 6/24/2002 12:00'!
deleteModule1
	| m |
	ModuleInstaller unload: self module1.
	m _ Module @ self path1.
	self assert: m isNil.
! !

!SimpleTestModule methodsFor: 'as yet unclassified' stamp: 'ab 6/27/2002 15:05'!
deleteModule11
	| m |
	ModuleInstaller unload: self module11.
	m _ Module @ self path11.
	self assert: m isNil! !

!SimpleTestModule methodsFor: 'as yet unclassified' stamp: 'ab 6/24/2002 17:39'!
deleteModule2
	| m |
	ModuleInstaller unload: self module2.
	m _ Module @ self path2.
	self assert: m isNil! !

!SimpleTestModule methodsFor: 'as yet unclassified' stamp: 'ab 7/6/2002 21:00'!
deleteModule3
	| m |
	ModuleInstaller unload: self module3.
	m _ Module @ self path3.
	self assert: m isNil! !

!SimpleTestModule methodsFor: 'as yet unclassified' stamp: 'ab 7/6/2002 21:07'!
deleteModule: m
	| p |
	p _ m path.
	ModuleInstaller unload: m.
	self assert: (Module @ p) isNil! !

!SimpleTestModule methodsFor: 'as yet unclassified' stamp: 'ab 6/24/2002 17:38'!
dummy2ClassName
	^ #MyDummyClass2! !

!SimpleTestModule methodsFor: 'as yet unclassified' stamp: 'ab 7/2/2002 14:29'!
dummy3ClassName
	^ #MyDummy3Class! !

!SimpleTestModule methodsFor: 'as yet unclassified' stamp: 'ab 6/24/2002 12:19'!
dummyClassName
	^#MyDummyClass! !

!SimpleTestModule methodsFor: 'as yet unclassified' stamp: 'ab 6/24/2002 17:44'!
methodSourceBar
	^ 'bar
^ 10'! !

!SimpleTestModule methodsFor: 'as yet unclassified' stamp: 'ab 6/25/2002 12:13'!
methodSourceFoo
	^ 'foo
^ ', (self dummy2ClassName) asString, ' new bar'! !

!SimpleTestModule methodsFor: 'as yet unclassified' stamp: 'ab 6/25/2002 13:22'!
methodSourceFoo2
	^ 'foo
^ Bar'! !

!SimpleTestModule methodsFor: 'as yet unclassified' stamp: 'ab 7/2/2002 15:15'!
methodSourceFooForAClassNamed: name
	^ 'foo
^ ' , name asString , ' new bar'! !

!SimpleTestModule methodsFor: 'as yet unclassified' stamp: 'ab 6/24/2002 18:17'!
methodSourceWithoutAnyReference
	^ 'nul
^ 10'! !

!SimpleTestModule methodsFor: 'as yet unclassified' stamp: 'ab 6/24/2002 12:00'!
module1
	^ Module @ self path1! !

!SimpleTestModule methodsFor: 'as yet unclassified' stamp: 'ab 6/27/2002 15:04'!
module11
	^ Module @ self path11! !

!SimpleTestModule methodsFor: 'as yet unclassified' stamp: 'ab 6/24/2002 17:39'!
module2
	^ Module @ self path2! !

!SimpleTestModule methodsFor: 'as yet unclassified' stamp: 'ab 7/6/2002 21:00'!
module3
	^ Module @ self path3! !

!SimpleTestModule methodsFor: 'as yet unclassified' stamp: 'ab 6/24/2002 12:00'!
path1
	^#(Temporary TestModule1)! !

!SimpleTestModule methodsFor: 'as yet unclassified' stamp: 'ab 6/27/2002 15:05'!
path11
	^ #(#Temporary #TestModule1  #TestModule1)! !

!SimpleTestModule methodsFor: 'as yet unclassified' stamp: 'ab 6/24/2002 17:38'!
path2
	^ #(#Temporary #TestModule2 )! !

!SimpleTestModule methodsFor: 'as yet unclassified' stamp: 'ab 7/6/2002 21:02'!
path3
	^ #(#Temporary #TestModule3 )! !

!SimpleTestModule methodsFor: 'as yet unclassified' stamp: 'ab 7/6/2002 21:14'!
path: aString
	| t |
	t _ OrderedCollection new.
	t add: #Temporary ; add: #SimpleTestModule.
	aString do: [:c| t add: (('Module' , c asString) asSymbol)].
	^ t asArray! !

