'From Squeak3.6 of ''6 October 2003'' [latest update: #5424] on 15 November 2003 at 5:05:05 pm'!

!ScrollPane methodsFor: 'event handling' stamp: 'hpt 11/15/2003 16:34'!
keyboardFocusChange: aBoolean
	hasFocus _ aBoolean.! !


!PluggableListMorph methodsFor: 'event handling' stamp: 'hpt 10/29/2003 21:57'!
mouseDown: evt
	| aMorph selectors |
	Preferences mouseOverForKeyboardFocus ifFalse:
		[evt hand newKeyboardFocus: self].
	evt yellowButtonPressed  "First check for option (menu) click"
		ifTrue: [^ self yellowButtonActivity: evt shiftPressed].
	aMorph _ self itemFromPoint: evt position.
	aMorph ifNil:[^super mouseDown: evt].
	self dragEnabled ifTrue: [aMorph highlightForMouseDown].
	selectors _ Array 
		with: #click:
		with: (doubleClickSelector ifNotNil:[#doubleClick:])
		with: nil
		with: (self dragEnabled ifTrue:[#startDrag:] ifFalse:[nil]).
	evt hand waitForClicksOrDrag: self event: evt selectors: selectors threshold: 10 "pixels".! !

!PluggableListMorph methodsFor: 'event handling' stamp: 'hpt 10/29/2003 21:55'!
mouseEnter: event
	super mouseEnter: event.
	self flag: #arNote. "remove this - keyboard input automatically goes right"
	Preferences mouseOverForKeyboardFocus ifTrue:
		[event hand newKeyboardFocus: self].! !

!PluggableListMorph methodsFor: 'event handling' stamp: 'hpt 10/29/2003 22:01'!
mouseLeave: event
	"The mouse has left the area of the receiver"

	super mouseLeave: event.
	Preferences mouseOverForKeyboardFocus ifTrue:
		[event hand releaseKeyboardFocus: self]! !


!PluggableTextMorph methodsFor: 'event handling' stamp: 'hpt 11/15/2003 16:41'!
keyboardFocusChange: focusGained in: aTextMorph
	"this method is called from TextMorphForEditView>>keyboardFocusChange: to notify the view (me) of keyboardFocusChange"
	focusGained 
		ifTrue: 
			[self showSelection]
		ifFalse:
			[self hasUnacceptedEdits & self acceptOnFocusLoss 
				ifTrue: [self accept]].! !

!PluggableTextMorph methodsFor: 'event handling' stamp: 'hpt 11/15/2003 17:01'!
mouseEnter: event
	super mouseEnter: event.
	self showSelectionOnlyOnKeyboardFocus ifFalse:
		[self showSelection].
	Preferences mouseOverForKeyboardFocus ifTrue: 
		[event hand newKeyboardFocus: textMorph].
! !

!PluggableTextMorph methodsFor: 'menu commands' stamp: 'hpt 11/4/2003 22:18'!
showSelectionOnlyOnKeyboardFocus: trueOrFalse
	self setProperty: #showSelectionOnlyOnKeyboardFocus toValue: trueOrFalse.
	trueOrFalse 
		ifTrue: [self hideSelectionIfNoKeyboardFocus]
		ifFalse: [textMorph hasFocus ifFalse: [self showSelection]].! !

!PluggableTextMorph methodsFor: 'model access' stamp: 'hpt 11/4/2003 22:13'!
hideSelectionIfNoKeyboardFocus
	self world ifNotNil: 
		[self world handsDo: [:h | h keyboardFocus == textMorph ifTrue: [^self]]].
	textMorph releaseEditor.! !

!PluggableTextMorph methodsFor: 'model access' stamp: 'hpt 11/4/2003 22:14'!
setSelection: sel
	selectionInterval _ sel.
	textMorph editor selectFrom: sel first to: sel last.
	self scrollSelectionIntoView ifFalse: [scroller changed].
	self showSelectionOnlyOnKeyboardFocus
		ifTrue: [self hideSelectionIfNoKeyboardFocus].
	^self.! !

!PluggableTextMorph methodsFor: 'model access' stamp: 'hpt 11/4/2003 22:17'!
showSelection
	selectionInterval ifNotNil: 
		[textMorph editor selectInterval: selectionInterval; setEmphasisHere].
	textMorph selectionChanged.! !

!PluggableTextMorph methodsFor: 'model access' stamp: 'hpt 11/4/2003 22:08'!
showSelectionOnlyOnKeyboardFocus
	^self valueOfProperty: #showSelectionOnlyOnKeyboardFocus ifAbsent: [false].! !

!PluggableTextMorph methodsFor: 'keyboard focus rotation' stamp: 'hpt 11/4/2003 19:38'!
acceptOnFocusLoss
	^self valueOfProperty: #autoAcceptOnFocusLoss ifAbsent: [false].! !

!PluggableTextMorph methodsFor: 'keyboard focus rotation' stamp: 'hpt 11/4/2003 19:36'!
autoAcceptOnFocusLoss: trueOrFalse
	self setProperty: #autoAcceptOnFocusLoss toValue: trueOrFalse.! !

!PluggableTextMorph methodsFor: '*APS-menu' stamp: 'hpt 11/15/2003 16:48'!
accept
	"Inform the model of text to be accepted, and return true if OK."

	"sps 8/13/2001 22:41: save selection and scroll info"

	| textToAccept ok saveSelection saveScrollerOffset |
	saveSelection := self selectionInterval copy.
	saveScrollerOffset := scroller offset copy.
	(self canDiscardEdits and: [(self hasProperty: #alwaysAccept) not]) 
		ifTrue: [^self flash].
	self hasEditingConflicts 
		ifTrue: 
			[(self 
				confirm: 'Caution!! This method may have been
changed elsewhere since you started
editing it here.  Accept anyway?') 
					ifFalse: [^self flash]].
	textToAccept := textMorph asText.
	ok := setTextSelector isNil or: 
					[setTextSelector numArgs = 2 
						ifTrue: 
							[model 
								perform: setTextSelector
								with: textToAccept
								with: self]
						ifFalse: [model perform: setTextSelector with: textToAccept]].
	ok == true 
		ifTrue: 
			[self setText: self getText.
			self hasUnacceptedEdits: false.
			(model dependents detect: 
					[:dep | 
					(dep isKindOf: PluggableTextMorph) 
						and: [dep getTextSelector == #annotation]]
				ifNone: [nil]) doIfNotNil: [:aPane | model changed: #annotation]].

	"sps 8/13/2001 22:41: restore selection and scroll info"
	
	["During the step for the browser, updateCodePaneIfNeeded is called, and 
		invariably resets the contents of the codeholding PluggableTextMorph
		at that time, resetting the cursor position and scroller in the process.
		The following line forces that update without waiting for the step, 		then restores the cursor and scrollbar"

	ok 
		ifTrue: 
			["(don't bother if there was an error during compile)"

			(model isKindOf: CodeHolder) ifTrue: [model updateCodePaneIfNeeded].
			WorldState addDeferredUIMessage: 
					[self acceptOnFocusLoss ifFalse: 
						[self currentHand newKeyboardFocus: textMorph].
					scroller offset: saveScrollerOffset.
					self setScrollDeltas.
					self setSelection: saveSelection ]]] 
			on: Error
			do: []! !


!TextMorphForEditView methodsFor: 'event handling' stamp: 'hpt 11/4/2003 19:25'!
keyboardFocusChange: aBoolean
	super keyboardFocusChange: aBoolean.
	self editView ifNotNil: [self editView keyboardFocusChange: aBoolean in: self].! !


!PluggableTextMorph reorganize!
('accessing' getTextSelector)
('debug and other' installModelIn:)
('dependents access' canDiscardEdits hasUnacceptedEdits)
('drawing' drawOn: wantsFrameAdornments)
('dropping/grabbing' wantsDroppedMorph:event:)
('editor access' handleEdit: scrollSelectionIntoView scrollSelectionIntoView: selectAll setTextMorphToSelectAllOnMouseEnter)
('event handling' handlesKeyboard: keyStroke: keyboardFocusChange:in: mouseEnter: mouseLeave:)
('genie-dispatching' handleGesture:)
('geometry' extent: extraScrollRange resetExtent scrollDeltaHeight)
('initialization' acceptOnCR: editString: font: initialize on:text:accept:readSelection:menu:)
('interactive error protocol' correctFrom:to:with: correctSelectionWithString: deselect nextTokenFrom:direction: notify:at:in: select selectFrom:to: selectInvisiblyFrom:to: selectionInterval)
('layout' acceptDroppingMorph:event:)
('menu commands' again browseChangeSetsWithSelector browseIt cancel changeStyle chooseAlignment classCommentsContainingIt classNamesContainingIt copySelection cut debugIt doIt explain exploreIt fileItIn find findAgain implementorsOfIt inspectIt languagePrefs methodNamesContainingIt methodSourceContainingIt methodStringsContainingit offerFontMenu paste pasteRecent presentSpecialMenu prettyPrint prettyPrintWithColor printIt printerSetup recognizeCharacters referencesToIt saveContentsInFile selectionAsTiles sendContentsToPrinter sendersOfIt setSearchString showSelectionOnlyOnKeyboardFocus: spawn tileForIt toggleAnnotationPaneSize translateIt undo verifyWordSpelling wordDefinition yellowButtonActivity)
('model access' eToyGetMainFont getSelection getText hideSelectionIfNoKeyboardFocus selectionInterval: setSelection: setText: setTextColor: showSelection showSelectionOnlyOnKeyboardFocus text)
('scroll bar events' scrollBarMenuButtonPressed: yellowButtonActivity:)
('transcript' appendEntry appendTextEtoy: bsText changeText: replaceSelectionWith:)
('unaccepted edits' askBeforeDiscardingEdits: hasEditingConflicts hasEditingConflicts: hasUnacceptedEdits: promptForCancel)
('updating' update:)
('keyboard focus rotation' acceptOnFocusLoss autoAcceptOnFocusLoss:)
('*APS-menu' accept)
!


!PluggableListMorph reorganize!
('accessing' highlightSelector highlightSelector: itemFromPoint:)
('debug and other' installModelIn:)
('drag and drop' potentialDropMorph potentialDropMorph: resetPotentialDropMorph)
('drawing' drawOn: highlightSelection superDrawOn: unhighlightSelection)
('dropping/grabbing' wantsDroppedMorph:event:)
('event handling' doubleClick: handlesKeyboard: handlesMouseOverDragging: keyStroke: keyboardFocusChange: mouseDown: mouseEnter: mouseEnterDragging: mouseLeave: mouseLeaveDragging: mouseMove: mouseUp: startDrag:)
('events' handlesBasicKeys)
('events-processing' handleMouseMove:)
('geometry' scrollDeltaHeight)
('initialization' autoDeselect: doubleClickSelector: font font: getListSelector: initForKeystrokes keystrokeActionSelector: list: listItemHeight on:list:selected:changeSelected:menu:keystroke:)
('layout' acceptDroppingMorph:event:)
('menu' getMenu:)
('menus' addCustomMenuItems:hand: copyListToClipboard copySelectionToClipboard setListFont)
('model access' basicKeyPressed: changeModelSelection: commandKeyTypedIntoMenu: getCurrentSelectionIndex getList modifierKeyPressed: specialKeyPressed:)
('obsolete' doubleClick:onItem: mouseDown:onItem: mouseEnterDragging:onItem: mouseLeaveDragging:onItem: mouseUp:onItem: removeObsoleteEventHandlers startDrag:onItem:)
('selection' getListSelector maximumSelection minimumSelection numSelectionsInView selectedMorph: selection selection: selectionIndex: setGetListSelector: setSelectedMorph:)
('submorphs-accessing' allSubmorphNamesDo:)
('updating' update: verifyContents)
!

