'From Squeak3.6 of ''6 October 2003'' [latest update: #5424] on 15 November 2003 at 4:49:08 pm'!
Object subclass: #KeyboardFocusChain
	instanceVariableNames: 'handlerChain '
	classVariableNames: 'DefaultInstance '
	poolDictionaries: ''
	category: 'Morphic-Text Support'!

!KeyboardFocusChain commentStamp: 'hpt 11/15/2003 16:02' prior: 0!
I am a chain of willing focus receptors.

The idea is that any morph can register his intention to handle keyboard focus rotation by simply joining to a keyboard focus chain. (Morph>>addToKeyboardFocusChain:)

see KeyboardFocusRotationHandler for addtional details.
!

Object subclass: #KeyboardFocusRotationHandler
	instanceVariableNames: 'focusChain focusReceptor '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Text Support'!

!KeyboardFocusRotationHandler commentStamp: 'hpt 11/15/2003 16:08' prior: 0!
a KeyboardFocusRotationHandler manage the individual aspect of a Morph to handle keyboard-focus rotation.

That is. A KeyboardFocusRotationHandler knows upon which keys strokes a Morph will release it's keyboard-focus (TAB for example), and in which direction.

To specialize a morph's keyboard-focus behaviour one must provide an specialized KeyboardFocusRotationHandler.!


!KeyboardFocusChain methodsFor: 'accessing' stamp: 'hpt 11/3/2003 21:37'!
add: aKeyboardFocusHandler 
	(handlerChain includes: aKeyboardFocusHandler) ifTrue: [^self].
	handlerChain add: aKeyboardFocusHandler.
	aKeyboardFocusHandler focusChain: self.
	self triggerEvent: #receptorAdded! !

!KeyboardFocusChain methodsFor: 'accessing' stamp: 'hpt 11/3/2003 21:30'!
empty
	handlerChain do: [:aHandler | self remove: aHandler]! !

!KeyboardFocusChain methodsFor: 'accessing' stamp: 'hpt 10/29/2003 22:15'!
remove: aKeyboardFocusHandler 
	(handlerChain includes: aKeyboardFocusHandler) ifFalse: [^self].
	handlerChain remove: aKeyboardFocusHandler.
	self triggerEvent: #receptorRemoved! !

!KeyboardFocusChain methodsFor: 'private' stamp: 'hpt 11/3/2003 21:30'!
initialize
	handlerChain := OrderedCollection new.! !

!KeyboardFocusChain methodsFor: 'focus' stamp: 'hpt 11/3/2003 21:31'!
currentFocusHandler
	^handlerChain 
		detect: [:aHandler | aHandler focusReceptor == ActiveHand keyboardFocus]
		ifNone: [nil]! !

!KeyboardFocusChain methodsFor: 'focus' stamp: 'hpt 11/2/2003 17:29'!
firstFocusHandler
	handlerChain isEmpty ifTrue: [^nil].
	^handlerChain first.! !

!KeyboardFocusChain methodsFor: 'focus' stamp: 'hpt 10/25/2003 22:28'!
nextFocusHandler
	handlerChain isEmpty ifTrue: [^nil].
	^handlerChain last == self currentFocusHandler
		ifTrue: 
			[handlerChain first]
		ifFalse: 
			[handlerChain 
				after: self currentFocusHandler 
				ifAbsent: [handlerChain first]].! !

!KeyboardFocusChain methodsFor: 'focus' stamp: 'hpt 10/25/2003 22:29'!
previousFocusHandler
	handlerChain isEmpty ifTrue: [^nil].
	^handlerChain first == self currentFocusHandler
		ifTrue: 
			[handlerChain last]
		ifFalse:
			[handlerChain 
				before: self currentFocusHandler 
				ifAbsent: [handlerChain last]].! !

!KeyboardFocusChain methodsFor: 'focus' stamp: 'hpt 11/3/2003 21:31'!
switchTo: aKeyboardFocusHandlerOrNil
	ActiveHand newKeyboardFocus: 
		(aKeyboardFocusHandlerOrNil ifNotNil: [aKeyboardFocusHandlerOrNil focusReceptor])! !

!KeyboardFocusChain methodsFor: 'focus' stamp: 'hpt 11/2/2003 17:29'!
switchToFirst
	self switchTo: self firstFocusHandler! !

!KeyboardFocusChain methodsFor: 'focus' stamp: 'hpt 10/25/2003 21:19'!
switchToNext
	self switchTo: self nextFocusHandler! !

!KeyboardFocusChain methodsFor: 'focus' stamp: 'hpt 10/25/2003 21:19'!
switchToPrevious
	self switchTo: self previousFocusHandler! !


!KeyboardFocusChain class methodsFor: 'instance creation' stamp: 'hpt 11/3/2003 21:42'!
default
	DefaultInstance ifNil: [DefaultInstance := self new].
	^DefaultInstance.! !

!KeyboardFocusChain class methodsFor: 'instance creation' stamp: 'hpt 11/2/2003 17:06'!
new
	^super new 
		initialize; 
		yourself.! !


!KeyboardFocusRotationHandler methodsFor: 'accessing' stamp: 'hpt 11/3/2003 20:46'!
focusChain
	^focusChain! !

!KeyboardFocusRotationHandler methodsFor: 'accessing' stamp: 'hpt 11/3/2003 21:27'!
focusChain: aKeyboardFocusChain
	focusChain := aKeyboardFocusChain! !

!KeyboardFocusRotationHandler methodsFor: 'accessing' stamp: 'hpt 11/3/2003 20:46'!
focusReceptor
	^focusReceptor! !

!KeyboardFocusRotationHandler methodsFor: 'accessing' stamp: 'hpt 11/3/2003 21:38'!
focusReceptor: aMorph
	focusReceptor := aMorph.
	aMorph keyboardFocusRotationHandler: self.! !

!KeyboardFocusRotationHandler methodsFor: 'focus rotation' stamp: 'hpt 11/3/2003 21:23'!
handlesKeyboardFocusRotation: anEvent
	"This event triggers a keyboard focus rotation?"

	^(self keyboardFocusRotationDirection: anEvent) notNil! !

!KeyboardFocusRotationHandler methodsFor: 'focus rotation' stamp: 'hpt 11/3/2003 20:59'!
keyboardFocusRotationDirection: anEvent
	"the direction #forwards / #backwards / nil that the focus should rotates upon this event"

	(anEvent keyCharacter == Character tab) & anEvent shiftPressed
		ifTrue: [^#backwards].
	(anEvent keyCharacter == Character tab) & anEvent shiftPressed not
		ifTrue: [^#forwards].
	^nil.! !

!KeyboardFocusRotationHandler methodsFor: 'focus rotation' stamp: 'hpt 11/3/2003 20:59'!
rotateKeyboardFocus: anEvent
	"rotate the keyboard focus in the direction that anEvent directs"

	(self keyboardFocusRotationDirection: anEvent) == #forwards
		ifTrue: [self rotateKeyboardFocusForwards].
	(self keyboardFocusRotationDirection: anEvent) == #backwards
		ifTrue: [self rotateKeyboardFocusBackwards].! !

!KeyboardFocusRotationHandler methodsFor: 'focus rotation' stamp: 'hpt 11/3/2003 20:59'!
rotateKeyboardFocusBackwards
	self focusChain switchToPrevious ! !

!KeyboardFocusRotationHandler methodsFor: 'focus rotation' stamp: 'hpt 11/3/2003 20:59'!
rotateKeyboardFocusForwards
	self focusChain switchToNext! !


!KeyboardFocusRotationHandler class methodsFor: 'instance creation' stamp: 'hpt 11/3/2003 21:37'!
focusReceptor: aMorph
	^self new 
		focusReceptor: aMorph;
		yourself.! !


!Morph methodsFor: 'events-processing' stamp: 'hpt 11/3/2003 19:25'!
handleKeystroke: anEvent 
	"System level event handling."

	anEvent wasHandled ifTrue: [^self].
	(self handlesKeyboardFocusRotation: anEvent) 
		ifTrue: [^self rotateKeyboardFocus: anEvent].
	(self handlesKeyboard: anEvent) ifFalse: [^self].
	anEvent wasHandled: true.
	^self keyStroke: anEvent! !

!Morph methodsFor: 'keyboard focus rotation' stamp: 'hpt 11/15/2003 16:15'!
addToKeyboardFocusChain: aKeyboardFocusChain
	"By default I don't care about keyboard focus so I jsut forward the request to my submorph. 	Any Morph subclass that wants to join a keyboard focus chain should reimplement this method."

	self submorphsDo: [:s | s addToKeyboardFocusChain: aKeyboardFocusChain].! !

!Morph methodsFor: 'keyboard focus rotation' stamp: 'hpt 11/15/2003 16:13'!
handlesKeyboardFocusRotation: anEvent 
	"Does this event trigger a keyboard focus rotation?"

	^self keyboardFocusRotationHandler notNil and:
		[self keyboardFocusRotationHandler handlesKeyboardFocusRotation: anEvent].! !

!Morph methodsFor: 'keyboard focus rotation' stamp: 'hpt 11/3/2003 20:39'!
keyboardFocusRotationHandler
	^self valueOfProperty: #keyboardFocusRotationHandler ifAbsent: [nil]! !

!Morph methodsFor: 'keyboard focus rotation' stamp: 'hpt 11/3/2003 20:39'!
keyboardFocusRotationHandler: aKeyboardFocusRotationHandler
	self setProperty: #keyboardFocusRotationHandler 
		toValue: aKeyboardFocusRotationHandler.! !

!Morph methodsFor: 'keyboard focus rotation' stamp: 'hpt 11/15/2003 16:13'!
rotateKeyboardFocus: anEvent 
	"rotate the keyboard focus in the direction that anEvent directed"

	self keyboardFocusRotationHandler rotateKeyboardFocus: anEvent.! !


!Morph class methodsFor: 'scripting' stamp: 'hpt 10/25/2003 18:03'!
additionsToViewerCategoryMiscellaneous
	"Answer viewer additions for the 'miscellaneous' category"

	^#(#miscellaneous #(#(#command #doMenuItem: 'do the menu item' #Menu) #(#command #show 'make the object visible') #(#command #hide 'make the object invisible') #(#command #wearCostumeOf: 'wear the costume of...' #Player) #(#command #fire 'trigger any and all of this object''s button actions') #(#slot #copy 'returns a copy of this object' #Player #readOnly #Player #getNewClone #unused #unused) #(#slot #elementNumber 'my index in my container' #Number #readWrite #Player #getIndexInOwner #Player #setIndexInOwner:) #(#slot #holder 'the object''s container' #Player #readOnly #Player #getHolder #Player #setHolder:) #(#command #stampAndErase 'add my image to the pen trails and go away')))! !


!PluggableListMorph methodsFor: 'event handling' stamp: 'hpt 11/15/2003 16:35'!
keyboardFocusChange: aBoolean
	"The message is sent to a morph when its keyboard focus changes.
	The given argument indicates that the receiver is gaining (versus losing) the keyboard focus.
	In this case, all we need to do is to redraw border feedback"

	super keyboardFocusChange: aBoolean.
	(self innerBounds areasOutside: (self innerBounds insetBy: 1))
		do: [ :rect | self invalidRect: rect ].! !

!PluggableListMorph methodsFor: 'keyboard focus rotation' stamp: 'hpt 11/3/2003 22:13'!
addToKeyboardFocusChain: aKeyboardFocusChain
	"To participate in a keyboardFocusChain I need"

	aKeyboardFocusChain add: (KeyboardFocusRotationHandler focusReceptor: self).! !


!PluggableTextMorph methodsFor: 'keyboard focus rotation' stamp: 'hpt 11/3/2003 21:36'!
addToKeyboardFocusChain: aKeyboardFocusChain
	"To participate in a keyboardFocusChain I need to subscribe my TextMorphForEditView"

	aKeyboardFocusChain add: (KeyboardFocusRotationHandler focusReceptor: textMorph).! !


!TextMorph methodsFor: 'events-processing' stamp: 'hpt 11/3/2003 19:25'!
handleKeystroke: anEvent 
	"System level event handling."

	| pasteUp |
	anEvent wasHandled ifTrue: [^self].
	(self handlesKeyboard: anEvent) ifFalse: [^self].
	(self handlesKeyboardFocusRotation: anEvent) 
		ifTrue: [^self rotateKeyboardFocus: anEvent].
	anEvent wasHandled: true.
	anEvent keyCharacter = Character tab 
		ifTrue: 
			["Allow passing through text morph inside pasteups"

			(self wouldAcceptKeyboardFocusUponTab 
				and: [(pasteUp := self pasteUpMorphHandlingTabAmongFields) notNil]) 
					ifTrue: [^pasteUp tabHitWithEvent: anEvent]].
	self keyStroke: anEvent! !


!TextMorph reorganize!
('accessing' asText autoFit: backgroundColor backgroundColor: borderWidth: contents contents: contents:wrappedTo: contentsAsIs: contentsWrapped: crAction crAction: editor fontName:size: getCharacters getFirstCharacter hasTranslucentColor isAutoFit isWrapped margins margins: newContents: setCharacters: setFirstCharacter: text textAlignment textAlignmentSymbol textColor textColor: textStyle userString wrapFlag:)
('alignment' centered justified leftFlush rightFlush)
('anchors' adjustTextAnchor: anchorMorph:at:type:)
('caching' loadCachedState releaseCachedState)
('card & stack' newContents:fromCard: setNewContentsFrom:)
('card in a stack' couldHoldSeparateDataForEachInstance)
('change reporting' ownerChanged)
('classification' isTextMorph)
('containment' fillingOnOff occlusionsOnOff recognizerArena setContainer:)
('copying' copy updateReferencesUsing: veryDeepFixupWith: veryDeepInner:)
('drawing' areasRemainingToFill: debugDrawLineRectsOn: drawNullTextOn: drawOn:)
('e-toy support' configureForKids getNumericValue setNumericValue:)
('editing' acceptContents acceptOnCR cancelEdits chooseAlignment chooseEmphasis chooseEmphasisOrAlignment chooseFont chooseStyle enterClickableRegion: handleEdit: handleInteraction:fromEvent: hasUnacceptedEdits: passKeyboardFocusTo: xeqLinkText:withParameter:)
('event handling' handlesKeyboard: handlesMouseDown: hasFocus keyStroke: mouseDown: mouseMove: mouseUp: wouldAcceptKeyboardFocusUponTab)
('events-processing' handleKeystroke: handleMouseMove: keyboardFocusChange:)
('genie-dispatching' handleGesture: lastGesture lastGesture: setAlignment:)
('genie-processing' defaultGestureDictionaryOrName gestureHandler)
('geometry' bounds container defaultLineHeight extent: minimumExtent privateMoveBy: textBounds)
('geometry testing' containsPoint:)
('initialization' beAllFont: defaultColor initialize setTextStyle: string:fontName:size: string:fontName:size:wrap:)
('layout' acceptDroppingMorph:event:)
('linked frames' addPredecessor: addSuccessor: firstCharacterIndex firstInChain isLinkedTo: lastCharacterIndex predecessor recomposeChain startingIndex successor withSuccessorsDo:)
('menu' autoFitOnOff autoFitString changeMargins: changeTextColor followCurve reverseCurveDirection setCurveBaseline: shiftedYellowButtonActivity wrapOnOff wrapString yellowButtonActivity)
('menus' addCustomMenuItems:hand:)
('objects from disk' convertToCurrentVersion:refStream:)
('player' currentDataValue variableDocks)
('printing' fullPrintOn:)
('scripting access' getAllButFirstCharacter setAllButFirstCharacter:)
('submorphs-add/remove' addMorphFront:fromWorldPosition: delete goBehind)
('testing' basicType)
('visual properties' fillStyle fillStyle:)
('private' adjustLineIndicesBy: clippingRectangle composeToBounds compositionRectangle fit installEditor installEditorToReplace: paragraph paragraphClass predecessor:successor: predecessorChanged privateOwner: privateRemoveMorph: releaseEditor releaseParagraph releaseParagraphReally selectionChanged setDefaultContentsIfNil setPredecessor: setSuccessor: text:textStyle: text:textStyle:wrap:color:predecessor:successor: updateFromParagraph)
!


!Morph reorganize!
('WiW support' addMorphInFrontOfLayer: addMorphInLayer: eToyRejectDropMorph:event: morphicLayerNumber morphicLayerNumberWithin: randomBoundsFor: shouldGetStepsFrom:)
('accessing' actorState actorState: actorStateOrNil adoptPaneColor: balloonText balloonTextSelector balloonTextSelector: beFlap: beSticky beUnsticky borderColor borderColor: borderStyle borderStyle: borderStyleForSymbol: borderWidth borderWidth: borderWidthForRounding color color: colorForInsets couldHaveRoundedCorners eventHandler eventHandler: forwardDirection hasTranslucentColor highlight highlightColor highlightColor: highlightOnlySubmorph: insetColor isFlap isLocked isShared isSticky lock lock: methodCommentAsBalloonHelp modelOrNil player player: presenter raisedColor regularColor regularColor: rememberedColor rememberedColor: resistsRemoval resistsRemoval: scaleFactor setBorderStyle: sqkPage sticky: toggleLocked toggleResistsRemoval toggleStickiness unHighlight unlock unlockContents url userString wantsToBeCachedByHand)
('accessing - extension' assureExtension extension hasExtension initializeExtension privateExtension: resetExtension)
('accessing - properties' hasProperty: otherProperties removeProperty: setProperties: setProperty:toValue: valueOfProperty: valueOfProperty:ifAbsent: valueOfProperty:ifAbsentPut: valueOfProperty:ifPresentDo:)
('button' doButtonAction fire firedMouseUpCode)
('button properties' buttonProperties buttonProperties: ensuredButtonProperties hasButtonProperties)
('caching' fullLoadCachedState fullReleaseCachedState loadCachedState releaseCachedState)
('card in a stack' abstractAModel beAStackBackground becomeSharedBackgroundField containsCard: couldHoldSeparateDataForEachInstance currentDataInstance explainDesignations goToNextCardInStack goToPreviousCardInStack holdsSeparateDataForEachInstance insertAsStackBackground insertCard installAsCurrent: isStackBackground makeHoldSeparateDataForEachInstance newCard reassessBackgroundShape relaxGripOnVariableNames reshapeBackground setAsDefaultValueForNewCard showBackgroundObjects showDesignationsOfObjects showForegroundObjects stack stackDo: stopHoldingSeparateDataForEachInstance tabHitWithEvent: wrapWithAStack)
('change reporting' addedOrRemovedSubmorph: colorChangedForSubmorph: invalidRect: invalidRect:from: ownerChanged userSelectedColor:)
('classification' demandsBoolean isAlignmentMorph isBalloonHelp isFlapOrTab isFlapTab isFlashMorph isFlexMorph isHandMorph isModalShell isPlayfieldLike isRenderer isStandardViewer isSyntaxMorph isTextMorph isWorldMorph isWorldOrHandMorph)
('converting' asDraggableMorph)
('copying' copy deepCopy duplicate duplicateMorphCollection: fullCopy updateReferencesUsing: usableSiblingInstance veryDeepCopyWith: veryDeepFixupWith: veryDeepInner:)
('creation' asMorph)
('debug and other' addDebuggingItemsTo:hand: addMouseActionIndicatorsWidth:color: addMouseUpAction addMouseUpActionWith: addViewingItemsTo: allStringsAfter: altSpecialCursor0 altSpecialCursor1 altSpecialCursor2 altSpecialCursor3 altSpecialCursor3: buildDebugMenu: deleteAnyMouseActionIndicators handMeTilesToFire inspectArgumentsPlayerInMorphic: inspectOwnerChain installModelIn: mouseUpCodeOrNil ownerChain programmedMouseDown:for: programmedMouseEnter:for: programmedMouseLeave:for: programmedMouseUp:for: programmedMouseUp:for:with: removeMouseUpAction resumeAfterDrawError resumeAfterStepError tempCommand viewMorphDirectly)
('drawing' areasRemainingToFill: boundingBoxOfSubmorphs boundsWithinCorners changeClipSubmorphs clipLayoutCells clipLayoutCells: clipSubmorphs clipSubmorphs: clippingBounds doesOwnRotation drawDropHighlightOn: drawDropShadowOn: drawErrorOn: drawMouseDownHighlightOn: drawOn: drawPostscriptOn: drawRolloverBorderOn: drawSubmorphsOn: expandFullBoundsForDropShadow: expandFullBoundsForRolloverBorder: fullDrawOn: hasClipSubmorphsString hide highlightForMouseDown highlightForMouseDown: highlightedForMouseDown imageForm imageForm:forRectangle: imageFormDepth: imageFormForRectangle: imageFormWithout:andStopThere: refreshWorld shadowForm show visible visible:)
('drop shadows' addDropShadow addDropShadowMenuItems:hand: changeShadowColor hasDropShadow hasDropShadow: hasDropShadowString hasRolloverBorder hasRolloverBorder: removeDropShadow setShadowOffset: shadowColor shadowColor: shadowOffset shadowOffset: shadowPoint: toggleDropShadow)
('dropping/grabbing' aboutToBeGrabbedBy: disableDragNDrop dragEnabled dragEnabled: dragNDropEnabled dragSelectionColor dropEnabled dropEnabled: dropHighlightColor dropSuccessColor enableDrag: enableDragNDrop enableDragNDrop: enableDrop: formerOwner formerOwner: formerPosition formerPosition: grabTransform highlightForDrop highlightForDrop: highlightedForDrop justDroppedInto:event: justGrabbedFrom: nameForUndoWording rejectDropMorphEvent: repelsMorph:event: resetHighlightForDrop separateDragAndDrop slideBackToFormerSituation: slideToTrash: startDrag:with: toggleDragNDrop transportedMorph undoGrabCommand vanishAfterSlidingTo:event: wantsDroppedMorph:event: wantsToBeDroppedInto: wantsToBeOpenedInWorld willingToBeDiscarded)
('e-toy support' adaptToWorld: adoptVocabulary: allMorphsAndBookPagesInto: appearsToBeSameCostumeAs: asNumber: asWearableCostume asWearableCostumeOfExtent: automaticViewing changeAllBorderColorsFrom:to: configureForKids containingWindow copyCostumeStateFrom: currentPlayerDo: cursor cursor: decimalPlacesForGetter: defaultValueOrNil defaultVariableName definePath deletePath embedInWindow embeddedInMorphicWindowLabeled: enclosingEditor enforceTileColorPolicy fenceEnabled followPath getNumericValue gridFormOrigin:grid:background:line: isAViewer isCandidateForAutomaticViewing isTileEditor listViewLineForFieldList: makeGraphPaper makeGraphPaperGrid:background:line: mustBeBackmost noteDecimalPlaces:forGetter: noteNegotiatedName:for: objectViewed referencePlayfield rotationStyle rotationStyle: setAsActionInButtonProperties: setNaturalLanguageTo: setNumericValue: setStandardTexture slotSpecifications succeededInRevealing: textureParameters topEditor unlockOneSubpart updateCachedThumbnail wantsRecolorHandle wrappedInWindow: wrappedInWindowWithTitle:)
('event handling' click click: cursorPoint doubleClick: doubleClickTimeout: dropFiles: firstClickTimedOut: handlesKeyboard: handlesMouseDown: handlesMouseOver: handlesMouseOverDragging: handlesMouseStillDown: hasFocus keyDown: keyStroke: keyUp: keyboardFocusChange: mouseDown: mouseEnter: mouseEnterDragging: mouseLeave: mouseLeaveDragging: mouseMove: mouseStillDown: mouseStillDownThreshold mouseUp: on:send:to: on:send:to:withValue: removeLink: restoreSuspendedEventHandler startDrag: suspendEventHandler transformFrom: transformFromOutermostWorld transformFromWorld wantsDropFiles: wantsEveryMouseMove wantsKeyboardFocusFor: wouldAcceptKeyboardFocus wouldAcceptKeyboardFocusUponTab)
('events-accessing' actionMap updateableActionMap)
('events-alarms' addAlarm:after: addAlarm:at: addAlarm:with:after: addAlarm:with:at: addAlarm:with:with:after: addAlarm:with:with:at: addAlarm:withArguments:after: addAlarm:withArguments:at: alarmScheduler removeAlarm: removeAlarm:at:)
('events-processing' containsPoint:event: defaultEventDispatcher handleDropFiles: handleDropMorph: handleEvent: handleFocusEvent: handleKeyDown: handleKeyUp: handleKeystroke: handleListenEvent: handleMouseDown: handleMouseEnter: handleMouseLeave: handleMouseMove: handleMouseOver: handleMouseStillDown: handleMouseUp: handleUnknownEvent: handlerForMouseDown: mouseDownPriority processEvent: processEvent:using: rejectDropEvent: rejectsEvent: transformedFrom:)
('events-removing' releaseActionMap)
('fileIn/out' attachToResource prepareToBeSaved reserveUrl: saveAsResource saveDocPane saveOnURL saveOnURL: saveOnURLbasic updateAllFromResources updateFromResource)
('filter streaming' drawOnCanvas: fullDrawPostscriptOn:)
('genie-dispatching' blueButtonClickHand:shift: gesture: gestureCode: gestureCommand: gestureKeystrokes: gestureMouseEvent: gestureStrokes: handleGesture: isGestureUndoable: isSpecialCharacterUndoable: modifyGesture:by: undoGesture:)
('genie-menu' addGenieMenuItems:hand: changeGestureDictionary hasNotExportedGestureDictionary hasReferencedGestureDictionary inspectGestureDictionary makeOwnCopyOfGestureDictionary makeOwnSubGestureDictionary)
('genie-processing' allowsGestureEscape allowsGesturePreprocessing allowsGestureStart: defaultGestureDictionaryOrName disableGestures gestureDictionary gestureDictionaryOrName gestureDictionaryOrName: gestureHandler gestureStart: handlesGestureStart: onGestureSend:to:)
('geometry' align:with: bottom bottom: bottomCenter bottomLeft bottomLeft: bottomRight bottomRight: bounds bounds: bounds:from: bounds:in: boundsIn: boundsInWorld center center: extent extent: fullBoundsInWorld globalPointToLocal: gridPoint: griddedPoint: height height: innerBounds left left: leftCenter localPointToGlobal: minimumExtent minimumExtent: nextOwnerPage outerBounds point:from: point:in: pointFromWorld: pointInWorld: position position: positionInWorld positionSubmorphs previousOwnerPage right right: rightCenter screenLocation screenRectangle setConstrainedPosition:hangOut: shiftSubmorphsBy: shiftSubmorphsOtherThan:by: top top: topCenter topLeft topLeft: topRight topRight: transformedBy: width width: worldBounds worldBoundsForHalo)
('geometry eToy' addTransparentSpacerOfSize: beTransparent cartesianBoundsTopLeft cartesianXY: color:sees: colorUnder degreesOfFlex forwardDirection: getIndexInOwner goHome heading heading: move:toPosition: referencePosition referencePosition: referencePositionInWorld referencePositionInWorld: rotationCenter rotationCenter: setDirectionFrom: setIndexInOwner: touchesColor: transparentSpacerOfSize: wrap x x: x:y: y y:)
('geometry testing' containsPoint: fullContainsPoint: obtrudesBeyondContainer)
('halos and balloon help' addHalo addHalo: addHalo:from: addHandlesTo:box: addMagicHaloFor: addOptionalHandlesTo:box: addSimpleHandlesTo:box: addWorldHandlesTo:box: balloonColor balloonColor: balloonFont balloonFont: balloonHelpAligner balloonHelpDelayTime balloonHelpTextForHandle: boundsForBalloon comeToFrontAndAddHalo defaultBalloonColor defaultBalloonFont defersHaloOnClickTo: deleteBalloon editBalloonHelpContent: editBalloonHelpText halo haloClass haloDelayTime hasHalo hasHalo: isLikelyRecipientForMouseOverHalos mouseDownOnHelpHandle: noHelpString okayToAddDismissHandle okayToAddGrabHandle okayToBrownDragEasily okayToExtractEasily okayToResizeEasily okayToRotateEasily removeHalo setBalloonText: setBalloonText:maxLineLength: setCenteredBalloonText: showBalloon: showBalloon:hand: transferHalo:from: wantsBalloon wantsDirectionHandles wantsDirectionHandles: wantsHalo wantsHaloFor: wantsHaloFromClick wantsHaloHandleWithSelector:inHalo: wantsScriptorHaloHandle)
('initialization' basicInitialize defaultBounds defaultColor inATwoWayScrollPane initialize intoWorld: openCenteredInWorld openInHand openInMVC openInWindow openInWindowLabeled: openInWindowLabeled:inWorld: openInWorld openInWorld: outOfWorld: resourceJustLoaded standardPalette)
('layout' acceptDroppingMorph:event: adjustLayoutBounds doLayoutIn: fullBounds layoutBounds layoutBounds: layoutChanged layoutInBounds: layoutProportionallyIn: minExtent minHeight minHeight: minWidth minWidth: privateFullBounds submorphBounds)
('layout-menu' addCellLayoutMenuItems:hand: addLayoutMenuItems:hand: addTableLayoutMenuItems:hand: changeCellInset: changeClipLayoutCells changeDisableTableLayout changeLayoutInset: changeListDirection: changeMaxCellSize: changeMinCellSize: changeNoLayout changeProportionalLayout changeReverseCells changeRubberBandCells changeTableLayout hasClipLayoutCellsString hasDisableTableLayoutString hasNoLayoutString hasProportionalLayoutString hasReverseCellsString hasRubberBandCellsString hasTableLayoutString layoutMenuPropertyString:from:)
('layout-properties' assureLayoutProperties assureTableProperties cellInset cellInset: cellPositioning cellPositioning: cellPositioningString: cellSpacing cellSpacing: cellSpacingString: disableTableLayout disableTableLayout: hResizing hResizing: hResizingString: layoutFrame layoutFrame: layoutInset layoutInset: layoutPolicy layoutPolicy: layoutProperties layoutProperties: listCentering listCentering: listCenteringString: listDirection listDirection: listDirectionString: listSpacing listSpacing: listSpacingString: maxCellSize maxCellSize: minCellSize minCellSize: reverseTableCells reverseTableCells: rubberBandCells rubberBandCells: spaceFillWeight spaceFillWeight: vResizeToFit: vResizing vResizing: vResizingString: wrapCentering wrapCentering: wrapCenteringString: wrapDirection wrapDirection: wrapDirectionString:)
('macpal' beep: currentVocabulary flash scriptPerformer)
('menu' addBorderStyleMenuItems:hand:)
('menus' absorbStateFromRenderer: adMiscExtrasTo: addAddHandMenuItemsForHalo:hand: addCopyItemsTo: addCustomHaloMenuItems:hand: addCustomMenuItems:hand: addExportMenuItems:hand: addFillStyleMenuItems:hand: addHaloActionsTo: addPaintingItemsTo:hand: addPlayerItemsTo: addStackItemsTo: addStandardHaloMenuItemsTo:hand: addTitleForHaloMenu: addToggleItemsToHaloMenu: adhereToEdge adhereToEdge: adjustedCenter adjustedCenter: allMenuWordings changeColor changeDirectionHandles changeDragAndDrop chooseNewGraphic chooseNewGraphicCoexisting: chooseNewGraphicFromHalo collapse dismissButton doMenuItem: exportAsBMP exportAsGIF exportAsJPEG hasDirectionHandlesString hasDragAndDropEnabledString helpButton inspectInMorphic inspectInMorphic: lockUnlockMorph lockedString makeNascentScript maybeAddCollapseItemTo: menuItemAfter: menuItemBefore: presentHelp printPSToFile printPSToFileNamed: putOnBackground putOnForeground resetForwardDirection resistsRemovalString setArrowheads setRotationCenter setRotationCenterFrom: setToAdhereToEdge: snapToEdgeIfAppropriate stickinessString transferStateToRenderer: uncollapseSketch)
('messenger' affiliatedSelector)
('meta-actions' addEmbeddingMenuItemsTo:hand: applyStatusToAllSiblings: beThisWorldsModel blueButtonDown: blueButtonUp: bringAllSiblingsToMe: buildHandleMenu: buildMetaMenu: changeColorTarget:selector:originalColor:hand: copyToPasteBuffer: dismissMorph: duplicateMorph: embedInto: grabMorph: handlerForBlueButtonDown: handlerForMetaMenu: inspectAt:event: invokeMetaMenu: invokeMetaMenuAt:event: makeMultipleSiblings: makeNewPlayerInstance: makeSiblings: makeSiblingsLookLikeMe: maybeDuplicateMorph maybeDuplicateMorph: openAButtonPropertySheet openAPropertySheet openATextPropertySheet potentialEmbeddingTargets resizeFromMenu resizeMorph: saveAsPrototype showActions showHiders subclassMorph)
('miscellaneous' setExtentFromHalo:)
('naming' choosePartName downshiftedNameOfObjectRepresented innocuousName name: nameForFindWindowFeature nameInModel nameOfObjectRepresented setNamePropertyTo: setNameTo: specialNameInModel tryToRenameTo: updateAllScriptingElements)
('object fileIn' convertAugust1998:using: convertNovember2000DropShadow:using:)
('objects from disk' convertToCurrentVersion:refStream: objectForDataStream: saveOnFile storeDataOn:)
('other' removeAllButFirstSubmorph)
('other events' menuButtonMouseEnter: menuButtonMouseLeave:)
('parts bin' inPartsBin initializeToStandAlone isPartsBin isPartsDonor isPartsDonor: markAsPartsDonor partRepresented residesInPartsBin)
('pen' choosePenColor: choosePenSize getPenColor getPenDown getPenSize liftPen lowerPen penColor: penUpWhile: trailMorph)
('piano rolls' addMorphsTo:pianoRoll:eventTime:betweenTime:and: encounteredAtTime:inScorePlayer:atIndex:inEventTrack:secsPerTick: justDroppedIntoPianoRoll:event: pauseFrom: resetFrom: resumeFrom: triggerActionFromPianoRoll)
('player' assureExternalName assuredCardPlayer assuredPlayer currentDataValue newPlayerInstance okayToDuplicate shouldRememberCostumes showPlayerMenu variableDocks)
('player commands' jumpTo: makeFenceSound set:)
('player viewer' openViewerForArgument updateLiteralLabel)
('printing' asEPS asPostscript asPostscriptPrintJob clipPostscript colorString: constructorString fullPrintOn: initString morphReport morphReportFor: morphReportFor:on:indent: pagesHandledAutomatically printConstructorOn:indent: printConstructorOn:indent:nodeDict: printOn: printSpecs printSpecs: printStructureOn:indent: reportableSize structureString textToPaste)
('rotate scale and flex' addFlexShell addFlexShellIfNecessary keepsTransform newTransformationMorph rotationDegrees)
('rounding' cornerStyle: roundedCorners roundedCornersString toggleCornerRounding wantsRoundedCorners)
('scripting' asEmptyPermanentScriptor bringTileScriptingElementsUpToDate bringUpToDate categoriesForViewer defaultFloatPrecisionFor: instantiatedUserScriptsDo: isTileLike isTileScriptingElement jettisonScripts makeAllTilesColored makeAllTilesGreen restoreTypeColor scriptEditorFor: selectorsForViewer tearOffTile triggerScript: useUniformTileColor viewAfreshIn:showingScript:at:)
('stepping and presenter' arrangeToStartStepping arrangeToStartSteppingIn: isStepping isSteppingSelector: start startStepping startStepping:at:arguments:stepTime: startSteppingIn: startSteppingSelector: step stepAt: stop stopStepping stopSteppingSelector: stopSteppingSelfAndSubmorphs)
('structure' activeHand allOwners allOwnersDo: firstOwnerSuchThat: hasOwner: isInWorld morphPreceding: nearestOwnerThat: orOwnerSuchThat: outermostMorphThat: outermostWorldMorph owner ownerThatIsA: ownerThatIsA:orA: pasteUpMorph pasteUpMorphHandlingTabAmongFields primaryHand renderedMorph root rootAt: topPasteUp topRendererOrSelf withAllOwners withAllOwnersDo: world)
('submorphs-accessing' allKnownNames allMorphs allMorphsDo: allNonSubmorphMorphs allSubmorphNamesDo: findA: findDeepSubmorphThat:ifAbsent: findDeeplyA: findSubmorphBinary: firstSubmorph hasSubmorphWithProperty: hasSubmorphs indexOfMorphAbove: lastSubmorph morphsAt: morphsAt:behind:unlocked: morphsAt:unlocked: morphsAt:unlocked:do: morphsInFrontOf:overlapping:do: morphsInFrontOverlapping: morphsInFrontOverlapping:do: rootMorphsAt: rootMorphsAtGlobal: shuffleSubmorphs submorphAfter submorphBefore submorphCount submorphNamed: submorphNamed:ifNone: submorphOfClass: submorphThat:ifNone: submorphWithProperty: submorphs submorphsBehind:do: submorphsDo: submorphsInFrontOf:do: submorphsReverseDo: submorphsSatisfying:)
('submorphs-add/remove' abandon actWhen actWhen: addAllMorphs: addAllMorphs:after: addMorph: addMorph:after: addMorph:asElementNumber: addMorph:behind: addMorph:fullFrame: addMorph:inFrontOf: addMorphBack: addMorphCentered: addMorphFront: addMorphFront:fromWorldPosition: addMorphFrontFromWorldPosition: addMorphNearBack: comeToFront copyWithoutSubmorph: delete deleteSubmorphsWithProperty: dismissViaHalo goBehind privateDelete removeAllMorphs removeAllMorphsIn: replaceSubmorph:by: submorphIndexOf:)
('system primitives' creationStamp)
('testing' canDrawAtHigherResolution canDrawBorder: completeModificationHash isFlexed isMorph knownName modificationHash renameTo: shouldDropOnMouseUp stepTime wantsSteps)
('text-anchor' addTextAnchorMenuItems:hand: changeDocumentAnchor changeInlineAnchor changeParagraphAnchor hasDocumentAnchorString hasInlineAnchorString hasParagraphAnchorString relativeTextAnchorPosition relativeTextAnchorPosition: textAnchorType textAnchorType:)
('texture support' isValidWonderlandTexture isValidWonderlandTexture: wonderlandTexture wonderlandTexture:)
('thumbnail' demandsThumbnailing morphRepresented permitsThumbnailing readoutForField: representativeNoTallerThan:norWiderThan:thumbnailHeight: updateThumbnailUrl updateThumbnailUrlInBook:)
('undo' commandHistory undoMove:redo:owner:bounds:predecessor:)
('updating' changed)
('user interface' defaultLabelForInspector initialExtent)
('viewer' externalName)
('visual properties' canHaveFillStyles cornerStyle fillStyle fillStyle: fillWithRamp:oriented: useBitmapFill useDefaultFill useGradientFill useSolidFill)
('private' moveWithPenDownBy: moveWithPenDownByRAA: privateAddMorph:atIndex: privateBounds: privateColor: privateDeleteWithAbsolutelyNoSideEffects privateFullBounds: privateFullMoveBy: privateMoveBy: privateOwner: privateRemoveMorph: privateRemoveMorphWithAbsolutelyNoSideEffects: privateSubmorphs privateSubmorphs:)
('*Refactory-RBExternalBrowserReferences' defineTempCommand)
('*Balloon3D-Wonderland' asTexture installAsWonderlandTextureOn: mapPrimitiveVertex:)
('keyboard focus rotation' addToKeyboardFocusChain: handlesKeyboardFocusRotation: keyboardFocusRotationHandler keyboardFocusRotationHandler: rotateKeyboardFocus:)
!

