'From Squeak3.7alpha of ''11 September 2003'' [latest update: #5566] on 26 November 2003 at 1:50:44 pm'!
"Change Set:		passWindowActivationClick
Date:			26 November 2003
Author:			Hernan Pablo Tylim

This change set is Andreas' quick tweak to SystemWindow>>mouseDown: to make windows activation click be forwarded to its submorphs.

See Andreas mail here: http://groups.yahoo.com/group/squeak/message/73813.

For your convenience a preference #passWindowActivationClick has been added, and additionaly, pressing shift while clicking on a pasive window will also stop the click to be forwarded to the submorphs when the preference is enabled.
"!


!SystemWindow methodsFor: 'events' stamp: 'hpt 11/26/2003 13:16'!
mouseDown: evt

	self setProperty: #clickPoint toValue: evt cursorPoint.
	TopWindow == self ifFalse:
		[evt hand releaseKeyboardFocus.
		self activate;
			passWindowActivationClick: evt].
	model windowActiveOnFirstClick ifTrue:
		["Normally window keeps control of first click.
		Need explicit transmission for first-click activity."
		submorphs do: [:m | (m containsPoint: evt cursorPoint) ifTrue: [m mouseDown: evt]]]

! !

!SystemWindow methodsFor: 'events' stamp: 'hpt 11/26/2003 13:16'!
passWindowActivationClick: evt
	((Preferences valueOfFlag: #passWindowActivationClick ifAbsent: [false]) and: 
		[evt shiftPressed not]) 
			ifTrue: [self processEvent: evt copy resetHandlerFields].! !

"Postscript:
Installing #passWindowActivationClick preference"
Preferences addPreference: #passWindowActivationClick category: #windows default:  true balloonHelp: 'if true, windows activation clicks will be forwarded to the windows submorphs'.

!

