Object subclass: #ClassBuilderTestClass
	instanceVariableNames: 'var1 var2 '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Tests-ClassBuilder'!

!ClassBuilderTestClass methodsFor: 'as yet unclassified' stamp: 'ar 2/28/2003 00:36'!
var1
	^var1! !

!ClassBuilderTestClass methodsFor: 'as yet unclassified' stamp: 'ar 2/28/2003 00:37'!
var1: anObject
	var1 := anObject! !

!ClassBuilderTestClass methodsFor: 'as yet unclassified' stamp: 'ar 2/28/2003 00:36'!
var2
	^var2! !

!ClassBuilderTestClass methodsFor: 'as yet unclassified' stamp: 'ar 2/28/2003 00:37'!
var2: anObject
	var2 := anObject! !


ClassBuilderTestClass subclass: #ClassBuilderTestSubClass
	instanceVariableNames: 'var3 var4 '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Tests-ClassBuilder'!

!ClassBuilderTestSubClass methodsFor: 'as yet unclassified' stamp: 'ar 2/28/2003 00:47'!
var3
	^var3! !

!ClassBuilderTestSubClass methodsFor: 'as yet unclassified' stamp: 'ar 2/28/2003 00:47'!
var3: obj
	var3 := obj.! !

!ClassBuilderTestSubClass methodsFor: 'as yet unclassified' stamp: 'ar 2/28/2003 00:47'!
var4
	^var4! !

!ClassBuilderTestSubClass methodsFor: 'as yet unclassified' stamp: 'ar 2/28/2003 00:47'!
var4: obj
	var4 := obj! !


TestCase subclass: #ClassBuilderTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Tests-ClassBuilder'!

!ClassBuilderTests methodsFor: 'Running' stamp: 'ar 2/28/2003 00:44'!
setUp
	"make sure we're up to date here"
	Object subclass: #ClassBuilderTestClass
		instanceVariableNames: 'var1 var2'
		classVariableNames: ''
		poolDictionaries: ''
		category: 'Kernel-Tests-ClassBuilder'.! !

!ClassBuilderTests methodsFor: 'Running' stamp: 'ar 2/28/2003 00:46'!
tearDown
	"make sure we're up to date here"
	Object subclass: #ClassBuilderTestClass
		instanceVariableNames: 'var1 var2'
		classVariableNames: ''
		poolDictionaries: ''
		category: 'Kernel-Tests-ClassBuilder'.! !

!ClassBuilderTests methodsFor: 'Running' stamp: 'ar 2/28/2003 00:52'!
testReshapeClass
	"see if reshaping classes works"
	| testInstance testClass testMeta newClass newMeta |
	testClass := ClassBuilderTestClass.
	testMeta := testClass class.
	testInstance := testClass new.
	testInstance var1: 42.
	testInstance var2: 'hello'.

	newClass := Object subclass: #ClassBuilderTestClass
		instanceVariableNames: 'foo var1 bar var2 mumble'
		classVariableNames: ''
		poolDictionaries: ''
		category: 'Kernel-Tests-ClassBuilder'.
	newMeta := newClass class.

	"test transparency of mapping"
	self assert: (testInstance var1 = 42).
	self assert: (testInstance var2 = 'hello').

	self assert: (testInstance instVarAt: 1) isNil.
	self assert: (testInstance instVarAt: 2) = 42.
	self assert: (testInstance instVarAt: 3) isNil.
	self assert: (testInstance instVarAt: 4) = 'hello'.
	self assert: (testInstance instVarAt: 5) isNil.

	"test transparency of reshapes"
	self assert: (testInstance class == newClass).
	self assert: (testClass == newClass).
	self assert: (testMeta == newMeta).
! !

!ClassBuilderTests methodsFor: 'Running' stamp: 'ar 2/28/2003 00:52'!
testReshapeClassWithJugglingInstVars
	"see if reshapes of classes juggle their instVars correctly"
	| testInstance testClass testMeta newClass newMeta |
	testClass := ClassBuilderTestClass.
	testMeta := testClass class.
	testInstance := testClass new.
	testInstance var1: 42.
	testInstance var2: 'hello'.

	newClass := Object subclass: #ClassBuilderTestClass
		instanceVariableNames: 'var2 foo bar mumble var1'
		classVariableNames: ''
		poolDictionaries: ''
		category: 'Kernel-Tests-ClassBuilder'.
	newMeta := newClass class.

	"test transparency of mapping"
	self assert: (testInstance var1 = 42).
	self assert: (testInstance var2 = 'hello').

	self assert: (testInstance instVarAt: 1) = 'hello'.
	self assert: (testInstance instVarAt: 2) isNil.
	self assert: (testInstance instVarAt: 3) isNil.
	self assert: (testInstance instVarAt: 4) isNil.
	self assert: (testInstance instVarAt: 5) = 42.

	"test transparency of reshapes"
	self assert: (testInstance class == newClass).
	self assert: (testClass == newClass).
	self assert: (testMeta == newMeta).
! !

!ClassBuilderTests methodsFor: 'Running' stamp: 'ar 2/28/2003 00:53'!
testReshapeSubClass
	"see if reshaping a class updates the instances of its subclass correctly"
	| testInstance testClass testMeta |
	testClass := ClassBuilderTestSubClass.
	testMeta := testClass class.
	testInstance := testClass new.
	testInstance var1: 42.
	testInstance var2: 'hello'.
	testInstance var3: 'foo'.
	testInstance var4: #bar.

	Object subclass: #ClassBuilderTestClass
		instanceVariableNames: 'var1 foo var2 bar mumble '
		classVariableNames: ''
		poolDictionaries: ''
		category: 'Kernel-Tests-ClassBuilder'.

	"test transparency of mapping"
	self assert: (testInstance var1 = 42).
	self assert: (testInstance var2 = 'hello').
	self assert: (testInstance var3 = 'foo').
	self assert: (testInstance var4 = #bar).

	self assert: (testInstance instVarAt: 1) = 42.
	self assert: (testInstance instVarAt: 2) isNil.
	self assert: (testInstance instVarAt: 3) = 'hello'.
	self assert: (testInstance instVarAt: 4) isNil.
	self assert: (testInstance instVarAt: 5) isNil.
	self assert: (testInstance instVarAt: 6) = 'foo'.
	self assert: (testInstance instVarAt: 7) = #bar.

	"test transparency of reshapes"
	self assert: (testInstance class == ClassBuilderTestSubClass).
	self assert: (testClass == ClassBuilderTestSubClass).
	self assert: (testMeta == ClassBuilderTestSubClass class).
! !
