'From Squeak3.2 of 11 July 2002 [latest update: #4956] on 24 February 2003 at 1:07:01 pm'!
TestCase subclass: #BCCMTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SUnit-Tests'!
!BCCMTestCase commentStamp: 'HJH 2/24/2003 13:06' prior: 0!
This class contains some tests regarding the classes 
	Behavior
		ClassDescription
			Class
			Metaclass
---
	!
]style[(55 8 3 16 4 5 4 9 6)f1,f1LBehavior Comment;,f1,f1LClassDescription Comment;,f1,f1LClass Comment;,f1,f1LMetaclass Comment;,f1!


!BCCMTestCase methodsFor: 'as yet unclassified' stamp: 'HJH 2/24/2003 11:29'!
test01metaclassName


	self assert: Dictionary class  name = 'Dictionary class'.
	self assert: OrderedCollection class name = 'OrderedCollection class'.
	! !

!BCCMTestCase methodsFor: 'as yet unclassified' stamp: 'HJH 2/24/2003 11:28'!
test02metaclassNumberOfInstances


	self assert: Dictionary class allInstances size  = 1.
	self assert: OrderedCollection class allInstances size  = 1.! !

!BCCMTestCase methodsFor: 'as yet unclassified' stamp: 'HJH 2/24/2003 11:36'!
test03superclass


	| s |
	self assert: Dictionary superclass == Set.
	self assert: OrderedCollection superclass == SequenceableCollection.

	s _ OrderedCollection new.
	s add: SequenceableCollection.
	s add: Collection.
	s add: Object.
	s add: ProtoObject.

	self assert: OrderedCollection allSuperclasses = s.

	
	! !

!BCCMTestCase methodsFor: 'as yet unclassified' stamp: 'HJH 2/24/2003 11:39'!
test04metaclassSuperclass


	| s |
	self assert: Dictionary class superclass == Set class.
	self assert: OrderedCollection class superclass == SequenceableCollection class.

	! !

!BCCMTestCase methodsFor: 'as yet unclassified' stamp: 'HJH 2/24/2003 12:53'!
test05metaclassSuperclassHierarchy


	| s |
	
	self assert: SequenceableCollection class instanceCount  = 1.
	self assert: Collection class instanceCount  = 1.
	self assert: Object class instanceCount  = 1.
	self assert: ProtoObject class instanceCount  = 1.
	
	s _ OrderedCollection new.
	s add: SequenceableCollection class.
	s add: Collection class.
	s add: Object class.
	s add: ProtoObject class.

	s add: Class.
	s add: ClassDescription.
	s add: Behavior.
	s add: Object.
	s add: ProtoObject.

	self assert: OrderedCollection class allSuperclasses  = s.



	
	

	! !

!BCCMTestCase methodsFor: 'as yet unclassified' stamp: 'HJH 2/24/2003 12:53'!
test06ClassDescriptionAllSubInstances


	
	| cdNo clsNo metaclsNo |

	cdNo _ ClassDescription allSubInstances size.
	clsNo _ Class allSubInstances size .
	metaclsNo _ Metaclass allSubInstances size.

	self assert: cdNo = (clsNo + metaclsNo).

	
	
	



	
	

	! !

!BCCMTestCase methodsFor: 'as yet unclassified' stamp: 'HJH 2/24/2003 12:12'!
test06bClassDescriptionAllSubInstances

	"What is happening here ? Why the difference? Does this difference stay the same accross Squeak versions?"
	
	|  clsNo metaclsNo n |

	n _ Object allSubclasses size.
	clsNo _ Class allSubInstances size .
	metaclsNo _ Metaclass allSubInstances size.

	self assert: (n + 8)= (clsNo + metaclsNo).

	
	
	



	
	

	! !

!BCCMTestCase methodsFor: 'as yet unclassified' stamp: 'HJH 2/24/2003 13:02'!
test07bmetaclassPointOfCircularity

	

	self assert: Metaclass class instanceCount = 1.
	self assert: Metaclass class someInstance == Metaclass.


	
	
	



	
	

	! !

!BCCMTestCase methodsFor: 'as yet unclassified' stamp: 'HJH 2/24/2003 12:16'!
test07metaclass

	

	self assert: OrderedCollection class class == Metaclass.
	self assert: OrderedCollection class class = Metaclass.

	self assert: Dictionary class class == Metaclass.
	self assert: Dictionary class class = Metaclass.


	self assert: Object class class == Metaclass.
	self assert: Object class class = Metaclass.



	
	
	



	
	

	! !

!BCCMTestCase methodsFor: 'as yet unclassified' stamp: 'HJH 2/24/2003 12:25'!
test08BCCMhierarchy

	

	self assert: Class superclass  == ClassDescription.
	self assert: Metaclass superclass == ClassDescription.

	self assert: ClassDescription superclass  == Behavior.
	self assert: Behavior superclass  = Object.


	self assert: Class class class ==  Metaclass.
	self assert: Metaclass class class  == Metaclass.
	self assert: ClassDescription class class == Metaclass.
	self assert: Behavior class class == Metaclass.




	
	
	



	
	

	! !

!BCCMTestCase methodsFor: 'as yet unclassified' stamp: 'HJH 2/24/2003 12:43'!
test09ObjectAllSubclasses

	| n2 |
	n2 _ Object allSubclasses size.
	self assert: n2 = (Object allSubclasses
			select: [:cls | cls class class == Metaclass
					or: [cls class == Metaclass]]) size! !
