'From Squeak3.6alpha of ''17 March 2003'' [latest update: #5269] on 18 June 2003 at 8:37:59 pm'!
Object subclass: #KCPStreamSpliter
	instanceVariableNames: 'removal classCreatedByChangeSets changesetsList '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KCPStreamSpliter'!

!FilePackage methodsFor: 'fileIn/fileOut' stamp: 'ab 6/18/2003 15:33'!
fileOutDoits: aStream
	aStream cr.
	doIts do:[:chgRec| chgRec fileOutOn: aStream].! !

!FilePackage methodsFor: 'fileIn/fileOut' stamp: 'ab 6/15/2003 18:22'!
fileOutNamed: fileName
	| stream |
	stream := FileStream newFileNamed: fileName.
	sourceSystem isEmpty ifFalse:[
		stream nextChunkPut: sourceSystem printString;cr ].
	self fileOutOn: stream.
	stream cr; cr.
	self classes do:[:cls|
		cls needsInitialize ifTrue:[
			stream cr; nextChunkPut: cls name,' initialize']].
	stream cr.
	stream close.

	"DeepCopier new checkVariables."
! !

!FilePackage methodsFor: 'fileIn/fileOut' stamp: 'ab 6/16/2003 13:52'!
fileOutNamed: fileName processingDoIt: doitProcess
	| stream |
	stream := FileStream newFileNamed: fileName.
	sourceSystem isEmpty ifFalse:[
		stream nextChunkPut: sourceSystem printString;cr ].
	self fileOutOn: stream processingDoIt: doitProcess.
	stream cr; cr.
	self classes do:[:cls|
		cls needsInitialize ifTrue:[
			stream cr; nextChunkPut: cls name,' initialize']].
	stream cr.
	stream close.

	"DeepCopier new checkVariables."
! !

!FilePackage methodsFor: 'fileIn/fileOut' stamp: 'ab 6/16/2003 13:54'!
fileOutOn: aStream processingDoIt: doitsMark
	"doitsMark has to be #doNotProcess #putAtTheBeginning #putAtTheEnd"
	(#(#doNotProcess #putAtTheBeginning #putAtTheEnd) includes: doitsMark) 
		ifFalse: [self error: 'Provide an acceptable process name for managing doit'].
	doitsMark == #putAtTheBeginning ifTrue: [self fileOutDoits: aStream].
	classOrder do:[:cls|
		cls fileOutDefinitionOn: aStream.
	].
	classes do:[:cls|
		cls fileOutMethodsOn: aStream.
		cls hasMetaclass ifTrue:[cls metaClass fileOutMethodsOn: aStream].
	].
	doitsMark == #putAtTheEnd ifTrue:[self fileOutDoits: aStream].! !

!FilePackage methodsFor: 'GUI' stamp: 'ab 6/15/2003 18:31'!
askForDoits
	| menu choice choices |
	choices := #('do not process' 'at the beginning' 'at the end' 'cancel').
	menu _ SelectionMenu selections: choices.
	choice := nil.
	[choices includes: choice] whileFalse: [
		choice _ menu startUpWithCaption: 
'The package contains unprocessed doIts.
When would like to process those?'].
	^choices indexOf: choice! !

!FilePackage methodsFor: 'GUI' stamp: 'ab 6/15/2003 18:31'!
fileOut
	| fileName |
	fileName := FillInTheBlank request: 'Enter the file name' initialAnswer:''.
	self fileOutNamed: fileName! !


!KCPStreamSpliter methodsFor: 'initialize' stamp: 'ab 6/17/2003 11:27'!
initialize
	removal := Dictionary new.
	classCreatedByChangeSets := Dictionary new.
	changesetsList := OrderedCollection new.
	! !

!KCPStreamSpliter methodsFor: 'initialization-removal' stamp: 'ab 6/13/2003 17:37'!
defineRemovalNamed: aName composedByFiles: fileList
	| classes filePackage |
	classes := OrderedCollection new.
	fileList do: [:filename|
		filePackage := FilePackage fromFileNamed: filename.
		filePackage classes associationsDo: [:assoc|
			assoc value hasDefinition ifTrue: [ classes add: assoc key]]].
	removal at: aName asSymbol put: classes! !

!KCPStreamSpliter methodsFor: 'network' stamp: 'ab 6/13/2003 15:19'!
getChangeSetsUrlsFrom: anUrlOrString 
	"answer a collection of string with the full url for evey  
	changeset in the page"
	| informMessage result |
	informMessage _ 'Getting urls from "' , anUrlOrString asString , '"...'.
	Transcript show: informMessage;
		 cr.
	""
	result _ Set new.
	Utilities
		informUser: informMessage
		during: [| url response parsedDocument | 
			url _ anUrlOrString asUrl.
			response _ HTTPSocket httpGet: anUrlOrString asString.
			""
			parsedDocument _ HtmlParser parse: response contents.
			parsedDocument
				allSubentitiesDo: [:each | ""
					(each isKindOf: HtmlAnchor)
						ifTrue: [| href | 
							href _ each href.
							(('*.cs.gz' match: href) or: [('*.cs' match: href)])
								ifTrue: [result add: (url newFromRelativeText: href) asString]]]].
	^ result asSortedCollection! !

!KCPStreamSpliter methodsFor: 'network' stamp: 'ab 6/13/2003 16:51'!
getFilePackageFrom: anUrl
	| changeSetName contents |
	contents _ anUrl retrieveContents content unzipped readStream contents.
	changeSetName _ anUrl path last sansPeriodSuffix.
	(FileStream fileNamed: changeSetName) nextPutAll: contents; close.

	^ FilePackage fromFileNamed: changeSetName.
! !

!KCPStreamSpliter methodsFor: 'split' stamp: 'ab 6/17/2003 14:37'!
createDoIt
	| file |
	file := FileStream newFileNamed: ('KCP', FileDirectory pathNameDelimiter asString, 'doit.st').
	changesetsList do: [:changeSetName|
		file nextPutAll: ('(FileStream fileNamed: ''', changeSetName, ''') fileIntoNewChangeSet.'); cr]
! !

!KCPStreamSpliter methodsFor: 'split' stamp: 'ab 6/17/2003 10:52'!
createIfNecessaryKCPFolder
	| fd |
	fd := FileDirectory on: (FileDirectory default pathName).
	(fd directoryExists: 'KCP')
		ifFalse: [fd createDirectory: 'KCP'].! !

!KCPStreamSpliter methodsFor: 'split' stamp: 'ab 6/14/2003 14:20'!
getClassesFromFilePackage: fp
	| classes |
	classes := OrderedCollection new.
	fp classes associationsDo: [:assoc| 
		classes add: assoc key].
	^ classes! !

!KCPStreamSpliter methodsFor: 'split' stamp: 'ab 6/14/2003 14:19'!
getDefinedClassesFromFilePackage: fp
	| classes |
	classes := OrderedCollection new.
	fp classes associationsDo: [:assoc| 
		(assoc value hasDefinition)
			ifFalse: [classes add: assoc key]].
	^ classes! !

!KCPStreamSpliter methodsFor: 'split' stamp: 'ab 6/13/2003 15:46'!
removalContainingClassNamed: classname
	removal associationsDo: [:assoc|
		(assoc value includes: classname asSymbol)
			ifTrue: [^ assoc key]].
	^ nil! !

!KCPStreamSpliter methodsFor: 'split' stamp: 'ab 6/17/2003 10:52'!
saveChangeSetComposedBy: changetSetForMainStream named: changeSetName
	| fd stream |
	self createIfNecessaryKCPFolder.
	"--"
	fd := FileDirectory on: (FileDirectory default pathName, FileDirectory pathNameDelimiter asString, 'KCP').
	"--"
	stream := fd newFileNamed: changeSetName.
	changetSetForMainStream do: [:pseudoClass| pseudoClass fileOutOn: stream].
	stream close.! !

!KCPStreamSpliter methodsFor: 'split' stamp: 'ab 6/14/2003 15:57'!
saveRemovalChangeset: classesBelongingToRemoval named: changeSetName
	| fd stream |
	fd := FileDirectory on: (FileDirectory default pathName).
	(fd directoryExists: 'KCP')
		ifFalse: [fd createDirectory: 'KCP'].
	"--"
	fd := FileDirectory on: (FileDirectory default pathName, FileDirectory pathNameDelimiter asString, 'KCP').
	(fd directoryExists: changeSetName)
		ifFalse: [fd createDirectory: changeSetName].
	"--"	
	fd := FileDirectory on: (FileDirectory default pathName, FileDirectory pathNameDelimiter asString, 'KCP', FileDirectory pathNameDelimiter asString, changeSetName).
	"--"	
	stream := fd newFileNamed: changeSetName.
	classesBelongingToRemoval associationsDo: [:assoc| assoc value fileOutOn: stream].
	stream close.
		! !

!KCPStreamSpliter methodsFor: 'split' stamp: 'ab 6/14/2003 15:57'!
saveRemovalChangesets: classesBelongingToRemovals named: changeSetName
	classesBelongingToRemovals associationsDo: [:assoc|
		|classesBelongingToRemoval|
		classesBelongingToRemoval := assoc value.
		(classesBelongingToRemoval size > 0)
			ifTrue: [
				self saveRemovalChangeset: classesBelongingToRemoval 
					named: (assoc key asString, changeSetName)]].! !

!KCPStreamSpliter methodsFor: 'split' stamp: 'ab 6/18/2003 20:32'!
splitChangeSet: anUrl 
	| fp classes classesBelongingToRemovals removalName changeSetForUnknown changeSetname originalChangeSetName |
	fp _ self getFilePackageFrom: anUrl.
	originalChangeSetName _ anUrl path last sansPeriodSuffix.
	changeSetname _ originalChangeSetName.
	classes _ fp classes.
	classesBelongingToRemovals _ Dictionary new.
	changeSetForUnknown _ OrderedCollection new.
	classes
		associationsDo: [:assoc | 
			| classname pseudoClass | 
			classname _ assoc key.
			pseudoClass _ assoc value.

			"if the changeset defines the class"
			pseudoClass hasDefinition 
				ifTrue: [classCreatedByChangeSets at: assoc key put: assoc value].

			"Check if the class belongs to any removal"
			removalName _ self removalContainingClassNamed: classname.
			removalName
				ifNil: ["It doesn't belongs to any removal"
					   "Is it a class belonging to the system?"
					   "yes, so we keep this class in the main stream"
						(Smalltalk includesKey: classname)
						ifFalse: ["no, then check if the changeset creates this class"
								(classCreatedByChangeSets includesKey: classname)
									ifFalse: [fp removeClass: pseudoClass.
											changeSetForUnknown add: pseudoClass]]]

				ifNotNil: ["We class was removed by a removal"
							(classesBelongingToRemovals includesKey: removalName)
								ifFalse: [classesBelongingToRemovals at: removalName put: OrderedCollection new].
							(classesBelongingToRemovals at: removalName)
								add: pseudoClass.
							fp removeClass: pseudoClass]].
	"---"
	changeSetForUnknown isEmpty not
		ifTrue: [classesBelongingToRemovals at: #Unclassified put: changeSetForUnknown].
	"---"
	self saveRemovalChangesets: classesBelongingToRemovals named: changeSetname.

	"self saveChangeSetComposedBy: changetSetForMainStream named: changeSetName"

	changeSetname := FileDirectory default pathName, FileDirectory pathNameDelimiter asString, 'KCP', FileDirectory pathNameDelimiter asString, changeSetname, '.cs'.
	changesetsList add: changeSetname.
	""
	classesBelongingToRemovals isEmpty 
		ifTrue: [FileDirectory default copyFileNamed: originalChangeSetName toFileNamed: changeSetname]
		ifFalse: [fp fileOutNamed: changeSetname processingDoIt: #putAtTheEnd]
! !

!KCPStreamSpliter methodsFor: 'split' stamp: 'ab 6/18/2003 20:21'!
splitChangeSets: urlCollection 
	| ignored fileIns |
	ignored _ 0.
	fileIns _ 0.
	""
	self createIfNecessaryKCPFolder.
	""
	Utilities
		informUserDuring: [:infoBar | ""
			(urlCollection asSortedCollection
				collect: [:each | each asUrl])
				withIndexDo: [:url :index | 
					| percent percentBar | 
					""
					self splitChangeSet: url.
					fileIns _ fileIns + 1.
					""
					percent _ index / urlCollection size roundTo: 0.1.
					percentBar _ String new: (50 * percent) rounded withAll: $..
					infoBar value: (percent * 100) asString , '% [' , percentBar , ']']].
	""
	Transcript cr; cr.
	Transcript show: '  Skiped ' , ignored asString , ' changesets';
		 cr.
	Transcript show: '  Filed in ' , fileIns asString , ' changesets';
		cr.
! !

!KCPStreamSpliter methodsFor: 'split' stamp: 'ab 6/14/2003 16:18'!
splitFromSwikiPage: pageStringOrUrl 
	" 
	self new splitFromSwikiPage: 'http://minnow.cc.gatech.edu/squeak/3083'.  
	"
	^ self
		splitChangeSets: (self getChangeSetsUrlsFrom: pageStringOrUrl)! !


!KCPStreamSpliter class methodsFor: 'image 3.6' stamp: 'ab 6/15/2003 17:37'!
splitKCP
	"self splitKCP"
	| spliter |
	spliter := self new.
	spliter defineRemovalNamed: #SUnit composedByFiles: #('SUnit-Preload.cs' 'SUnit-UI.cs' 'SUnit.cs').
	spliter defineRemovalNamed: #BaseTest composedByFiles: #('Tests.st').
	spliter defineRemovalNamed: #PWS composedByFiles: #('PWS.st').
	spliter defineRemovalNamed: #Scamper composedByFiles: #('Network-HTML.cs' 'Scamper.cs').
	spliter defineRemovalNamed: #VMMaker composedByFiles: #('VMCodePackage.9.cs').
	"spliter defineRemovalNamed: #SystemTracer composedByFiles: #('SystemTracer2-setfixes.1.cs' 'SystemTracer2.st' 'SystemTracer2-setfixes.cs')."
	spliter defineRemovalNamed: #Celeste composedByFiles: #('CelesteInstall1.3.cs').
	spliter defineRemovalNamed: #MorphicGames composedByFiles: #('Morphic-Games.2.st').
	spliter defineRemovalNamed: #Balloon3d composedByFiles: #('Graphics-Tools.st' 'Graphics-External.st' 'Balloon3D-Kernel.st' 'Balloon3D-Plugins.st' 'Balloon3D-Import.st' 'Balloon3D-VRML.st' 'Balloon3D-Pooh.st' 'Balloon3D-Morphic.st' 'Balloon3D-Wonderland.st' 'Balloon3D-Packaging.st').

	spliter splitFromSwikiPage: 'http://minnow.cc.gatech.edu/squeak/3083'.
 spliter inspect! !

!KCPStreamSpliter class methodsFor: 'image 3.6' stamp: 'ab 6/14/2003 17:53'!
testSplitKCP
	"self testSplitKCP"
	| spliter |
	spliter := self new.
	spliter defineRemovalNamed: #SUnit composedByFiles: #('SUnit-Preload.cs' 'SUnit-UI.cs' 'SUnit.cs').
	spliter defineRemovalNamed: #Scamper composedByFiles: #('Network-HTML.cs' 'Scamper.cs').
	spliter defineRemovalNamed: #VMMaker composedByFiles: #('VMCodePackage.9.cs').
	spliter defineRemovalNamed: #SystemTracer composedByFiles: #('SystemTracer2-setfixes.1.cs' 'SystemTracer2.st' 'SystemTracer2-setfixes.cs').
	spliter defineRemovalNamed: #Celeste composedByFiles: #('CelesteInstall1.3.cs').
	spliter defineRemovalNamed: #MorphicGames composedByFiles: #('Morphic-Games.2.st').
	spliter defineRemovalNamed: #Balloon3d composedByFiles: #('Graphics-Tools.st' 'Graphics-External.st' 'Balloon3D-Kernel.st' 'Balloon3D-Plugins.st' 'Balloon3D-Import.st' 'Balloon3D-VRML.st' 'Balloon3D-Pooh.st' 'Balloon3D-Morphic.st' 'Balloon3D-Wonderland.st' 'Balloon3D-Packaging.st').
 
	
	"spliter splitFromSwikiPage: 'http://minnow.cc.gatech.edu/squeak/3083'. "
self halt.
	spliter splitChangeSet: (Url absoluteFromText: 'http://minnow.cc.gatech.edu/squeak/uploads/3083/KCP-0083-NewBeepENG.cs')! !

!KCPStreamSpliter class methodsFor: 'instance creation' stamp: 'ab 6/13/2003 14:54'!
new
	^ super new initialize;yourself! !


!KCPStreamSpliter class reorganize!
('image 3.6' splitKCP testSplitKCP)
('instance creation' new)
!

