'From Squeak3.7alpha of ''11 September 2003'' [latest update: #5623] on 30 January 2004 at 1:15:55 pm'!
"Change Set:		KCP-0180-MoreCompilerProtocolRefactoring
Date:			04 March 2004
Author:			Nathanael Schaerli
Version:			2

Deprecates the ClassDescription>>removeSelectorUnlogged: as we now use #removeSelectorSilently: instead.

Version 2:
This version fixes a bug in the method #removeSelectorSilently: that was introduced in an earlier changeset.
"!


!Behavior methodsFor: 'accessing method dictionary' stamp: 'NS 3/4/2004 21:04'!
removeSelectorSilently: selector 
	"Remove selector without sending system change notifications"

	^ SystemChangeNotifier uniqueInstance doSilently: [self removeSelector: selector].! !

!ClassDescription methodsFor: 'deprecated' stamp: 'NS 1/30/2004 13:14'!
removeSelectorUnlogged: aSymbol 
	"Remove the message whose selector is aSymbol from the method dictionary of the receiver, if it is there. Answer nil otherwise.  Do not log the action either to the current change set or to the changes log"

	self deprecated: 'Use removeSelectorSilently: instead'.
	(self methodDict includesKey: aSymbol) ifFalse: [^ nil].
	super removeSelector: aSymbol.
	self organization removeElement: aSymbol! !


!Player class methodsFor: 'scripts' stamp: 'NS 1/30/2004 13:11'!
removeScriptNamed: aScriptName
	aScriptName ifNotNil:
		[scripts removeKey: aScriptName.
		self removeSelectorSilently: aScriptName]! !


!CardPlayer class methodsFor: 'slots' stamp: 'NS 1/30/2004 13:11'!
removeAccessorsFor: varName
	"Remove the instance-variable accessor methods associated with varName"

	| nameString |
	nameString _ varName asString capitalized.
	self removeSelectorSilently: ('get', nameString) asSymbol.
	self removeSelectorSilently: ('set', nameString, ':') asSymbol! !

