'From Squeak3.7alpha of 11 September 2003 [latest update: #5816] on 14 March 2004 at 6:14:35 pm'!
"Change Set:		KCPBehaviorsubclasses
Date:			14 March 2004
Author:			stphane ducasse

Behavior>>subclasses was not defined. Therefore a lot of the methods
of Behavior were defined in Behavior but could only be run on ClassDescription instances. Breaking the principle that a class should not rely on its subclasses. This fix implements a slow implementation of subclasses that can be executed on Behavior instances. Tests provided"!

TestCase subclass: #BehaviorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Classes-Tests'!

!Behavior methodsFor: 'accessing class hierarchy' stamp: 'sd 3/14/2004 18:09'!
subclasses
	"slow implementation since Behavior does not keep trace of subclasses"
	
	^ self class allInstances  select: [:each | each superclass = self ]! !


!BehaviorTest methodsFor: 'tests' stamp: 'sd 3/14/2004 18:11'!
testBehaviorSubclasses
	"self run: #testBehaviorSubclasses"
	
	| b b2 |
	b := Behavior new.
	b superclass: OrderedCollection.
	b methodDictionary: MethodDictionary new.
	self shouldnt: [b subclasses ] raise: Error.
	self shouldnt: [b withAllSubclasses] raise: Error.
	self shouldnt: [b allSubclasses] raise: Error.
	b2 := Behavior new.
	b2 superclass: b.
	b2 methodDictionary: MethodDictionary new.
	self assert: (b subclasses includes: b2).
	self assert: (b withAllSubclasses includes: b).! !

