Object subclass: #Analyzer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Analyzer'!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Analyzer class
	instanceVariableNames: ''!

!Analyzer class methodsFor: 'examples' stamp: 'ab 3/4/2003 01:23'!
example1
	"self example1"
	Analyzer externalReferenceOf: (#(#Object #Behavior #ClassDescription #Class )
			collect: [:clsname | Smalltalk at: clsname]) inspect! !

!Analyzer class methodsFor: 'examples' stamp: 'ab 3/4/2003 01:47'!
example2
	"self example2"
	(Analyzer externalReferenceOf: (#(#Behavior #ClassDescription #Class )
			collect: [:clsname | Smalltalk at: clsname])) inspect! !

!Analyzer class methodsFor: 'examples' stamp: 'ab 3/4/2003 01:58'!
example3
	"self example3"
	(((Analyzer
		externalReferenceOf: (#(#Behavior #ClassDescription #Class )
				collect: [:clsname | Smalltalk at: clsname]))
		select: [:clsName | (Smalltalk includesKey: clsName)
				and: [(Smalltalk at: clsName)
						isKindOf: Class]])
		select: [:clssName | ((Smalltalk at: clssName) category asString beginsWith: 'Kernel') not]) inspect! !

!Analyzer class methodsFor: 'examples' stamp: 'ab 3/4/2003 02:01'!
example4
	"self example4"
	(((Analyzer
		externalReferenceOf: (#(#Object #Behavior #ClassDescription #Class )
				collect: [:clsname | Smalltalk at: clsname]))
		select: [:clsName | (Smalltalk includesKey: clsName)
				and: [(Smalltalk at: clsName)
						isKindOf: Class]])
		select: [:clssName | ((Smalltalk at: clssName) category asString beginsWith: 'Kernel') not]) inspect! !

!Analyzer class methodsFor: 'examples' stamp: 'ab&lp 3/6/2003 15:42'!
example5
	"self example5"
	| classes |
	classes _ #(#ClassBuilder #ClassDescription #Class )
				collect: [:clsname | Smalltalk at: clsname].
	(Analyzer methodsIn: Behavior callingMethodsDefinedIn: classes) inspect! !


!Analyzer class methodsFor: 'methods' stamp: 'ab&lp 3/6/2003 15:33'!
doesClass: cls define: aSelector 
	^ cls methodDict includesKey: aSelector!
]style[(11 3 9 9 5 3 25 9)f1b,f1cblue;b,f1b,f1cblue;b,f1,f1cblue;i,f1,f1cblue;i! !

!Analyzer class methodsFor: 'methods' stamp: 'ab&lp 3/6/2003 15:11'!
methodsCalledAndCalleeForClass: aClass 
	| r |
	r _ Set new.
	aClass methodDict associationsDo:
		 [:assoc | (assoc value literals
				select: [:l | l isKindOf: Symbol])
				do: [:ll | r add: (Array with: assoc key with: ll)]].
	^ r! !

!Analyzer class methodsFor: 'methods' stamp: 'ab 3/4/2003 01:28'!
methodsCalledForClass: aClass 
	| r |
	r _ Set new.
	aClass methodDict values
		do: [:cm | (cm literals
				select: [:l | l isKindOf: Symbol])
				do: [:ll | r add: ll]].
	^ r! !

!Analyzer class methodsFor: 'methods' stamp: 'ab&lp 3/6/2003 15:01'!
methodsDefinedForClass: aClass 
	^ aClass methodDict keys ! !

!Analyzer class methodsFor: 'methods' stamp: 'ab&lp 3/6/2003 15:40'!
methodsIn: cls callingMethodsDefinedIn: classes 
	"Give collection matching (m1, m2) where: 
	- m1 is defined in C 
	- m2 is defined in classes 
	- m2 called in m1 of C,  
	- and m2 not defined in C"
	"We made the following assumption: If a method foo is in defined in cls and in classes, then if cls call foo, then it calls its own"
	| methodsCalled allMethodsDefined ans |
	methodsCalled _ self methodsCalledAndCalleeForClass: cls.
	allMethodsDefined _ Set new.
	classes
		do: [:clss | allMethodsDefined
				addAll: (self methodsDefinedForClass: clss)].
	ans _ methodsCalled
				select: [:calleeCalled | (self doesClass: cls define: calleeCalled second) not
						and: [allMethodsDefined includes: calleeCalled second]].
	^ ans! !

!Analyzer class methodsFor: 'methods' stamp: 'ab 3/4/2003 01:43'!
referingMethodsDefinedInSubclasses: aClass
	| r |
	r _ self methodsCalledForClass: aClass.
	subclasses _ aClass allSubclasses.
	subclasses remove: aClass.

	! !


!Analyzer class methodsFor: 'dependencies' stamp: 'ab 3/4/2003 01:54'!
dependenciesForClass: aClass 
	| r |
	r _ Set new.
	aClass methodDict values
		do: [:cm | (cm literals
				select: [:l | l isKindOf: LookupKey])
				do: [:ll | ll key ifNotNil: [r add: ll key]]].
	^ r! !

!Analyzer class methodsFor: 'dependencies' stamp: 'ab 3/4/2003 00:58'!
externalReference
! !

!Analyzer class methodsFor: 'dependencies' stamp: 'ab 3/4/2003 01:19'!
externalReferenceOf: aCollectionOfClass 
	| r |
	r _ Set new.
	aCollectionOfClass
		do: [:cls | r
				addAll: (self dependenciesForClass: cls)].
	aCollectionOfClass 
		do: [:clss | r
				remove: clss name
				ifAbsent: []].
	^ r! !


TestCase subclass: #AnalyzerTest
	instanceVariableNames: 'classesCreated '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Analyzer'!

!AnalyzerTest methodsFor: 'methods' stamp: 'ab 3/8/2003 14:03'!
testMethodCallDefinedInSubclasses
	| cls1 cls2 r |
	cls1 _ self createClass: #MyClass1.
	cls2 _ self createClass: #MyClass2 superclass: cls1.
	"-------"
	cls1 compile: 'foo ^ self bar'.
	cls2 compile: 'bar ^ true'.
	"-------"
	self assert: cls2 new foo.
	r _ Analyzer
				methodsIn: cls1
				callingMethodsDefinedIn: (Array with: cls2).
	r _ r asOrderedCollection.
	self assert: r size = 1.
	self assert: r first size = 2.
	self assert: r first first == #foo.
	self assert: r first second == #bar.
! !

!AnalyzerTest methodsFor: 'methods' stamp: 'ab 3/8/2003 14:03'!
testMethodCallDefinedInSubclasses2
	| cls1 cls2 r cls3 cls4 |
	cls1 _ self createClass: #MyClass1.
	cls2 _ self createClass: #MyClass2 superclass: cls1.
	cls3 _ self createClass: #MyClass3.
	cls4 _ self createClass: #MyClass4 superclass: cls3.
	"-------"
	cls1 compile: 'foo ^ self f1; f2'.
	cls1 compile: 'bar ^ self f3; foo'.
	cls1 compile: 'zork ^ self bar; blah'.
	cls2 compile: 'f1 ^ true'.
	cls2 compile: 'f2 ^ true'.
	cls3 compile: 'f3 ^ true'.
	cls3 compile: 'foo ^ true'.
	cls4 compile: 'f3 ^ true'.
	cls4 compile: 'f4 ^ true'.
	cls4 compile: 'bleubleu ^ true'.
	cls4 compile: 'bouba ^ true'.
	"-------"
	r _ Analyzer
				methodsIn: cls1
				callingMethodsDefinedIn: (Array
						with: cls2
						with: cls3
						with: cls4).
	r _ r asOrderedCollection.
	self assert: r size = 3.
	self
		assert: (r includesAllOf: #(#(#foo #f1) #(#foo #f2) #(#bar #f3) )).
! !

!AnalyzerTest methodsFor: 'methods' stamp: 'ab 3/8/2003 14:03'!
testMethodsCalledAndCalleeForClass
	| cls r |
	cls _ self createClass: #MyClass.
	"-------"
	cls compile: 'foo ^ Object'.
	cls compile: 'bar Transcript show: ''blah blah'''.
	cls compile: 'zork OrderedCollection new'.
	cls compile: 'foobar Object new asMorph; beep'.
	"-------"
	r _ Analyzer methodsCalledAndCalleeForClass: cls.
	self assert: r size = 3.
	self
		assert: (r includesAllOf: #(#(#bar #show:) #(#foobar #asMorph) #(#foobar #asMorph) )).
! !

!AnalyzerTest methodsFor: 'methods' stamp: 'ab 3/8/2003 14:03'!
testMethodsCalledForClass
	| cls r |
	cls _ self createClass: #MyClass.
	"-------"
	cls compile: 'foo ^ Object'.
	cls compile: 'bar Transcript show: ''blah blah'''.
	cls compile: 'zork OrderedCollection new'.
	cls compile: 'foobar Object new asMorph; beep'.
	"-------"
	r _ Analyzer methodsCalledForClass: cls.
	self assert: r size = 3.
	self
		assert: (r includesAllOf: #(#beep #show: #asMorph )).
! !


!AnalyzerTest methodsFor: 'dependencies' stamp: 'ab 3/8/2003 14:04'!
testDependenciesForClass
	| cls r |
	cls _ self createClass: #MyClass.
	"-------"
	cls compile: 'foo ^ Object'.
	cls compile: 'bar Transcript show: ''blah blah'''.
	cls compile: 'zork OrderedCollection new'.
	"-------"
	r _ Analyzer dependenciesForClass: cls.
	self assert: r size = 3.
	self
		assert: (r includesAllOf: #(#Object #Transcript #OrderedCollection )).
! !

!AnalyzerTest methodsFor: 'dependencies' stamp: 'ab 3/8/2003 14:04'!
testExternalReferenceOf
	| r cls1 cls2 cls3 |
	cls1 _ self createClass: #MyClass1.
	cls2 _ self createClass: #MyClass2.
	cls3 _ self createClass: #MyClass3.
	"-------"
	cls1 compile: 'foo ^ MyClass2'.
	cls1 compile: 'bar MyClass1 show: ''blah blah'''.
	cls1 compile: 'zork OrderedCollection new'.
	cls1 compile: 'baz Morph new openInWorld'.
	"-------"
	cls2 compile: 'foo ^ Object'.
	cls2 compile: 'bar Transcript show: ''blah blah'''.
	cls2 compile: 'zork OrderedCollection new'.
	"-------"
	cls3 compile: 'foo ^ Object'.
	cls3 compile: 'bar Transcript show: ''blah blah'''.
	cls3 compile: 'zork MyClass3 new'.
	"-------"
	r _ Analyzer
				externalReferenceOf: (#(#MyClass1 #MyClass2 #MyClass3 )
						collect: [:clsName | Smalltalk at: clsName]).
	self assert: r size = 4.
	self
		assert: (r includesAllOf: #(#Object #Transcript #OrderedCollection #Morph )).
! !


!AnalyzerTest methodsFor: 'utility' stamp: 'ab 3/8/2003 13:55'!
createClass: aClassname
	^ self createClass: aClassname superclass: Object 
! !

!AnalyzerTest methodsFor: 'utility' stamp: 'ab 3/8/2003 14:05'!
createClass: aClassname superclass: aClass 
	| r |
	r _ aClass
		subclass: aClassname
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: 'Analyzer'.
	classesCreated add: r.
	^ r! !

!AnalyzerTest methodsFor: 'utility' stamp: 'ab 3/4/2003 01:05'!
removeClassIfExists: aClassname
	Smalltalk at: aClassname ifPresent: [:cls| cls removeFromSystem]! !


!AnalyzerTest methodsFor: 'running' stamp: 'ab 3/8/2003 13:54'!
setUp
	classesCreated _ OrderedCollection new! !

!AnalyzerTest methodsFor: 'running' stamp: 'ab 3/8/2003 13:54'!
tearDown
	classesCreated do: [:cls| cls removeFromSystem]! !
