'From Squeak3.5 of ''11 April 2003'' [latest update: #5180] on 12 May 2003 at 4:31:01 pm'!
"Change Set:		KCP-0074-tmvClassBuilderTests
Date:			12 May 2003
Author:			Roel Wuyts and Alexandre Bergel

Moved the tests that test a fix for a bug in the chape changing of classes (done by Andres in changeset KCP-001-VVCVC) to CleanKernelTest. That way we do not start to have different testclasses around, and the kernel tests are in one and the same place. We also fixed the tests to use 'Smalltalk at: CVCV' instead of directly referencing class names."!


!CleanKernelTest methodsFor: 'utility' stamp: 'rw 5/12/2003 12:33'!
createClassNamed: aClassname superClass: aClass 

	^self createClassNamed: aClassname superClass: aClass instanceVariables: ''! !

!CleanKernelTest methodsFor: 'utility' stamp: 'rw 5/12/2003 12:32'!
createClassNamed: aClassname superClass: aClass instanceVariables: instvarString

	| r |
	r := aClass
		subclass: aClassname
		instanceVariableNames: instvarString
		classVariableNames: ''
		poolDictionaries: ''
		category: 'KCP-Tests'.
	self classesCreated add: r.
	^ r! !

!CleanKernelTest methodsFor: 'Running' stamp: 'rw 5/12/2003 12:52'!
setUp

	| classBuilderTestClass classBuilderTestSubClass |
	self createClassNamed: #ClassBuilderTestClass superClass: Object instanceVariables: 'var1 var2'.
	classBuilderTestClass := (Smalltalk at: #ClassBuilderTestClass).
	classBuilderTestClass compile: 'var1	^var1'.
	classBuilderTestClass compile: 'var1: object	var1 := object'.
	classBuilderTestClass compile: 'var2	^var2'.
	classBuilderTestClass compile: 'var2: object	var2 := object'.

	self createClassNamed: #ClassBuilderTestSubClass superClass: classBuilderTestClass instanceVariables: 'var3 var4'.
	classBuilderTestSubClass := (Smalltalk at: #ClassBuilderTestSubClass).
	classBuilderTestSubClass compile: 'var3	^var3'.
	classBuilderTestSubClass compile: 'var3: object	var3 := object'.
	classBuilderTestSubClass compile: 'var4	^var4'.
	classBuilderTestSubClass compile: 'var4: object	var4 := object'.! !

!CleanKernelTest methodsFor: 'classBuilder' stamp: 'rw 5/12/2003 12:48'!
testReshapeClass
	"see if reshaping classes works"
	"self run: #testReshapeClass"

	| testInstance testClass testMeta newClass newMeta |
	testClass _ Smalltalk at: #ClassBuilderTestClass.
	testMeta _ testClass class.
	testInstance _ testClass new.
	testInstance var1: 42.
	testInstance var2: 'hello'.
	newClass _ self
				createClassNamed: #ClassBuilderTestClass
				superClass: Object
				instanceVariables: 'foo var1 bar var2 mumble'.
	newMeta _ newClass class.
	"test transparency of mapping"
	self assert: testInstance var1 = 42.
	self assert: testInstance var2 = 'hello'.
	self assert: (testInstance instVarAt: 1) isNil.
	self assert: (testInstance instVarAt: 2)
			= 42.
	self assert: (testInstance instVarAt: 3) isNil.
	self assert: (testInstance instVarAt: 4)
			= 'hello'.
	self assert: (testInstance instVarAt: 5) isNil.
	"test transparency of reshapes"
	self assert: testInstance class == newClass.
	self assert: testClass == newClass.
	self assert: testMeta == newMeta! !

!CleanKernelTest methodsFor: 'classBuilder' stamp: 'rw 5/12/2003 12:49'!
testReshapeClassWithJugglingInstVars
	"see if reshapes of classes juggle their instVars correctly"

	| testInstance testClass testMeta newClass newMeta |
	testClass _ Smalltalk at: #ClassBuilderTestClass.
	testMeta _ testClass class.
	testInstance _ testClass new.
	testInstance var1: 42.
	testInstance var2: 'hello'.
	newClass _ self
				createClassNamed: #ClassBuilderTestClass
				superClass: Object
				instanceVariables: 'var2 foo bar mumble var1'.
	newMeta _ newClass class.
	"test transparency of mapping"
	self assert: testInstance var1 = 42.
	self assert: testInstance var2 = 'hello'.
	self assert: (testInstance instVarAt: 1)
			= 'hello'.
	self assert: (testInstance instVarAt: 2) isNil.
	self assert: (testInstance instVarAt: 3) isNil.
	self assert: (testInstance instVarAt: 4) isNil.
	self assert: (testInstance instVarAt: 5)
			= 42.
	"test transparency of reshapes"
	self assert: testInstance class == newClass.
	self assert: testClass == newClass.
	self assert: testMeta == newMeta! !

!CleanKernelTest methodsFor: 'classBuilder' stamp: 'rw 5/12/2003 12:55'!
testReshapeSubClass
	"self run: #testReshapeSubClass"
	"self debug: #testReshapeSubClass"

	| testInstance testClass testMeta |

	testClass _ Smalltalk at: #ClassBuilderTestSubClass.
	testMeta _ testClass class.
	testInstance _ testClass new.
	testInstance var1: 42.
	testInstance var2: 'hello'.
	testInstance var3: 'foo'.
	testInstance var4: #bar.
	self
		createClassNamed: #ClassBuilderTestClass
		superClass: Object
		instanceVariables: 'var1 foo var2 bar mumble '.
	self assert: testInstance var1 = 42.
	self assert: testInstance var2 = 'hello'.
	self assert: testInstance var3 = 'foo'.
	self assert: testInstance var4 = #bar.
	self assert: (testInstance instVarAt: 1)
			= 42.
	self assert: (testInstance instVarAt: 2) isNil.
	self assert: (testInstance instVarAt: 3)
			= 'hello'.
	self assert: (testInstance instVarAt: 4) isNil.
	self assert: (testInstance instVarAt: 5) isNil.
	self assert: (testInstance instVarAt: 6)
			= 'foo'.
	self assert: (testInstance instVarAt: 7)
			= #bar.
	self assert: testInstance class == (Smalltalk at: #ClassBuilderTestSubClass).
	self assert: testClass == (Smalltalk at: #ClassBuilderTestSubClass).
	self assert: testMeta == (Smalltalk at: #ClassBuilderTestSubClass) class! !


!CleanKernelTest reorganize!
('behavior' testAccessingClassHierarchy testAccessingClassHierarchySuperclasses testRemoveDefaultSelectorForMethod)
('utility' classesCreated createClassNamed: createClassNamed:superClass: createClassNamed:superClass:instanceVariables: isSelector:definedInClass: isSelector:definedInClassOrMetaClass: isSelector:deprecatedInClass: newIsSelector:deprecatedInClass: removeClassNamedIfExists:)
('module reference' testRemoveSubclassModuleMethod testRemoveSubclassModuleMethodInClass)
('isMeta' testBehaviorDefineIsMeta testMetaclassDefineIsMeta testMovePowerManagementToPwerManagement testMoveSortAllCategoriesToClassOrganizer testPullUpIsMeta testPullUpIsWithAllSubclasses)
('allSubclasses' testPullUpAllSubclasses)
('environment' testMetaclassClassClassDescriptionDoesNotReferToSmalltalk testMetaclassDoesNotReferToSmalltalk testNilEnvironment)
('browing' testRemoveAllCallsOn testRemoveBroweMethod testRemoveBrowseAllAccesses testRemoveBrowseAllStores testRemoveBrowseClassVarRef testRemoveBrowseClassVariables testRemoveBrowseInstVarDefs testRemoveBrowseInstVarRefs testRemoveConfirmRemovalOf testRemoveShowOnSystemDictionary testRemovebrowseObsoleteReferences)
('Running' setUp tearDown)
('query' testAllCallsOn testAllCallsOnAnd testAllMethodsSelect testIsThereAnImplementorOf testNumberOfImplementors testRemoveAllBehaviorsDo testRemoveAllClassesImplementing testRemoveAllGlobalRefs testRemoveAllGlobalRefsWithout testRemoveAllImplementedMessages testRemoveAllImplementedMessagesWithout testRemoveAllImplementorsOf testRemoveAllImplementorsOfLocalTo testRemoveAllMethodsInCategory testRemoveAllMethodsWithSourceStringMatchCase testRemoveAllObjectsDo testRemoveAllObjectsSelect testRemoveAllPrimitiveMessages testRemoveAllPrimitiveMethodsInCategories testRemoveAllSelect testRemoveAllSelectNoDoits testRemoveAllSentMessages testRemoveAllSentMessagesWithout testRemoveAllUnSentMessages testRemoveAllUnSentMessagesWithout testRemoveAllUnimplementedCalls testRemoveAllUnreferencedClassVariables testRemoveAllUnusedClassesWithout testRemoveBrowseAllCallsOn testRemoveBrowseAllCallsOnAnd testRemoveBrowseAllCallsOnLocalTo testRemoveBrowseAllImplementorsOf testRemoveBrowseAllImplementorsOfList testRemoveBrowseAllImplementorsOfListTitle testRemoveBrowseAllImplementorsOfLocalTo testRemoveBrowseAllMethodsInCategory testRemoveBrowseAllObjectReferencesToExceptIfNone testRemoveBrowseAllSelect testRemoveBrowseAllSelectNameAutoSelect testRemoveBrowseAllUnSentMessages testRemoveBrowseAllUnimplementedCalls testRemoveBrowseClassesWithNamesContainingCaseSensitive testRemoveBrowseMessageListName testRemoveBrowseMessageListNameAutoSelect testRemoveBrowseMethodsWhoseNamesContain testRemoveBrowseMethodsWithSourceString testRemoveBrowseMethodsWithStringMatchCase testRemoveClassThatUnderstands testRemoveForceDisplayUpdate testRemoveSelectorsWithAnyImplementorsIn testRemoveUnimplemented testRemoveallCallsOn testRemoveallCallsOnAnd testRemoveallUnSentMessagesIn testRemovebrowseClassCommentsWithString)
('image reader class' testRemoveImageReader)
('classBuilder' testReshapeClass testReshapeClassWithJugglingInstVars testReshapeSubClass)
!

Smalltalk removeClassNamed: #ClassBuilderTestSubClass!
Smalltalk removeClassNamed: #ClassBuilderTests!
