'From Squeak3.7alpha of ''11 September 2003'' [latest update: #5595] on 12 December 2003 at 3:51:30 pm'!
"Change Set:		KCP-t0112-FixCanUnderstand
Date:			12 December 2003
Author:			Nathanael Schaerli

Fixes canUnderstand so that it deals with abstract methods (i.e., subclassResponsibility and shouldNotImplement) in the right way."!

TestCase subclass: #BehaviorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Classes-Tests'!
TestCase subclass: #CompiledMethodTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Kernel-Methods-Tests'!

!BehaviorTest methodsFor: 'as yet unclassified' stamp: 'NS 12/12/2003 15:47'!
testCanUnderstand
	"self run: #testCanUnderstand"

	self assert: (Integer canUnderstand: #printString).
	self assert: (Integer canUnderstand: #basicAt:put:).
	self assert: (Dictionary canUnderstand: #remove:) not.
	self assert: (Number canUnderstand: #*) not.! !


!CompiledMethodTests methodsFor: 'example methods' stamp: 'NS 12/12/2003 14:27'!
noMarkerMethod1
	self x.
	^ self subclassResponsibility! !

!CompiledMethodTests methodsFor: 'example methods' stamp: 'NS 12/12/2003 14:27'!
noMarkerMethod2
	self x.
	self subclassResponsibility! !

!CompiledMethodTests methodsFor: 'example methods' stamp: 'NS 12/12/2003 14:26'!
returnSelfNegated
	^ self negated! !

!CompiledMethodTests methodsFor: 'example methods' stamp: 'NS 12/12/2003 14:26'!
returnSelfShouldNotImplement
	^ self shouldNotImplement! !

!CompiledMethodTests methodsFor: 'example methods' stamp: 'NS 12/12/2003 14:25'!
returnSelfSubclassResponsibility
	^ self subclassResponsibility! !

!CompiledMethodTests methodsFor: 'example methods' stamp: 'NS 12/12/2003 14:26'!
selfNegated
	self negated! !

!CompiledMethodTests methodsFor: 'example methods' stamp: 'NS 12/12/2003 14:25'!
selfShouldNotImplement
	self shouldNotImplement! !

!CompiledMethodTests methodsFor: 'example methods' stamp: 'NS 12/12/2003 14:25'!
selfSubclassResponsibility
	self subclassResponsibility! !

!CompiledMethodTests methodsFor: 'tests' stamp: 'NS 12/12/2003 15:20'!
testIsAbstract
	"self run: #testIsAbstract"

	self assert: (self class >> #returnSelfSubclassResponsibility) isAbstract.
	self assert: (self class >> #selfSubclassResponsibility) isAbstract.
	self assert: (self class >> #returnSelfShouldNotImplement) isAbstract.
	self assert: (self class >> #selfShouldNotImplement) isAbstract.
	self assert: (self class >> #returnSelfNegated) isAbstract not.
	self assert: (self class >> #selfNegated) isAbstract not.
	self assert: (self class >> #noMarkerMethod1) isAbstract not.
	self assert: (self class >> #noMarkerMethod2) isAbstract not.! !

!CompiledMethodTests methodsFor: 'tests' stamp: 'NS 12/12/2003 14:31'!
testMarker
	"self run: #testMarker"

	self assert: (self class >> #returnSelfSubclassResponsibility) markerOrNil = #subclassResponsibility.
	self assert: (self class >> #selfSubclassResponsibility) markerOrNil = #subclassResponsibility.
	self assert: (self class >> #returnSelfShouldNotImplement) markerOrNil = #shouldNotImplement.
	self assert: (self class >> #selfShouldNotImplement) markerOrNil = #shouldNotImplement.
	self assert: (self class >> #returnSelfNegated) markerOrNil = #negated.
	self assert: (self class >> #selfNegated) markerOrNil = #negated.
	self assert: (self class >> #noMarkerMethod1) markerOrNil isNil.
	self assert: (self class >> #noMarkerMethod2) markerOrNil isNil.! !

