'From Squeak3.6 of ''6 October 2003'' [latest update: #5424] on 16 October 2003 at 11:11:50 am'!
"Change Set:		BFAVAbsoluteSaveFix-nk
Date:			15 October 2003
Author:			Ned Konz

15 October:
Improved error handling when the server is down.
Improved loading of saved posts.

Fixes saving archive posts in the BFAV when they have absolute pathnames."!


!BugFixArchiveHttpClient methodsFor: 'accessing' stamp: 'nk 10/16/2003 09:43'!
availableLocalUidsForUrl: aUrlOrString 
	| repository urlString |
	repository _ self repository
				ifNil: [^ #()].
	urlString _ aUrlOrString asString.
	^ (repository uidsStoredAtFileUrl: urlString) ifNil: [ #() ].! !

!BugFixArchiveHttpClient methodsFor: 'accessing' stamp: 'bkv 6/4/2003 12:56'!
localUidsForUrl: aUrlOrString

	| urlString uids |

    urlString _ aUrlOrString asString.
    uids _ localUids at: urlString ifAbsent: [ nil ].
    uids ifNil: [ ^nil ].
    ^ uids 
	     ! !

!BugFixArchiveHttpClient methodsFor: 'updates' stamp: 'nk 10/16/2003 11:06'!
loadPreviousStopAfter: maxPosts
 
	| newPosts limit  |
	newPosts _ OrderedCollection new.
	limit _ (maxPosts isNil or: [maxPosts == 0])
		ifTrue: [ 500 ]
		ifFalse: [ maxPosts ].

     self updateUrls do: [ :updateUrl | | loadUids allLocalUids newUids allServerUids totalUids |
		self loadServerUidsFromUrl: updateUrl.
		allServerUids _ (self serverUidsForUrl: updateUrl) ifNil: [ #() ].
		allLocalUids _ (self localUidsForUrl: updateUrl) ifNil: [ #() ].
		newUids _ ((allServerUids asSet difference: allLocalUids))
			asSortedCollection: [ :a :b | a > b ].
		totalUids _ newUids size.
		limit < 0 ifTrue: [ limit _ totalUids ].
		loadUids _ newUids copyFrom: 1 to: (limit min: totalUids).
		newPosts addAll: (self loadUids: loadUids fromUrl: updateUrl).
	].
	^newPosts 

     ! !

!BugFixArchiveHttpClient methodsFor: 'updates' stamp: 'nk 10/16/2003 11:10'!
loadUpdatesStopAfter: maxPosts
 
	| newPosts limit  |
	newPosts _ OrderedCollection new.
	limit _ (maxPosts isNil or: [maxPosts == 0])
		ifTrue: [ 500 ]
		ifFalse: [ maxPosts ].

     self updateUrls do: [ :updateUrl |
		| loadUids newUids allServerUids availableLocalUids totalUids lastLocalId |
		self loadServerUidsFromUrl: updateUrl.
		allServerUids _ (self serverUidsForUrl: updateUrl) ifNil: [ #() ].
		availableLocalUids _ (self localUidsForUrl: updateUrl) ifNil: [ #() ].
		lastLocalId _ availableLocalUids at: 1 ifAbsent: [ 0 ].
		newUids _ ((allServerUids asSet difference: availableLocalUids) select: [ :ea | ea > lastLocalId ])
			asSortedCollection: [ :a :b | a > b ].
		totalUids _ newUids size.
		limit < 0 ifTrue: [ limit _ totalUids ].
		loadUids _ newUids copyFrom: 1 to: (limit min: totalUids).
		loadUids isEmpty ifFalse: [ newPosts addAll: (self loadUids: loadUids fromUrl: updateUrl) ].
	].
	^ newPosts 

     ! !


!EmailFileRepository methodsFor: 'files' stamp: 'nk 10/14/2003 13:27'!
saveAttachmentsFor: anArchivePost
	"Save the attachments. Make sure that any path information is stripped from them."

	| attachments attachmentDir savedFiles |
	attachments _ anArchivePost attachments.
	attachments isEmptyOrNil
		ifTrue: [^ nil].
	(attachments notEmpty
			and: [attachments first isString])
		ifTrue: [^ attachments].
	"Attachments exist and have not yet been parsed and saved to filesystem."
	attachmentDir _ anArchivePost attachmentsDirectory.
	attachmentDir assureExistence.
	savedFiles _ OrderedCollection new.
	attachments
		do: [:part | 
			| stream streamSize file fileSize sizeDiff | 
			(part isKindOf: MailMessage)
				ifTrue: [stream _ RWBinaryOrTextStream with: part body content.
					file _ attachmentDir
								fileNamed: (FileDirectory localNameFor: part name)]
				ifFalse: [stream _ RWBinaryOrTextStream with: part content.
					file _ attachmentDir fileNamed: anArchivePost postUrl path last].
			streamSize _ stream contents size.
			fileSize _ file contents size.
			"Don't unnecessarily append to an existing file"
			sizeDiff _ streamSize - fileSize.
			sizeDiff >= 0
				ifTrue: [file
						nextPutAll: (stream contents copyFrom: streamSize - sizeDiff + 1 to: streamSize)].
			stream close.
			file close.
			savedFiles add: file name].
	^ savedFiles! !

BugFixArchiveHttpClient removeSelector: #maxAvailableLocalUidFromUrl:!
