'From Squeak3.6beta of ''4 July 2003'' [latest update: #5387] on 3 October 2003 at 1:07:21 am'!

!CommentNotePad methodsFor: 'gui building' stamp: 'dvf 10/3/2003 01:05'!
notePadMenu: aMenu 

	aMenu
		add: 'send to list'
		target: self
		action: #mailCommentsToList.
	self parentPost
		ifNotNil: [aMenu
					add: 'send to issue authors'
					target: self
					action: #mailCommentsToPostGroupAuthors].
	aMenu addLine.
	aMenu
		add: 'help'
		target: self
		action: #helpWindow.
	aMenu addLine.
	aMenu
		add: 'open as email to list'
		target: self
		action: #openCommentsAsMailToList.
	self parentPost
		ifNotNil: [aMenu
					add: 'open as email to issue authors'
					target: self
					action: #openCommentsAsMailToPostGroupAuthors].
	aMenu addLine.

	^ aMenu! !

!CommentNotePad methodsFor: 'services' stamp: 'dvf 10/3/2003 00:15'!
mailCommentsTo: emailAddressOrNil
	"If emailAddressOrNil is nil, it will be filled in from either the parent post, or from the default list posting address."

	| aTitle windowLabel parensComments from to body mailMsg mailMan bodyStream |

	parensComments _ self formatSummaryCommentsWithTags.
	"Make sure that the archivePost title is set correctly, if this is a new post with no parent".
	self parentPost ifNil: [self label ifNotNil: [ windowLabel _ self label. ].
							  windowLabel isEmptyOrNil 
								ifTrue: [ aTitle _ parensComments. ]
								ifFalse: [ aTitle _ windowLabel.
										  self archivePost title: aTitle. ]].

	aTitle _ self archivePost title ifNil: [ '<No title loaded>' ].	 
	body _ self mainComments.
	from _ MailSender userName.
	from isEmptyOrNil ifTrue: [ from _ '<Your name/email address is not yet defined in this system>' ].
	to _ emailAddressOrNil.
	body _ body ifNil: [ '' ].

	"Prepare the message"
	bodyStream _ WriteStream on: (String new: 1500).
	bodyStream
		cr; cr;
		nextPutAll: body;
		nextPutAll: (String new: 14 withAll: Character cr);
		nextPutAll: self blurb.

	mailMsg _ MailMessage from: bodyStream contents.

	mailMsg setField: 'from' toString: from.

	mailMsg setField: 'subject' toString: (aTitle, ' ', parensComments).
	mailMsg setField: 'List-Id' toString: 'squeak-harvest.lists.squeakfoundation.org'.

	self setThreadingHeadersIn: mailMsg withToAddress: to.

	(mailMsg hasFieldNamed: 'to')
		ifFalse: [ mailMsg setField: 'to' toString: (to ifNil: [ self defaultPostingAddress ]) ].

	"Make sure to add attachments if there are any"
	self addAttachmentsTo: mailMsg.
	mailMan _ self mailServiceProvider sendMailMessage: mailMsg. 

	^  mailMan! !

!CommentNotePad methodsFor: 'services' stamp: 'dvf 10/3/2003 01:05'!
mailCommentsToPostGroupAuthors

	| mailMan mails |
	mails _ self postGroupAuthors.
	mailMan _ self mailCommentsTo: mails.
	mailMan submit.
	self delete.! !

!CommentNotePad methodsFor: 'services' stamp: 'dvf 10/3/2003 01:02'!
openCommentsAsMailToPostGroupAuthors
	self mailCommentsTo: self postGroupAuthors! !

!CommentNotePad methodsFor: 'services' stamp: 'dvf 10/3/2003 00:44'!
postGroupAuthors
	| pg |
	pg _ parentPost archive archivePostGroups detect: [:e | e posts includes: parentPost].
	^(pg posts collect: [:e | e authorEmail, ', ']), {'Bert Freudenberg <bert@isg.cs.uni-magdeburg.de>'}.! !

CommentNotePad removeSelector: #mailCommentsToPostGroupParties!
