'From Squeak3.6beta of ''4 July 2003'' [latest update: #5395] on 13 August 2003 at 11:24:38 am'!
"Change Set:		BFAVStreamCompatibility-nk
Date:			13 August 2003
Author:			Ned Konz

This brings the BFAV's usage of the SimpleServiceEntries into line with the new changes that should be happening to use streams instead of file names (to browse remote files, zip entries, etc.).

Also fixes a problem with saving files into the default directory.
"!

Object subclass: #BugFixArchiveAttachment
	instanceVariableNames: 'fullName '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BugFixArchive-UI'!

!BugFixArchiveAttachment commentStamp: 'nk 8/13/2003 10:53' prior: 0!
This is a stand-in for the FileList for SimpleServiceEntry instances to use.!


!BugFixArchiveAttachment methodsFor: 'accessing' stamp: 'nk 8/13/2003 11:11'!
directory
	^FileDirectory forFileName: fullName! !

!BugFixArchiveAttachment methodsFor: 'accessing' stamp: 'nk 8/13/2003 10:45'!
fileName
	^fullName! !

!BugFixArchiveAttachment methodsFor: 'accessing' stamp: 'nk 8/13/2003 10:44'!
fullName
	^fullName! !

!BugFixArchiveAttachment methodsFor: 'accessing' stamp: 'nk 8/13/2003 10:44'!
fullName: anObject
	fullName := anObject! !


!BugFixArchiveAttachment class methodsFor: 'instance creation' stamp: 'nk 8/13/2003 11:12'!
fullName: aFileName
	^self new fullName: aFileName! !


!BugFixArchiveViewer methodsFor: 'gui building-field pane' stamp: 'nk 8/13/2003 11:17'!
performPackageAttachmentService: aServiceEntry on: anAttachment
	"Just in case we change the attachments, make sure to scan again"
	aServiceEntry perform: aServiceEntry requestSelector
		withArguments: { aServiceEntry getArgumentsFrom: (BugFixArchiveAttachment fullName: anAttachment) }.
	self selectedPackage attachments: (self selectedPackage attachmentsDirectory fullNamesOfAllFilesInSubtree).! !


!BugFixArchiveViewer class methodsFor: 'utilities' stamp: 'nk 8/13/2003 11:21'!
saveAttachment: oldFullName
	| oldFileName oldPathName newFullName newFileName newPathName oldFile defaultDirectory |

	FileDirectory activeDirectoryClass splitName: oldFullName to:
		[:path :file |
		oldFileName _ file.
		oldPathName _ path].

	defaultDirectory _ self lastSavedAttachmentsDirectory.
	newFullName _ FillInTheBlank
					request: 'Enter a new file name'
					initialAnswer: (defaultDirectory fullNameFor: oldFileName).
	newFullName isEmpty ifTrue: [^ self].

	FileDirectory activeDirectoryClass splitName: newFullName to:
		[:path :file |
		newFileName _ file.
		newPathName _ path].
	newPathName isEmpty ifTrue: [ newPathName _ FileDirectory default fullName ].
	self lastSavedAttachmentsDirectory: (FileDirectory on: newPathName).

	oldFile _ (FileDirectory on: oldPathName) readOnlyFileNamed: oldFullName.
	(FileDirectory on: newPathName) putFile: oldFile named: newFileName.
! !

