'From Squeak3.6beta of ''4 July 2003'' [latest update: #5352] on 21 July 2003 at 1:23:47 am'!
"Change Set:		BFAVsaveAttachmentAs-dew
Date:			21 July 2003
Author:			Doug Way

Adds a 'save as...' menu item to each attachment submenu.  Also, the 'save as...' fill-in-the-blank prompt re-uses the last saved directory, in case you are saving a bunch of attachments to the same directory.  (This may or may not be useful to everyone.)"!

AbstractPackageViewer subclass: #BugFixArchiveViewer
	instanceVariableNames: 'adHocFilterBlock groupSizeLimit nameRegexp emailRegexp titleOrBodyRegexp displayInGroupsPref backgroundUpdater '
	classVariableNames: 'LastSavedAttachmentsDirectory '
	poolDictionaries: ''
	category: 'BugFixArchive-UI'!

!BugFixArchiveViewer methodsFor: 'menu' stamp: 'dew 7/20/2003 23:52'!
addAttachmentServicesToMenu: aMenu
	| pkg services attachmentDir attachments |
	pkg _ self selectedPackage.
	pkg ifNil: [ ^aMenu ].
	(attachments _ pkg attachments) isEmptyOrNil ifTrue: [ ^aMenu ].
	aMenu add: 'view attachments (v)' action: #viewPostAttachments;
		balloonTextForLastItem: 'Open a file explorer to this post''s attachments.'.
	attachmentDir _ pkg attachmentsDirectory fullName.
	attachments asSortedCollection do: [ :attachment | | newMenu |
		newMenu _ aMenu species new.
		services _ FileList itemsForFile: attachment.
		services add:
			(SimpleServiceEntry
				provider: FileStream
				label: 'save as...'
				selector: #saveAs:
				description: 'save the file with another name/directory').
		services withIndexDo: [:service :i |
"self halt."
			newMenu 
				add: (service label)
				target: self
				selector: #performPackageAttachmentService:on:
				argumentList: { service. attachment }.
			newMenu balloonTextForLastItem: service description.
			service useLineAfter ifTrue: [newMenu addLine]
		].
		aMenu add: ((Text fromString: (attachment copyFrom: attachmentDir size + 2 to: attachment size)) allBold)
			subMenu: newMenu
			target: aMenu defaultTarget
			selector: #viewPostAttachments
			argumentList: #()
	].
	^aMenu! !


!BugFixArchiveViewer class methodsFor: 'accessing' stamp: 'dew 7/21/2003 00:39'!
lastSavedAttachmentsDirectory
	LastSavedAttachmentsDirectory
		ifNil: [LastSavedAttachmentsDirectory _ FileDirectory default].
	^ LastSavedAttachmentsDirectory! !

!BugFixArchiveViewer class methodsFor: 'accessing' stamp: 'dew 7/21/2003 01:14'!
lastSavedAttachmentsDirectory: fileDirectory
	LastSavedAttachmentsDirectory _ fileDirectory! !


!FileStream class methodsFor: '*BugFixesArchive' stamp: 'dew 7/21/2003 01:06'!
saveAs: oldFullName
	| oldFileName oldPathName newFullName newFileName newPathName oldFile defaultDirectory |

	FileDirectory activeDirectoryClass splitName: oldFullName to:
		[:path :file |
		oldFileName _ file.
		oldPathName _ path].

	defaultDirectory _ BugFixArchiveViewer lastSavedAttachmentsDirectory.
	newFullName _ FillInTheBlank
					request: 'Enter a new file name'
					initialAnswer: (defaultDirectory fullNameFor: oldFileName).
	newFullName isEmpty ifTrue: [^ self].

	FileDirectory activeDirectoryClass splitName: newFullName to:
		[:path :file |
		newFileName _ file.
		newPathName _ path].
	BugFixArchiveViewer lastSavedAttachmentsDirectory: (FileDirectory on: newPathName).

	oldFile := (FileDirectory on: oldPathName) readOnlyFileNamed: oldFullName.
	(FileDirectory on: newPathName) putFile: oldFile named: newFileName.
! !


!FileStream class reorganize!
('instance creation' fileNamed: forceNewFileNamed: fullName: isAFileNamed: new newFileNamed: oldFileNamed: oldFileOrNoneNamed: readOnlyFileNamed:)
('concrete classes' concreteStream)
('browser requests' httpPostDocument:args: httpPostMultipart:args: post:target:url:ifError: post:url:ifError: requestURL:target: requestURLStream: requestURLStream:ifError:)
('dnd requests' requestDropStream:)
('initialize-release' initialize)
('*BugFixesArchive' saveAs:)
('file reader services' fileIn: fileReaderServicesForFile:suffix: isSourceFileSuffix: removeLineFeeds: serviceFileIn serviceRemoveLineFeeds services)
('class initialization' unload)
!

