'From Squeak3.7alpha of ''11 September 2003'' [latest update: #5420] on 11 October 2003 at 11:43:10 am'!
"Change Set:		KCP-0103-VMProfilinginSTImage
Date:			24 September 2003
Author:			stephane ducasse

This changeset moves VM profiling primitives from SystemDictionary to SmalltalkImage. Simple.

v3: SmalltalkImage current"!


!SmalltalkImage methodsFor: 'vm profiling' stamp: 'sd 9/24/2003 11:54'!
clearProfile
	"Clear the profile database."

	<primitive: 250>
! !

!SmalltalkImage methodsFor: 'vm profiling' stamp: 'sd 9/24/2003 11:54'!
dumpProfile
	"Dump the profile database to a file."

	<primitive: 251>
! !

!SmalltalkImage methodsFor: 'vm profiling' stamp: 'sd 9/24/2003 11:54'!
profile: aBlock
	"Make a virtual machine profile of the given block."
	"Note: Profiling support is provided so that VM implementors
	 can better understand and improve the efficiency of the virtual
	 machine. To use it, you must be running a version of the
	 virtual machine compiled with profiling enabled (which
	 makes it much slower than normal even when not profiling).
	 You will also need the CodeWarrior profile reader application."

	self stopProfiling.
	self clearProfile.
	self startProfiling.
	aBlock value.
	self stopProfiling.
	self dumpProfile.! !

!SmalltalkImage methodsFor: 'vm profiling' stamp: 'sd 9/24/2003 11:55'!
startProfiling
	"Start profiling the virtual machine."

	<primitive: 252>
! !

!SmalltalkImage methodsFor: 'vm profiling' stamp: 'sd 9/24/2003 11:55'!
stopProfiling
	"Stop profiling the virtual machine."

	<primitive: 253>
! !


!SystemDictionary methodsFor: 'profiling' stamp: 'sd 9/30/2003 13:52'!
clearProfile
	"Clear the profile database."

	self deprecated: [self clearProfileDeprecatedPrimitive] explanation: 'Use SmalltalkImage current  clearProfile'.
! !

!SystemDictionary methodsFor: 'profiling' stamp: 'sd 7/2/2003 21:53'!
clearProfileDeprecatedPrimitive
	"Clear the profile database."
	<primitive: 250>
! !

!SystemDictionary methodsFor: 'profiling' stamp: 'sd 9/30/2003 13:52'!
dumpProfile
	"Dump the profile database to a file."

		self deprecated: [self dumpProfileDeprecatedPrimitive] explanation: 'Use SmalltalkImage current  dumpProfile'.
! !

!SystemDictionary methodsFor: 'profiling' stamp: 'sd 7/2/2003 21:54'!
dumpProfileDeprecatedPrimitive
	"Dump the profile database to a file."

	<primitive: 251>
! !

!SystemDictionary methodsFor: 'profiling' stamp: 'sd 7/2/2003 21:56'!
profile: aBlock
	"Make a virtual machine profile of the given block."
	"Note: Profiling support is provided so that VM implementors
	 can better understand and improve the efficiency of the virtual
	 machine. To use it, you must be running a version of the
	 virtual machine compiled with profiling enabled (which
	 makes it much slower than normal even when not profiling).
	 You will also need the CodeWarrior profile reader application."

	self deprecatedExplanation: 'Use SmalltalkImage current profile: aBlock'.
	self stopProfiling.
	self clearProfile.
	self startProfiling.
	aBlock value.
	self stopProfiling.
	self dumpProfile.! !

!SystemDictionary methodsFor: 'profiling' stamp: 'sd 9/30/2003 13:52'!
startProfiling
	"Start profiling the virtual machine."

	self deprecated: [self startProfilingDeprecatedPrimitive] explanation: 'Use SmalltalkImage current  startProfiling'.
! !

!SystemDictionary methodsFor: 'profiling' stamp: 'sd 7/2/2003 21:55'!
startProfilingDeprecatedPrimitive
	"Start profiling the virtual machine."

	<primitive: 252>
! !

!SystemDictionary methodsFor: 'profiling' stamp: 'sd 9/30/2003 13:52'!
stopProfiling
	"Stop profiling the virtual machine."

	self deprecated: [self stopProfilingDeprecatedPrimitive] explanation: 'Use SmalltalkImage current  stopProfiling'.

! !

!SystemDictionary methodsFor: 'profiling' stamp: 'sd 7/2/2003 21:55'!
stopProfilingDeprecatedPrimitive
	"Stop profiling the virtual machine."

	<primitive: 253>
! !

