'From Squeak3.7alpha of ''11 September 2003'' [latest update: #5420] on 11 October 2003 at 11:39:46 am'!
"Change Set:		KCP-0106-MoveModuletoSmalltalkImage
Date:			24 September 2003
Author:			stephane ducasse

Extract form SystemDictionary all the primitives working on the modules and define them on the class SmalltalkImage.

v3: SmalltalkImage current"!


!SmalltalkImage methodsFor: 'modules' stamp: 'sd 6/27/2003 23:47'!
listBuiltinModule: index
	"Return the name of the n-th builtin module.
	This list is not sorted!!"
	<primitive: 572>
	^self primitiveFailed! !

!SmalltalkImage methodsFor: 'modules' stamp: 'sd 9/30/2003 14:00'!
listBuiltinModules
	"SmalltalkImage current listBuiltinModules"
	"Return a list of all builtin modules (e.g., plugins). Builtin plugins are those that are 	compiled with the VM directly, as opposed to plugins residing in an external shared library. 	The list will include all builtin plugins regardless of whether they are currently loaded 
	or not. Note that the list returned is not sorted!!"

	| modules index name |
	modules _ WriteStream on: Array new.
	index _ 1.
	[true] whileTrue:[
		name _ self listBuiltinModule: index.
		name ifNil:[^modules contents].
		modules nextPut: name.
		index _ index + 1.
	].! !

!SmalltalkImage methodsFor: 'modules' stamp: 'sd 6/27/2003 23:48'!
listLoadedModule: index
	"Return the name of the n-th loaded module.
	This list is not sorted!!"
	<primitive: 573>
	^self primitiveFailed! !

!SmalltalkImage methodsFor: 'modules' stamp: 'sd 9/30/2003 14:00'!
listLoadedModules
	"SmalltalkImage current listLoadedModules"
	"Return a list of all currently loaded modules (e.g., plugins). Loaded modules are those that currently in use (e.g., active). The list returned will contain all currently active modules regardless of whether they're builtin (that is compiled with the VM) or external (e.g., residing in some external shared library). Note that the returned list is not sorted!!"
	| modules index name |
	modules _ WriteStream on: Array new.
	index _ 1.
	[true] whileTrue:[
		name _ self listLoadedModule: index.
		name ifNil:[^modules contents].
		modules nextPut: name.
		index _ index + 1.
	].! !

!SmalltalkImage methodsFor: 'modules' stamp: 'sd 6/27/2003 23:49'!
unloadModule: aString
	"Primitive. Unload the given module.
	This primitive is intended for development only since some
	platform do not implement unloading of DLL's accordingly.
	Also, the mechanism for unloading may not be supported
	on all platforms."
	<primitive: 571>
	^self primitiveFailed! !


!SystemDictionary methodsFor: 'miscellaneous' stamp: 'sd 9/30/2003 13:59'!
listBuiltinModule: index
	"Return the name of the n-th builtin module.
	This list is not sorted!!"
	
	self deprecated: [self listBuiltinModuleDeprecatedPrimitive: index] explanation: 'Use SmalltalkImage current  listBuiltinModule:'. 
	^self primitiveFailed! !

!SystemDictionary methodsFor: 'miscellaneous' stamp: 'sd 7/2/2003 22:13'!
listBuiltinModuleDeprecatedPrimitive: index
	"Return the name of the n-th builtin module.
	This list is not sorted!!"
	<primitive: 572>
	^self primitiveFailed! !

!SystemDictionary methodsFor: 'miscellaneous' stamp: 'sd 9/30/2003 13:59'!
listBuiltinModules
	"Smalltalk listBuiltinModules"
	"Return a list of all builtin modules (e.g., plugins). Builtin plugins are those that are compiled with the VM directly, as opposed to plugins residing in an external shared library. The list will include all builtin plugins regardless of whether they are currently loaded or not. Note that the list returned is not sorted!!"
	| modules index name |
	self deprecatedExplanation: 'Use SmalltalkImage current listBuiltinModules'.
	modules _ WriteStream on: Array new.
	index _ 1.
	[true] whileTrue:[
		name _ self listBuiltinModule: index.
		name ifNil:[^modules contents].
		modules nextPut: name.
		index _ index + 1.
	].! !

!SystemDictionary methodsFor: 'miscellaneous' stamp: 'sd 9/30/2003 13:59'!
listLoadedModule: index
	"Return the name of the n-th loaded module.
	This list is not sorted!!"
	
	self deprecated: [self listLoadedModuleDeprecatedPrimitive: index] explanation: 'Use SmalltalkImage current listLoadedModule:'. 
	^self primitiveFailed! !

!SystemDictionary methodsFor: 'miscellaneous' stamp: 'sd 7/2/2003 22:13'!
listLoadedModuleDeprecatedPrimitive: index
	"Return the name of the n-th loaded module.
	This list is not sorted!!"
	<primitive: 573>
	^self primitiveFailed! !

!SystemDictionary methodsFor: 'miscellaneous' stamp: 'sd 9/30/2003 13:59'!
listLoadedModules
	"Smalltalk listLoadedModules"
	"Return a list of all currently loaded modules (e.g., plugins). Loaded modules are those that currently in use (e.g., active). The list returned will contain all currently active modules regardless of whether they're builtin (that is compiled with the VM) or external (e.g., residing in some external shared library). Note that the returned list is not sorted!!"
	| modules index name |
	self deprecatedExplanation: 'Use SmalltalkImage current listBuiltinModules'.
	modules _ WriteStream on: Array new.
	index _ 1.
	[true] whileTrue:[
		name _ self listLoadedModule: index.
		name ifNil:[^modules contents].
		modules nextPut: name.
		index _ index + 1.
	].! !

!SystemDictionary methodsFor: 'miscellaneous' stamp: 'sd 9/30/2003 14:00'!
unloadModule: aString
	"Primitive. Unload the given module.
	This primitive is intended for development only since some
	platform do not implement unloading of DLL's accordingly.
	Also, the mechanism for unloading may not be supported
	on all platforms."
	self deprecated: [self unloadModuleDeprecatedPrimitive: aString] explanation: 'Use SmalltalkImage current unloadModule:'. 
	^self primitiveFailed! !

!SystemDictionary methodsFor: 'miscellaneous' stamp: 'sd 7/2/2003 22:13'!
unloadModuleDeprecatedPrimitive: aString
	"Primitive. Unload the given module.
	This primitive is intended for development only since some
	platform do not implement unloading of DLL's accordingly.
	Also, the mechanism for unloading may not be supported
	on all platforms."
	<primitive: 571>
	^self primitiveFailed! !

