ColorForm subclass: #ColorFormHelper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Golgi-Helpers'!
!ColorFormHelper commentStamp: '<historical>' prior: 0!
The sole purpse of this class is one class msg that allows easy substitution of one color by another. needed only because colorForms do not fileout/in easily, and plain form does not seem to handle transparency (needed in wedges) correctly...

resu _ Form fromUserWithExtent: 8@18
resu _ resu copy: (0@0 corner: 8@18)
resu replaceColor: Color red withColor: Color black
resu replaceColor: Color black withColor: Color red
resu replaceColor: Color red withColor: Color green
resu _ ColorForm mappingWhiteToTransparentFrom: resu
resu _ ColorForm mapFrom: Color lightYellow To: Color transparent in: resu
resu _ ColorForm vanishAllBut: Color red in: resu
lightYellow
resu displayAt: 10@10 
GoTranslateSmalltalk inspect Smalltalk garbageCollect

	[	[

	|	|

	"
	

GoTranslateSmalltalk addwedgeImage: resu toFamily: #comment forState: #contracted
GoTranslateSmalltalk initWedgeDict
GoTranslateSmalltalk inspect
Workspace someInstance inspect!


"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

ColorFormHelper class
	instanceVariableNames: ''!

!ColorFormHelper class methodsFor: 'as yet unclassified' stamp: 'ms 10/7/1998 00:25'!
mapFrom: oldC To: newC in: aFormOrCursor
"Return a ColorForm copied from aFormOrCursor with oldcolor mapped to newColor."

	| f map |
	aFormOrCursor depth <= 8 ifFalse: [
		^ self error: 'argument depth must be 8-bits per pixel or less'].
	(aFormOrCursor isKindOf: ColorForm) ifTrue: [
		f _ aFormOrCursor deepCopy.
		map _ aFormOrCursor colors.
	] ifFalse: [
		f _ ColorForm extent: aFormOrCursor extent depth: aFormOrCursor depth.
		f copyBits: aFormOrCursor boundingBox
			from: aFormOrCursor
			at: 0@0
			clippingBox: aFormOrCursor boundingBox
			rule: Form over
			fillColor: nil.
		map _ Color indexedColors copyFrom: 1 to: (1 bitShift: aFormOrCursor depth)].
	map _ map collect: [:c |
		c = oldC ifTrue: [newC] ifFalse: [c]].
	f colors: map.
	^ f
! !

!ColorFormHelper class methodsFor: 'as yet unclassified' stamp: 'ms 10/4/1998 01:38'!
vanishAllBut: aColor in: aFormOrCursor
	"Return a ColorForm copied from the given Form or Cursor with white mapped to transparent."

	| f map |
	aFormOrCursor depth <= 8 ifFalse: [
		^ self error: 'argument depth must be 8-bits per pixel or less'].
	(aFormOrCursor isKindOf: ColorForm) ifTrue: [
		f _ aFormOrCursor deepCopy.
		map _ aFormOrCursor colors.
	] ifFalse: [
		f _ ColorForm extent: aFormOrCursor extent depth: aFormOrCursor depth.
		f copyBits: aFormOrCursor boundingBox
			from: aFormOrCursor
			at: 0@0
			clippingBox: aFormOrCursor boundingBox
			rule: Form over
			fillColor: nil.
		map _ Color indexedColors copyFrom: 1 to: (1 bitShift: aFormOrCursor depth)].
	map _ map collect: [:c |
		c = aColor ifFalse: [Color transparent] ifTrue: [c]].
	f colors: map.
	^ f
! !


Object subclass: #GoCoffreFort
	instanceVariableNames: ''
	classVariableNames: 'ParaCache Tresor '
	poolDictionaries: ''
	category: 'Golgi-Helpers'!
!GoCoffreFort commentStamp: '<historical>' prior: 0!
cut&paste buffer (aka pasteBuffer/clipboard)

the current squeak implementation is not ok for us: it distributes the clipboard between ParagraphEditor.CurrentSelection and HandMorph.PasteBuffer (+ ok concealed calls to Smalltalk.clipboardText which is the system clipboard) without unifying them. The result is that the textMorphs only have access to the text clipboard, thus preventing implementation of pasting headers onto an active meatMorph. It also prvides no mechanism for unicity of info across clipboards. Finally, the HandMorph.PasteBuffer insists on doing veryDeepCopy all the time without allowing any kind of lightweight access. 
Thus decided to write a wrapper around ParagraphEditor.CurrentSelection which is looked at by all goObjects, and that can contain either text or morphs. But now need to make this wrapper accessible from all textMorphs (ParagraphEditor). Considered resorting to a global declaration of GoSession as global and keep a reference to the pasteBuffer/clipboard in GoSession (or the pasteBuffer/clipboard as global, or declare the pasteBuffer/clipboard as a golgi global).  Kept a lightweight solution with a global in GoCoffreFort.

Upgraded the cut/copy/paste mechanism in GoParagraphEditor to use GoCoffreFort so as to ensure unicity of info and accessibility to other kinds of info.

There is one tough issue: since our content overrides that of ParagraphEditor, it becomes quirky to fill the ParagraphEditor buffer outside of golgi (thus not updating us) and then try to paste it into golgi. this would work only if our content is nil. To work around that i keep a copy of the last known state of the ParagraphEditor buffer, and if the actual content is different from that, i serve that (reasoning that it must hav been changed after i have been since i have not heard about it.) This is under 'cooperation fix'.!


"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

GoCoffreFort class
	instanceVariableNames: ''!

!GoCoffreFort class methodsFor: 'access' stamp: 'ms 11/3/1998 15:16'!
content
	"alternative lexeme for 'tresor'"
	^ self tresor! !

!GoCoffreFort class methodsFor: 'access' stamp: 'ms 11/3/1998 15:16'!
content: x
	"alternative lexeme for 'tresor:'"
	^ self tresor: x! !

!GoCoffreFort class methodsFor: 'access' stamp: 'ms 11/3/1998 15:15'!
put: x
	"alternative lexeme for 'tresor:'"
	^ self tresor: x! !

!GoCoffreFort class methodsFor: 'access' stamp: 'ms 11/4/1998 11:44'!
stealContents
	"to get the content of the paste buffer, emptying it after uses."
	| t |
	t _ self tresor.
	Tresor _ nil.
	^ t! !

!GoCoffreFort class methodsFor: 'access' stamp: 'ms 11/4/1998 11:43'!
tresor
	self paraBufferIsFresher ifTrue: [
		Tresor _ nil.
		^ self paraBuffer].
	^ Tresor! !

!GoCoffreFort class methodsFor: 'access' stamp: 'ms 11/4/1998 13:00'!
tresor: t
	self updateParaCache.
	Tresor _ t! !


!GoCoffreFort class methodsFor: 'cooperation fix' stamp: 'ms 11/3/1998 16:14'!
paraBuffer
	^ GoParagraphEditor paragraphClipboard! !

!GoCoffreFort class methodsFor: 'cooperation fix' stamp: 'ms 11/4/1998 12:56'!
paraBufferIsFresher
	"see explanation in class comments."
	^ (ParaCache = "sameAs:" self paraBuffer) not! !

!GoCoffreFort class methodsFor: 'cooperation fix' stamp: 'ms 11/4/1998 12:59'!
updateParaCache
	ParaCache _ self paraBuffer! !


TextMorphEditor subclass: #GoParagraphEditor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Golgi-Helpers'!
!GoParagraphEditor commentStamp: '<historical>' prior: 0!
I am here to 
- allow morphs to specify their own keyCombo mappings overriding those of ParagraphEditor (by sending modifier+keystroke up the food chain for processing).
- make tab a special char. (that way it is easy to still treat it as normal tab, while the reciprocal is not true)
- change the cut/copy/paste mechanism to use GoCoffreFort so as to ensure unicity of info across classes/clipboards and accessibility to other kinds of info than text. (note: I use GoCoffreFort content as a one-timer. its content is nilled out after it is pasted. more intuitive to me, but can be changed)
!


!GoParagraphEditor methodsFor: 'keyboard (new methods)' stamp: 'miso 10/13/1999 15:52'!
key: char combo: comboSymbol stream: s
	"allows me to delegate decision about what action to take on cmd keys> If delegating results in true/false, I take this to be the standard result fo a an accomplished action and pass it back to kb dispatcher. If nil is returned, I consider that the action was not done and will perform my default action"
	| keyNum  |
	^ (morph key: char combo: comboSymbol stream: s) ifNil: [
		"take a shot at doing it ourselves, if people above didn't get it"
		keyNum _ char asciiValue + 1.
		comboSymbol = nil ifTrue: [
			"special key"
			^ self perform: (CmdActions at: keyNum) with: s].
		comboSymbol = #cmd ifTrue: [
			^ self perform: (CmdActions at: keyNum) with: s].
		comboSymbol = #cmdShift ifTrue: [
			^ self perform: (ShiftCmdActions at: keyNum) with: s]]! !

!GoParagraphEditor methodsFor: 'keyboard (new methods)' stamp: 'ms 11/1/1998 15:09'!
keyStrokeIsModified
"look for cmd/cmdShift just like ParagraphEditor.dispatchOnCharacter:with: did, but cleaner :-). Answer with a modifier keys descriptor : #cmd, #cmdShift, nil"

	sensor commandKeyPressed ifTrue: [
		sensor leftShiftDown
			ifTrue: [^ #cmdShift]
			ifFalse: [^ #cmd]].

	"the control key can be used to invoke shift-cmd shortcuts"
	sensor controlKeyPressed ifTrue: [^ #cmdShift].

	^ nil! !

!GoParagraphEditor methodsFor: 'keyboard (new methods)' stamp: 'ms 11/1/1998 15:37'!
keyStrokeIsSpecial: char
"Answer whether this is a special key that is a command even withut modifier. Encapsulate the call to specialShiftCmdKeys so as to include tab in special keys."

	"enter, backspace, arrows, escape, etc. are command keys"
	(self class specialShiftCmdKeys includes: char asciiValue) ifTrue: [^ true].

	"-=-= special for golgi, until it is put into specialChars -=-="
	char = Character tab 
		ifTrue: [^ true].

	^ false! !


!GoParagraphEditor methodsFor: '  overriden' stamp: 'miso 10/17/1999 10:37'!
dispatchOnCharacter: char with: typeAheadStream
	"Carry out the action associated with this character, if any. Type-ahead is passed so some routines can flush or use it."
	"overiden to: i. allow my morph to dispatch special key combos. this gives much more flexibility to plug in specialised behaviors for accelerator keys. ii. distinguish between cmdSpecialKey and specialKey without cmd"
	| combo  |
	combo _ self keyStrokeIsModified.
	char = Character enter ifTrue: [
		^ self dispatchOnEnterWith: typeAheadStream].
	(self keyStrokeIsSpecial: char) ifTrue: [
		^ self key: char combo: combo stream: typeAheadStream].
	combo ifNotNil: [
		^ self key: char combo: combo stream: typeAheadStream].
	^ self perform: #normalCharacter: with: typeAheadStream! !


!GoParagraphEditor methodsFor: '  helpers' stamp: 'miso 10/17/1999 10:51'!
readKeyboard
"This is exactly the same is in superclass. No modif. Put here only because I commented it and don't want to lose it on fileOut :-)"

	"Key struck on the keyboard. Find out which one and, if special, carry 
	out the associated special action. Otherwise, add the character to the 
	stream of characters.  Undoer & Redoer: see closeTypeIn."

	| typeAhead char |
	typeAhead _ WriteStream on: (String new: 128).
	[sensor keyboardPressed] whileTrue: 
		[self deselect.
			[sensor keyboardPressed] whileTrue: 
				[char _ sensor keyboardPeek.
				(self dispatchOnCharacter: char with: typeAhead) ifTrue:
					"scroll after each char, but only if readChar returns true"
					[beginTypeInBlock _ nil.
					^self selectAndScroll; updateMarker].
				self openTypeIn].

		"keyboard not pressed anymore"
		startBlock = stopBlock ifFalse: "save highlighted characters"
			[UndoSelection _ self selection]. 
		self zapSelectionWith: 
			(Text string: typeAhead contents emphasis: emphasisHere).

		"reset our vars"
		typeAhead reset.
		startBlock _ stopBlock copy.

		"scroll into view"
		sensor keyboardPressed ifFalse: 
			[self selectAndScroll.
			sensor keyboardPressed
				ifFalse: [self updateMarker]
		]
	]! !


!GoParagraphEditor methodsFor: 'clipboard upgrade' stamp: 'ms 11/12/1998 13:30'!
clipboardTextOLD
	"get things from our wrapper clipboardText rather than ParagraphEditor.CurrentSelection. Ours is a superset of that, except in one case: if text was copied from outside of golgi and wants to be pasted into golgi, while our own clipboardText is not empty. There are two workarounds for this case: use shsift-cmd-v to paste if you remember the problem. Else paste a second time (the first paste flushes our buffer, the second pste will thus use the ParagraphEditor buffer). "
		"in the future, could keep a copy of the last known state of ParagraphEditor buffer, and use it when its content !!= to lastKnownState"	| c |
	c _ self pasteBuffer stealContents.
	c
		ifNotNil: [^c]
		ifNil: [^ super clipboardText]! !

!GoParagraphEditor methodsFor: 'clipboard upgrade' stamp: 'ms 11/3/1998 16:00'!
clipboardTextPut: text
	"Set text currently on the GoClipboard"
	super clipboardTextPut: text  "Set text currently on the ParagraphEditor clipboard.  Also export to system clipboard".
	self pasteBuffer put: text "do this after normal clipboard update so that we can compare contents"! !

!GoParagraphEditor methodsFor: 'clipboard upgrade' stamp: 'ms 11/3/1998 16:02'!
paragraphClipboard
	"allow access to ParagraphEditor buffer, to be able to compare contents with GoCoffreFort"
	^ super clipboardText! !

!GoParagraphEditor methodsFor: 'clipboard upgrade' stamp: 'ms 11/3/1998 15:13'!
pasteBuffer
	^ GoCoffreFort! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

GoParagraphEditor class
	instanceVariableNames: ''!

!GoParagraphEditor class methodsFor: 'clipboard upgrade' stamp: 'ms 11/12/1998 13:32'!
paragraphClipboard
	"allow access to ParagraphEditor buffer, to be able to compare contents with GoCoffreFort"

	"^ CurrentSelection"

	"copied from ParagraphEditor.clipboardText"
	| s |
	s _ Smalltalk clipboardText.
	(s isEmpty or: [s = CurrentSelection string])
		ifTrue: [^ CurrentSelection]
		ifFalse: [^ s asText]! !


Object subclass: #GoPreferences
	instanceVariableNames: 'prefDict sessionMngr '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Golgi-Helpers'!
!GoPreferences commentStamp: '<historical>' prior: 0!
I hold prefs (without presupposing that they are only booleans). If sessionMngr is not nil, i notify all ongoing sessions of any pref-change.

Being an independent object i can be swapped, so there can be many pref-sets coexisting in golgi.!


!GoPreferences methodsFor: 'get/set' stamp: 'miso 10/24/1999 15:25'!
enforcePref: prefUpdatingBlock
"walk all existing headers running prefUpdatingBlock on them. prefUpdatingBlock must take one var: the header being updated. Used when a pref is set, to make the change live"

	"why not GoHeader allInstancesDo: ?"
	Golgi allInstancesDo: [:v |
		v walkHeadersWith: prefUpdatingBlock ].
	GoSniffer sniffer headerBank scratchHeaderBank
	"what about hidden headers? GolgiCache, headerBankCache...: "

! !

!GoPreferences methodsFor: 'get/set' stamp: 'ms 11/2/1998 12:31'!
getPref: prefSymbol

	^ prefDict at: prefSymbol ifAbsent: []! !

!GoPreferences methodsFor: 'get/set' stamp: 'ms 11/2/1998 12:20'!
setPref: prefSymbol to: v

	^ prefDict at: prefSymbol put: v! !


!GoPreferences methodsFor: 'wrappers' stamp: 'ms 11/2/1998 12:35'!
headerColorPref: c
"reset the pref for color of meat & header, and notify all existing headers of the change."

	self setPref: #headerColor to: c.
	self setPref: #meatColor to: c.
	self enforcePref: [:h| h setColor: c].! !

!GoPreferences methodsFor: 'wrappers' stamp: 'ms 11/2/1998 12:35'!
meatColorPref: c
	"reset the pref for color of meat & header, and notify all existing headers of the change"
	self setPref: #meatColor to: c.
	self enforcePref: [:h| h meatMorph setColor: c]! !

!GoPreferences methodsFor: 'wrappers' stamp: 'miso 10/10/1999 11:50'!
scrollpaneColorPref: c
"reset the pref for color of scrollpane, and notify all existing bigBrothers of the change."

	self setPref: #scrollpaneColor to: c.
	self enforcePref: [:h| h setColor: c].! !


!GoPreferences methodsFor: 'macros' stamp: 'miso 10/10/1999 11:49'!
colorPref: c for: o

	| theColor |
	theColor _ self normaliseColor: c.

	o = #overall ifTrue: [^self setAllColorsTo: theColor].
	o = #GoHeader ifTrue: [^self headerColorPref: theColor].
	o = #GoMeat ifTrue: [^self meatColorPref: theColor].
	o = #Golgi ifTrue: [^self scrollpaneColorPref: theColor].

	self error: 'cannot set color pref for: ', o printString, ' coz i don''t know what it is'.

"	target _ (Compiler evaluate: o for: self logged: false).
	target setColor: theColor updating: bigBrothers.	"	! !

!GoPreferences methodsFor: 'macros' stamp: 'ms 3/7/1999 03:26'!
normaliseColor: c
	| theColor |
	theColor _ c.
	theColor ifNil: [
		theColor _ FillInTheBlank request: 'type a color in:' initialAnswer: 'black'.
		theColor isEmpty ifTrue: [^self].
		theColor _ theColor asSymbol].
	(theColor isKindOf: Symbol)
		ifTrue: [theColor _ Color perform: theColor].
	^ theColor
	"#2	view backgroundColor: Color fromUser; uncacheBits; display"
	"#3- HandMorph chooseColor"
		"w colorPicker"
		"w _ self world"
		"colorPicker _ self changeColorTarget: nil selector: nil"
		"[colorPicker isInWorld] whileTrue: [w doOneCycle]"
		"^ colorPicker selectedColor"! !

!GoPreferences methodsFor: 'macros' stamp: 'ms 11/2/1998 12:37'!
setAllColorsTo: realColor
	self headerColorPref: realColor.
	self scrollpaneColorPref: realColor	"scroller"! !

!GoPreferences methodsFor: 'macros' stamp: 'miso 10/10/1999 11:56'!
setMargin: whichMargin in: o to: n

	| target |
	target _ (Compiler evaluate: o for: self logged: false).
	target setMargin: whichMargin to: n updating: Golgi allInstances! !


!GoPreferences methodsFor: 'admin' stamp: 'ms 3/7/1999 04:53'!
checkCriticalPrefs
	GoHeader checkMargins! !

!GoPreferences methodsFor: 'admin' stamp: 'ms 11/2/1998 12:23'!
initialize
	prefDict _ Dictionary new! !

!GoPreferences methodsFor: 'admin' stamp: 'ms 11/2/1998 12:23'!
sessionMngr: m
	sessionMngr _ m! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

GoPreferences class
	instanceVariableNames: ''!

!GoPreferences class methodsFor: 'as yet unclassified' stamp: 'miso 10/5/1999 21:52'!
new
	^ super new initialize.! !


Object subclass: #GoSniffer
	instanceVariableNames: 'bigBrothers sniffDaughters theSniffProcess shutUp shortDelay longDelay headerBank '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Golgi-Helpers'!

!GoSniffer methodsFor: 'as yet unclassified' stamp: 'ms 3/7/1999 03:21'!
addBigBrother: b
	bigBrothers _ bigBrothers copyWith: b.
! !

!GoSniffer methodsFor: 'as yet unclassified' stamp: 'ms 3/7/1999 04:38'!
askFillHeaderBank
	[self headerBank addOneHeaderToBank ~~ nil] whileTrue:  [
		self giveOneCycle]! !

!GoSniffer methodsFor: 'as yet unclassified' stamp: 'ms 3/7/1999 03:15'!
backgroundLoadDaughtersOf: aHeader
	"this recursively walks the tree and attempts to load all terminals"
	aHeader isExpanded
		ifTrue: [
			aHeader subheaders do: [
				:d  |
				self backgroundLoadDaughtersOf: d]]
		ifFalse: [
			self sniff: aHeader
			"a terminal"
			"		aHeader subheadersNeedLoading ifTrue: [
			// aHeader dressDaughters
			// Transcript show: 'loading...', (aHeader getMeat); cr.
			hPane _ aHeader subheaderPane.
			self giveOneCycle.
			aHeader meme daughters do: [: d |
				hPane paneDress: d meat: #meat daughters: #daughters 
						after: #last depth: nil. 
				self giveOneCycle ].
			aHeader subheadersNeedLoading: false.

			aHeader isExpanded ifFalse: [ hPane boundsGivenToplineAndYield: (
				(aHeader bounds left + 25)@aHeader bounds bottom
				corner: (aHeader bounds  right)@0 ).
			self giveOneCycle ]]]"]! !

!GoSniffer methodsFor: 'as yet unclassified' stamp: 'miso 10/8/1999 20:37'!
checkSnifferAlive

	theSniffProcess ifNil: [ "??? hwo happened"
		self launchSniffingProcess].
	theSniffProcess suspendedContext ifNil: [
		self suicide.
		self launchSniffingProcess	]
! !

!GoSniffer methodsFor: 'as yet unclassified' stamp: 'ms 3/7/1999 03:13'!
giveOneCycle
	self mainBigBrother ifNil: [
		^ Processor yield].
	self mainBigBrother world doOneCycle.
	shutUp ifTrue: [
		self suspendSniffer].
	Processor yield! !

!GoSniffer methodsFor: 'as yet unclassified' stamp: 'ms 3/7/1999 03:51'!
handleEvent: evt

! !

!GoSniffer methodsFor: 'as yet unclassified' stamp: 'ms 3/7/1999 04:38'!
headerBank
	^ headerBank! !

!GoSniffer methodsFor: 'as yet unclassified' stamp: 'miso 10/11/1999 07:48'!
initialize

	sniffDaughters _ Array new.
	bigBrothers _ Array new.
	headerBank _ HeaderBank new.
	shortDelay _ Delay forMilliseconds: 500.
	longDelay _ Delay forSeconds: 5.
	shutUp _ false.
	self launchSniffingProcess! !

!GoSniffer methodsFor: 'as yet unclassified' stamp: 'ms 3/7/1999 03:13'!
launchSniffingProcess

	theSniffProcess _  [ self sniffingProcess] fork


"pseudoFork: aBlock
This mimicks fork/forkAt: priority, which we will use once it returns the newly created process.

	| forkedProcess |
	forkedProcess _ aBlock newProcess.
	// forkedProcess priority: Processor userBackgroundPriority.
	forkedProcess resume.
	^ forkedProcess.	"
! !

!GoSniffer methodsFor: 'as yet unclassified' stamp: 'ms 3/7/1999 02:40'!
loadDaughtersOf: aHeader

	self checkSnifferAlive.
	(sniffDaughters includes: aHeader) ifFalse:
		[sniffDaughters _ (Array with: aHeader), sniffDaughters]! !

!GoSniffer methodsFor: 'as yet unclassified' stamp: 'ms 3/7/1999 03:15'!
loadRequest
	| h  |
	[sniffDaughters size > 0] whileTrue: [
		h _ sniffDaughters first.
		h subheaders do: [
			:newH  |
			self sniff: newH].
		sniffDaughters _ sniffDaughters copyWithout: h]! !

!GoSniffer methodsFor: 'as yet unclassified' stamp: 'ms 3/7/1999 03:17'!
mainBigBrother
	"return the first bigBro that is currently in world, if none of them is, just the first bigBro, if none, nil."
	bigBrothers isEmpty
		ifTrue: [^nil]
		ifFalse: [
			bigBrothers do: [: b |
				b world ifNotNil: [^b]].
			"none was in a world, return the first"
			^ bigBrothers first].
	^nil! !

!GoSniffer methodsFor: 'as yet unclassified' stamp: 'miso 10/13/1999 11:30'!
removeBigBrother: b

	bigBrothers _ bigBrothers copyWithout: b	
! !

!GoSniffer methodsFor: 'as yet unclassified' stamp: 'ms 3/7/1999 03:19'!
resumeSniffer

	theSniffProcess ifNotNil: [ theSniffProcess resume ]
! !

!GoSniffer methodsFor: 'as yet unclassified' stamp: 'miso 10/25/1999 10:11'!
sniff: aHeader
	"load subheader if necessary"
	| hPane  |
	aHeader isExpanded ifTrue: [
		^ self].
	aHeader subheadersNeedLoading ifFalse: [
		^ self
		"	Transcript show: 'loading...', (aHeader getMeat); cr."].
	hPane _ aHeader subheaderPane.
	self giveOneCycle.
	aHeader translator daughters do: [
		:d  |
		aHeader dressSubmeme: d.
		self giveOneCycle].
	aHeader isExpanded ifFalse: [
		hPane boundsGivenToplineAndYield: ((aHeader bounds left + 25) @ aHeader bounds bottom corner: aHeader bounds right @ 0).
		self giveOneCycle]! !

!GoSniffer methodsFor: 'as yet unclassified' stamp: 'miso 10/5/1999 22:12'!
sniffingProcess
	[self mainBigBrother = nil] whileTrue: [
		shortDelay wait].
	[self mainBigBrother primaryHand = nil] whileTrue: [
		shortDelay wait].
	[true] whileTrue: [
		bigBrothers isEmpty ifTrue: [
			self suicide].
		World ifNotNil: [
			World hands first startReportingEventsTo: self.
			self loadRequest.
			self askFillHeaderBank.
			World hands first stopReportingEventsTo: self].
		Processor yield
		"	self backgroundLoadDaughtersOf: bigBro.
		theGlobals scratchHeaderBank.	"
		" using 'longDelay wait' at the end of each cycle is not good: somehow it slows down the main process a lot (on expands)."]! !

!GoSniffer methodsFor: 'as yet unclassified' stamp: 'miso 10/13/1999 10:59'!
suicide

	World primaryHand stopReportingEventsTo: self.
	theSniffProcess ifNotNil: [
		theSniffProcess terminate]! !

!GoSniffer methodsFor: 'as yet unclassified' stamp: 'ms 3/7/1999 03:19'!
suspendSniffer

	theSniffProcess ifNotNil: [ 
		shutUp_false. 
		self mainBigBrother primaryHand stopReportingEventsTo: self.
		theSniffProcess suspend ]
! !

!GoSniffer methodsFor: 'as yet unclassified' stamp: 'miso 10/13/1999 11:26'!
viewClosingDown: bigBrotherOfView
"an object viewer on a memePool is closing down. Take whatever steps are appropriate to the end of an editing session. eg ask backup mngr if wants to do anything."

	self removeBigBrother: bigBrotherOfView.
	bigBrothers isEmpty ifTrue: [self suicide].


! !

!GoSniffer methodsFor: 'as yet unclassified' stamp: 'ms 3/7/1999 03:21'!
zapDaughtersToSniff
	sniffDaughters _ nil! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

GoSniffer class
	instanceVariableNames: ''!

!GoSniffer class methodsFor: 'as yet unclassified' stamp: 'miso 10/5/1999 22:16'!
killAllSessions
	"close all open outlines. if some GoSession instance still exists after that, emergencyKill it."
	| gTop theSniff |
	theSniff _ self someInstance.
	theSniff ifNil: [^self].
	theSniff suicide.
	Object halt. gTop _ theSniff mainBigBrother.
	[gTop = nil] whileFalse: [
		"find the top of that golg"
		(gTop owner isKindOf: TransformMorph) ifTrue: [
			gTop _ gTop owner owner].
		"find who is responsible for that top. ask him to die"
		(gTop owner isKindOf: SystemWindow)
			ifTrue: [
				"bring to front"
				gTop owner model ifNil: "something went wrong" [gTop die].
				gTop owner delete]
			ifFalse: "weird. just detach it?" [
				gTop die].
		gTop _ theSniff mainBigBrother].
	theSniff zapDaughtersToSniff "delete requests for daughters".
	"check this does it"
	theSniff _ nil "no more pointers to that instance".
	Smalltalk garbageCollect.
	self someInstance
		ifNil: [
			self notify: 'dead!!']
		ifNotNil: [
			self someInstance inspect.
			self error: 'can''t get this GoSession instance to die...'.]! !

!GoSniffer class methodsFor: 'as yet unclassified' stamp: 'miso 10/10/1999 22:50'!
loadDaughtersOf: aHeader

	self sniffer loadDaughtersOf: aHeader! !

!GoSniffer class methodsFor: 'as yet unclassified' stamp: 'miso 10/5/1999 21:53'!
new
	^ super new initialize.! !

!GoSniffer class methodsFor: 'as yet unclassified' stamp: 'ms 3/7/1999 03:47'!
sniffer

	^ self theOnlyInstance! !

!GoSniffer class methodsFor: 'as yet unclassified' stamp: 'miso 10/10/1999 22:51'!
theOnlyInstance
	self instanceCount > 0 
		ifTrue: [^ self someInstance ]
		ifFalse: [^ super new initialize]! !


Object subclass: #HeaderBank
	instanceVariableNames: 'dummyMeme '
	classVariableNames: 'MaxHeadersInBank TheHeaderBank '
	poolDictionaries: ''
	category: 'Golgi-Helpers'!
!HeaderBank commentStamp: '<historical>' prior: 0!
For speed, I preventively stock headers. When a new header is needed, it can be snatched from me and its content reset, which is much faster than recreating a whole new header.!


!HeaderBank methodsFor: 'accessors' stamp: 'miso 10/19/1999 13:38'!
dummyMeme
	^ dummyMeme! !

!HeaderBank methodsFor: 'accessors' stamp: 'ms 9/7/1998 19:40'!
maxHeadersInBank
	MaxHeadersInBank ifNil: [ MaxHeadersInBank _ 200 ].
	^ MaxHeadersInBank! !

!HeaderBank methodsFor: 'accessors' stamp: 'ms 9/5/1998 19:34'!
maxHeadersInBank: m
	MaxHeadersInBank _ m! !


!HeaderBank methodsFor: 'header bank' stamp: 'miso 10/19/1999 14:07'!
addOneHeaderToBank

	self privTempCheckDummymemeSanity.
	TheHeaderBank size < self maxHeadersInBank
		ifTrue: [TheHeaderBank _ TheHeaderBank copyWith: 
			(GoHeader rawWithAccessor: (GoTranslator meme: dummyMeme))]
		ifFalse: [^ nil ]! !

!HeaderBank methodsFor: 'header bank' stamp: 'ms 7/3/1999 22:13'!
fillHeaderBank

	| i |
	i_TheHeaderBank size.
	[i<=self maxHeadersInBank] whileTrue: [
		TheHeaderBank _ TheHeaderBank copyWith: 
			(GoHeader rawWithAccessor: (GoTranslator meme: dummyMeme)).
		i _ TheHeaderBank size]! !

!HeaderBank methodsFor: 'header bank' stamp: 'ms 3/8/1999 16:02'!
headerFromBank
	|resu|
	TheHeaderBank size > 0 ifTrue: [
		resu _ TheHeaderBank first. 
		TheHeaderBank _ TheHeaderBank copyWithout: resu.
		^ resu ].
	^nil! !

!HeaderBank methodsFor: 'header bank' stamp: 'ms 3/8/1999 16:03'!
initialize

	TheHeaderBank ifNil: [TheHeaderBank _ Array new].
	dummyMeme _ Meme new.! !

!HeaderBank methodsFor: 'header bank' stamp: 'miso 10/19/1999 13:53'!
privTempCheckDummymemeSanity
"somehow dummy meme once ended with 2700 dependents, none of them in the bank and all of them with fresh unlinked headers..."

	dummyMeme dependents size > 210 ifTrue: [^ self error: 'too many dependents on dummy meme in header bank... ?!!!!?']! !

!HeaderBank methodsFor: 'header bank' stamp: 'ms 3/8/1999 16:03'!
scratchHeaderBank

	TheHeaderBank _ Array new! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

HeaderBank class
	instanceVariableNames: ''!

!HeaderBank class methodsFor: 'serve headers' stamp: 'ms 3/8/1999 16:02'!
headerFromBank
	| resu  |
	TheHeaderBank size > 0 ifTrue: [
		resu _ TheHeaderBank first.
		TheHeaderBank _ TheHeaderBank copyWithout: resu.
		^ resu].
	Transcript
		 show: 'empty';
		 cr.
	^ nil! !

!HeaderBank class methodsFor: 'serve headers' stamp: 'miso 10/5/1999 21:53'!
new
	^ super new initialize.! !


TextMorphForEditView subclass: #MichTextMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Golgi-Helpers'!
!MichTextMorph commentStamp: '<historical>' prior: 0!
This whole class is just to workaround one bug in the standard TextMorph. The bug is that if you resize the TextMorph (eg by resizing the PluggableTextMorph) while editing the text in it, the selection is forgotten. This means that in an auto-resizing text-editor which grows as the user types in, every growth will provoke amnesia and the insertionPoint will be zapped to the beginning of the text. Bottomline: the text ended up mangled.
The workaround is pretty simple: every time releaseParagraph is invoked, copy the current selection into pluggable.selectionExtent (just as is standardly done when the mouse leaves the TextMorph). Conversely, everytime we recreate a paragraph, set teh selection to the selection backed up in pluggable.selectionExtent , if any (just as is standardly done when the mouse re-enters the TextMorph).
Note that this workaround unfortunately requires adding two accessors to pluggableTxtMrph: selectionBackup & selectionBackup: so that TextMorph can read and write those values.
[Finaly, note another small bug, described in note.1 in the code for TextMorph.paragraph]!


!MichTextMorph methodsFor: 'opEditor support' stamp: 'ms 12/19/1998 00:20'!
editorClass
	^ GoParagraphEditor! !

!MichTextMorph methodsFor: 'opEditor support' stamp: 'ms 10/11/1998 14:35'!
installEditor
	"Install an editor for my paragraph.  This constitutes 'hasFocus'."
	editor ifNotNil: [^ editor].
	editor _ self editorClass new morph: self.
	editor changeParagraph: self paragraph.
	self selectionChanged.
	^ editor! !

!MichTextMorph methodsFor: 'opEditor support' stamp: 'ms 12/19/1998 00:24'!
installEditorToReplace: priorEditor
	"overrode hardcoded editor class, ms"
	"Install an editor for my paragraph.  This constitutes 'hasFocus'.
	If priorEditor is not nil, then initialize the new editor from its state.
	We may want to rework this so it actually uses the prior editor."
	| stateArray  |
	priorEditor ifNotNil: [
		stateArray _ priorEditor stateArray].
	editor _ self editorClass new morph: self.
	editor changeParagraph: self paragraph.
	priorEditor ifNotNil: [
		editor stateArrayPut: stateArray].
	self selectionChanged.
	^ editor! !

!MichTextMorph methodsFor: 'opEditor support' stamp: 'miso 10/17/1999 10:50'!
key: char combo: comboSymbol stream: s
"if return true/false means action is done, but if return nil, means action was not done and somebody lower in the foodchain will take a shot at it (ultimately, the editor will)"

	"filter cmdTab to be a normal tab"
	(comboSymbol = #cmdShift and: [char = Character tab]) ifTrue: [
			^ editor normalCharacter: s].
	^ editView key: char combo: comboSymbol stream: s.


" old, was @beginning to speed up (put away to make more flexible)

	comboSymbol ifNil: [
		keyNum = 9 ifTrue:	[^ nil].		// cmdDel ~~ Del
		keyNum = 29 ifTrue:	[^ nil].		// cmdArrow ~~ Arrow
		keyNum = 30 ifTrue:	[^ nil].		// cmdArrow ~~ Arrow
		keyNum = 31 ifTrue:	[^ nil].		// cmdArrow ~~ Arrow
		keyNum = 32 ifTrue:	[^ nil].		// cmdArrow ~~ Arrow
	].
"! !


!MichTextMorph methodsFor: 'bug workaround' stamp: 'ms 8/28/1998 21:07'!
paragraph
	| oldSelection |
	paragraph = nil ifFalse: [ ^ paragraph ].
	paragraph ifNotNil: [^ paragraph].
	self setDefaultContentsIfNil.
	paragraph _ (self paragraphClass new textOwner: owner)
					compose: text style: textStyle copy
					from: self startingIndex in: self container.

	"-=-= new code starts here. adapted from mouseEnter:"

"we need to restrict it to focus elements or else any change of bounds will cause us to redraw selection, even out of focus"

	editView ifNotNil: [  "all these checks are actually needed :-( "
		editView hasFocus ifTrue: [
			oldSelection _ editView selectionBackup.
			oldSelection ifNotNil: [
				self handleEdit: 
					[self editor selectInterval: editView selectionBackup ]]]].

"	self hasFocus ifTrue: [
		oldSelection _ editView selectionBackup.
		oldSelection ifNotNil: [
			// ugly hack. see note.1 below
			(oldSelection first = 1) ifFalse: [
				self handleEdit: [
					self editor selectInterval: editView selectionBackup ]]]].

self world ifNotNil: [
	self world activeHand ifNotNil: [
		self world activeHand keyboardFocus = self ifTrue: [
			oldSelection _ editView selectionBackup.
			oldSelection ifNotNil: [
				self handleEdit: 
					[self editor selectInterval: editView selectionBackup ]]]]].

	editView ifNotNil: [ 
		self world activeHand ifNotNil: [
		self world activeHand keyboardFocus = self ifTrue: [
			oldSelection _ editView selectionBackup.
			oldSelection ifNotNil: [
				(oldSelection first = 1) ifFalse:   
					[self handleEdit: 
						[self editor selectInterval: editView selectionBackup ]]]]]].
"

 "all these checks are actually needed :-( . ugly hack. see note.1 below"
"	editView ifNotNil: [ 
		oldSelection _ editView selectionBackup.
		oldSelection ifNotNil: [
			(oldSelection first = 1) ifFalse:   
				[self handleEdit: 
					[self editor selectInterval: editView selectionBackup ]]]].
"
	"-=-= new ends here."

	wrapFlag ifFalse:
		["Was given huge container at first... now adjust"
		paragraph adjustRightX].
	self fit.
	^ paragraph

" note.1:		There is an strange remain of MVC in MorphWorld interfering here:
			when an editor is created, it is actually associated to an MVC Paragraph.
			Right after that, the paragraph is exchanged in favor of a Morphic
			NewParagraph. But while creating the newPara, if we ask editor to set 
			selection, the editor will pass the request to the old style para which 
			will barf. 
			The ugly workaround plays on the fact that the initial selection is 
			always at 1.
"! !

!MichTextMorph methodsFor: 'bug workaround' stamp: 'ms 8/28/1998 20:56'!
releaseParagraph

	"the following instruction is adapated from code in mouseLeave:"
	editor ifNotNil: [ 
		editView selectionBackup: self editor selectionInterval ]. 
	^ super releaseParagraph.
! !


!MichTextMorph methodsFor: 'experimental' stamp: 'ms 8/31/1998 02:58'!
fit
	"Adjust bounds to fit the text if not in a rigid container. Overridden to show the whole text after fitting."
	| newExtent para |
	newExtent _ (self paragraph extent max: 9@textStyle lineGrid) + (0@2).
	newExtent ~= bounds extent ifTrue:
		[(container == nil and: [successor == nil]) ifTrue:
			[para _ paragraph.  "Save para (layoutChanged smashes it)"
			super extent: newExtent.
			paragraph _ para]].
	container ifNotNil:
		[self privateBounds: container bounds truncated].
	self paragraph positionWhenComposed: self position.
	successor ifNotNil:
		[successor predecessorChanged].
	self changed. "Too conservative: only paragraph composition
					should cause invalidation."
! !

!MichTextMorph methodsFor: 'experimental' stamp: 'miso 10/30/1999 17:10'!
keyboardFocusChange: aBoolean

	aBoolean
		ifTrue: ["A hand is wanting to send us characters..."
			editView coreBecomeFocus]
		ifFalse: ["A hand has clicked elsewhere..."
			editView coreStopBeingFocus].
	^ super keyboardFocusChange: aBoolean.! !

!MichTextMorph methodsFor: 'experimental' stamp: 'ms 8/29/1998 17:10'!
mouseDown: event
"upon first click, give meat morph a chance to react in case this constitutes focus change"

	event hand keyboardFocus = self
		ifFalse: [ editView mouseDown: event ].
"		ifTrue: [ ^ super mouseDown: event ]."
	^ super mouseDown: event



"	editor = nil ifTrue: [ ^ editView mouseDown: event ].
OpSession playSound.
	^ super mouseDown: event."

"	event hand newKeyboardFocus: self.
	self handleInteraction: [editor mouseDown: event] fromEvent: event.

	// let pluggable handle it, if wants
	(editView mouseDown: event) ifFalse: [
		^ super mouseDown: event ]
"! !

!MichTextMorph methodsFor: 'experimental' stamp: 'ms 10/7/1998 11:30'!
releaseEditor 
	"Overriden so that we do not keep selection highlighted when we loose foc. Release the editor for my paragraph.  This morph no longer 'hasFocus'."
	editor ifNotNil:
		[self selectionChanged.
		paragraph selectionStart: nil selectionStop: nil.
		editor _ nil]
! !

!MichTextMorph methodsFor: 'experimental' stamp: 'ms 10/11/1998 16:42'!
updateFromParagraph  
"overidden to scroll beginning of txt back into view"
	| newStyle sel oldLast |
	paragraph ifNil: [^ self].
	wrapFlag ifNil: [wrapFlag _ true].
	editor ifNotNil: [sel _ editor selectionInterval.
					editor storeSelectionInParagraph].
	paragraph textStyle = textStyle
		ifTrue: [self fit. 
			editView ifNotNil: [editView scrollBarValue: 0.0]
		]
		ifFalse: ["Broadcast style changes to all morphs"
				newStyle _ paragraph textStyle.
				(self firstInChain text: text textStyle: newStyle) recomposeChain.
				sel ifNotNil: [self installEditor selectFrom: sel first to: sel last]].
	sel ifNil: [^ self].

	"If selection is in top line, then recompose predecessor for possible ripple-back"
	predecessor ifNotNil:
		[sel first <= (paragraph lines first last+1) ifTrue:
			[oldLast _ predecessor lastCharacterIndex.
			predecessor paragraph recomposeFrom: oldLast orLineAbove: false.
			oldLast = predecessor lastCharacterIndex
				ifFalse: [predecessor changed. "really only last line"
						self predecessorChanged]]].

	((predecessor~~nil and: [sel first <= paragraph firstCharacterIndex])
		or: [successor~~nil and: [sel first > (paragraph lastCharacterIndex+1)]])
		ifTrue:
		["The selection is no longer inside this paragraph.
		Pass focus to the paragraph that should be in control."
		self releaseEditor.
		self firstInChain withSuccessorsDo:
			[:m |  (sel first between: m firstCharacterIndex
								and: m lastCharacterIndex+1)
					ifTrue: [m installEditor selectFrom: sel first to: sel last.
							m selectionChanged.
							^ self passKeyboardFocusTo: m]].
		^ self].
	editor ifNil:
		["Reinstate selection after, eg, style change"
		self installEditor selectFrom: sel first to: sel last.
		self editor setEmphasisHere]
! !


!MichTextMorph methodsFor: 'speeding up' stamp: 'miso 10/14/1999 09:43'!
quickContents: stringOrText
"override for speed: do not create/relese para cache to set bounds now (as opposed to newContents:). Makes a big difference while loading headers (which will be resizedanyway)."

	text _ stringOrText asText! !


Morph subclass: #UbiqImage
	instanceVariableNames: 'image center maxExtent referencePoint '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Golgi-Helpers'!
!UbiqImage commentStamp: '<historical>' prior: 0!
A wrapper that can contain any img type
[early class - to be checked for bloat]!


!UbiqImage methodsFor: 'accessors' stamp: 'ms 9/20/1998 13:14'!
center: c
	center _ c.
	self guessBounds.! !

!UbiqImage methodsFor: 'accessors' stamp: 'ms 10/10/1998 14:27'!
image: i
"should we store the img type to speed up drawing? or even request it from sender?"

	(i isKindOf: Symbol)	ifTrue: [
		image _ nil.
		self guessBounds.
		^ color _ Color perform: i].

	(i isKindOf: Color)	ifTrue: [
		image _ nil.
		self guessBounds.
		^ color _ i].

	(i isKindOf: ColorForm orOf: Form) ifTrue: [ 
		image _ i. 
		color _ Color transparent.
		^ self guessBounds ].

	(i isKindOf: ImageMorph) ifTrue: [ 
		image _ i. 
		color _ Color transparent.
		^ self guessBounds ].

	(i isKindOf: BlockContext) ifTrue: [ ^ image _ i ].

	image _ i.! !

!UbiqImage methodsFor: 'accessors' stamp: 'ms 9/24/1998 11:41'!
maxExtent
	^ maxExtent! !

!UbiqImage methodsFor: 'accessors' stamp: 'ms 9/24/1998 11:41'!
maxExtent: m
	maxExtent _ m! !


!UbiqImage methodsFor: 'setters' stamp: 'ms 10/14/1998 16:56'!
image: i bounds: b
	self image: i center: b center maxExtent: b extent! !

!UbiqImage methodsFor: 'setters' stamp: 'ms 10/14/1998 16:55'!
image: i center: c maxExtent: m
	center _ c.
	maxExtent _ m.
	self image: i.
	self guessBounds.
	self layoutChanged! !


!UbiqImage methodsFor: 'priv' stamp: 'ms 9/21/1998 02:32'!
drawOn: aCanvas

	image ifNil: [^ super drawOn: aCanvas].

	aCanvas image: image at: bounds origin.! !

!UbiqImage methodsFor: 'priv' stamp: 'ms 10/10/1998 14:27'!
guessBounds

	center ifNil: [self error: 'cannot guess bounds without center'].
	image 	ifNil: [
				maxExtent ifNil: [self error: 'cannot guess for rect without extent'].
				^bounds _ self rectFromCenter: center extent: maxExtent]
			ifNotNil: [^bounds _ self rectFromCenter: center extent: image extent]! !

!UbiqImage methodsFor: 'priv' stamp: 'ms 9/21/1998 02:29'!
initialize
	super initialize.
! !

!UbiqImage methodsFor: 'priv' stamp: 'ms 9/21/1998 02:39'!
privateMoveBy: d

	super privateMoveBy: d.
	center _ center translateBy: d! !

!UbiqImage methodsFor: 'priv' stamp: 'ms 9/20/1998 13:05'!
rectFromCenter: c extent: e

	| midHeight midWidth |
	midHeight _ e y // 2.
	midWidth _ e x // 2.
	^ Rectangle left: c x-midWidth 
				right: c x+(e x - midWidth) 		"for uneven numbers"
				top: c y-midHeight 
				bottom: c y+(e y - midHeight)
! !


!UbiqImage methodsFor: 'tobe adapted' stamp: 'ms 9/20/1998 12:27'!
subimageDrawOn: aCanvas

| imageType |
imageType_3.
	imageType == #aForm ifTrue: [ ^ aCanvas image: image at: bounds origin ].
	imageType == #aSymbol ifTrue: [ "Rectangle ImageMorph"
		^ aCanvas fillRectangle: bounds color: color ].
	imageType == #aBlock ifTrue: [
		^ image value: aCanvas value: self value: Color red. ].

	^ self error: 'dont know how to draw this class: ', (imageType printString), ' '.

! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

UbiqImage class
	instanceVariableNames: ''!

!UbiqImage class methodsFor: 'as yet unclassified' stamp: 'ms 9/20/1998 12:46'!
image: i bounds: b

	^ self new image: i bounds: b! !

!UbiqImage class methodsFor: 'as yet unclassified' stamp: 'ms 9/20/1998 12:46'!
image: i center: c maxExtent: m

	^ self new image: i center: c maxExtent: m
! !
EllipseMorph subclass: #GoHeaderAlias
	instanceVariableNames: 'target seducteur '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Golgi-Basics'!
!GoHeaderAlias commentStamp: '<historical>' prior: 0!
I stand for a header during drag&drop, giving feedback to the user during the operation. I turn red if the current drop site is forbidden (ie. within myself).

[Part of my raison d'etre is that dragged elements seem to be expected to have world coordinates, but GoHeaders have transformed coordins.]!


!GoHeaderAlias methodsFor: 'drag&drop' stamp: 'ms 12/23/1998 15:25'!
beGrabbedBy: aHand
	"aHand grabMorph: self"
	World addMorph: self.
	aHand startReportingEventsTo: self! !

!GoHeaderAlias methodsFor: 'drag&drop' stamp: 'ms 10/30/1998 15:44'!
handleEvent: evt
	evt isMouseMove ifTrue: [^ self mouseMove: evt].
	evt isMouseUp ifTrue: [^ self mouseUp: evt]! !

!GoHeaderAlias methodsFor: 'drag&drop' stamp: 'ms 12/23/1998 16:04'!
mouseMove: evt
	"this is to follow a drag operation"
	self zieutezLeSeducteur: evt! !

!GoHeaderAlias methodsFor: 'drag&drop' stamp: 'ms 12/24/1998 00:34'!
mouseUp: evt
	"this is to terminate a drag operation"
	evt hand stopReportingEventsTo: self.
	self delete "really - 'deregister' ".
	seducteur
		ifNil: [
			target askForMeatFocus: evt hand "put away focus on whole header"]
		ifNotNil: [
			seducteur acceptDroppingMorph: target event: evt.
			target justDroppedInto: seducteur event: evt]! !

!GoHeaderAlias methodsFor: 'drag&drop' stamp: 'miso 10/8/1999 21:59'!
zieutezLeSeducteur: evt
	"called while dragging, to find out who would be the current attractor"
	| newPoz localCursorCoord  |

	"if cursor is over myself i obscure the header under me (and target would not change anyway)"
	(self containsPoint: evt cursorPoint) ifTrue: [ ^ self ].	

	seducteur _ evt hand dropTargetFor: self event: evt.
	(seducteur isKindOf: GoHeader) 	
		ifFalse: ["temp attempt to stop dropping on world, 057p9"
			seducteur _ nil. 
			newPoz _ target boundsInWorld topLeft.
			newPoz _ (newPoz x +10) @ (newPoz y +15).
			color _ Color red] 
		ifTrue: [
			localCursorCoord _ (evt transformedBy: (seducteur transformFrom: World)) cursorPoint.
			seducteur _ seducteur doYouWannaDelegateDropeeAt: localCursorCoord "ask header if drop goes into one of its subheader (ie mouse is in its margin)".
			(seducteur isInside: target) 
				ifTrue: [
					color _ Color red.
					"newPoz _ target boundsInWorld topLeft."
					newPoz _ seducteur boundsInWorld topLeft.
					newPoz _ (newPoz x +10) @ (newPoz y +15).
					seducteur _ nil]
				ifFalse: [
					color _ Color yellow.
					newPoz _ seducteur whereDoIDrop: localCursorCoord "ask header if i shouold shoow as sister or daughter poz".
					newPoz _ newPoz x @ (newPoz y - (self height / 2))].
			self position: newPoz
			"do we want to calc height wrt seducteur? to see if go above/below"]! !


!GoHeaderAlias methodsFor: 'private' stamp: 'miso 10/7/1999 12:40'!
initialize
	super initialize.
	self extent: 16 @ 6.
	self color: Color red! !

!GoHeaderAlias methodsFor: 'private' stamp: 'ms 10/29/1998 23:53'!
target
	^ target! !

!GoHeaderAlias methodsFor: 'private' stamp: 'ms 10/30/1998 14:52'!
target: t
	target _ t! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

GoHeaderAlias class
	instanceVariableNames: ''!

!GoHeaderAlias class methodsFor: 'all' stamp: 'miso 10/25/1999 10:22'!
target: aHeader

	^ self new 
		target: aHeader;
		position: aHeader positionInWorld! !

!GoHeaderAlias class methodsFor: 'all' stamp: 'miso 10/25/1999 10:21'!
target: aHeader hand: h
	| a |
	a _ self target: aHeader.
	h startReportingEventsTo: a.
	^a! !

!GoHeaderAlias class methodsFor: 'all' stamp: 'ms 12/23/1998 23:05'!
visualiseDragOf: aHeader fromEvent: evt
	| a newPoz |
	a _ self new target: aHeader.
	newPoz _ aHeader positionInWorld.
	a position: (newPoz x +10) @ (newPoz y +15).
	"a zieutezLeSeducteur: evt"
	a beGrabbedBy: evt hand.
	^ a! !


RectangleMorph subclass: #GoHeadersPane
	instanceVariableNames: 'bigBrother paneToHeaderLink '
	classVariableNames: 'BottomMargin LeftMargin PaddingBetweenSubTexts RightMargin TopMargin '
	poolDictionaries: ''
	category: 'Golgi-Basics'!
!GoHeadersPane commentStamp: '<historical>' prior: 0!
I am a pane that contains headers (rectangles)... The headers entirely fill me, and I grow (vertically) as they grow, but I impose a horizontal constant size. I am used to represent the set of subheaders inside a header (and one of my subclasses, GoHeader is used to represent the whole header).
-----------

Other candidates For Superclasses:
	m.border.rectangle.alignmentMorph 
		(has positioning problems & doesn't resize with momPane)!


!GoHeadersPane methodsFor: 'general properties' stamp: 'ms 8/23/1998 14:20'!
isHidden
"tests whether the submorph/owner link is in, ie whether drawing occurs"

	^ owner ~~ nil

! !

!GoHeadersPane methodsFor: 'general properties' stamp: 'ms 11/7/1998 13:11'!
isWedge
	^ false! !


!GoHeadersPane methodsFor: '  margins' stamp: 'ms 8/16/1998 15:37'!
bottomMargin
	^ BottomMargin! !

!GoHeadersPane methodsFor: '  margins' stamp: 'ms 9/12/1998 12:23'!
bottomMargin: n
	BottomMargin _ n! !

!GoHeadersPane methodsFor: '  margins' stamp: 'ms 8/16/1998 15:38'!
leftMargin
	^ LeftMargin! !

!GoHeadersPane methodsFor: '  margins' stamp: 'miso 10/25/1999 10:34'!
paddingBetweenSubTexts
	^ PaddingBetweenSubTexts! !

!GoHeadersPane methodsFor: '  margins' stamp: 'ms 8/16/1998 15:38'!
rightMargin
	^RightMargin! !

!GoHeadersPane methodsFor: '  margins' stamp: 'ms 8/24/1998 10:01'!
topMargin
	^ TopMargin! !


!GoHeadersPane methodsFor: 'subheaders' stamp: 'ms 11/7/1998 15:44'!
headerAt: SymbolOrHeader
"Changed to always return headers, this now acts as a symbol-filter."

	| index |
"	(SymbolOrHeader isKindOf: Symbol) ifFalse: [^ SymbolOrHeader ]. "

	index _ SymbolOrHeader.
	SymbolOrHeader == #root ifTrue: [ index _ 1 ].
	SymbolOrHeader == #last ifTrue: [ index _ submorphs size ].

	^ self headerAtIndex: index! !

!GoHeadersPane methodsFor: 'subheaders' stamp: 'ms 11/7/1998 15:45'!
headerAtIndex: index

	index == 0 ifTrue: [ ^ #root ].  "this is ugly, but seems needed in 'de/pro-moteSelf' "
	index == (submorphs size + 1) ifTrue: [ ^ #end ].
	^ submorphs at: index ifAbsent: [ ^ self error: 
				 				'asking for a non-existing header :-(' ]! !

!GoHeadersPane methodsFor: 'subheaders' stamp: 'miso 10/29/1999 14:44'!
positionOfSubheader: aHeader

	^ submorphs indexOf: aHeader! !

!GoHeadersPane methodsFor: 'subheaders' stamp: 'miso 10/29/1999 14:56'!
subheaders
	^ submorphs! !

!GoHeadersPane methodsFor: 'subheaders' stamp: 'miso 10/29/1999 14:53'!
whatIsAfterSubheader: prevSubHeaderOrSymbol

	(prevSubHeaderOrSymbol isKindOf: Symbol) ifFalse: [
		^ self headerAtIndex: (submorphs indexOf: prevSubHeaderOrSymbol) + 1 ].
	prevSubHeaderOrSymbol == #root ifTrue: [
		^ self headerAtIndex: 1 ].
	prevSubHeaderOrSymbol == #last ifTrue: [
		^ submorphs size ]. "treat this always in headerAfterIndex"

^ self error: 'could not find header after ', prevSubHeaderOrSymbol printString, '  because I could not recognise what this is... '.


"	(nextSubHeaderOrSymbol isKindOf: Symbol) 
		ifTrue: [ ^ self headerBeforeIndex: nextSubHeaderOrSymbol ]
		ifFalse: [ ^ self headerBeforeIndex: 
							(submorphs indexOf: nextSubHeaderOrSymbol) ] "! !

!GoHeadersPane methodsFor: 'subheaders' stamp: 'miso 10/29/1999 14:53'!
whatIsBeforeSubheader:   nextSubHeaderOrSymbol

	(nextSubHeaderOrSymbol isKindOf: Symbol) ifFalse: [
		^ self headerAtIndex: (submorphs indexOf: nextSubHeaderOrSymbol) - 1 ].
	nextSubHeaderOrSymbol == #root ifTrue: [
		^ self error: 'asked for element before root, should never arise' ].
	nextSubHeaderOrSymbol == #last ifTrue: [
		^ self headerAt: submorphs size - 1 ].

^ self error: 'could not find header before ', nextSubHeaderOrSymbol printString, '  because I could not recognise what this is... '.


"	(nextSubHeaderOrSymbol isKindOf: Symbol) 
		ifTrue: [ ^ self headerBeforeIndex: nextSubHeaderOrSymbol ]
		ifFalse: [ ^ self headerBeforeIndex: 
							(meatOrSubheaders indexOf: nextSubHeaderOrSymbol) ] "! !


!GoHeadersPane methodsFor: '  core reorg subs' stamp: 'miso 10/29/1999 14:40'!
addSubHeader: incomingHeader after: existingHeader
"The fundamental building block of header adding. Called both by h.reorgSelf verbs (from move/putSelfInto via h.addH) and by hp.dress verbs (from paneDress:withAccessorType:after:).
	This just registers a preexisting header, next redraw will make it visible if i am expanded. It has no influence on my expansion state. See comment in class comments for more details.
	It used to be called registerHeader:below: which has the advantage of being coherent with the general use of register/ deregister, but since it actually results in a adding of visual entities, add* was more intuitive. The register/ deregister pair is kept for non-visual adding.
	We count on caller having asked the permission to model to make this change!! 
 We do not check against bogus oldMorphs, be careful!!
 return index, or prevMeme?"

	| index |
	"submorphs _ submorphs copyWith: incomingHeader."
	incomingHeader newMom: self.

	index _ nil.
	existingHeader == #nil ifTrue: [ "just re-showing existing sub"
			index _ submorphs size ].
	existingHeader == #root ifTrue: [
			submorphs _ (Array with: incomingHeader), submorphs.
			index _ 1 ].
	existingHeader == #last ifTrue: [
			submorphs _ submorphs copyWith: incomingHeader.
			index _ submorphs size ].

	(index == nil) ifTrue: [
		(existingHeader isKindOf: Number) 
			ifTrue: [index _ existingHeader]
			ifFalse: [index _ submorphs indexOf: existingHeader].
		submorphs _ (submorphs copyFrom: 1 to: index), 
							(Array with: incomingHeader),
							(submorphs copyFrom: (index _ index + 1) 
								to: submorphs size) ].

	self layoutChanged.
	self changed.

	^ index! !

!GoHeadersPane methodsFor: '  core reorg subs' stamp: 'miso 10/29/1999 14:41'!
releaseOneSubheader: aHeader
"This is the basic building block of header releasing, called from h.moveSelf and h.deleteSelf (via mom-h.releaseOneSubheader:). Do not delete it, it might be moved elsewhere. Just deregister it from our subs."
"##should be called deregister to be coherent"

	submorphs _ submorphs copyWithout: aHeader.
	aHeader zapOwner.

	self changed.
	self layoutChanged.
! !


!GoHeadersPane methodsFor: 'aboveMe' stamp: 'miso 10/25/1999 12:18'!
bigBrother

	^ bigBrother
! !

!GoHeadersPane methodsFor: 'aboveMe' stamp: 'ms 11/23/1998 09:21'!
bigBrother: bb
	bigBrother _ bb.
	submorphs do: [:d| d bigBrother: bb]! !

!GoHeadersPane methodsFor: 'aboveMe' stamp: 'ms 7/3/1999 17:23'!
header

	^ self owner! !

!GoHeadersPane methodsFor: 'aboveMe' stamp: 'miso 10/8/1999 20:43'!
headerAbove
	paneToHeaderLink ifNil: [^ self error: 'cannt give you owner, i have no more mom'].
	"temp"
	^ paneToHeaderLink! !

!GoHeadersPane methodsFor: 'aboveMe' stamp: 'ms 8/17/1998 23:00'!
isRoot
	^ owner == self bigBrother! !

!GoHeadersPane methodsFor: 'aboveMe' stamp: 'miso 10/25/1999 12:04'!
logicalOwner
"the 'owner' instVar only gives the visual owner, and returns nil if we are hidden. We give the real owner, whether visible or not"

	^ paneToHeaderLink! !

!GoHeadersPane methodsFor: 'aboveMe' stamp: 'miso 10/25/1999 12:08'!
logicalOwner: aMorphOrNil
"set the real owner, whether we're visible in it or not"

	paneToHeaderLink _ aMorphOrNil! !

!GoHeadersPane methodsFor: 'aboveMe' stamp: 'miso 10/25/1999 12:13'!
newMom: aMorphOrNil
"this changes the hierarchy, it is *not* for visual effects. It should *always* be accessed by setter of aMorphOrNil's logical daughter, so that we keep in sync"

	self logicalOwner: aMorphOrNil.
	aMorphOrNil 
		ifNil: [self bigBrother: aMorphOrNil]
		ifNotNil: [self bigBrother: aMorphOrNil bigBrother].! !

!GoHeadersPane methodsFor: 'aboveMe' stamp: 'miso 10/8/1999 20:04'!
zapOwner

	owner _ nil! !


!GoHeadersPane methodsFor: 'saving' stamp: 'ms 7/3/1999 23:43'!
isDirty
	^ self subsAreDirty! !

!GoHeadersPane methodsFor: 'saving' stamp: 'ms 3/6/1999 14:06'!
queryForSave
"answer whether 'needToSave'. 
(PopUpMenu/SelectionMenu directly return the result of the action of their menuItems. MenuMorph/GoMenu MenuMorph invokeItem:)"

"
	| m |
	m _ GoMenu newUpOn: self.
	m		add: 'save' action: #recursiveSave;
			add: 'throw away' action: #discard;
			add: 'do nothing' action: #cancel;
		addTitle: 'Changes have not been saved. 
What do you want to do with them?'.
	^ self popUpMenuCarefully: m
"
	^ (SelectionMenu 
			labelList: #('save' 'throw away' 'do nothing')
			selections: #(save discard cancel))
				startUpWithCaption: 'Changes have not been saved. 
What do you want to do with them?'.
! !

!GoHeadersPane methodsFor: 'saving' stamp: 'ms 7/3/1999 23:59'!
recursiveSave
"header panes are irrelevant to saving proper, we just redistribute the msg. 
Note that if we implemented this as 'save: #symbol' which passes the same down, it would allow us to save just our subheaders, one level down. any use for that?"

	submorphs do: [: s | s recursiveSave ]! !


!GoHeadersPane methodsFor: 'prefs' stamp: 'ms 11/1/1998 20:10'!
getPrefFor: prefSymbol
	^ self class getPrefFor: prefSymbol! !

!GoHeadersPane methodsFor: 'prefs' stamp: 'miso 10/16/1999 07:34'!
prefs
	^ self class prefs! !

!GoHeadersPane methodsFor: 'prefs' stamp: 'ms 11/1/1998 20:11'!
setPref: prefSymbol to: v

	^ self class setPref: prefSymbol to: v! !


!GoHeadersPane methodsFor: 'geometry' stamp: 'ms 11/7/1998 15:36'!
boundsGivenTopline: topLine
"computes the height we need given the topLine, which is a rect of which we only look at topBar. Meaning that 3 of our 4 coordinates are given, and we compute the fourth. We do that recursively, asking each subTextMorph how much height it needs. We answer with our new bounds, including the coordinate for our bottom." 

	| subBox nextBoxTopline |
	self position: topLine topLeft.

	nextBoxTopline _ (topLine left + self leftMargin)@topLine top + self topMargin
				corner: (topLine right - self rightMargin)@0.

	submorphs do: [: h |		"see fn.3"
		h isWedge ifFalse: [ "this verb is ls used by GoHeader"
			subBox _ h boundsGivenTopline: nextBoxTopline.
			nextBoxTopline _ subBox withTop: (subBox bottom + self paddingBetweenSubTexts)]].

	"subLine _ subBox withTop: subBox bottom + self bottomMargin. 
	self bottomRight: subLine topRight.		see fn.1"

	self bottomRight: topLine right @ (subBox bottom + self bottomMargin).

	^ bounds.


"
fn.1: One important thing here is that the verb updating our coordinates, should not end up calling 'privateFullMoveBy:' otherwise we waste cylces on relooping over our subMorphs which we have just done.
	Earlier way of doing it solved the craze thing without solving the cylce-waste problem (but did not need to introduce privatePosition!!) :
		self position: maxRect topLeft.  [was called at the beginning]
		self privateExtent: (maxRect right@topOfNextSub).  [at the end]
	Still earlier ways:
		privateBounds: (maxRect withBottom: topOfNextSub).	[w/out privateExtent:]
	Or
		fullBounds _ bounds _ (maxRect withBottom: topOfNextSub).
	Or
		// subBounds now indicates our bounds
		subBounds _ (maxRect withBottom: topOfNextSub).
		fullBounds _ bounds _ subBounds.
		self updateOtherSubs: subBounds.
		// this was to introduce a hook for other subMorphs, 
		// which turned out not to be needed. could be handy in the future.
	The advertised but rejected solution:
		self softBounds: (maxRect withBottom: topOfNextSub).  

fn.3	All of this would be so much simpler with 'break'... 
		break would also avoid unnecessary looping which will be important when have very long subheader lists

		The earlier version (incorrect):

	meatOrSubheaders do: [: subText |
		(subBoundsMax bottom > topOfNextSub) ifTrue:
		[
		topOfNextSub _	(subText boundsGivenMax: subBoundsMax) 
			+ self paddingBetweenSubTexts.
		subBoundsMax _ subBoundsMax withTop: topOfNextSub.
		]

fn4. call 'position:' before recursive step. If our subMorphs get positioned first, our repositioning will preserve diff :-(. Gets into muddles at startup when everybody has crazy bounds.

"! !

!GoHeadersPane methodsFor: 'geometry' stamp: 'ms 11/7/1998 15:42'!
boundsGivenToplineAndYield: topLine
"computes the height we need given the topLine, which is a rect of which we only look at topBar. Meaning that 3 of our 4 coordinates are given, and we compute the fourth. We do that recursively, asking each subTextMorph how much height it needs. We answer with our new bounds, including the coordinate for our bottom." 

	| subBox nextBoxTopline |
	self position: topLine topLeft.

	nextBoxTopline _ (topLine left + self leftMargin)
						@topLine top + self topMargin
				corner: (topLine right - self rightMargin)@0.

	submorphs do: [: h |		"see fn.3"
		h isWedge ifFalse: [ "this verb is ls used by GoHeader"
			subBox _ h boundsGivenTopline: nextBoxTopline.
			nextBoxTopline _ subBox withTop: (subBox bottom + self paddingBetweenSubTexts)]].

	"subLine _ subBox withTop: subBox bottom + self bottomMargin. 
	self bottomRight: subLine topRight.		see fn.1"

	self bottomRight: topLine right @ (subBox bottom + self bottomMargin).
"Processor yield."
	^ bounds.


"
fn.1: One important thing here is that the verb updating our coordinates, should not end up calling 'privateFullMoveBy:' otherwise we waste cylces on relooping over our subMorphs which we have just done.
	Earlier way of doing it solved the craze thing without solving the cylce-waste problem (but did not need to introduce privatePosition!!) :
		self position: maxRect topLeft.  [was called at the beginning]
		self privateExtent: (maxRect right@topOfNextSub).  [at the end]
	Still earlier ways:
		privateBounds: (maxRect withBottom: topOfNextSub).	[w/out privateExtent:]
	Or
		fullBounds _ bounds _ (maxRect withBottom: topOfNextSub).
	Or
		// subBounds now indicates our bounds
		subBounds _ (maxRect withBottom: topOfNextSub).
		fullBounds _ bounds _ subBounds.
		self updateOtherSubs: subBounds.
		// this was to introduce a hook for other subMorphs, 
		// which turned out not to be needed. could be handy in the future.
	The advertised but rejected solution:
		self softBounds: (maxRect withBottom: topOfNextSub).  

fn.3	All of this would be so much simpler with 'break'... 
		break would also avoid unnecessary looping which will be important when have very long subheader lists

		The earlier version (incorrect):

	meatOrSubheaders do: [: subText |
		(subBoundsMax bottom > topOfNextSub) ifTrue:
		[
		topOfNextSub _	(subText boundsGivenMax: subBoundsMax) 
			+ self paddingBetweenSubTexts.
		subBoundsMax _ subBoundsMax withTop: topOfNextSub.
		]

fn4. call 'position:' before recursive step. If our subMorphs get positioned first, our repositioning will preserve diff :-(. Gets into muddles at startup when everybody has crazy bounds.

"! !

!GoHeadersPane methodsFor: 'geometry' stamp: 'ms 9/6/1998 03:06'!
changed

owner changed

"	self invalidRect: bounds	"	"withBottom: bigBrother bounds bottom)"

"	self isRoot
		ifFalse: [ owner changed ]
		ifTrue:
			[self invalidRect: (self fullBounds withBottom: bigBrother bounds bottom)] "


" owner subChanged: self. See comments there"

"self invalidRect: (self fullBounds withBottom: mom bottom)"! !

!GoHeadersPane methodsFor: 'geometry' stamp: 'miso 10/9/1999 12:31'!
fullBounds
	"do not start a recalc, recalcs are always initiated by bigBrother, coz they 
	might always influence some higher-level header. Just assume the 
	higher recalcs are being done correctly :-) "

	fullBounds ifNil: [ fullBounds _ bounds].
	^ fullBounds
! !

!GoHeadersPane methodsFor: 'geometry' stamp: 'miso 10/9/1999 12:31'!
layoutChanged
"just percolate the msg up to bigBrother, and leave a trace telling we need to collect new bounds (can serve as a sign telling change originated from this branch"

	fullBounds _ nil.
	owner ifNotNil: [owner layoutChanged].
! !


!GoHeadersPane methodsFor: 'printing' stamp: 'miso 11/2/1999 17:11'!
printOn: aStream
	"used in inspectors, debuggers, etc."

	super printOn: aStream. aStream nextPutAll: ' for: ', 
		(self header ifNotNil: [self header content asString] ifNil: ['<nada>']).! !


!GoHeadersPane methodsFor: 'priv' stamp: 'miso 10/25/1999 10:28'!
bottomRight: aPoint
"Little utility to set my corner to aPoint. Mimicks extent: which i want to avoid coz its unnecessary to translate to extent and back to corner :-) "

	bounds bottomRight = aPoint ifFalse: [
		self changed.
		bounds _ bounds topLeft corner: aPoint.
		self layoutChanged.
		self changed ].! !

!GoHeadersPane methodsFor: 'priv' stamp: 'ms 7/3/1999 23:59'!
initialize

	super initialize.

	PaddingBetweenSubTexts ifNil: [ "clunky way of telling Class not inited"
		GoHeadersPane initialize ].

	borderWidth _ 0.	"override sysWin settings"
	color _ Color transparent.

! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

GoHeadersPane class
	instanceVariableNames: ''!

!GoHeadersPane class methodsFor: 'as yet unclassified' stamp: 'ms 11/1/1998 19:50'!
getPrefFor: prefSymbol

	^ self prefs at: prefSymbol ifAbsent: []! !

!GoHeadersPane class methodsFor: 'as yet unclassified' stamp: 'ms 8/16/1998 20:19'!
initialize
	PaddingBetweenSubTexts _ 0.
	LeftMargin _ 0.
	RightMargin _ 0.
	TopMargin _ 0.
	BottomMargin _ 0.
! !

!GoHeadersPane class methodsFor: 'as yet unclassified' stamp: 'miso 10/16/1999 07:34'!
prefs

	^ GolgiGlobals at: #Prefs ifAbsent: [
		GolgiGlobals at: #Prefs put: GoPreferences new].! !

!GoHeadersPane class methodsFor: 'as yet unclassified' stamp: 'ms 11/1/1998 19:43'!
setPref: prefSymbol to: v

	^ self prefs at: prefSymbol put: v! !


GoHeadersPane initialize!


GoHeadersPane subclass: #GoHeader
	instanceVariableNames: 'translator meat wedge meatIsDirty '
	classVariableNames: 'HeaderBottomMargin HeaderLeftMargin HeaderRightMargin HeaderTopMargin PaneColor '
	poolDictionaries: ''
	category: 'Golgi-Basics'!
!GoHeader commentStamp: '<historical>' prior: 0!
I represent one header. My major components are: a wedge (GoWege), a text (GoMeat), and a pane with subheaders (GoHeadersPane).

If you think about it, I am really a special type of GoHeadersPane the only diff is that I keep a margin to the left of my subs, and I put a wedge in that margin.!


!GoHeader methodsFor: 'general properties' stamp: 'miso 10/30/1999 15:37'!
countExpandedSubHeaders

	| n |
	n _ self subheaders size.
	self subheaders do: [:d|
		n _ n + (d countExpandedSubHeaders)].
	^ n
! !

!GoHeader methodsFor: 'general properties' stamp: 'ms 7/3/1999 17:23'!
header
"use when you don't know whether you are in a pane or in me to be sure to deal with me (eg. printOn:)"
	^ self! !

!GoHeader methodsFor: 'general properties' stamp: 'miso 10/25/1999 12:43'!
isContracted

	^ wedge state == #contracted
! !

!GoHeader methodsFor: 'general properties' stamp: 'miso 10/25/1999 12:43'!
isExpanded

	^ 	wedge state == #expanded! !

!GoHeader methodsFor: 'general properties' stamp: 'ms 11/7/1998 16:46'!
isRoot
	^ owner isRoot! !

!GoHeader methodsFor: 'general properties' stamp: 'miso 10/24/1999 15:03'!
isThisYourMeme: aMeme
"answer whether aMeme is the meme I am currently viewing"

	^ self meme == aMeme! !

!GoHeader methodsFor: 'general properties' stamp: 'miso 10/8/1999 21:44'!
meme
	^ self translator meme! !

!GoHeader methodsFor: 'general properties' stamp: 'miso 10/25/1999 10:23'!
positionInWorld
"used by GoHeaderAlias during dnd"

	^ self boundsInWorld topLeft! !

!GoHeader methodsFor: 'general properties' stamp: 'miso 10/25/1999 12:41'!
setColor: c
"sets color for this header only. Called directly from menu"

	| theColor | 
	theColor _ (c isKindOf: String "orSymbol!!") 
					ifTrue: [Color perform: c]
					ifFalse: [c].
	self color: theColor.
	meat setColor: theColor.
! !

!GoHeader methodsFor: 'general properties' stamp: 'miso 10/29/1999 14:51'!
sisterAfter
	^ self headerAbove whatIsAfterSubheader: self! !

!GoHeader methodsFor: 'general properties' stamp: 'miso 10/29/1999 14:52'!
sisterBefore
	^ self headerAbove whatIsBeforeSubheader: self! !

!GoHeader methodsFor: 'general properties' stamp: 'miso 10/25/1999 12:37'!
translator
	^ translator
! !

!GoHeader methodsFor: 'general properties' stamp: 'miso 10/25/1999 13:56'!
translator: a
	translator _ a.
	a header: self.

	"when plugging in a translator refresh the values that i get from it"
	self color: translator defaultColor.

	meat class = a meatClass ifFalse: [self privCreateMeatBox].
	meat textMorph quickContents: meat getText.

	self defaultWedge.
	self refreshWedgeState.! !

!GoHeader methodsFor: 'general properties' stamp: 'ms 7/3/1999 00:08'!
whereAddHeader
	"somebody is wanting to add a header below me but does not know where. answer with the default location: as my first daughter if i am expanded, as my sister otherwise. Note that the answer needs two parts: #(mom futureSisterAbove)"
	self isExpanded
		ifTrue: [^ {self . #root}]
		ifFalse: [^ {self headerAbove. self}]! !


!GoHeader methodsFor: '  margins' stamp: 'ms 9/12/1998 16:38'!
bottomMargin
	^ HeaderBottomMargin! !

!GoHeader methodsFor: '  margins' stamp: 'ms 9/12/1998 16:38'!
leftMargin
	^ HeaderLeftMargin! !

!GoHeader methodsFor: '  margins' stamp: 'ms 9/12/1998 16:38'!
rightMargin
	^ HeaderRightMargin! !

!GoHeader methodsFor: '  margins' stamp: 'ms 9/12/1998 16:38'!
topMargin
	^ HeaderTopMargin! !


!GoHeader methodsFor: 'meat' stamp: 'miso 11/2/1999 17:10'!
content
"this is neutral between headerMeat and memeMeat. Interpreted as headerMeat if there is some, and memeMeat otherwise (eg in bigBrother)"
	^ self headerMeat! !

!GoHeader methodsFor: 'meat' stamp: 'miso 10/25/1999 12:40'!
headerMeat

	^ meat text! !

!GoHeader methodsFor: 'meat' stamp: 'miso 10/25/1999 12:41'!
meatColor: c
"for menu (can be used by toggleBreakpoint)"
	meat setColor:  c.! !

!GoHeader methodsFor: 'meat' stamp: 'miso 10/25/1999 12:40'!
meatMorph
"for menus to be able to set color"
	^ meat! !

!GoHeader methodsFor: 'meat' stamp: 'miso 10/30/1999 16:10'!
memeMeat
	^ self translator memeContent! !

!GoHeader methodsFor: 'meat' stamp: 'miso 10/30/1999 16:09'!
memeMeat: m
"set the text of the header, ignoring previous content. return whether was successful ('save' counts on it)."

	self translator memeContent: m.
	^ true! !

!GoHeader methodsFor: 'meat' stamp: 'miso 10/25/1999 12:40'!
privCreateMeatBox
"(re)create my meatBox. add it to subMorph list, register it as meat."

	meat _ translator meatClass on: self "see fn1"
				text: #memeMeat 
				accept: #memeMeat:
				readSelection: nil
				menu: nil. "#buildGolgiMenu:given:"
	self addMorphBack: meat.
	^meat.

"addMorphFron.layoutChanged->releases para. change-> triggers unnecessary fullBounds calc on fake buonds layoutChanged: percolate to mom who causes recalc."
"fn.1		This call creates the view & registers the 'on' arg as its model. The other args are the names of the model-msgs which will be the makers of the described actions. The editor/controller is installed on the fly by model
"! !

!GoHeader methodsFor: 'meat' stamp: 'miso 7/4/1999 16:05'!
refreshMeat
	"used by translator when it changes our meme, or when escaping form discarded changes"

	self meatMorph refreshMeat.! !

!GoHeader methodsFor: 'meat' stamp: 'miso 10/25/1999 12:39'!
setHeaderContent: theContent
	"set the text of the header, ignoring previous content, 
	and returns ref to the contentContainerView"

	self memeMeat: theContent.
	meat refreshMeat.! !

!GoHeader methodsFor: 'meat' stamp: 'miso 10/25/1999 12:40'!
setMeatModel: theModel

	meat model: theModel.
! !

!GoHeader methodsFor: 'meat' stamp: 'miso 10/25/1999 12:41'!
showSelectionBugWorkaround
	meat textMorph updateFromParagraph

"see comment in GoTranslateSmalltalk.notify:at:in:, where this is needed"! !


!GoHeader methodsFor: 'wedge' stamp: 'miso 10/24/1999 15:23'!
aNextStateMethod: theButton
"private!! the method passed to wedge to compute next state given current state of affairs. Ideally should be able to get info about modifier key being pressed when button was clicked."

	| state |
	state _ theButton state.

	"returns #expanded if state=nil !!"
	state = #inert  ifTrue: [ ^ #inert ].
	state = #contracted 
		ifTrue:	[ ^ #expanded]
		ifFalse: [ ^ #contracted].

	^ self error: 'I cannot switch from this state, because I do not understand it... ', 
		state printString. ! !

!GoHeader methodsFor: 'wedge' stamp: 'miso 10/28/1999 12:27'!
cmdMouseDownIn: wedgeName while: evt

	translator headerMenu popUpAt: evt hand position event: evt! !

!GoHeader methodsFor: 'wedge' stamp: 'ms 9/8/1998 18:29'!
cmdMouseMoveIn: wedgeName while: evt

"	evt hand showTemporaryCursor: Cursor menu.
	^ evt hand showTemporaryCursor: nil."
! !

!GoHeader methodsFor: 'wedge' stamp: 'miso 10/25/1999 12:42'!
defaultWedge
	wedge imageFamily: translator defaultImageFamily.
	self wedgeBackgroundColor: translator defaultColor.
! !

!GoHeader methodsFor: 'wedge' stamp: 'miso 10/25/1999 12:43'!
initWedge
"private"

	wedge _  GoWedge switch: [: theButton | self aNextStateMethod: theButton].
	wedge 	buttonName: 'wedge';
				target: self;
				position: bounds origin;
				extent: HeaderLeftMargin@16;
				state: #expanded 	startAction: [self unhideSubheadersAndRefresh]  
									stopAction: nil;
				state: #contracted 	startAction: [self hideSubheaders] 
									stopAction: nil;
				state: #inert			startAction: nil
									stopAction: nil.

	self addMorph: wedge.



"or:	theWedge addStatesFromDescriptorArray: 
							#(	(inert gray nil nil)
								(expanded green nil nil)
								(contracted red nil nil)	).
"
! !

!GoHeader methodsFor: 'wedge' stamp: 'miso 10/24/1999 15:01'!
refreshWedgeState
	self isExpanded ifTrue: [^self setWedgeExpanded].
	self hasSubheaders 
		ifTrue: [^self setWedgeContracted]
		ifFalse: [^self setWedgeInert]! !

!GoHeader methodsFor: 'wedge' stamp: 'miso 10/25/1999 12:43'!
resetWedgeFromLeft: n
	wedge bounds: (wedge bounds withLeft: (self bounds left+ n))! !

!GoHeader methodsFor: 'wedge' stamp: 'miso 10/25/1999 12:43'!
setWedgeContracted
	wedge jumpToState: #contracted.! !

!GoHeader methodsFor: 'wedge' stamp: 'miso 10/25/1999 12:43'!
setWedgeExpanded
	wedge jumpToState: #expanded.! !

!GoHeader methodsFor: 'wedge' stamp: 'miso 10/25/1999 12:42'!
setWedgeImage: i forState: s

	wedge state: s image: i
! !

!GoHeader methodsFor: 'wedge' stamp: 'miso 10/25/1999 12:42'!
setWedgeImageFamily: fDescriptor

	wedge imageFamily: fDescriptor! !

!GoHeader methodsFor: 'wedge' stamp: 'miso 10/25/1999 12:42'!
setWedgeInert

	wedge jumpToState: #inert.! !

!GoHeader methodsFor: 'wedge' stamp: 'miso 10/25/1999 12:43'!
wedgeBackgroundColor: c
	wedge backgroundColor: c; changed.! !


!GoHeader methodsFor: 'aboveMe' stamp: 'miso 10/8/1999 20:12'!
bigBrother: bb
	bigBrother _ bb.
	paneToHeaderLink ifNotNil: [paneToHeaderLink bigBrother: bb]! !

!GoHeader methodsFor: 'aboveMe' stamp: 'miso 10/25/1999 13:36'!
headerAbove
"counts on the fact that headers are never contained in anything else but a GoHeadersPane"

	^ owner headerAbove! !

!GoHeader methodsFor: 'aboveMe' stamp: 'miso 10/8/1999 21:45'!
isInside: putativeAncestor
	"this helps during drag&drop to prevent dropping inside myself... Delegate to model, as we might not be in the in the same outline"

	^ self translator isInside: putativeAncestor meme! !

!GoHeader methodsFor: 'aboveMe' stamp: 'miso 10/25/1999 12:05'!
logicalOwner
"answer the real owner, whether visible or not. We are nevere 'hidden' so just give owner"

	^ owner! !

!GoHeader methodsFor: 'aboveMe' stamp: 'miso 10/25/1999 12:07'!
logicalOwner: aMorphOrNil
"set the real owner, whether visible or not. We are nevere 'hidden' so just set owner"

	owner _ aMorphOrNil! !

!GoHeader methodsFor: 'aboveMe' stamp: 'ms 10/30/1998 11:27'!
positionInMom
	^ self headerAbove positionOfSubheader: self.! !

!GoHeader methodsFor: 'aboveMe' stamp: 'miso 10/25/1999 10:27'!
world
"I can be 'hidden', ie part of a headerpane which is still owned by a momheader but not currently in submorphs coz not currently shown. In those cases i don't have an 'owner' but i do have a world. What we really want to know is which world my golgi is in, if any."

	^ self bigBrother ifNil: [nil] ifNotNil: [self bigBrother world]! !


!GoHeader methodsFor: 'subheaders' stamp: 'miso 10/24/1999 15:00'!
daughters
"added so that walkMeme actions can also walk panes (thus getting access to unsaved content)"

	^ self subheaders! !

!GoHeader methodsFor: 'subheaders' stamp: 'miso 10/25/1999 12:37'!
hasSubheaders

	^ translator daughters size > 0! !

!GoHeader methodsFor: 'subheaders' stamp: 'miso 10/8/1999 20:13'!
headerAt: i
	^ paneToHeaderLink headerAt: i.! !

!GoHeader methodsFor: 'subheaders' stamp: 'miso 10/8/1999 20:12'!
headerAtIndex: i
	^ paneToHeaderLink headerAtIndex: i.! !

!GoHeader methodsFor: 'subheaders' stamp: 'ms 7/1/1999 23:02'!
isSubmemeDressed: aMeme
"answer whether any of my immediate daughters are viewing aMeme"

	(self whichDaughterDressesThisMeme: aMeme)
		ifNil: [^ false]
		ifNotNil: [^ true]! !

!GoHeader methodsFor: 'subheaders' stamp: 'miso 10/29/1999 14:44'!
positionOfSubheader: aSubheader
	^ paneToHeaderLink positionOfSubheader: aSubheader.! !

!GoHeader methodsFor: 'subheaders' stamp: 'miso 10/8/1999 20:12'!
subheaders
	^ paneToHeaderLink 
		ifNil: [Array new]
		ifNotNil: [paneToHeaderLink subheaders]! !

!GoHeader methodsFor: 'subheaders' stamp: 'miso 10/24/1999 14:56'!
subheadersNeedLoading
"An early attempt to speedup: upon expanding subheaders, need to know if all are dressed, but want to avoid calculating each one of them... so cached a state 'subsAreLoaded'. This started being messy quickly, so reverted to checking sizes of respective daughters. An alternative is to keep a daughtersAlreadyDressed flag, with the assumptions that we dress them all only once, and they remained fully sync-ed ever after"

	^ self translator daughters size ~= self daughters size! !

!GoHeader methodsFor: 'subheaders' stamp: 'miso 10/30/1999 20:25'!
whatIsAfterSubheader: subHeaderOrSymbol

	^ self subheaderPane whatIsAfterSubheader: subHeaderOrSymbol! !

!GoHeader methodsFor: 'subheaders' stamp: 'miso 10/30/1999 20:29'!
whatIsBeforeSubheader: subHeaderOrSymbol

	^ self subheaderPane whatIsBeforeSubheader: subHeaderOrSymbol! !

!GoHeader methodsFor: 'subheaders' stamp: 'ms 7/1/1999 23:36'!
whichDaughterDressesThisMeme: aMemeOrSymbol
"answer whether any of my immediate daughters are viewing aMeme, and if so, which. I can also get a symbol descriptor such as #root, in which case I just send it back."

	(aMemeOrSymbol isKindOf: Symbol) ifTrue: [^ aMemeOrSymbol].
	self subheaders do: [:s| (s isThisYourMeme: aMemeOrSymbol) ifTrue: [^s]].
	^nil! !

!GoHeader methodsFor: 'subheaders' stamp: 'ms 7/2/1999 10:02'!
whoDressesThisMeme: aMeme
"answer whether any header in me are viewing aMeme, and if so, which"

	| dresser |
	(self isThisYourMeme: aMeme) ifTrue: [^ self].
	self subheaders do: [:s| (dresser _ (s whoDressesThisMeme: aMeme)) ifNotNil: [^ dresser ]].
	^nil! !


!GoHeader methodsFor: '  expansion' stamp: 'miso 10/14/1999 09:41'!
hideSubheaders
"This is called from the wedge, or from boundsGivenMax (and frm raleaseOnSub when releasing the last sub) , the wedge state is thus not to be changed. The owner/submorphs relation is broken so that subheaderpane does not compete for screenspace anymore. I don't really release the subheaderpane: it is referenced from my 'theSubheadersPane' var."

	self changed.			"invalidates old area"
	paneToHeaderLink zapOwner.
	submorphs _ submorphs copyWithout: paneToHeaderLink.
	self layoutChanged.		"force calc of new fullBounds"

	self containsFocus ifTrue: [self askForMeatFocus]

	"this is in case we go back to an implementation of containsFocus that always returns false if the header is contracted (and we don't want to test that before, in case it slows down the contraction:
	(self subheaders detect: [:h | h containsFocus] ifNone: [nil]) ifNotNil: [self askForMeatFocus]. "
! !

!GoHeader methodsFor: '  expansion' stamp: 'ms 10/4/1998 14:05'!
rawExpandSubheaders
"This is to programmatically show subheaders (as opposed to showing them after a wedge-click, we thus need to set the wedge state"

	self unhideSubheaders.
	self setWedgeExpanded.! !

!GoHeader methodsFor: '  expansion' stamp: 'miso 10/25/1999 11:55'!
unhideSubheaders
	"This is the raw version to be used on startup"

	self subheadersNeedLoading
		ifTrue: [self dressSubheaders]
		ifFalse: [self isExpanded ifTrue: [^ self.]].

	submorphs _ submorphs copyWith: paneToHeaderLink.
	paneToHeaderLink privateOwner: self.

	GoSniffer loadDaughtersOf: self.
! !

!GoHeader methodsFor: '  expansion' stamp: 'miso 10/24/1999 15:37'!
unhideSubheadersAndRefresh
"This is called from the wedge, or from boundsGivenMax, the wedge state is thus not to be changed"

	self subheadersNeedLoading
		ifTrue: [self dressSubheaders]
		ifFalse: [self isExpanded ifTrue: [^ self.]].

"This part used to be in an autonomous 'unhideSubheaders' verb (while we were 'seizeSubheaders'). But we ended up being the only caller of that berb as the distinction between hide/release faded."

"Transcript show: (Time millisecondsToRun: [
]) printString; cr.
"
	submorphs _ submorphs copyWith: paneToHeaderLink.
	bigBrother layoutChanged.
	bigBrother fullBounds.
	bigBrother changed.
	"self topContainer //world// displayWorld.	we need all hte speed we can get, here"
	World displayWorld.
	paneToHeaderLink privateOwner: self.

	GoSniffer loadDaughtersOf: self.

"
meme daughters size ~~ 0 ifTrue: setWedgeContracted
background	 ProcessorScheduler fork At: priority 
Processor yield.	"

"	paneToHeaderLink preventiveSubDaughterDress.

			#Here should say: #needPreventiveLoading and upon fullBounds=nil
			should diplay and then do all preventive loading on morphs that require
			it."
	
! !

!GoHeader methodsFor: '  expansion' stamp: 'miso 7/5/1999 21:15'!
wannaContractSubheaders
"This is to programmatically hide subheaders (as opposed to hiding them after a wedge-click, we thus need to set the wedge state"

	self hideSubheaders.
	^ self setWedgeContracted.
! !

!GoHeader methodsFor: '  expansion' stamp: 'miso 7/5/1999 21:16'!
wannaExpandSubheaders
"This is to programmatically show subheaders (as opposed to showing them after a wedge-click, we thus need to set the wedge state"

	self unhideSubheadersAndRefresh.
	self setWedgeExpanded.! !


!GoHeader methodsFor: '  misc' stamp: 'miso 10/30/1999 16:05'!
dressSubheaders
"(re)load all daughters of my model. Return true if there were daughters to dress, false otherwise."

	self translator daughters do: [:d| self dressSubmeme: d].
	^ true



! !

!GoHeader methodsFor: '  misc' stamp: 'miso 10/28/1999 12:19'!
dressSubmeme: aSubmeme

	| h indexOfSisterAbove |
	(self isSubmemeDressed: aSubmeme) ifTrue: [^false].

	h _ GoTranslator createHeaderAndTranslatorFor: aSubmeme viewedInside: self.
	indexOfSisterAbove _ (aSubmeme indexInMom: self meme) - 1.
	^ h corePutSelfIntoHeader: self afterSub: indexOfSisterAbove
! !

!GoHeader methodsFor: '  misc' stamp: 'miso 10/24/1999 15:26'!
walkHeadersWith: aOneArgumentBlock
"the block is evaluated with each (dressed) header in turn as the argument, except for bigBrother"

	aOneArgumentBlock value: self.
	self subheaders ifNotNil: [
		self subheaders do: [:s | s walkHeadersWith: aOneArgumentBlock]]! !


!GoHeader methodsFor: '  core reorg subs' stamp: 'miso 10/29/1999 14:59'!
addSubHeader: incomingHeader after: existingHeader
"internal: called by incomingHeader during the process of moving/deleting itself. Use reorgSelf methods. 
This is a relay verb for the building block of reorgSelf and create, ie. pane.addSubHeader:after:"

	^ self subheaderPane addSubHeader: incomingHeader after: existingHeader.
! !

!GoHeader methodsFor: '  core reorg subs' stamp: 'miso 10/29/1999 14:55'!
releaseOneSubheader: aHeader
"internal: called by the subheader during the process of moving/deleting itself" 

	self subheaderPane releaseOneSubheader: aHeader.
	self checkForEmptySubPane.
	^ true
! !


!GoHeader methodsFor: '  subheaderPane' stamp: 'miso 10/28/1999 13:26'!
checkForEmptySubPane

	self subheaders size = 0 ifTrue: [ 
		self setWedgeInert. 
		self hideSubheaders. "undo the owner/submorphs connection"
		paneToHeaderLink newMom: nil.
		paneToHeaderLink _ nil. "now undo the paneLink&bigBro connection"
		].

"do not keep empty subpanes around, so that (even silent) arrival of new subs triggers creation of a new subpane, and the concmittant setting of the wedge (otherwise would need a mechanism to track re-arrival of a first subheader)"! !

!GoHeader methodsFor: '  subheaderPane' stamp: 'miso 10/24/1999 15:15'!
privSubheaderpaneClass
	^ GoHeadersPane! !

!GoHeader methodsFor: '  subheaderPane' stamp: 'miso 10/25/1999 13:21'!
subheaderPane
"construct one if needed"

	paneToHeaderLink ifNil: [ 
		self subheadersNeedLoading ifTrue: [ "construct one, was in privAddSubheaderPane"
			paneToHeaderLink _ self privSubheaderpaneClass new.
			paneToHeaderLink newMom: self.
			self setWedgeContracted ]].
	^ paneToHeaderLink! !


!GoHeader methodsFor: 'reorg self' stamp: 'miso 10/30/1999 19:32'!
goDown

	| lowerSister |
	lowerSister _ self sisterAfter.
		lowerSister == #end  ifTrue: [self flash. ^ false].
	^ self wannaMoveSelfAfter: lowerSister! !

!GoHeader methodsFor: 'reorg self' stamp: 'ms 7/3/1999 22:52'!
goLeft

	self isRoot ifTrue: [self flash. ^ false].
	^ self wannaMoveSelfAfter: self headerAbove! !

!GoHeader methodsFor: 'reorg self' stamp: 'miso 10/17/1999 10:06'!
goRight

	| higherSister |
	higherSister _ self sisterBefore.
		higherSister == #root  ifTrue: [self flash. ^ false].
	^ self wannaMoveSelfInto: higherSister
! !

!GoHeader methodsFor: 'reorg self' stamp: 'miso 11/2/1999 17:18'!
goUp
"eventually should become goUpBy: n. Or else the latter is a call to us with for 1 to n, goUp"

	| higherSister |
	higherSister _ self sisterBefore.
		higherSister == #root  ifTrue: [self flash. ^ false].
	^ self wannaMoveSelfBefore: higherSister
! !

!GoHeader methodsFor: 'reorg self' stamp: 'miso 10/30/1999 15:40'!
tab
	Sensor leftShiftDown 
		ifTrue: [ ^ self goLeft]
		ifFalse: [ ^ self goRight].! !

!GoHeader methodsFor: 'reorg self' stamp: 'ms 7/2/1999 15:47'!
wannaMoveSelfAfter: aHeader
"no symbol accepted as arguments here!! (We could though, interpreting them as mom_self mom.) Used in promoteSelf & createSister.
Ultimately, this is lexical sugar for 'headerPane addSubHeader:after:'"

	^ self wannaMoveSelfIntoHeader: (aHeader headerAbove) afterSub: aHeader
! !

!GoHeader methodsFor: 'reorg self' stamp: 'ms 7/2/1999 15:48'!
wannaMoveSelfBefore: aHeader
"This is slightly ugly, but helps us keep all the registering/dregistering in a single place, moveSelfIntoHeader:afterSub:, and all calls to add ourselves as call to addSubHeader:after:"

	^ self wannaMoveSelfIntoHeader: (aHeader headerAbove) afterSub: (aHeader sisterBefore)
! !

!GoHeader methodsFor: 'reorg self' stamp: 'miso 10/20/1999 12:08'!
wannaMoveSelfInto: aHeader
"Used for demoting: put at end of subheaders of aHeader."

	^ self wannaMoveSelfIntoHeader: aHeader  afterSub: #last
! !

!GoHeader methodsFor: 'reorg self' stamp: 'miso 10/25/1999 10:11'!
wannaMoveSelfIntoHeader: newContainerHeader afterSub: futureSisterDescriptor
"see older version for capacity of mving from a nonGolgi environment"

	(self translator headerWantsToMoveOutOf: self headerAbove
							into: newContainerHeader 
							afterSub: futureSisterDescriptor)   ifFalse: [^false].

	newContainerHeader wannaExpandSubheaders.
	self askForMeatFocus.
	self setDirty.
	^ true! !

!GoHeader methodsFor: 'reorg self' stamp: 'miso 10/25/1999 10:11'!
wannaProcreate
	"this is cmdReturn "

	| newMeme futureMom futureSister |
	futureMom _ self whereAddHeader. "hack: really an array of {mom.sister}"
	futureSister _ futureMom second.
	futureMom _ futureMom first.

	newMeme _ futureMom translator headerWantsADaughterAfter: futureSister.

	"header will be created by callback from meme-creating action. but focus must be dealt with
	here rather than in callback, coz only golg-initiated procreation changes focus."
	(futureMom whichDaughterDressesThisMeme: newMeme) askForMeatFocus.! !

!GoHeader methodsFor: 'reorg self' stamp: 'miso 10/25/1999 12:38'!
wannaPutSelfIntoHeader: newContainerHeader afterSub: futureSisterDescriptor

	(translator headerWantsToGoInto: newContainerHeader afterSub: futureSisterDescriptor)
		ifFalse: [^false].

	newContainerHeader wannaExpandSubheaders.
	self setDirty.
	^ true! !

!GoHeader methodsFor: 'reorg self' stamp: 'miso 10/25/1999 10:11'!
wannaSuicide
"me and my meme want to leave the mom I'm in. We have no further business, since we only view meme under that particular mom. So I also want me and my translator to be detached from our meme (which might continue to live under some other mom)"

	^ self translator headerWantsToGetOutOf: self headerAbove! !


!GoHeader methodsFor: '  data callbacks' stamp: 'miso 10/20/1999 13:59'!
dataGotOutOfMom "=suicide = getOutOfMom =putSelfOutOfMom"
"I view data under this mom, but data get out of it without going anywhere. I have no more business, suicide (forget about my meme). Don't change focus, except if I contain it."

	| nextFocus |
	nextFocus _ self containsFocus ifTrue: [self whoInheritsFocus].
	self corePutSelfOutOfMom 
		ifFalse: [^false].
	self translator forgetHeaderAndMeme.
	nextFocus ifNotNil: [nextFocus askForMeatFocus].
	^ true! !

!GoHeader methodsFor: '  data callbacks' stamp: 'miso 10/20/1999 13:59'!
dataMovedOutOfMomInto: newContainerHeader afterSub: futureSisterDescriptor "=moveSelfOutOfMom:afterSub"
"make a move that imitates the data move"

	self corePutSelfOutOfMom.
	self corePutSelfIntoHeader: newContainerHeader afterSub: futureSisterDescriptor.
	^ true! !


!GoHeader methodsFor: '  core reorg self (priv)' stamp: 'miso 10/25/1999 11:30'!
corePutSelfIntoHeader: newContainerHeader afterSub: futureSisterDescriptor
"core mv header verb (does not deal with focus-inheritance, or meme-side of things: only used  after having moved the data around. Use wanna* verbs). Might be a mv from within viewer, outside of viewer or a creation."

	^ newContainerHeader addSubHeader: self after: futureSisterDescriptor! !

!GoHeader methodsFor: '  core reorg self (priv)' stamp: 'miso 10/25/1999 12:57'!
corePutSelfOutOfMom
"core mv header verb, does not check for focus-deletion, or meme-side of things. Might be a mv within viewer, outside of viewer or a deletion."
"see prev version for capacity to come from nonGolg environment"

	^ self headerAbove releaseOneSubheader: self.! !


!GoHeader methodsFor: 'saving' stamp: 'ms 10/11/1998 18:23'!
askBeforeDiscardingEdits
"should be a pref when those will exist"

	^ true! !

!GoHeader methodsFor: 'saving' stamp: 'ms 7/3/1999 23:49'!
isDirty
	^ self meatIsDirty or: [self subsAreDirty]

	! !

!GoHeader methodsFor: 'saving' stamp: 'miso 10/25/1999 12:39'!
localSave
"this is adapted from the original content of acccept. Inform the model of text to be accepted, and return true if OK."

	meatIsDirty ifFalse: [ self flash ].
		"only happens when a local save is asked in clean header,
		in nonLocal cases the msg never gets from ancestor down to us"

	meat save.
	meatIsDirty _ false.! !

!GoHeader methodsFor: 'saving' stamp: 'ms 10/29/1998 15:38'!
meatIsDirty
	^ meatIsDirty! !

!GoHeader methodsFor: 'saving' stamp: 'ms 10/4/1998 18:33'!
needToSave
	^ self isDirty & self askBeforeDiscardingEdits ! !

!GoHeader methodsFor: 'saving' stamp: 'ms 7/4/1999 00:40'!
recursiveSave

	self meatIsDirty ifTrue: [ self localSave ].
	self subheaderPane ifNotNil: [self subheaderPane recursiveSave].
	^ true! !

!GoHeader methodsFor: 'saving' stamp: 'ms 7/3/1999 23:55'!
refreshFromMemes

	meatIsDirty ifTrue: [self refreshMeat. meatIsDirty _ false].

	self subsAreDirty ifTrue: [
		self subheaders do: [: h | h refreshFromMemes]]! !

!GoHeader methodsFor: 'saving' stamp: 'miso 10/25/1999 12:38'!
resetMeme: m
"change the meme we are associated to (do not change the translator). crucial to allow editing of one script into another. 
Note that content of meme and ofo header might be out of sync aftr this, it is up to the caller to decide how to resync"

	(translator understandsThisMeme: m) 
		ifFalse: [^ self error: 'cannot change the meme this header is linked to because our meme-translator does not understand this meme'].

	translator meme: m! !

!GoHeader methodsFor: 'saving' stamp: 'ms 9/22/1998 15:42'!
save: specialKey

	specialKey == #local ifTrue: [ ^ self localSave ].  "only local save"
	specialKey == #localWithSubs ifTrue: [ ^ self recursiveSave ]. "not activated"
	"specialKey == #global ifTrue: [ self bigBrother recursiveSave ]"

	^ self bigBrother recursiveSave. 	"save whole outline, even if bogus key"! !

!GoHeader methodsFor: 'saving' stamp: 'miso 10/25/1999 12:41'!
setDirty

	"meatIsDirty ifFalse: [ if we've alredy been dirtied, don't bother"
		meatIsDirty _ true.
		meat setDirty. "for visual feedback"! !

!GoHeader methodsFor: 'saving' stamp: 'ms 7/3/1999 23:48'!
subsAreDirty
	self subheaders do: [:s| s isDirty ifTrue: [^true]].
	^ false! !


!GoHeader methodsFor: 'focus' stamp: 'ms 11/1/1998 20:39'!
askForFocus: hand

	^ hand newKeyboardFocus: self.! !

!GoHeader methodsFor: 'focus' stamp: 'miso 10/25/1999 12:40'!
askForMeatFocus

	^ meat askForFocus: self primaryHand.! !

!GoHeader methodsFor: 'focus' stamp: 'miso 10/25/1999 12:40'!
askForMeatFocus: hand

	^ meat askForFocus: hand! !

!GoHeader methodsFor: 'focus' stamp: 'miso 10/30/1999 17:04'!
containsFocus
"am i, or something contained in me, focused?"

	self bigBrother ifNil: [^ false].
	self bigBrother lastFoci do: [: f | (f isInside: self) ifTrue: [^true]].
	^ false


" this does it the recursive way, which I suppose is slower:

	(self hasFocus or: [theMeatMorph hasFocus]) ifTrue: [^true].
	self isContracted ifTrue: [^ false].  // no need to look into contracted subs 
	self subheaders do: [: s | s containsFocus ifTrue: [^true]].
	^false.
"! !

!GoHeader methodsFor: 'focus' stamp: 'miso 10/20/1999 10:35'!
hasFocus
"this is to test whether the *entire* header is focused, ie. returns false if meat is in focus"

	^ self bigBrother 
		ifNil: [false]
		ifNotNil: [self bigBrother submorphHasFocus: self]! !

!GoHeader methodsFor: 'focus' stamp: 'miso 10/30/1999 17:09'!
meatLostFocus
"callback: give a chance to my translator to do stuff like automatic cleaning of meat (eg. for syntax of code)"

	self translator meatLostFocus! !

!GoHeader methodsFor: 'focus' stamp: 'miso 10/20/1999 13:34'!
whoInheritsFocus
"say who would inherit my focus if i were to die now. Return nil if there is no candidate, bigBro will deal with it"

	| momHeader myFocusPoz |
	momHeader _ self headerAbove.
	momHeader subheaders size = 1	"i am the only header, no sister can inherit, pass up"
		ifTrue: [^ momHeader = self bigBrother ifTrue: [nil] ifFalse: [momHeader]].
	myFocusPoz _  momHeader positionOfSubheader: self.
	myFocusPoz = 1
		ifTrue: [^ (momHeader headerAt: 2)]
		ifFalse: [^ (momHeader headerAt: myFocusPoz-1)].


"	THIS IS TO PUT FOCUS ON VACATED POSITION
	oldFocusPoz > oldMom subheaders size  
		ifTrue: [
			oldMom subheaders size = 0	
				ifTrue: [ oldMom becomeFocus: ourHand]
				ifFalse: [(oldMom headerAt:(oldFocusPoz-1)) becomeFocus: ourHand] ]
		ifFalse: [
			(oldMom headerAt: oldFocusPoz) becomeFocus: ourHand ]
"
! !


!GoHeader methodsFor: '  core' stamp: 'miso 10/30/1999 17:03'!
coreBecomeFocus
"called from hand.newKeyboardFocus: via 'self.keyboardFocusChange: true'. Hand already registered us as the focus bearer (in its keyboardFocus var)"

	self walkHeadersWith: [:h| 
		h wedgeBackgroundColor: Color yellow.
		h meatColor: Color yellow.].

	self bigBrother ifNotNil: [
		self bigBrother lastFocus: self]. "keep track of last focus for mouseEnter: in golgPane"
! !

!GoHeader methodsFor: '  core' stamp: 'miso 10/30/1999 17:09'!
coreStopBeingFocus
"called from hand.newKeyboardFocus: via 'self.keyboardFocusChange: false'. Hand already unregistered us as the focus bearer (in its keyboardFocus var)"

	self walkHeadersWith: [:h| 
		h defaultWedge.
		h meatColor: self translator defaultColor].! !

!GoHeader methodsFor: '  core' stamp: 'miso 10/30/1999 17:10'!
keyboardFocusChange: aBoolean

	aBoolean
		ifTrue: ["A hand is wanting to send us characters..."
			self coreBecomeFocus]
		ifFalse: ["A hand has clicked elsewhere..."
			self coreStopBeingFocus]
! !


!GoHeader methodsFor: 'drag&drop' stamp: 'miso 7/5/1999 21:49'!
acceptDroppingMorph: aMorph event: evt
	"standard API to allow the user to add submorphs just by dropping them on this morph."

	| newMom newSister |
	(aMorph isKindOf: GoHeader) ifFalse: [^false]. "don't swallow nonHeader objects"

	"decide whether aMorph should be my sister or my daughter"
	(self dropInside: (evt transformedBy: (self transformFrom: World)) cursorPoint)
		ifTrue: [ newMom _ self. self isExpanded ifTrue: [newSister _ #root] ifFalse: [newSister _ #last]]
		ifFalse:  [ newMom _ self headerAbove. newSister _ self].

	^ evt shiftPressed "allow either mv of aMorph or creation of duplicates (aliases/links)"
		ifTrue: [aMorph wannaPutSelfIntoHeader: newMom afterSub: newSister]
		ifFalse: [aMorph wannaMoveSelfIntoHeader: newMom afterSub: newSister]! !

!GoHeader methodsFor: 'drag&drop' stamp: 'miso 10/7/1999 11:43'!
beGrabbedByEvt: evt
	"called from wedge, initiates a drag&drop operation. See documentation."

	GoHeaderAlias visualiseDragOf: self fromEvent: evt! !

!GoHeader methodsFor: 'drag&drop' stamp: 'miso 10/7/1999 11:46'!
doYouWannaDelegateDropeeAt: localPoint
"i was elected as the receiver of the drop-wannabe, because i am the most embedded morph containing the drop-wannabe. but if the localPoint is in my left margin near one of my submorphs, I pass drop on to them"

	| adjustedPoint |
	(self isInMargin: localPoint) 
		ifTrue: [adjustedPoint _ (localPoint x + self leftMargin) @ localPoint y]
		ifFalse: [adjustedPoint _ localPoint].

	self isExpanded ifTrue: [ "contracted headers keep coords... (only some?)"
		self subheaders do: [: s |
			(s fullContainsPoint: adjustedPoint) ifTrue: [^ s doYouWannaDelegateDropeeAt: adjustedPoint]]].

	^ self! !

!GoHeader methodsFor: 'drag&drop' stamp: 'miso 10/7/1999 12:24'!
dropInside: cursorPoz
	"i am the candidate-host for a drop or paste action, and i am asked whether i would absorb the dropped element as a submorph or not (ie or as a sister below me). Answer with bool. cursorPoz is in local coord."
	self isExpanded ifFalse: [
		"either sis below or first sub"
		(cursorPoz x - bounds left) < 22 ifTrue: [
			^ false]		"put under meat, as first sub"].
	^ true! !

!GoHeader methodsFor: 'drag&drop' stamp: 'ms 12/23/1998 23:36'!
isInMargin: localPoint

	localPoint x <= (self bounds left + self leftMargin) ifTrue: [^true].
	^false! !

!GoHeader methodsFor: 'drag&drop' stamp: 'ms 10/29/1998 23:32'!
wantsDroppedMorph: aMorph event: evt
	"Supports adding morphs by dropping."

	^ true! !

!GoHeader methodsFor: 'drag&drop' stamp: 'miso 10/25/1999 12:39'!
whereDoIDrop: cursorPoz
	"cursorPoz must be in local coordinates"
	| dropPoz  |
	dropPoz _ self boundsInWorld left @ meat boundsInWorld bottom.
	(self dropInside: cursorPoz)
		ifTrue: [
			^ dropPoz _ (dropPoz x + 40) @ dropPoz y]
		ifFalse: [
			^ dropPoz _ (dropPoz x + 5) @ dropPoz y]! !


!GoHeader methodsFor: 'cut&paste' stamp: 'ms 11/3/1998 16:46'!
coffreFort
	"return a reference to the pasteBuffer we use in common with MeatMorph"
	^ GoCoffreFort! !

!GoHeader methodsFor: 'cut&paste' stamp: 'ms 11/22/1998 17:13'!
copyToCoffreFort
	"= copyToClipbard, copyToPasteBuffer"
	self hasFocus ifFalse: [^nil] "we might be called on a cmdC in our meat. if so, decline to act".
	self coffreFort put: self copyWithAccessor! !

!GoHeader methodsFor: 'cut&paste' stamp: 'miso 10/20/1999 13:08'!
cut
	"put my meme into buffer, forget about me completly. A header will be rebuilt if I am pasted into a golg"

	self hasFocus ifFalse: [^nil] "we might be called on a cmdC in our meat. if so, decline to act".

	self coffreFort put: self meme.
	self wannaSuicide.! !

!GoHeader methodsFor: 'cut&paste' stamp: 'miso 10/20/1999 13:09'!
deferredCut
	"put me into buffer, move me when paste occurs"

	self hasFocus ifFalse: [^nil] "we might be called on a cmdC in our meat. if so, decline to act".

	self coffreFort put: self meme! !

!GoHeader methodsFor: 'cut&paste' stamp: 'miso 10/20/1999 14:20'!
paste
	"allow pasting of headers onto me to indicate adding headers after me"
	| pastee hHostData nextMom nextSisterBefore |
	pastee _ self coffreFort content.
	(pastee isKindOf: Meme) ifTrue: [
		hHostData _ self whereAddHeader.
		nextMom _ hHostData first meme.
		nextSisterBefore _ (hHostData second isKindOf: Symbol) ifTrue: [hHostData second] ifFalse: [hHostData second meme].
		pastee putSelfIntoHeader: nextMom afterSub: nextSisterBefore.
		^ true "indicate we handled it, whatever the outcome"
		].
	(pastee isKindOf: GoHeader) ifTrue: [ "should not happen anymore"
		hHostData _ self whereAddHeader.
		pastee wannaMoveSelfIntoHeader: hHostData first afterSub: hHostData second.
		^ true "indicate we handled it, whatever the outcome"
		].
	^ nil "if we are called from meat key-shortcut, allow ParaEditor to handle it"! !


!GoHeader methodsFor: 'keys' stamp: 'miso 11/1/1999 08:48'!
key: char combo: comboSymbol stream: s
	"this is the locus of default key mappings for all headers. can be overridden by translator. (default key mappings for meat are in ParagraphEditor)"
	| keyNum  |
	^ (translator key: char combo: comboSymbol) ifNil: [
		"take a shot at doing it ourselves, if people above didn't get it"
		keyNum _ char asciiValue.
		comboSymbol = nil ifTrue: [
			keyNum = 9 ifTrue: [
				self tab.
				^ true
				"tab reorgs"]].
		comboSymbol = #cmdShift ifTrue: [
			char = $s ifTrue: [
				self save: #local.
				^ true]].
		comboSymbol = #cmd ifTrue: [
			char = $c ifTrue: [
				^ self copyToCoffreFort
				"allow it to return nil"].
			char = $d ifTrue: [
				self goDown.
				^ true].
			char = $l ifTrue: [
				self goLeft.
				^ true].
			char = $r ifTrue: [
				self goRight.
				^ true].
			char = $u ifTrue: [
				self goUp.
				^ true].
			char = $v ifTrue: [
				^ self paste].
			char = $x ifTrue: [
				^ self cut].
			keyNum = 8 ifTrue: [
				self wannaSuicide.
				^ true
				"cmdDelete"].
			keyNum = 13 ifTrue: "cmdReturn" [
				self wannaProcreate.
				^ true
				""].
			keyNum = 28 ifTrue: [
				self goLeft.
				^ true
				"cmdArrowLeft"].
			keyNum = 29 ifTrue: [
				self goRight.
				^ true
				"cmdArrowRight"].
			keyNum = 30 ifTrue: [
				self goUp.
				^ true
				"cmdArrowUp"].
			keyNum = 31 ifTrue: [
				self goDown.
				^ true
				"cmdArrowDown"].
			char = $s ifTrue: [
				self save: #global.
				^ true]].
		^ nil
		"no action from us, allow lower element to act"]! !

!GoHeader methodsFor: 'keys' stamp: 'miso 10/25/1999 12:41'!
keyStroke: evt
"when we are focus we are 'keyboardFocus' and thus receive any kb action. we look for cmd/cmdShift just like GoParagraphEditor.dispatchOnCharacter:with: does, but taking info from evt rather than sensor. If cmd/shiftCmd process it, else deselect self and pass it on to meat."

	| char dummyStream combo |
	char _ evt keyCharacter.
	dummyStream _ WriteStream on: (String new: 10).
	combo _ self keyStrokeIsModified: evt.
	(self keyStrokeIsSpecial: evt) ifTrue: [ "special key: enter, delete, tab, etc."
		^ self key: char combo: combo stream: dummyStream].
	combo ifNotNil: [ "modifier pressed: cmd, shiftCmd"
		^ self key: char combo: combo stream: dummyStream].

	"not a special char, deselect self, select meat, and pass evt to it"
	self askForMeatFocus: evt hand.
	^ meat textMorph keyStroke: evt
! !

!GoHeader methodsFor: 'keys' stamp: 'ms 11/1/1998 18:58'!
keyStrokeIsModified: evt
"look for cmd/cmdShift just like GoParagraphEditor.keyStrokeIsModified does, but taking info from evt rather than sensor. Answer with a modifier keys descriptor : #cmd, #cmdShift, nil"

	evt commandKeyPressed ifTrue: [
		evt shiftPressed
			ifTrue: [^ #cmdShift]
			ifFalse: [^ #cmd]].

	"the control key can be used to invoke shift-cmd shortcuts"
	evt controlKeyPressed ifTrue: [^ #cmdShift].

	^ nil! !

!GoHeader methodsFor: 'keys' stamp: 'ms 11/1/1998 18:59'!
keyStrokeIsSpecial: evt
"Answer whether this is a special key-evt that is a command even without modifier"

	"enter, backspace, arrows, escape, etc. are command keys"
	(ParagraphEditor specialShiftCmdKeys includes: evt keyCharacter asciiValue)
		ifTrue: [^ true].

	"-=-= special for golgi, until it is put into specialChars"
	evt keyCharacter = Character tab 
		ifTrue: [^ true].

	^ false! !


!GoHeader methodsFor: 'create delete copy' stamp: 'miso 10/25/1999 12:37'!
copyWithAccessor
	"copy me, my accessor, my meme, and all the submemes in my meme. don't dress those however."
	^ self class withTranslator: translator copyWithMeme

! !

!GoHeader methodsFor: 'create delete copy' stamp: 'miso 10/25/1999 10:11'!
detachFromdata
"make sure there are no more references to me or my translator. this is used when the golgi pane is getting deleted."
"find a better name"

	self subheaders do: [: s | s detachFromdata].
	self translator forgetHeaderAndMeme.! !

!GoHeader methodsFor: 'create delete copy' stamp: 'miso 10/24/1999 15:38'!
initialize
"this is called at the beginning of instance creation: fill in those values that are presupposed"

	super initialize.
	paneToHeaderLink _ nil.
	meatIsDirty _ false.
	self	initWedge.
	^ self 
! !

!GoHeader methodsFor: 'create delete copy' stamp: 'miso 10/25/1999 12:38'!
isItOkToDie
"asks whether i can be discarded and end my life now. Yes unless me or my daughters contain changes that the user wants to continue editing. (sent by okToChange)"

	| r |
	self needToSave 
		ifTrue: [ r _ self queryForSave.
			r = #save ifTrue: [self recursiveSave. ^ true].
			r = #discard ifTrue: [translator bigBrotherWasDiscarded: self. ^ true].
			r = #cancel ifTrue: [^ false].
			r ifNil: [^ false].
			^ self error: 'dialog internal error']
		ifFalse: [^ true].


"	self needToSave 
		ifTrue: [^ self queryForSave]
		ifFalse: [^ true].		"

! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

GoHeader class
	instanceVariableNames: ''!

!GoHeader class methodsFor: 'prefs' stamp: 'ms 10/7/1998 02:38'!
Margin: whichMargin

	| theMargin |
	whichMargin = #top  ifTrue: 	[theMargin _ HeaderTopMargin].
	whichMargin = #bottom  ifTrue: [theMargin _ HeaderBottomMargin].
	whichMargin = #right  ifTrue: 	[theMargin _ HeaderRightMargin].
	whichMargin = #left  ifTrue: 	[theMargin _ HeaderLeftMargin].
	whichMargin = #interSub  ifTrue: [theMargin _ PaddingBetweenSubTexts].

	theMargin ifNil: [ theMargin _ self setMargin: whichMargin 
						to: (self defaultValueOfMargin: whichMargin)].
	^ theMargin! !

!GoHeader class methodsFor: 'prefs' stamp: 'ms 9/21/1998 02:57'!
checkMargins
"Make sure margins have some value. else fullBounds will fail. Just calling the margins ensures that they get some value."

	self Margin: #top.
	self Margin: #bottom.
	self Margin: #right.
	self Margin: #left.
	self Margin: #interSub.! !

!GoHeader class methodsFor: 'prefs' stamp: 'ms 10/7/1998 12:09'!
defaultValueOfMargin: whichMargin

	whichMargin = #top  ifTrue: 	[^0].
	whichMargin = #bottom  ifTrue: [^0].
	whichMargin = #right  ifTrue: 	[^0].
	whichMargin = #left  ifTrue: 	[^20].
	whichMargin = #interSub  ifTrue: [^0].

	^0! !

!GoHeader class methodsFor: 'prefs' stamp: 'ms 10/7/1998 02:38'!
setMargin: whichMargin to: n

	whichMargin = #top  ifTrue: 	[HeaderTopMargin _ n].
	whichMargin = #bottom  ifTrue: [HeaderBottomMargin _ n].
	whichMargin = #right  ifTrue: 	[HeaderRightMargin _ n].
	whichMargin = #left  ifTrue: 	[HeaderLeftMargin _ n].
	whichMargin = #interSub  ifTrue: [PaddingBetweenSubTexts _ n].

	^n
"indentingTopMargin == HeaderPaneTopMargin"
"indentingBottomMargin == HeaderPaneBottomMargin"! !

!GoHeader class methodsFor: 'prefs' stamp: 'miso 10/24/1999 15:24'!
setMargin: whichMargin to: n updating: listOfViews

	self setMargin: whichMargin to: n.
	whichMargin = #wedge
		ifTrue: [
			listOfViews do: [:v |
				v walkHeadersWith: [:h| h resetWedgeFromLeft: n] ]]
		ifFalse: [
			listOfViews ifNotNil: [
				listOfViews do: [:v | v layoutChanged ]]]! !


!GoHeader class methodsFor: 'instantiating' stamp: 'miso 10/25/1999 10:13'!
rawWithAccessor: anAccessor
"do not try to tap HeaderBank, since HeaderBank calls me to fill itself"

	^ super new translator: anAccessor! !

!GoHeader class methodsFor: 'instantiating' stamp: 'miso 10/25/1999 10:13'!
withTranslator: anAccessor

	^ self new translator: anAccessor "reset accessor and refresh properties from it"

! !


PluggableTextMorph subclass: #GoMeat
	instanceVariableNames: 'maxHeight rectCache widthCache '
	classVariableNames: 'MeatColor '
	poolDictionaries: ''
	category: 'Golgi-Basics'!
!GoMeat commentStamp: '<historical>' prior: 0!
I represent the typical content of a header: an editable text of arbitrary size, with style. I grow/shrinks vertically as my text grows/shrinks. 

I have been patched to show my scrollbar only when it is actually useful: if the text is bigger than I am, and if the bar is longer than a rachitic blob that you can't manipulate.

In the future I might have some more layout options: a maximal vertical size beyond which I show my scrollbar, and maybe a 1-line view.

--- 
Note: The isDirty mechanism might end up slightly out of sync with textMorph's var hasUnacceptedEdits, but always in one direction: isDirty is true while hasUnacceptedEdits is false. This is harmless as it will only trigger a couple of extra calls to save, who will decline. (The possible mismatch is due to the fact  that several scripts set hasUnacceptedEdits to false independently of saving...)!


!GoMeat methodsFor: 'accessors' stamp: 'ms 8/9/1998 03:12'!
getTextHeight
	textMorph ifNil: [ ^ self bounds height].
	^ textMorph bounds height.! !

!GoMeat methodsFor: 'accessors' stamp: 'miso 10/14/1999 09:28'!
isInside: aMorph

	^ owner isInside: aMorph! !

!GoMeat methodsFor: 'accessors' stamp: 'ms 11/7/1998 13:12'!
isWedge
	^ false! !

!GoMeat methodsFor: 'accessors' stamp: 'ms 9/10/1998 17:27'!
meatColorPref
	MeatColor ifNil: [MeatColor _ Color transparent].
	^ MeatColor! !

!GoMeat methodsFor: 'accessors' stamp: 'miso 10/24/1999 15:25'!
meatColorPref: c
"sets color for all header texts"
	MeatColor _ c.
	owner bigBrother walkHeadersWith: [:h| h meme setColor: c]
! !

!GoMeat methodsFor: 'accessors' stamp: 'ms 8/6/1998 19:26'!
minHeight
	^ 25.! !

!GoMeat methodsFor: 'accessors' stamp: 'ms 9/9/1998 23:57'!
model: aModel
"overriden to not register as a dependent. Dependents were never cleared."

	model _ aModel.
! !

!GoMeat methodsFor: 'accessors' stamp: 'ms 7/4/1999 01:19'!
refreshMeat

	self setText: self getText.
	self textMorph releaseParagraph. "otherwise does not show, sometimes."! !

!GoMeat methodsFor: 'accessors' stamp: 'ms 11/2/1998 11:56'!
setColor: c
"sets color for this meat only. Called from menu therefore allows c to be symbol or nil"

	self color: 
		((c isKindOf: String "orSymbol!!") 
			ifTrue: [Color perform: c]
			ifFalse: [c]).
	self changed
! !

!GoMeat methodsFor: 'accessors' stamp: 'ms 8/6/1998 20:26'!
setMeat: newContent
	self setText: newContent.

"setContents:  contents:
editString: setSelection: setText:"! !


!GoMeat methodsFor: 'geometry' stamp: 'ms 8/29/1998 04:22'!
boundsGivenMax1: maxRect
	| ourTempBottom newRect h |
	maxHeight _ maxRect height.

	h _ self setWidthGetHeight:  maxRect width. 
			"also calls extent: which resets all bounds "
	ourTempBottom _ maxRect top + h.

	(ourTempBottom >= maxRect bottom)
		ifTrue: [
			(maxRect top + self minHeight >= maxRect bottom)
				ifTrue: [ "we cannot squeeze into there..."
					newRect _ nil.
					ourTempBottom _ nil.
					^ nil ]
				ifFalse: [ "just show whatever we can..."
					ourTempBottom _ maxRect bottom.
					newRect _ maxRect withBottom: ourTempBottom. ].
		]
		ifFalse: [
			newRect _ maxRect withBottom: ourTempBottom. ].

	(newRect = rectCache) ifFalse: [
		rectCache _ newRect.
		self bounds: newRect ].

	^ ourTempBottom.
! !

!GoMeat methodsFor: 'geometry' stamp: 'ms 8/29/1998 04:24'!
boundsGivenMax: maxRect
	| ourTempBottom newRect h |
	maxHeight _ maxRect height.

	h _ self setWidthGetHeight:  maxRect width. 
			"also calls extent: which resets all bounds "
	ourTempBottom _ maxRect top + h.
	newRect _ maxRect withBottom: ourTempBottom.

	(newRect = rectCache) ifFalse: [
		rectCache _ newRect.
		self bounds: newRect ].

	^ ourTempBottom.
! !

!GoMeat methodsFor: 'geometry' stamp: 'ms 9/2/1998 12:32'!
boundsGivenTopline: topLine

	| newRect |

	newRect _ topLine withBottom: topLine top + (self setWidthGetHeight: topLine width).

	(newRect = rectCache) ifFalse: [
"Transcript show: (Time millisecondsToRun: 
			[
owner bigBrother ubiq ifNotNil: [owner bigBrother ubiq: owner bigBrother ubiq+1]."
		rectCache _ newRect.
		self bounds: newRect
"] ) printString, ' - '."
 ].

	^ bounds
! !

!GoMeat methodsFor: 'geometry' stamp: 'ms 9/5/1998 20:36'!
boundsGivenToplineAndYield: topLine

	| newRect |

	newRect _ topLine withBottom: topLine top + (self setWidthGetHeight: topLine width).

	(newRect = rectCache) ifFalse: [
"Transcript show: (Time millisecondsToRun: 
			[
owner bigBrother ubiq ifNotNil: [owner bigBrother ubiq: owner bigBrother ubiq+1]."
		rectCache _ newRect.
		self bounds: newRect.
		Processor yield
"] ) printString, ' - '."
 ].

	^ bounds
! !

!GoMeat methodsFor: 'geometry' stamp: 'ms 11/2/1998 14:41'!
drawOn: aCanvas 
"do not include a thin red inset border for unaccepted edits. experiment with different feedbacks. try putting the whole pane darker than its container for instance. or changing wedge"

	| curOwner theColor ok |
	self hasUnacceptedEdits 
		ifTrue: [
			curOwner _ self.
			ok_false.
			[ok=false] whileTrue: [
				curOwner color == Color transparent 
					ifFalse: [theColor _ curOwner color  darker. ok_true].
				curOwner owner 
					ifNil: [theColor _ Color veryVeryLightGray. ok_true]
					ifNotNil: [curOwner _ curOwner owner]]].

	theColor ifNil: [theColor _ self color "Color transparent"].
	aCanvas fillRectangle: bounds color: theColor.
! !

!GoMeat methodsFor: 'geometry' stamp: 'ms 11/4/1998 01:18'!
printOn: aStream

	super printOn: aStream.
	aStream nextPutAll: ' - '.
	self text asString printOn: aStream! !

!GoMeat methodsFor: 'geometry' stamp: 'ms 9/1/1998 12:46'!
setWidthGetHeight: aWidth

	(aWidth == widthCache)
		ifTrue: [ ^ textMorph bounds height ]
		ifFalse: [ widthCache _ aWidth ].
	textMorph extent: aWidth @ (textMorph bounds bottom).
	^ textMorph bounds height.


"	aWidth = maxHeight ifTrue: [
		^ Transcript show:'resetting width ', textMorph bounds width printString;cr.].
	maxHeight _ aWidth."


"	(aWidth = textMorph bounds width) ifTrue: [
		Transcript show: 'meat did not change size.'; cr.	
		^ textMorph bounds height.
	]. 
	Transcript show: 'meat changed size.'; cr.	
	textMorph extent: aWidth @ (textMorph bounds bottom).
	^ textMorph bounds height.	
"

	! !


!GoMeat methodsFor: 'topic/focus' stamp: 'ms 11/4/1998 01:10'!
askForFocus

	^ self askForFocus: self primaryHand.! !

!GoMeat methodsFor: 'topic/focus' stamp: 'ms 10/31/1998 16:06'!
askForFocus: hand

	hand newKeyboardFocus: textMorph.
! !

!GoMeat methodsFor: 'topic/focus' stamp: 'miso 10/14/1999 09:08'!
hasFocus

	"owner ifNil: [^false]"
	^ (owner bigBrother submorphHasFocus: self) or: [owner bigBrother submorphHasFocus: textMorph]! !


!GoMeat methodsFor: '  core' stamp: 'miso 10/30/1999 17:11'!
coreBecomeFocus
"called from hand.newKeyboardFocus: via 'self.keyboardFocusChange: true'. Hand already registered us as the focus bearer (in its keyboardFocus var)"

	selectionInterval ifNotNil:
		[textMorph handleEdit: 
			[textMorph editor selectInterval: selectionInterval]].
	self showScrollbar.

	owner bigBrother ifNotNil: [owner bigBrother lastFocus: self]. "keep track of last focus for mouseEnter: in golgPane"
! !

!GoMeat methodsFor: '  core' stamp: 'miso 10/30/1999 17:11'!
coreStopBeingFocus
"like becomeFocus: this is called from hand.newKeyboardFocus: via michTextMorph.kbFocChange"

	self selectionInterval: textMorph editor selectionInterval.
	self hideScrollbar.

	owner meatLostFocus. "callback"! !

!GoMeat methodsFor: '  core' stamp: 'miso 10/30/1999 17:13'!
keyboardFocusChange: aBoolean
"sent by hand to the new focus bearer. redirect it to textMorph. should go to textMorph directly, but we sometime receive it if bigBrother registered us as lastFocus and wants to reactivate lastFocus (eg. on mouseEnter:)"

	^ textMorph keyboardFocusChange: aBoolean! !

!GoMeat methodsFor: '  core' stamp: 'miso 10/30/1999 17:12'!
mouseDown: event
"receive the event from text morph, when mouseDown: is the first click in that morph"

	self askForFocus: event hand.! !

!GoMeat methodsFor: '  core' stamp: 'ms 10/31/1998 16:37'!
mouseEnter: event

"	self askForFocus: event hand.		"! !

!GoMeat methodsFor: '  core' stamp: 'ms 8/28/1998 14:12'!
mouseLeave: event

"do not say 'self stopBeingFocus: event.' as this is already triggered by the mouseEnter->kbFocChange"
! !


!GoMeat methodsFor: 'saving' stamp: 'ms 8/18/1998 12:54'!
accept
"This is standard API, we receive it from kb on cmdS. User wants to save. Inform the header of these intentions, and let him take appropriate action. This gets called whenenever cmdS is hit in a textMorph. Note that cmdShiftSave doesn't get to us at all, it gets sent to search: which has been overriden to directly call header."

	owner save: #global.! !

!GoMeat methodsFor: 'saving' stamp: 'ms 9/24/1998 03:27'!
hasUnacceptedEdits: aBoolean
"Overriden so as to tell header we got dirtied, if we did."

	super hasUnacceptedEdits: aBoolean.
	aBoolean  ifTrue: [ owner ifNotNil: [owner setDirty] ].
! !

!GoMeat methodsFor: 'saving' stamp: 'ms 7/3/1999 23:54'!
save
"this is a 'localSave' called from header, *not* directly from cmdS. cmdS goes to meat.accept, then to header.accept who dispatches as necessary throughout the outline (globalSave), and it then comes back to us at some point. (This is better than directly overriding kbController as several places send the 'accept' msg. It is [adapted from?] the original script in pluggable.accept, except for the return value."

	| textToAccept ok |
	self canDiscardEdits ifTrue: "needToSave ifFalse:" [^ self "flash"]. "another header might need saving!!"
	textToAccept _ textMorph asText.
	ok _ (setTextSelector == nil) or:
		[setTextSelector numArgs = 2
			ifTrue: [model perform: setTextSelector with: textToAccept with: self]
			ifFalse: [model perform: setTextSelector with: textToAccept]].
	ok ifTrue:
		[self setText: self getText.
		self hasUnacceptedEdits: false].
	^ ok! !

!GoMeat methodsFor: 'saving' stamp: 'ms 10/12/1998 03:06'!
setDirty
	hasUnacceptedEdits _ true ! !


!GoMeat methodsFor: 'bug workaround' stamp: 'ms 8/15/1998 23:11'!
selectionBackup
	^ selectionInterval! !

!GoMeat methodsFor: 'bug workaround' stamp: 'ms 8/28/1998 18:11'!
selectionBackup: newSelect
	^ self selectionInterval: newSelect
! !

!GoMeat methodsFor: 'bug workaround' stamp: 'ms 10/29/1998 21:53'!
setText: aText
"overriden to install a MichTextMorph instead of , to work around a bug in the handling of selection by TextMorph. See comments to the MichTextMorph class."
"29/10: do not say 'hasUnacceptedEdits: false' so as to allow normalisation of unsaved content"
	scrollBar setValue: 0.0.
	textMorph
		ifNil: [textMorph _ MichTextMorph new
						contents: aText wrappedTo: self innerBounds width-6.
				textMorph setEditView: self.
				scroller addMorph: textMorph]
		ifNotNil: [textMorph newContents: aText].! !


!GoMeat methodsFor: 'scrollBar enhance' stamp: 'ms 8/28/1998 11:08'!
hideScrollbar
	retractableScrollBar ifTrue: [self privateRemoveMorph: scrollBar]! !

!GoMeat methodsFor: 'scrollBar enhance' stamp: 'ms 8/29/1998 09:52'!
scrollBarValue: scrollValue
"do not ohardcode a horizontal offset of 3, use what is already in there."

	scroller hasSubmorphs ifFalse: [^ self].
	scroller offset: scroller offset x @ (self totalScrollRange * scrollValue)! !

!GoMeat methodsFor: 'scrollBar enhance' stamp: 'ms 8/28/1998 11:29'!
showScrollbar

	| minimalHeight |
	minimalHeight _ 40.
	bounds height < minimalHeight ifTrue: [ ^ self ].

	bounds height < textMorph bounds height ifFalse: [ ^ self ].

	(retractableScrollBar and: [(submorphs includes: scrollBar) not])
		ifTrue: [self privateAddMorph: scrollBar atIndex: 1.
				self resizeScrollBar.
				scrollBar changed].
! !


!GoMeat methodsFor: 'admin' stamp: 'ms 11/3/1998 17:23'!
coffreFort
	"return a reference to the pasteBuffer we use in common with GoHeader"
	^ GoCoffreFort! !

!GoMeat methodsFor: 'admin' stamp: 'ms 10/11/1998 13:42'!
initialize

"	super initialize.		"

	bounds _ 0@0 corner: 50@40.
	submorphs _ EmptyArray.

		open _ false.
	"	self color: Color transparent."
			borderColor _ #inset.
			retractableScrollBar _ scrollBarOnLeft _ true.
			scrollBar := ScrollBar new model: self slotName: 'scrollBar'.
			scrollBar borderWidth: 2; borderColor: #inset.
			retractableScrollBar ifFalse: [self addMorph: scrollBar].
			scroller := TransformMorph new color: Color transparent.
			scroller offset: 0@0.
			self addMorph: scroller.
			self on: #mouseEnter send: #mouseEnter: to: self.
			self on: #mouseLeave send: #mouseLeave: to: self.
				askBeforeDiscardingEdits _ true.

	borderWidth _ 0.
	maxHeight _ 50.
	self hasUnacceptedEdits: true.
	self color: self meatColorPref.
"	isFocus _ false.	"
! !

!GoMeat methodsFor: 'admin' stamp: 'ms 12/5/1998 20:51'!
key: char combo: comboSymbol stream: s

	^ (owner key: char combo: comboSymbol stream: s) ifNil: [
		"take a shot at doing it ourselves, if people above didn't get it"

		comboSymbol = #cmd ifTrue: [
			char = $v ifTrue:	[^self paste]].

		^ nil "no action from us, allow lower element to act"
	].! !

!GoMeat methodsFor: 'admin' stamp: 'ms 10/11/1998 15:33'!
on: anObject text: getTextSel accept: setTextSel readSelection: getSelectionSel menu: getMenuSel

	self model: anObject.
	getTextSelector _ getTextSel.
	setTextSelector _ setTextSel.
	getSelectionSelector _ getSelectionSel.
	getMenuSelector _ getMenuSel.

		"remplace 'setText:' pour eviter bound-makers qui
		sont lents et inutiles"
		scrollBar setValue: 0.0.
		textMorph _ MichTextMorph new
						quickContents: self getText.
				textMorph setEditView: self.
				scroller addMorph: textMorph.
		self hasUnacceptedEdits: false.

	"init selectionInterval or else mouseEnter/becomeFoc will not show anything"
	selectionInterval _ 1 to: 0.


"	self setText: self getText.
	self setSelection: self getSelection.	"! !

!GoMeat methodsFor: 'admin' stamp: 'ms 11/3/1998 17:44'!
paste
	"allow pasting of headers onto me to indicate adding headers after me"

	(self coffreFort content isKindOf: GoHeader) ifTrue: [
		^ owner paste].
	^ nil "if we are called from key-shortcut, allow ParaEditor to handle it"! !


!GoMeat methodsFor: 'experimental' stamp: 'ms 8/28/1998 09:22'!
copyVars

	self privateBounds: (bounds origin corner: bounds corner).  
			"deep-copy bounds"

	scroller _ scroller copy.
	scroller privateOwner: self.
	"transform?"
	self privateSubmorphs: (Array with: scroller).

	textMorph _ textMorph copy.
	textMorph privateOwner: scroller.
	textMorph setEditView: self.
	scroller privateSubmorphs: (Array with: textMorph).

	scrollBar _ scrollBar copy.
	scrollBar privateOwner: self.
	scrollBar model: self.
	"owner submorphs model"

	^ self! !

!GoMeat methodsFor: 'experimental' stamp: 'ms 9/4/1998 16:27'!
textMorph
	^ textMorph! !


!GoMeat methodsFor: 'debug' stamp: 'ms 8/10/1998 13:08'!
layoutChanged
	^ super layoutChanged.
"	fullBounds_nil.
	TEMP/EXPLORATORY
	we get many such call from TextMorph, and some embarassing
	ones during recalc that lead to infinite recursion. 
	See later how we deal with that."

	"see if we can discriminates our initiating a change of layout.
	(bounds height = self getTextHeight) ifFalse: [
		self boundsGivenMax: (bounds withHeight: maxHeight)]."! !


Model subclass: #GoTranslator
	instanceVariableNames: 'meme cmdMap cmdShiftMap '
	classVariableNames: 'DefaultCmdMap DefaultCmdShiftMap ImgFamilies '
	poolDictionaries: ''
	category: 'Golgi-Basics'!
!GoTranslator commentStamp: '<historical>' prior: 0!
I translate memes (internal or external) so that headers (viewers) can access them uniformly.

If I am the translator for bigBrother, and we're filling a system window, I also act as the model for that window. Meaning that I receive - and manage - the 'release' and the 'okToChange' msgs.
!


!GoTranslator methodsFor: 'header link' stamp: 'miso 10/25/1999 13:55'!
addDependent: anObject
	"ignore requests from sysWins/scrollers. (& mk sure we hv only 1)"

	"I can be the 'model' for sysWin/scroller. Ignore them"
	(anObject isKindOf: GoHeader) ifFalse: [^ self].

	self dependents size > 0 
		ifTrue: [^ self error: '2 deps']
		ifFalse: [^ super addDependent: anObject].
! !

!GoTranslator methodsFor: 'header link' stamp: 'miso 10/28/1999 12:17'!
createYourHeaderGivenData: someData momHeader: aHeader

	| headerClass |
	headerClass _ self class headerClassFor: someData givenMomViewer: aHeader.
	^ headerClass withTranslator: self.! !

!GoTranslator methodsFor: 'header link' stamp: 'miso 10/25/1999 13:52'!
forgetHeaderAndMeme
"also takes care of removing self from meme-deps since i have no more dependents. so should now be called forgetHeaderAndMeme"

	self removeDependent: self header.
	self meme removeDependent: self.
! !

!GoTranslator methodsFor: 'header link' stamp: 'mich 10/3/1999 20:26'!
header

	^ self dependents first! !

!GoTranslator methodsFor: 'header link' stamp: 'miso 10/25/1999 13:56'!
header: aHeader

	^ self addDependent: aHeader! !


!GoTranslator methodsFor: '  properties' stamp: 'mich 10/5/1999 10:06'!
defaultColor
"only for meat. assume that header/wedge are off-limits. if want to allow temp-color that persist through session, can cache them in an iVar here and provide a defaultColor: accessor"

	self meme semanticType = #shadow ifTrue: [^ Color red].

^Color transparent
	"^ (self prefs getPref: #meatColor) ifNil: [Color transparent]."! !

!GoTranslator methodsFor: '  properties' stamp: 'ms 11/7/1998 12:03'!
defaultImageFamily

"	^ #(	(inert gray)
			(expanded green)
			(contracted red)	
		)
"
	^ self getImageFamily: #arrow

! !

!GoTranslator methodsFor: '  properties' stamp: 'ms 11/7/1998 12:05'!
meatClass

	^ GoMeat! !

!GoTranslator methodsFor: '  properties' stamp: 'miso 10/30/1999 16:34'!
meatLostFocus
"callback: headers send this msg after their meat stops being being focus, to allw me to take action. default does nothing."
! !

!GoTranslator methodsFor: '  properties' stamp: 'ms 9/22/1998 10:26'!
save: who

	who save: #global! !


!GoTranslator methodsFor: '  reorgs ' stamp: 'ms 7/3/1999 18:36'!
headerWantsADaughterAfter: headerOrSymbol
"called from GoHeader.procreate"

	self reorgsAllowed ifFalse: [^false].
	^ self meme createDaughterAfter: (self headerDescriptor2memeDescriptor: headerOrSymbol).! !

!GoTranslator methodsFor: '  reorgs ' stamp: 'miso 10/20/1999 13:16'!
headerWantsToGetOutOf: momHeader
"leave the mom I'm in, first in meme, then in header. I have no further business, since I only view meme under that particular mom. So I also want to be detached from my meme (which might continue to live under some other mom)"

	self reorgsAllowed ifFalse: [^false].

	^ self meme moveSelfOutOf: momHeader meme! !

!GoTranslator methodsFor: '  reorgs ' stamp: 'ms 7/3/1999 23:16'!
headerWantsToGoInto: newHeader afterSub: headerOrSymbol

	self reorgsAllowed ifFalse: [^false].
	^ self meme putSelfInto: newHeader meme
				after: (self headerDescriptor2memeDescriptor: headerOrSymbol)! !

!GoTranslator methodsFor: '  reorgs ' stamp: 'miso 10/20/1999 13:03'!
headerWantsToMoveOutOf: oldHeader into: newHeader afterSub: headerOrSymbol

	self reorgsAllowed ifFalse: [^false].
	^ meme moveSelfOutOf: oldHeader meme
			into: newHeader meme
			after: (self headerDescriptor2memeDescriptor: headerOrSymbol)

	"for mono-mom memes:
	^ meme moveSelfInto: newHeader meme after: headerOrSymbol"! !

!GoTranslator methodsFor: '  reorgs ' stamp: 'ms 11/3/1998 20:28'!
reorgsAllowed
	^ true! !


!GoTranslator methodsFor: '  wedge dict' stamp: 'ms 10/4/1998 00:35'!
getImageFamily: fSymbol

	^ self class getImageFamily: fSymbol
! !

!GoTranslator methodsFor: '  wedge dict' stamp: 'ms 10/3/1998 19:04'!
wedgeImageDict
"return the image dict for this class, ignoring superclasses. create one if absent"

	^ ImgFamilies! !

!GoTranslator methodsFor: '  wedge dict' stamp: 'ms 9/25/1998 14:31'!
wedgeImageDicts
"creates it if absent"

	^ self class wedgeImageDicts! !


!GoTranslator methodsFor: '  menus' stamp: 'miso 10/28/1999 12:34'!
buildMenuFrom: aList
"this is a commodity verb that allows to pass the list describing the item as an argument."

	^ (MenuMorph new defaultTarget: self) addSmartList: aList! !

!GoTranslator methodsFor: '  menus' stamp: 'miso 10/28/1999 12:33'!
colorPaletteFor: o

	| menu target |
	target _ (Compiler evaluate: o for: self logged: false).
	menu _ MenuMorph new defaultTarget: self.
	self itemsForColorPalette do: [:aColor | 
		menu	add: aColor asString  target: target  selector: #setColor:
				argument: aColor asSymbol ].
	menu addLine.
	menu add: 'tell me...' target: target selector: #setColor: argument: nil;
			popUpAt: self primaryHand position forHand: self primaryHand

"			add: 'tell me...'  target: sessionMngr  selector: #setColor:in:
				argumentList: (Array with: nil with: target);
"
! !

!GoTranslator methodsFor: '  menus' stamp: 'miso 10/29/1999 14:22'!
golgiMenu
"construct a menu for bigBrother"

^ (MenuMorph new defaultTarget: self) addSmartList: #(
		('rename'		rename)
		('backup'		backup)
		('save' 			saveAll)
		('misc'
			('edit jumpPoints' 		viewJumpPoints)
			('count headers'			showSubheaderCount))
		('prefs...'		subMenu	itemsForPrefs)
		-
		('dev...'
			('set version num' 		setVersion))
	).
	"add: 'save as...' subMenu: (self buildMenuFrom: self itemsForSaveAs)"! !

!GoTranslator methodsFor: '  menus' stamp: 'miso 11/1/1999 22:36'!
headerMenu

	^ (MenuMorph new defaultTarget: self) addSmartList:  #(
			('become a jump point'	becomeJumppoint)
			('hoist' 				hoist)
			('export' 			backup)
			-
			('misc...'
				('save' 					saveAll)
				('count headers'			showSubheaderCount)
				('temp colors'
					('text'				colorPaletteFor:	'self meatMorph')
					('header'			colorPaletteFor:	'self')
					('background'		colorPaletteFor:	'bigBrother')))
			('debug...'
				('kill cached headers'	globalKillCachedHeaders)
				('wedge is comment'		setCommentImage))
			('inspect...'
				('translator'				inspect:		'self translator')
				('meme'					inspect:		'self meme')
				('meme meat'			inspect:		'self meme content')
				-
				('prefs'					inspect:		'bigBrother prefs'))
		)


"		add: 'save as...' subMenu: (self buildMenuFrom: self itemsForSaveAs); "! !

!GoTranslator methodsFor: '  menus' stamp: 'miso 10/28/1999 12:32'!
itemsForColorPalette
	^ #(	transparent
			white
			gray
			green
			red
			blue
			yellow
		)
! !

!GoTranslator methodsFor: '  menus' stamp: 'miso 10/29/1999 13:50'!
itemsForPrefs

	^ #(('appearance...'
			('themes...'
				('plain'				plainTheme)
				('debug'				debugTheme))
			-
			('color'
				('overall'		colorPaletteFor:		overall)
				-
				('headers'		colorPaletteFor:		GoHeader)
				('text'			colorPaletteFor:		GoMeat)
				('scroller'		colorPaletteFor:		Golgi))
			('margins'
				('left'			queryMarginNumberFor:in:	(left GoHeader) )
				('right'			queryMarginNumberFor:in:	(right GoHeader) )
				('top'			queryMarginNumberFor:in:	(top GoHeader) )
				('bottom'		queryMarginNumberFor:in:	(bottom GoHeader) )
				-
				('wedge'		queryMarginNumberFor:in:	(wedge GoHeader) )
				('between subs'	queryMarginNumberFor:in:	(interSub GoHeader) )))
		)
! !

!GoTranslator methodsFor: '  menus' stamp: 'miso 10/28/1999 12:29'!
itemsForSaveAs
	^ #(
			('parenthesised text'		saveAs:		parens)
			('tabbed text'			saveAs:		tab)
			('xml'					saveAs:		xml)
			('dotHead'				saveAs:		dotHead)
		)
! !

!GoTranslator methodsFor: '  menus' stamp: 'miso 10/29/1999 14:35'!
perform: selector orSendTo: otherTarget
"In the menu I built, every menuItem without arguments is reworked by setInvokingView: (apparently for MVC compatibility) so as to not be directly performed by me (the legit target) but rather I am asket to perform:orSendTo:, and the Object default for that is to send to otherTarget. Usually the target is the model and otherTarget is the view so all is ok, but here the other target is ScrollPane (which is the invoker) instead of Golgi... So override. "

	^ self perform: selector! !


!GoTranslator methodsFor: '    items' stamp: 'miso 10/30/1999 15:30'!
debugTheme
	self header prefs setAllColorsTo: Color transparent.
	self header prefs colorPref: #gray for: #GoHeader.
	self header prefs colorPref: #yellow for: #GoMeat.
	self header prefs setMargin: #interSub in: #GoHeader to: 5.! !

!GoTranslator methodsFor: '    items' stamp: 'miso 10/30/1999 15:41'!
globalKillCachedHeaders
	"should really be in Golgi:HeaderBank"
	GoSniffer sniffer headerBank scratchHeaderBank! !

!GoTranslator methodsFor: '    items' stamp: 'miso 10/30/1999 15:38'!
hoist
	Golgi view: self meme! !

!GoTranslator methodsFor: '    items' stamp: 'miso 11/1/1999 22:36'!
inspect: anItemAsSymbol

	(Compiler evaluate: anItemAsSymbol for: self logged: false) explore! !

!GoTranslator methodsFor: '    items' stamp: 'miso 10/30/1999 15:31'!
plainTheme
	self header prefs colorPref: #transparent for: #GoHeader.
	self header prefs setMargin: #interSub in: #GoHeader to: 0.! !

!GoTranslator methodsFor: '    items' stamp: 'miso 10/30/1999 15:32'!
queryMarginNumberFor: whichMargin in: o
	| n target oldVal |
	target _ (Compiler evaluate: o for: self logged: false).
	oldVal _ target Margin: whichMargin.

	n _ 'Value for ', whichMargin printString, ' margin:' .
	n _ FillInTheBlank request: n initialAnswer: oldVal printString .
	n _ n asNumber.
"	n isTypeOf: Number ifFalse: [^self]."
	^ self header prefs setMargin: whichMargin in: o to: n.! !

!GoTranslator methodsFor: '    items' stamp: 'miso 10/30/1999 15:33'!
rename

	| name |
	name _ self meme content.
	name _ FillInTheBlank request: 'New name:' initialAnswer: name.
	name isEmpty ifFalse: [
		self header renameGolgiTo: name]! !

!GoTranslator methodsFor: '    items' stamp: 'miso 10/29/1999 13:50'!
saveAll
	self header bigBrother recursiveSave! !

!GoTranslator methodsFor: '    items' stamp: 'miso 10/30/1999 15:26'!
setVersion
	Golgi setVersion! !

!GoTranslator methodsFor: '    items' stamp: 'miso 10/30/1999 15:37'!
showSubheaderCount

	^ self inform: 'There are ', self meme countDaughtersRecursively asString, ' daughters'! !

!GoTranslator methodsFor: '    items' stamp: 'miso 10/30/1999 15:41'!
tab
	self header tab! !


!GoTranslator methodsFor: '  keys' stamp: 'ms 11/1/1998 16:57'!
buildDefaultCmdMap 

	"adapted from ParagraphEditor.initializeCmdKeyShortcuts.
	Initialize the (unshifted) command-key shortcut table. This implementation dooe nothing (ie i do not override header actions, i am the default translator) but it shows how to go about doing it."

	| theCmdMap cmds |
	theCmdMap _ Array new: 256.  "use temp in case of a crash"
	theCmdMap atAllPut: nil.

	"temp keep arrow lines here, might need them to implement header-hop"
	theCmdMap at: (28 + 1) put: #noop:.					"left arrow key"
	theCmdMap at: (29 + 1) put: #noop:.					"right arrow key"
	theCmdMap at: (30 + 1) put: #noop:.					"up arrow key"
	theCmdMap at: (31 + 1) put: #noop:.					"down arrow key"

	cmds _ #(
		"$e	doSomething"
	).
	1 to: cmds size by: 2 do: [ :i |
		theCmdMap at: ((cmds at: i) asciiValue + 1) put: (cmds at: i + 1).].

	^ theCmdMap! !

!GoTranslator methodsFor: '  keys' stamp: 'ms 11/1/1998 16:59'!
buildDefaultCmdShiftMap 
	"Initialize the shift-command-key (or control-key) shortcut table."

	| theCmdMap cmds |
	"shift-command and control shortcuts"
	theCmdMap _ Array new: 256.  "use temp in case of a crash"
	theCmdMap atAllPut: nil.

	cmds _ #(
	).

	1 to: cmds size by: 2 do: [ :i |
		theCmdMap at: ((cmds at: i) asciiValue + 1)		put: (cmds at: i + 1).
		theCmdMap at: (((cmds at: i) asciiValue - 96) + 1)	put: (cmds at: i + 1).
	].

	^ theCmdMap! !

!GoTranslator methodsFor: '  keys' stamp: 'ms 9/22/1998 15:46'!
defaultCmdMap 

	DefaultCmdMap ifNil: [DefaultCmdMap _ self buildDefaultCmdMap].
	^ DefaultCmdMap! !

!GoTranslator methodsFor: '  keys' stamp: 'ms 10/16/1998 18:32'!
defaultCmdShiftMap 
	DefaultCmdShiftMap ifNil: [DefaultCmdShiftMap _ self buildDefaultCmdShiftMap].
	^ DefaultCmdShiftMap! !

!GoTranslator methodsFor: '  keys' stamp: 'miso 10/30/1999 21:56'!
key: char combo: comboSymbol
	| theSelector keyNum  |
	theSelector _ nil.
	keyNum _ char asciiValue + 1.
	comboSymbol = #cmd ifTrue: [
		theSelector _ cmdMap at: keyNum].
	comboSymbol = #cmdShift ifTrue: [
		theSelector _ cmdShiftMap at: keyNum].
	theSelector ifNil: [
		^ nil].
	theSelector = #nil ifTrue: [
		^ nil].
	theSelector = #noop: ifTrue: [
		^ nil].
	self perform: theSelector.
	^ true
	"alway return true, else same keyDown is reprocessed and we get in a loop"! !


!GoTranslator methodsFor: 'meme properties' stamp: 'mich 10/3/1999 23:57'!
accessorTypeForDaughters
"some meme types require that their daughter be of a fixed type. a nil answer means that we will chose an accessor as a function of the meme being dressed"

	^ nil! !

!GoTranslator methodsFor: 'meme properties' stamp: 'ms 9/21/1998 23:14'!
daughters

	^ meme daughters! !

!GoTranslator methodsFor: 'meme properties' stamp: 'miso 10/8/1999 21:48'!
isInside: putativeMemeAncestor
	"this helps during drag&drop to prevent dropping inside myself... Delegate to model, as we might not be in the in the same outline"

	^ self meme isInside: putativeMemeAncestor! !

!GoTranslator methodsFor: 'meme properties' stamp: 'ms 9/21/1998 23:10'!
meme
	^ meme! !

!GoTranslator methodsFor: 'meme properties' stamp: 'ms 7/1/1999 22:53'!
meme: newMeme
"this is only accessed on translator creation and on reinstantiateMemes"

	meme _ newMeme.
	newMeme newDataReader: self! !

!GoTranslator methodsFor: 'meme properties' stamp: 'miso 10/30/1999 16:10'!
memeContent
	^ meme content! !

!GoTranslator methodsFor: 'meme properties' stamp: 'miso 10/30/1999 16:09'!
memeContent: newContent
"set the text of the meme, ignoring previous content. return whether was successful ('save' counts on it)."

	self meme content: newContent.
	^ true! !


!GoTranslator methodsFor: '  reorgs' stamp: 'ms 7/4/1999 00:39'!
dataChanged
	self dependents do: [:d | d refreshMeat]! !

!GoTranslator methodsFor: '  reorgs' stamp: 'miso 10/20/1999 13:42'!
dataGotOutOf: aMomMeme
"if meme left the mom I'm viewing it under, I have no further business, since I only view meme under that particular mom. So header needs to leave its mom and detach me from meme (which might continue to live under some other mom)"

	(self headerIsViewedUnder: aMomMeme) ifTrue: [self header dataGotOutOfMom "=suicide"]
! !

!GoTranslator methodsFor: '  reorgs' stamp: 'miso 10/25/1999 13:41'!
dataHasNewDaughter: newDaughterMeme
"signal that my header needs to refresh its daughters. this can be either upon newMeme creation, or newMeme mv into my meme. 
Note that in the latter case this may be a duplicate msg already signaled in the moved daughter with memeMovedInto:after: This is necessary since there are multiple views of data, and each view can have either me, or newDaughterMeme, or both. In case it has only me, we need this msg, in case it has only meme, we need the mv one."

	self header dressSubheaders 
	"Since header might not have dressed its daughters yet, and aSubmeme might be in the middle of them, it needs to make sure that they all get dressed. Easiest is to tell them all to dress, those that are already will ignore it"! !

!GoTranslator methodsFor: '  reorgs' stamp: 'miso 10/20/1999 13:44'!
dataMovedOutOf: oldMomMeme into: newMomMeme after: memeOrSymbol
"beware!! if data moved into newMomMeme, it doesn't mean that i will do a corresponding move. I will only do so if the prospective new mom is within the same viewer (or else to cumbersome to determine who goes where when multiple instance of me and newMom are present simultaneously). If mom is not in same viewer, this is equivalent to becomeOrphan. The whole buisiness of putting me into a new mom (ie the very existence of this method) is superfluous anyway, since newMoms will be sent a newDaughtersExist msg (so that we could just have had a dataGotOutOf: and newDaughtersExist). Kept this msg for slight optimisation: avoids recreating headers for every mv operation"

	| newMomHeader newSisterHeader |

	(self headerIsViewedUnder: oldMomMeme) ifFalse: [^false].
	newMomHeader _ self header bigBrother whoDressesThisMeme: newMomMeme.
	newMomHeader 
		ifNil: [ "not in our golgi. hara kiri. the real newMomHeader will create another daughter"
			self header dataGotOutOfMom.
			^ false] 
		ifNotNil: [
			newSisterHeader _ newMomHeader whichDaughterDressesThisMeme: memeOrSymbol.
			self header dataMovedOutOfMomInto: newMomHeader afterSub: newSisterHeader].

	^ true
! !


!GoTranslator methodsFor: '  misc' stamp: 'miso 10/12/1999 11:16'!
backup
	self meme backup! !

!GoTranslator methodsFor: '  misc' stamp: 'miso 10/30/1999 15:35'!
becomeJumppoint
"ask memeSoup to point to me as an officially recognised area, ie. an entry-point into the meme soup"

	meme ancestor addJumpPoint: meme! !

!GoTranslator methodsFor: '  misc' stamp: 'miso 10/29/1999 14:04'!
viewJumpPoints
	Golgi view: meme ancestor jumpPointsHolder! !


!GoTranslator methodsFor: 'misc' stamp: 'ms 9/22/1998 02:21'!
acceptableMemeDescriptor: headerOrSymbol
"we need to get the daughtr meme corresponding to headerOrSymbol, but it we cannot say 'headerOrSymbol meme' in case it is a symbol, so we need to test it."

	(headerOrSymbol isKindOf: Symbol) 
		ifTrue: [^ headerOrSymbol ]
		ifFalse: [^ headerOrSymbol meme ]! !

!GoTranslator methodsFor: 'misc' stamp: 'ms 11/4/1998 12:26'!
copyWithMeme
	^ self class meme: meme copyWithDaughters! !

!GoTranslator methodsFor: 'misc' stamp: 'ms 11/24/1998 11:02'!
familyAboutToChange
"private!! my headers are about leave their mom, sisters. Give those a chance to adapt. For instance removing a header in a script sets the script dirty"

	"dependents do: [:d | d setDirty]."! !

!GoTranslator methodsFor: 'misc' stamp: 'ms 7/2/1999 12:28'!
familyJustChanged
"private!! my headers are acquiring a new family (changing mom, sisters), give me a chance to adapt. For instance adding/moving a header under a comment in a script results in the incoming header being commented"

! !

!GoTranslator methodsFor: 'misc' stamp: 'mich 10/3/1999 20:34'!
flashDependents

	self dependents do: [: d | d flash]
! !

!GoTranslator methodsFor: 'misc' stamp: 'ms 7/3/1999 18:31'!
headerDescriptor2memeDescriptor: headerOrSymbol

	(headerOrSymbol isKindOf: Symbol) 
		ifTrue: [^ headerOrSymbol ]
		ifFalse: [^ headerOrSymbol meme ]! !

!GoTranslator methodsFor: 'misc' stamp: 'miso 10/16/1999 17:21'!
headerIsViewedUnder: aMomMeme
"our header might have several moms. see if the viewer i'm translating for is viewing the relevant one"

	| oldHeader |
	oldHeader _ self header headerAbove.
	oldHeader ifNil: [^false]. "happens when oldHeader is bigBro, and some other viewer on him mv"
	^ oldHeader meme == aMomMeme
! !

!GoTranslator methodsFor: 'misc' stamp: 'miso 11/1/1999 08:43'!
initialize
	"this is called at *end* of instance creation: fill in those values that are needed but have been left blank up to now"
	meme ifNil: [^ self error: 'cannot work without data'].
	cmdMap ifNil: [cmdMap _ self defaultCmdMap].
	cmdShiftMap ifNil: [cmdShiftMap _ self defaultCmdShiftMap].
	self class ensureBasicWedgeImages.
	dependents ifNil: [dependents _ Array new].
	self familyJustChanged.			"give me a chance to adapt to my environment"! !

!GoTranslator methodsFor: 'misc' stamp: 'miso 10/8/1999 16:42'!
printOn: aStream
	"used in inspectors, debuggers, etc."

	super printOn: aStream. aStream nextPutAll: 
		'[', self identityHash printString, '] for: '. self meme printOn: aStream.! !

!GoTranslator methodsFor: 'misc' stamp: 'ms 9/23/1998 15:16'!
understandsThisMeme: m
	^ self class understandsThisMeme: m! !


!GoTranslator methodsFor: 'bigBrother/ancestor -specific' stamp: 'ms 9/24/1998 10:53'!
authoriseBigBrotherSave: whoAsked

	^ true! !

!GoTranslator methodsFor: 'bigBrother/ancestor -specific' stamp: 'ms 11/7/1998 18:58'!
bigBrotherWasDiscarded: whoAsked! !

!GoTranslator methodsFor: 'bigBrother/ancestor -specific' stamp: 'miso 10/28/1999 12:28'!
buildGolgiMenu: m given: shiftKeyState
"when i'm the model for a container of Golgi, I relay this"

	^ self golgiMenu! !


!GoTranslator methodsFor: 'sysWin modelling' stamp: 'miso 7/7/1999 08:59'!
initialExtent
"sysWin calls to its model: defaultBackgroundColor windowReqNewLabel: okToChange step wantsSteps (stepTime) modelWakeUp initialExtent labelString windowIsClosing release"

	^ 350@400! !

!GoTranslator methodsFor: 'sysWin modelling' stamp: 'mich 10/3/1999 20:44'!
okToChange
	"Bizarre semantics: seems to mean something like areYouInADeletableState-or-areYouModifiableAtAll. But the answer to the two questions is not necessarily the same, I can be a modifiable object (i.e. the answer is 'yes') but dirty (i.e. the answer is 'no'). To preserve sanity I treat it as areYouInADeletableState only, ie. the call when sysWin is about to delete, "

	
	^ self header isItOkToDie! !

!GoTranslator methodsFor: 'sysWin modelling' stamp: 'miso 10/8/1999 17:02'!
release

	self header detachFromdata! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

GoTranslator class
	instanceVariableNames: 'wedgeFamilies '!

!GoTranslator class methodsFor: 'wedgeDict' stamp: 'ms 4/11/1999 21:55'!
addwedgeImage: i toFamily: f forState: s

	| newFamily oldFamily |
	newFamily _ Array new.
	oldFamily _ self sureWedgeImageDict at: f.
	oldFamily ifNil: [ "create it with minimal necessary values"
		oldFamily _ #((inert gray)(contracted gray)(expanded gray))].
	oldFamily do: [: onePair |
		onePair first = s
			ifTrue: [newFamily _ newFamily copyWith: (Array with: s with: i)]
			ifFalse: [newFamily _ newFamily copyWith: onePair]].
	^ self addwedgeImageFamily: newFamily called: f

! !

!GoTranslator class methodsFor: 'wedgeDict' stamp: 'ms 4/11/1999 20:57'!
addwedgeImageFamily: aFamily called: aName

	^ self sureWedgeImageDict at: aName put: aFamily

"	^ ImgFamilies at: aName put: aFamily	"! !

!GoTranslator class methodsFor: 'wedgeDict' stamp: 'ms 4/12/1999 12:54'!
ensureBasicWedgeImages
"root translator's default is to make sure that the #arrow family is present"

	| baseImage curFamily expandedImg contractedImg |

	"is the #arrow family already present?"
	self sureWedgeImageDict. "if none, getImageFamily: will fail"
	curFamily _ self getImageFamily: #arrow.
	curFamily isEmpty ifFalse: [^self].

	baseImage _ Form extent: 6@3			"upArrow, copied from ScrollBar"
					fromArray: #(2r11e28 2r1111e27 2r111111e26)
					offset: 0@0.
"	baseImage replaceColor: Color white withColor: Color transparent.	"
	
	curFamily _ Array new: 3. 
	expandedImg _ baseImage rotateBy: #pi centerAt: 0@0.  
	"must rotate before change white"
	expandedImg depth = 1 ifTrue: [
		expandedImg _ ColorForm mappingWhiteToTransparentFrom: expandedImg].
	curFamily at: 1 put: 
		(Array with: #expanded with: expandedImg).
	contractedImg _ baseImage rotateBy: #right centerAt: 0@0. 
	contractedImg depth = 1 ifTrue: [
		contractedImg _ ColorForm mappingWhiteToTransparentFrom: contractedImg].
	curFamily at: 2 put: 
		(Array with: #contracted with: contractedImg).
	curFamily at: 3 put: (Array with: #inert with: #gray).
	self addwedgeImageFamily: curFamily called: #arrow.! !

!GoTranslator class methodsFor: 'wedgeDict' stamp: 'ms 12/5/1998 20:44'!
getImageFamily: fSymbol
"cycle through the imageDicts in me and my sups looking for the fSymbol family. return the first found so that subclasses can override superclass data"

	| family |
	self wedgeImageDicts do: [: d |
		family _ d at: fSymbol ifAbsent: [nil].
		family ifNotNil: [^family] ].

	^ Array new

"return an empty array if family is absent so that nothing gets changed in wedge"! !

!GoTranslator class methodsFor: 'wedgeDict' stamp: 'ms 4/11/1999 20:56'!
sureWedgeImageDict
"return the img dict for this class, ignoring superclass dicts. creates one if none exists."

	wedgeFamilies ifNil: [wedgeFamilies _ Dictionary new].
	^ wedgeFamilies

"	self sharedPools do: [: aPool |
		(aPool at: #isWedgeDict ifAbsent: [false]) ifTrue: [^ aPool]].

	aPool _ Dictionary new.
	aPool at: #isWedgeDict put: true.
	self addSharedPool: aPool.
	^ aPool"! !

!GoTranslator class methodsFor: 'wedgeDict' stamp: 'ms 4/11/1999 20:57'!
wedgeImageDict
"return the img dict for this class, ignoring superclass dicts. creates one if none exists."

	^ wedgeFamilies! !

!GoTranslator class methodsFor: 'wedgeDict' stamp: 'ms 4/11/1999 21:13'!
wedgeImageDicts
"return the set of img dicts defined in me and my superclasses"

	| allImgDicts |
	self name = #GoTranslator 
		ifTrue: [allImgDicts _ Array new]
		ifFalse: [allImgDicts _ self superclass wedgeImageDicts].
	wedgeFamilies ifNotNil: "avoid creating it inadvertently"
		[allImgDicts _ allImgDicts copyWith: self sureWedgeImageDict]	.
	allImgDicts isEmpty 
		ifFalse: [^ allImgDicts]
		ifTrue: [^ self error: 'cannot find any imgDict although should hv been created at init'].


"	| allImgDicts |
	allImgDicts _ Array new.
	self allSharedPools do: [: aPool |
		(aPool at: #isWedgeDict ifAbsent: [false]) 
			ifTrue: [allImgDicts _ allImgDicts copyWith: aPool]].

	allImgDicts isEmpty 
		ifFalse: [^ allImgDicts]
		ifTrue: [^ self error: 'cannot find any imgDict although should hv been created at init'].
"

"  based on imgDict in class var. doesnt wrk coz cant beoverriden.
	| curClass allImgDicts |
	allImgDicts _ Array new.
	curClass _ self class.
	[curClass isKindOf: GoTranslator] whileTrue: [
		allImgDicts _ allImgDicts copyWith: curClass wedgeImageDict].
	^ allImgDicts

	^ allImgDicts copyWith: aPool
"! !


!GoTranslator class methodsFor: 'class vars' stamp: 'ms 9/23/1998 15:02'!
acceptableMemeTypes
	^ #(Meme)! !

!GoTranslator class methodsFor: 'class vars' stamp: 'ms 9/23/1998 15:22'!
understandsThisMeme: m
	^ self acceptableMemeTypes includes: m class name! !

!GoTranslator class methodsFor: 'class vars' stamp: 'ms 9/26/1998 10:21'!
zapGlobals
	| thePool |
	DefaultCmdMap _ nil.
	DefaultCmdShiftMap _ nil.
	self sharedPools do: [: aPool |
		(aPool at: #isWedgeDict ifAbsent: [false]) ifTrue: [thePool _ aPool]].
	thePool ifNotNil: [self removeSharedPool: thePool]! !


!GoTranslator class methodsFor: 'instance creation' stamp: 'ms 7/3/1999 20:52'!
accessorClassFor: dataObjectOrSymbol givenMomViewer: momHeader

	(dataObjectOrSymbol isKindOf: CodeMeme) ifTrue: [^ GoTranslateSmalltalk].
	(dataObjectOrSymbol isKindOf: ParseNode) ifTrue: [^ GoTranslateSqueakParseTree].
	(dataObjectOrSymbol isKindOf: Meme) ifTrue: [^ GoTranslator].

	^ GoTranslator "default"! !

!GoTranslator class methodsFor: 'instance creation' stamp: 'miso 10/28/1999 12:19'!
createHeaderAndTranslatorFor: someData viewedInside: aHeader

	| translator |
	"find an appropriate translator and glue it onto the data"
	translator _ (self accessorClassFor: someData givenMomViewer: aHeader) meme: someData.
	^ translator createYourHeaderGivenData: someData momHeader: aHeader! !

!GoTranslator class methodsFor: 'instance creation' stamp: 'mich 10/2/1999 23:31'!
headerClassFor: dataObjectOrSymbol givenMomViewer: momHeader

	momHeader ifNil: [^ Golgi].

	^ GoHeader   "default"! !

!GoTranslator class methodsFor: 'instance creation' stamp: 'ms 9/23/1998 19:16'!
meme: aMemeRef
	^ super new 
		meme: aMemeRef;			"later download external refs"
		initialize! !

!GoTranslator class methodsFor: 'instance creation' stamp: 'ms 9/21/1998 21:54'!
new
	^ self error: 'i make no sense without a header and some data'! !


Morph subclass: #GoWedge
	instanceVariableNames: 'buttonName target state actWhen nextStateCallback actionDict imageDict joker '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Golgi-Basics'!
!GoWedge commentStamp: '<historical>' prior: 0!
ToDo:
 we don't know how to draw blocks yet.
 upgrade standard #pressed state?

I am a button, with several goodies:
 hot swappable multi-state: I can have as many states as you want, and you can add states during runtime.
 exit-action (pluggable): each state is associated to an exit-state action (and an enter-state action)
 separate hit-area from img-area: the actual button drawing is a subset of me, and the hit-area is me. you can set the look&feel of the two, thus having a background and an image.
 multiple img sets (hot swappable): each state is associated to an image, and you can swap the image at runtime.
 multiple img type: images can be just a Color, or a Form/ColorForm/ImageMorph

-=-=-=-=-=

you provide two types of methods (blocks), 
	those that specify what action to take when entering/exiting a given state,
	one that specifies how to calculate the next state.

The catch: 
In all methods (blocks) that you give me, 'self' does not refer to me (the button), but it rather refers to whoever created me. Ie whoever contained the blocks in the first place.  
	(This is true both for blocks that specify what action to take when entering/exiting a given state, and for the method telling me how to calculate the next step.)
	Typically, however, you need to refer to me in your nextState method (eg to know what my current state is). Thus, the block specifying how to compute the next state *must* take one argument. That argument will be initialized with a reference to me. 

Note: if you provide a #pressed state, it will be used while the mouse button is pressed down (to provide feedback). This is the only standard (ie hardcoded) state name. If you ignore it, nothing happens. If you provide nil value for any of its properties, that property is just ignored.



----
[PluggableButtonController
ThreePhaseButtonMorph / PluggableButtonMorph
Model.Switch(.Button)]

------


responsiveness is pretty important here, But we need to be able to set routines 'live' upon init. maybe use a variation on addSelector:withMethod: .
-=-=-=-=-=-=
Compatibility with previous: the threeStateButton allowed to pass arguments to switchState, we don't.!


!GoWedge methodsFor: 'public' stamp: 'ms 11/2/1998 10:51'!
imageFamily: aWedgeImageFamily
"ex imagesFromDescriptorArray: "

	aWedgeImageFamily do: [: oneImage | 
		oneImage ifNotNil: [self state: oneImage first image: oneImage second]].! !

!GoWedge methodsFor: 'public' stamp: 'ms 10/4/1998 13:48'!
jumpToState: theNewState
"change my appearance and my recorded state, but do not do any action associated with changes of state. Called externally when the change-actions are already done."

	state = theNewState ifTrue: [^self].
	state _ theNewState.
	self wearLookForState: state.
	^ state
! !

!GoWedge methodsFor: 'public' stamp: 'ms 9/21/1998 01:14'!
nextstateMethod: aBlock
	"remember that a block must take one argument, which will be
	the button it is acting in. See comments for this class."

	^ nextStateCallback _ aBlock. ! !

!GoWedge methodsFor: 'public' stamp: 'ms 9/21/1998 03:10'!
state: aStateName image: aDrawable
	| ubiq |
	ubiq _ aDrawable.
	(ubiq isKindOf: String) ifTrue: [ ubiq _ ubiq asSymbol ].

	imageDict at: aStateName put: (Array with: ubiq with: (self getImageType: ubiq)).

	aStateName = state ifTrue: [self subImage image: ubiq. self changed].! !

!GoWedge methodsFor: 'public' stamp: 'ms 9/21/1998 01:09'!
state: aStateName image: aDrawable startAction: aStartBlock stopAction: aStopBlock

	self state: aStateName image: aDrawable.
	self state: aStateName startAction: aStartBlock stopAction: aStopBlock.
! !

!GoWedge methodsFor: 'public' stamp: 'ms 9/21/1998 01:08'!
state: aStateName startAction: aStartBlock stopAction: aStopBlock
	"should become 'model addState: ..."

	| cleanStartBlock cleanStopBlock |
	"clean up because #nil <> nil, and thus ifNotNil: failed..."
	aStartBlock = #nil 
		ifTrue: [cleanStartBlock _ nil ].
	aStopBlock = #nil 
		ifTrue: [cleanStopBlock _ nil].

	aStartBlock ifNotNil: [cleanStartBlock _ aStartBlock fixTemps].
	aStopBlock ifNotNil: [cleanStartBlock _ aStopBlock fixTemps].

	actionDict add: (Association key: aStateName value: 
						(Array	with: cleanStartBlock with: cleanStopBlock )).! !

!GoWedge methodsFor: 'public' stamp: 'ms 9/21/1998 00:55'!
stateFromDescriptor: aFullStateDescriptor

	^ self state: aFullStateDescriptor first 
		image: aFullStateDescriptor second 
		startAction: aFullStateDescriptor third 
		stopAction: aFullStateDescriptor fourth.! !

!GoWedge methodsFor: 'public' stamp: 'ms 9/23/1998 11:35'!
statesFromDescriptorArray: anArrayOfStateDescriptors
	"(called from class switch:states:)  "

	anArrayOfStateDescriptors do: [: oneDescriptor | self stateFromDescriptor: oneDescriptor ].! !


!GoWedge methodsFor: '  accessors' stamp: 'ms 9/20/1998 23:09'!
actWhen: condition
	"Accepts symbols:  #buttonDown, #buttonUp, and #whilePressed"

	actWhen _ condition! !

!GoWedge methodsFor: '  accessors' stamp: 'ms 9/24/1998 11:48'!
backgroundColor
	color! !

!GoWedge methodsFor: '  accessors' stamp: 'ms 9/20/1998 13:19'!
backgroundColor: c
	color _ c! !

!GoWedge methodsFor: '  accessors' stamp: 'ms 9/8/1998 13:44'!
buttonName
	^ buttonName! !

!GoWedge methodsFor: '  accessors' stamp: 'ms 9/8/1998 13:43'!
buttonName: n
	buttonName _ n! !

!GoWedge methodsFor: '  accessors' stamp: 'ms 9/24/1998 11:44'!
defaultImageSize
"decides how big a rectangle we draw when we get given a simple color as subimage. ignored by Forms fr now"

	^ self image maxExtent! !

!GoWedge methodsFor: '  accessors' stamp: 'ms 9/24/1998 11:42'!
defaultImageSize: s
"decides how big a rectangle we draw when we get given a simple color as subimage. ignored by Forms fr now"

	self image maxExtent: s! !

!GoWedge methodsFor: '  accessors' stamp: 'ms 11/7/1998 13:12'!
isWedge
	^ true! !

!GoWedge methodsFor: '  accessors' stamp: 'ms 9/20/1998 23:51'!
state
	^ state.! !

!GoWedge methodsFor: '  accessors' stamp: 'ms 9/21/1998 00:13'!
subImage
	^ submorphs first! !

!GoWedge methodsFor: '  accessors' stamp: 'ms 9/20/1998 23:55'!
target
	^ target! !

!GoWedge methodsFor: '  accessors' stamp: 'ms 9/8/1998 13:44'!
target: t
	target _ t! !


!GoWedge methodsFor: 'system API' stamp: 'ms 11/23/1998 10:36'!
click: evt
"we only get this upon yellow-click (option click on mac): upon yellow mouse-down, i ask if this is a click or a drag (#waitForClicksOrDrag:event:) and this method is invoked on clicks. the whole header is already selected."

! !

!GoWedge methodsFor: 'system API' stamp: 'ms 11/23/1998 10:04'!
drag: evt

	^ target beGrabbedByEvt: evt! !

!GoWedge methodsFor: 'system API' stamp: 'ms 9/21/1998 00:04'!
extent: aPoint

	bounds extent = aPoint ifFalse: [
		self changed.
		bounds _ bounds topLeft extent: aPoint.
		submorphs first center: bounds center.	"reposition image"
		self layoutChanged.
		self changed].
! !

!GoWedge methodsFor: 'system API' stamp: 'ms 8/11/1998 00:35'!
handlesMouseDown: evt

	^ true
! !

!GoWedge methodsFor: 'system API' stamp: 'miso 10/18/1999 09:39'!
mouseDown: evt

evt yellowButtonPressed ifTrue: [ "initiate a drag&drop operation"
	"transform coordinates to world-centered boundsInWorld"
	^ owner beGrabbedByEvt: evt].

evt shiftPressed ifTrue: [ 
	target ifNotNil: [
		(target class canUnderstand: #cmdMouseDownIn:while:) ifTrue: [
			^ target perform: #cmdMouseDownIn:while: with: buttonName with: evt ]]].

evt yellowButtonPressed ifTrue: [ 
	"ask to tell us whether it is a click or a drag. to do that HandMorph will compare this evt with nxt one. but this evt has been transformed to our local coord while next one will be used raw. this bugs, so retransform this evt to world coord"
	evt setCursorPoint: ((self transformFrom: World) invert: evt targetPoint).
	target askForFocus: evt hand.
	^ evt hand waitForClicksOrDrag: self event: evt].

"	^ owner beGrabbedByEvt: evt].

	target ifNotNil: [
		(target class canUnderstand: #cmdMouseDownIn:while:) ifTrue: [
			^ target perform: #cmdMouseDownIn:while: with: buttonName with: evt ]]]."

self wearLookForState: #pressed.	"The only standard state. hook for pressed feedBack"
actWhen == #buttonDown
	ifTrue: [self changeState: self getNextState]
	ifFalse: [super mouseDown: evt].
	"Allow on:send:to: to set the response to events other than actWhen"! !

!GoWedge methodsFor: 'system API' stamp: 'miso 10/18/1999 09:39'!
mouseMove: evt
"only called on move-while-mous-down ? mouseMove: "

(self containsPoint: evt cursorPoint)
	ifTrue: [

evt yellowButtonPressed ifTrue: [
	target ifNotNil: [
		(target class canUnderstand: #cmdMouseMoveIn:while:) ifTrue: [
			^ target perform: #cmdMouseMoveIn:while: with: buttonName with: evt ]]].

	actWhen == #whilePressed 
		ifTrue: [self changeState: self getNextState]
		ifFalse: [super mouseMove: evt]]
		"Allow on:send:to: to set the response to events other than actWhen"! !

!GoWedge methodsFor: 'system API' stamp: 'miso 10/17/1999 14:30'!
mouseUp: evt

actWhen == #buttonUp 
	ifTrue: [
		(self containsPoint: evt cursorPoint)
			ifTrue: [ self changeState: self getNextState ]
			ifFalse: [ target ifNotNil: [target mouseUpBalk: evt] ]
			"Allow owner to keep it selected for radio buttons"]				
	ifFalse: [super mouseUp: evt
		"Allow on:send:to: to set the response to events other than actWhen"]	
! !


!GoWedge methodsFor: 'priv' stamp: 'miso 10/28/1999 12:13'!
changeState: theNewState
"complete change of state: action to get out of previous, action to get into new, redraw self. Follows  user click"

	| act |
	state = theNewState ifTrue: [^ state].

	self wearLookForState: theNewState.

	act _ self getStopActionFor: state.
	act ifNotNil:  [ act value ].		"act ifNotNil: [ target perform: act ]. "

	act _ self getStartActionFor: theNewState.
	act ifNotNil:  [ act value ].

	^ state _ theNewState! !

!GoWedge methodsFor: 'priv' stamp: 'ms 11/2/1998 14:22'!
drawOn: aCanvas 

	aCanvas fillRectangle: "(self bounds insetBy: 1)" bounds color: color.
! !

!GoWedge methodsFor: 'priv' stamp: 'ms 9/23/1998 12:43'!
getImageForState: aState
"get the image associated with this state, and if no such state, return nil. Note that what is returned is a collection consisting of the object to be drawn, and then the type of object it is. Three types are allowed: a form, a color [as string, or symbol] (in which case the button bounds will be filled with that color), and a block (in which case the block will be executed and will be expected to draw the button). Returning the image type along with the image allows us not to compute it all the time..."

	^ imageDict at: aState ifAbsent: [ ^ nil ].
! !

!GoWedge methodsFor: 'priv' stamp: 'ms 9/21/1998 01:15'!
getNextState
"Call the method computing what to do, which was provided to us on init. That method should take one argument: me."

	^ nextStateCallback value: self.! !

!GoWedge methodsFor: 'priv' stamp: 'ms 9/21/1998 01:25'!
getStartActionFor: aState
	| theAct |
	theAct _ actionDict at: aState  ifAbsent: [ nil ].
	theAct ifNotNil: [
		theAct _ theAct first ].
	^ theAct.! !

!GoWedge methodsFor: 'priv' stamp: 'ms 9/21/1998 01:25'!
getStopActionFor: aState
	| theAct |
	theAct _ actionDict at: aState  ifAbsent: [ nil ].
	theAct ifNotNil: [
		theAct _ theAct second ].
	^ theAct.! !

!GoWedge methodsFor: 'priv' stamp: 'ms 10/4/1998 01:18'!
initialize
	super initialize.

	imageDict _  Dictionary new. 
	color _ Color transparent.
	self addMorph: (UbiqImage image: #red center: bounds center maxExtent: 3@3).

	actionDict _ Dictionary new.
	nextStateCallback _ []. 

	actWhen _ #buttonDown! !

!GoWedge methodsFor: 'priv' stamp: 'ms 9/26/1998 12:09'!
wearLookForState: theNewState

	| imageProperties |
	imageProperties _ self getImageForState: theNewState. "a Collec"
	imageProperties ifNil: [ ^ nil ].

	self subImage image: imageProperties first.
	self changed.
! !


!GoWedge methodsFor: 'experimental' stamp: 'ms 9/21/1998 01:11'!
getImageType: theImage

	(theImage isKindOf: ImageMorph orOf: Form) ifTrue: [ ^ #aForm ].
	(theImage isKindOf: Symbol orOf: String) ifTrue: [ ^ #aSymbol ].
	(theImage isKindOf: BlockContext) ifTrue: [ ^ #aBlock ].

	^ self error: 'OpWedge cannot add this image to its repertoire, because I dont understand what type of image it is: ', (theImage class asString).! !

!GoWedge methodsFor: 'experimental' stamp: 'ms 8/11/1998 21:15'!
joker
"Joker is a variable for use in the method that you provide in order to calculate the next state (stored in the theNextstateMethod var). Joker is unused by the button class as is; it is just a convenience to be able to pass more powerfull nextState methods, eg. remembering past states."

	^ joker.
! !

!GoWedge methodsFor: 'experimental' stamp: 'ms 8/11/1998 12:05'!
joker: aValue
	^ joker _ aValue.! !


!GoWedge methodsFor: '  menu' stamp: 'miso 10/17/1999 11:36'!
handleEvent: evt
"even a steady mouse on a btton receives mouseMove: so we can use this even to poll for cmdKeys, when those will be reported by Sensor."! !

!GoWedge methodsFor: '  menu' stamp: 'ms 9/9/1998 14:24'!
handlesMouseOver: evt
"for future use, to show a menu cursor if a cmd key i pressed while mouse is in wedge"

	^ false
! !

!GoWedge methodsFor: '  menu' stamp: 'ms 9/9/1998 14:22'!
mouseEnter: evt
"for future use, to show a menu cursor if a cmd key i pressed while mouse is in wedge"

	evt hand startReportingEventsTo: self.
! !

!GoWedge methodsFor: '  menu' stamp: 'ms 9/9/1998 14:22'!
mouseLeave: evt
"for future use, to show a menu cursor if a cmd key i pressed while mouse is in wedge"
	evt hand stopReportingEventsTo: self.! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

GoWedge class
	instanceVariableNames: ''!

!GoWedge class methodsFor: 'instance creation' stamp: 'ms 8/11/1998 13:28'!
defaultComputingOfNextState
	"just toggle to the next state..."! !

!GoWedge class methodsFor: 'instance creation' stamp: 'ms 8/11/1998 00:19'!
defaultStates

	^#(	(#on 'green' #enterOn #exitOn)
		(#off red #enterOff #exitOff) )

"	(#on 	#[: aCanvas me aColor | aCanvas fillRectangle: me bounds color: color]
 #enterOn #exitOn)	"

! !

!GoWedge class methodsFor: 'instance creation' stamp: 'ms 9/8/1998 13:44'!
name: aN target: aT switch: aBlock states: anArrayOfStateDescriptors

	| b |
	b _ self switch: aBlock states: anArrayOfStateDescriptors.
	b 	buttonName: aN;
		target: aT.	
	^ b 
! !

!GoWedge class methodsFor: 'instance creation' stamp: 'ms 8/11/1998 19:22'!
newDefault
	^ self switch: self defaultComputingOfNextState states: self defaultStates! !

!GoWedge class methodsFor: 'instance creation' stamp: 'ms 9/21/1998 01:13'!
switch: aBlock
	| b |
	b _ super new.
	b 	nextstateMethod: aBlock.
	^ b 
! !

!GoWedge class methodsFor: 'instance creation' stamp: 'ms 9/21/1998 01:13'!
switch: aBlock states: anArrayOfStateDescriptors

	| b |
	b _ super new.
	b 	statesFromDescriptorArray:  anArrayOfStateDescriptors;
		nextstateMethod: aBlock.
	^ b 
! !


GoHeader subclass: #Golgi
	instanceVariableNames: 'lastFocus '
	classVariableNames: 'ScrollPaneColor '
	poolDictionaries: ''
	category: 'Golgi-Basics'!
!Golgi commentStamp: '<historical>' prior: 0!
I am the invisible header that sits atop of all root header and contains them (I used to be called GoBigBrother). My meat is invisible but can be used for a variety of purposes: in normal outlines it contains the title of the outline, in code-outlines it contains the stamp of the code.

get ScrollPaneColor out of me. rewrite all pref-external pref also!!!


!Golgi methodsFor: 'general properties' stamp: 'ms 9/12/1998 18:41'!
leftMargin
	^ 0! !

!Golgi methodsFor: 'general properties' stamp: 'miso 10/25/1999 13:57'!
translator: a
	translator _ a.
	a header: self.

	"do not update color/meat/wedge!!"

! !


!Golgi methodsFor: 'meat & wedge' stamp: 'miso 11/2/1999 17:11'!
content
"this is neutral between headerMeat and memeMeat. Interpreted as headerMeat if there is some, and memeMeat otherwise (eg in bigBrother)"
	^ self memeMeat! !

!Golgi methodsFor: 'meat & wedge' stamp: 'miso 11/2/1999 17:12'!
headerMeat
"this asks for the content fo the pane, not of the meme. since we have none, return an empty string."
	^ self error: 'can i remove this now that ''content'' has been introduced?'! !

!Golgi methodsFor: 'meat & wedge' stamp: 'ms 8/16/1998 16:50'!
setWedgeContracted
! !

!Golgi methodsFor: 'meat & wedge' stamp: 'ms 8/17/1998 02:28'!
setWedgeExpanded
! !


!Golgi methodsFor: 'subheaders' stamp: 'miso 10/13/1999 10:29'!
checkForEmptySubPane
"make sure we always have at least one subheader header"

	self subheaders size = 0 ifTrue: [ 
		self dressSubmeme: (Meme string: '' mom: self meme after: #last)]! !

!Golgi methodsFor: 'subheaders' stamp: 'mich 10/3/1999 23:30'!
mainHeader
	^ self subheaders first! !

!Golgi methodsFor: 'subheaders' stamp: 'ms 7/3/1999 23:59'!
refreshFromMemes
"called when someone cached us but fears that we still contain user-discarded dirt"
	self hasHiddenDirt ifFalse: [^self].
	self subheaders do: [: h | h refreshFromMemes].
	meatIsDirty _ false! !

!Golgi methodsFor: 'subheaders' stamp: 'miso 10/10/1999 10:51'!
refreshMeat
"if the content of my meme changes, it will call this (via translator.dataChanged). I don't care."! !

!Golgi methodsFor: 'subheaders' stamp: 'miso 10/24/1999 15:25'!
walkHeadersWith: aOneArgumentBlock
"the block is evaluated with each (expanded) header in turn as the argument, except for bigBrother"

	self subheaders do: [:s | s walkHeadersWith: aOneArgumentBlock ]
! !


!Golgi methodsFor: 'aboveMe' stamp: 'miso 10/28/1999 12:04'!
bigBrother
	^ self! !

!Golgi methodsFor: 'aboveMe' stamp: 'miso 10/10/1999 11:26'!
container
	^ self scrollPane owner! !

!Golgi methodsFor: 'aboveMe' stamp: 'mich 10/3/1999 23:26'!
headerAbove

	^ nil! !

!Golgi methodsFor: 'aboveMe' stamp: 'mich 10/3/1999 23:24'!
ownerChanged
"needed when we are embedded in non system window."

	owner width ~~ self width ifTrue: [
		bounds _ bounds withWidth: owner width.
		fullBounds _ nil ]

"	bounds _ bounds origin corner:
				(bounds origin x + owner width) @ (bounds origin y + owner height).
	fullBounds _ nil. "! !

!Golgi methodsFor: 'aboveMe' stamp: 'miso 10/28/1999 12:05'!
world
"I inherit a modified version of this from GoHeader (asking me directly). Escape that, go back to normal version."

	^ owner == nil ifTrue: [nil] ifFalse: [owner world]! !


!Golgi methodsFor: 'display' stamp: 'mich 10/3/1999 23:32'!
changed
"since our fullBounds calc recurses to us, we cannot do the standard 'invalidRect: self fullBounds', that would be a vicious circle. Both formulations below seem to yield equivalent results."

	self invalidRect: bounds	

"	fullBounds ifNotNil: [ self invalidRect: fullBounds ]	"
! !

!Golgi methodsFor: 'display' stamp: 'ms 10/1/1998 13:41'!
displayWorld
	
"this is a hack to allow keeping displayWorld in expand subs, in order to speed it up. during construction of the golgi, we are the topmostMorph and this msg gets to us."! !

!Golgi methodsFor: 'display' stamp: 'miso 10/9/1999 13:07'!
fullBounds
| oldbounds |
"We always have 1-and-only-1 submorph: a subHeader pane. Also, we need to read bounds into fullBouds only after boundsGivenTopline: coz it will generate tons of layoutChanged which will reset our fullBounds to nil..."

	oldbounds_bounds.

	fullBounds ifNil: [
		submorphs isEmpty ifTrue: [self halt].
		fullBounds _ self boundsGivenTopline: bounds].

	"horrendous trick to get slider in scrollbar to update as we change"
	oldbounds=bounds ifFalse: [owner owner setScrollDeltas] "extent:" .

	^ fullBounds.


		"a little trick to put golgi into a non sysWin mom: (use ownerChanged instead)"
"		owner ifNotNil: [
			bounds setOrigin: 0@0 corner: owner extent ]."

"		sBounds _ bounds.
		submorphs do: [:s| sBounds _ sBounds withTop: (s boundsGivenMax: sBounds)].
"! !

!Golgi methodsFor: 'display' stamp: 'miso 10/8/1999 20:13'!
isExpanded

	^ submorphs includes: paneToHeaderLink

"could just return false, as this is asked only when we first expand "! !

!Golgi methodsFor: 'display' stamp: 'miso 10/9/1999 12:59'!
layoutChanged
"just trigger recalc of subs by nil-ing fullBounds. no upwards percolation since I change size only when owner tells me to. no downwards since that is done in fullBounds recalc. "

	fullBounds _ nil.

	"gets called when:
	 I am being added, in addMorphFront:, before removing 
	me from old owner, so that I can patch up things there.
		Since OutlinerMorph and HeaderPane cannot be moved as such, 
		we do not care about that call. (headers do however, and they need
		tell their owner that they left.
	Something has just been added to me. Just triggering recalc is then ok.
	"
! !


!Golgi methodsFor: 'focus' stamp: 'ms 7/4/1999 00:55'!
handlesMouseOver: evt
	^ true! !

!Golgi methodsFor: 'focus' stamp: 'miso 10/14/1999 09:00'!
lastFoci
"keep multiple foci in anticipation of being able to handle multiple hands working on us. For now just send our unique focus, as list"

	^ Array with: lastFocus! !

!Golgi methodsFor: 'focus' stamp: 'ms 11/4/1998 01:01'!
lastFocus
	^ lastFocus! !

!Golgi methodsFor: 'focus' stamp: 'miso 10/9/1999 10:33'!
lastFocus: f

	f 
		ifNil: ["should check wether we have subs. but we always do..." 
			self mainHeader askForMeatFocus]
		ifNotNil: [lastFocus _ f]! !

!Golgi methodsFor: 'focus' stamp: 'miso 10/30/1999 17:02'!
mouseEnter: event

	self lastFocus 
		ifNil: [self mainHeader askForMeatFocus: event hand]
		ifNotNil: [lastFocus askForFocus: event hand].! !

!Golgi methodsFor: 'focus' stamp: 'miso 10/14/1999 09:02'!
submorphHasFocus: m

	^ lastFocus = m
	"^ self lastFoci includes: h"
! !


!Golgi methodsFor: 'save/close' stamp: 'miso 10/13/1999 10:52'!
detachFromdata
"this is used when the golgi pane is getting deleted. Called from sysWin.delete->translator(=model).release"

	super detachFromdata.
	GoSniffer sniffer viewClosingDown: self.	! !

!Golgi methodsFor: 'save/close' stamp: 'ms 7/4/1999 00:56'!
hasHiddenDirt
"do we have dirt that was discarded by the user"

	^ meatIsDirty! !

!Golgi methodsFor: 'save/close' stamp: 'ms 7/3/1999 23:43'!
isDirty
"ignore meatIsDirty, i use that var to note when i contain discarded changes"
	^ self subsAreDirty 
! !

!Golgi methodsFor: 'save/close' stamp: 'miso 10/25/1999 12:37'!
recursiveSave
"saving the whole golgi. first consult with translator that it is ok to save the full monty."

	self subsAreDirty ifFalse: [ self flash. ^ false ].
	(translator authoriseBigBrotherSave: self) ifFalse: [ ^ false ].
	^ super recursiveSave
		ifFalse: [^false]
		ifTrue: [meatIsDirty _ false. ^true]. "could reset 	meatIsDirty in an override of localSave"! !


!Golgi methodsFor: 'creation' stamp: 'miso 10/25/1999 12:43'!
initialize

	super initialize.

	bigBrother _ self.
	wedge _ nil.
	submorphs _ Array new. "super put wedge there"
	color _ Color transparent "white".! !


!Golgi methodsFor: 'asMainPane' stamp: 'miso 10/30/1999 16:17'!
OBSOLETEMaybeReinstantiateMemes
"link all headers to a fresh meme. set the content of the fresh meme to the content of the header. This is used to when user wants to keep changes without dirtying original memes. (Created for script editing when selector name is changed: old selctor content must remain, but new changes must be kept too.) "
	
	| theBlock |
	theBlock _ [: header |
		header resetMeme: header meme copy.
		header memeMeat: header headerMeat.
		header meme putSelfInto: (header owner 
									ifNotNil:[header headerAbove meme]
									ifNil:[nil]) 
					after: #last].

	translator meme: Meme new.
	self walkHeadersWith: theBlock.
	super recursiveSave


"		header resetMeme: (Meme addWithString: s headerMeat
							mom: (s owner 
									ifNotNil:[s headerAbove meme]
									ifNil:[nil])   
							after: #last)].
"
! !

!Golgi methodsFor: 'asMainPane' stamp: 'miso 10/30/1999 16:09'!
renameGolgiTo: aName
	self translator memeContent: aName.
	(self scrollMorph owner isKindOf: SystemWindow) 
		ifTrue: [self scrollMorph owner setLabel: aName]! !

!Golgi methodsFor: 'asMainPane' stamp: 'mich 10/3/1999 23:15'!
scrollMorph
	^ owner owner! !

!Golgi methodsFor: 'asMainPane' stamp: 'ms 9/23/1998 14:25'!
scrollPane
	^ owner owner! !

!Golgi methodsFor: 'asMainPane' stamp: 'ms 9/12/1998 02:08'!
scrollPaneColor
	^ self class ScrollPaneColor! !

!Golgi methodsFor: 'asMainPane' stamp: 'ms 9/23/1998 14:26'!
scrollPaneColor: c
	self scrollPane color: c! !

!Golgi methodsFor: 'asMainPane' stamp: 'miso 10/28/1999 12:07'!
setColor: c

	owner owner color: 
		((c isKindOf: String "orSymbol!!") 
			ifTrue: [Color perform: c]
			ifFalse: [c]).
! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Golgi class
	instanceVariableNames: ''!

!Golgi class methodsFor: 'prefs' stamp: 'ms 9/12/1998 01:53'!
ScrollPaneColor	
	ScrollPaneColor ifNil: [ScrollPaneColor _ Color transparent].
	^ ScrollPaneColor
! !

!Golgi class methodsFor: 'prefs' stamp: 'ms 9/12/1998 01:56'!
ScrollPaneColor: c
	ScrollPaneColor _ c
! !

!Golgi class methodsFor: 'prefs' stamp: 'ms 9/12/1998 02:00'!
setColor: c updating: listOfViews
"reset the pref for color of top level, ie. scroller, and notify all existing scrollers of the change."

	ScrollPaneColor _ c.
	listOfViews ifNotNil: [ listOfViews do: [:v | v scrollPaneColor: c ]]! !


!Golgi class methodsFor: 'golgi entrance points' stamp: 'miso 10/12/1999 11:43'!
start

	self worldMenu: World primaryHand! !

!Golgi class methodsFor: 'golgi entrance points' stamp: 'miso 10/12/1999 11:26'!
worldMenu: requestingHand

	^ MemeSoup mainSoup worldMenu: requestingHand
! !


!Golgi class methodsFor: '  creating a viewer' stamp: 'miso 10/11/1999 08:20'!
dataInUnopenedWindow: data


	self prefs checkCriticalPrefs. "before creating anything"
	^ self golgInUnopenedWindow: (self dress: data)! !

!Golgi class methodsFor: '  creating a viewer' stamp: 'miso 10/30/1999 16:01'!
golgInUnopenedWindow: theGolg
"this and all the view* methods should be in - and used to be in - GoWindow.vewUnopened  - but that would require setting up a class with just a couple of methods. So we sacrifice elegance to compactness..."

	| thePane |
	thePane _ ScrollPane new.
	thePane	model: theGolg translator; "so menu-bldg is sent there"
			getMenuSelector: #buildGolgiMenu:given:.
	thePane scroller offset: 0@0.
	thePane scroller addMorph: theGolg.
	thePane setScrollDeltas. "shouldn't this be done automatically when add sub morph to a scrollpane??"

	^ SystemWindow new 
		 	"extent: 250 @ 300;" 
			model: theGolg translator;
			addMorph: thePane frame: (0 @ 0 corner: 1 @ 1);
			setLabel: theGolg memeMeat! !

!Golgi class methodsFor: '  creating a viewer' stamp: 'mich 10/2/1999 23:36'!
view: whatever
"a shorthand for viewInWindow:inWorld:"

	^ self  view: whatever inWorld: World! !

!Golgi class methodsFor: '  creating a viewer' stamp: 'mich 10/2/1999 23:35'!
view: something inWorld: w
"a shorthand for viewInWindow:inWorld:"

	^ self viewInWindow: something inWorld: w! !

!Golgi class methodsFor: '  creating a viewer' stamp: 'mich 10/2/1999 23:36'!
viewInWindow: whatever

	^ self  view: whatever inWorld: World! !

!Golgi class methodsFor: '  creating a viewer' stamp: 'miso 10/11/1999 08:20'!
viewInWindow: data inWorld: w

	| theWin theGolg |
	self prefs checkCriticalPrefs. "before creating anything"

	theGolg _ Golgi dress: data.
	GoSniffer sniffer addBigBrother: theGolg.
	theWin _ self golgInUnopenedWindow: theGolg.
	w	ifNotNil: [theWin openInWorld: w].
	^ theWin! !

!Golgi class methodsFor: '  creating a viewer' stamp: 'miso 10/28/1999 13:06'!
viewIncoming
	self view: (Soups first daughterCalled: #incoming)! !


!Golgi class methodsFor: 'misc' stamp: 'miso 11/1/1999 08:42'!
checkGlobals
"create necessary globals upon install, called after fileIn of code. Avoid creating if you can, better do lazy-creation, if possible. Just ensure basic slots."

	"first make sure we have our slot in globals"
	Smalltalk at: #GolgiGlobals ifAbsent: [
		Smalltalk at: #GolgiGlobals put: Dictionary new].

	"then subslots for prefs"
	GolgiGlobals at: #Prefs ifAbsent: [
		GolgiGlobals at: #Prefs put: GoPreferences new].
	GolgiGlobals at: #CoffreFort ifAbsent: [
		GolgiGlobals at: #CoffreFort put: GoCoffreFort new].

	"generate arrow-forms and color pseudo wedges in codeHeaders"
	GoTranslator ensureBasicWedgeImages.
! !

!Golgi class methodsFor: 'misc' stamp: 'miso 10/5/1999 22:06'!
popUpMenuCarefully2: m
"not sure whether diff from 1, check later"
	"workaround for the fact that menus appearing towards the right edge have cursor in them and mouse up selects a menu item before user gets to see the menu... When the distance between cursor and right is not sufficient, we put menu to the left of the cursor."
	"tehPatch:
	showAt _ aPoint.
	maxWidth _ World bounds width. //self worldBounds width.
	self fullBounds. //make sure we know our size
	(maxWidth - showAt x) < self width  ifTrue: [//menu does not fit to our right
		showAt x > self width ifTrue: [
			//but it fits to our left
			showAt _ (showAt x  - self  width) @ showAt y]].
"
	| h showAt maxWidth menuWidth  |
	h _ World activeHand.
	h ifNil: [
		h _ World hands first].
	"-=-=-=  patch to put into popUpAt:forHand: -=-=-= "
	"showAt _ aPoint."
	showAt _ Sensor cursorPoint.
	"self worldBounds width."
	maxWidth _ World bounds width.
	m fullBounds.
	"make sure we know our size"
	menuWidth _ m width.
	(maxWidth - showAt x) < menuWidth ifTrue: [
		"menu does not fit to our right"
		showAt x > menuWidth ifTrue: [
			"but it fits to our left"
			showAt _ (showAt x - menuWidth) @ showAt y]		"-=-=-=-=-="].
	^ m popUpAt: showAt forHand: h! !

!Golgi class methodsFor: 'misc' stamp: 'miso 10/5/1999 22:09'!
popUpMenuCarefully: m
"workaround for the fact that menus appearing towards the right edge have cursor in them and mouse up selects a menu item before user gets to see the menu... When the distance between cursor and right is not sufficient, we put menu to the left of the cursor."

"tehPatch:
	showAt _ aPoint.
	maxWidth _ World bounds width. //self worldBounds width.
	self fullBounds. //make sure we know our size
	(maxWidth - showAt x) < self width  ifTrue: [//menu does not fit to our right
		showAt x > self width ifTrue: [
			//but it fits to our left
			showAt _ (showAt x  - self  width) @ showAt y]].
"
	| h showAt maxWidth menuWidth |
	h _ self world activeHand.
	h ifNil: [h _ World hands first].
	showAt _ Sensor cursorPoint.
	"-=-=-=  patch to put into popUpAt:forHand: -=-=-= "
	"showAt _ aPoint."
	maxWidth _ World bounds width. "self worldBounds width."
	m fullBounds. "make sure we know our size"
	menuWidth _ m width.

	(maxWidth - showAt x) < menuWidth  ifTrue: ["menu does not fit to our right"
		showAt x > menuWidth ifTrue: [
			"but it fits to our left"
			showAt _ (showAt x  - menuWidth) @ showAt y]].
	"-=-=-=-=-="

	^ m popUpAt: showAt forHand: h.! !

!Golgi class methodsFor: 'misc' stamp: 'miso 10/30/1999 15:26'!
setVersion

	| r |
	r _ self version.
	r _ FillInTheBlank request: 'New version:' initialAnswer: r.
	self version: r.! !

!Golgi class methodsFor: 'misc' stamp: 'miso 10/10/1999 11:23'!
version

	^ GolgiGlobals at: #version ifAbsent: [GolgiGlobals at: #version put: '0']! !

!Golgi class methodsFor: 'misc' stamp: 'miso 10/15/1999 14:02'!
version: newVersion

	^ GolgiGlobals at: #version put: newVersion! !


!Golgi class methodsFor: 'instance creation' stamp: 'ms 3/7/1999 03:39'!
dress: aMeme

	^ self dress: aMeme accessorType: nil! !

!Golgi class methodsFor: 'instance creation' stamp: 'miso 10/28/1999 12:20'!
dress: aMeme accessorType: aMemeAccessorClass

	| theBigBrother theAccessor |

	theBigBrother _ aMemeAccessorClass 
		ifNil: [GoTranslator createHeaderAndTranslatorFor: aMeme viewedInside: nil]
		ifNotNil: [
			theAccessor _ aMemeAccessorClass meme: aMeme.
			theAccessor createYourHeaderGivenData: aMeme momHeader: nil].

	theBigBrother
			dressSubheaders; 
			checkForEmptySubPane;
			unhideSubheaders.

	^ theBigBrother

! !


Model subclass: #Node
	instanceVariableNames: 'moms daughters content semanticType '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Golgi-Basics'!

!Node methodsFor: 'accessors' stamp: 'ms 7/2/1999 16:17'!
dataReaders
	^ self dependents! !

!Node methodsFor: 'accessors' stamp: 'ms 3/6/1999 04:19'!
daughters
	^ daughters! !

!Node methodsFor: 'accessors' stamp: 'ms 3/6/1999 04:20'!
daughters: d
	daughters_d! !

!Node methodsFor: 'accessors' stamp: 'ms 7/2/1999 22:20'!
moms
	^moms! !

!Node methodsFor: 'accessors' stamp: 'ms 7/2/1999 16:18'!
newDataReader: dr
	^ self addDependent: dr! !

!Node methodsFor: 'accessors' stamp: 'ms 3/6/1999 04:27'!
semanticType

	^ semanticType! !

!Node methodsFor: 'accessors' stamp: 'ms 3/6/1999 04:27'!
semanticType: s

	semanticType _ s! !

!Node methodsFor: 'accessors' stamp: 'miso 11/1/1999 23:11'!
sisterAfterMeInMom: aMomOfMine
	^ aMomOfMine daughterAfter: self! !

!Node methodsFor: 'accessors' stamp: 'miso 11/1/1999 23:12'!
sisterBeforeMeInMom: aMomOfMine
	^ aMomOfMine daughterBefore: self! !


!Node methodsFor: 'name & address' stamp: 'miso 7/5/1999 15:07'!
containsRelativeInternalUrl: rUrl

	(self localPath sameAs: rUrl first) ifFalse: [^false].
	rUrl size = 1 ifTrue: [^self].
	self daughters do: [: d | d containsRelativeInternalUrl: (rUrl copyWithout: rUrl first)].
	^ false! !

!Node methodsFor: 'name & address' stamp: 'miso 10/12/1999 10:35'!
externalName

	^ self name , FileDirectory dot , Utilities dateTimeSuffix, '.tree'
! !

!Node methodsFor: 'name & address' stamp: 'miso 7/5/1999 15:07'!
resolveRelativeInternalUrl: rUrl

	(self localPath sameAs: rUrl first) ifFalse: [^nil].
	rUrl size = 1 ifTrue: [^self].
	self daughters do: [: d | d resolveRelativeInternalUrl: (rUrl copyWithout: rUrl first)].
	^ nil! !


!Node methodsFor: 'content' stamp: 'miso 11/1/1999 10:55'!
content
	^ content! !

!Node methodsFor: 'content' stamp: 'miso 7/4/1999 18:09'!
content: c
	content _ c.		"^ meat acceptContents: t		contents: is more careful"
	self dataReaders do: [:r| r dataChanged].! !

!Node methodsFor: 'content' stamp: 'miso 11/2/1999 14:20'!
contentAsFlatText
"For fileOut. used to do with an adaptation of nextChunkPutWithStyle: but embedding !!s was too fragile"

	| t |
	t _ self content.
	t class == String ifTrue: [^t].
	t runs coalesce.
	"check if there is any style worth saving"
	(t runs values = (OrderedCollection new)) ifTrue: [^t asString].
	(t runs values = (OrderedCollection with: (Array with: TextFontChange font1))) ifTrue: [^t asString]. 
	^ String streamContents: [:stream | 
		stream nextPutAll: ']sqStyle['.
		t runs writeScanOn: stream.
		stream nextPutAll: ']'.
		stream nextPutAll: t asString].
! !

!Node methodsFor: 'content' stamp: 'miso 10/31/1999 17:52'!
contentFromFlattenedText: aString
"For fileIn. used to do with an adaptation of nextChunkPutWithStyle: but embedding !!s was too fragile"

	self content: (self unflattenContentString: aString)! !

!Node methodsFor: 'content' stamp: 'miso 11/1/1999 10:55'!
contentString
	"guarantee that meat will be a string"
	^ self content asString! !

!Node methodsFor: 'content' stamp: 'miso 10/31/1999 17:53'!
unflattenContentString: aString
"private. unflatten the string found in fileOuts"

	| peek stream runsRaw runStream runs |
	stream _ ReadStream on: aString.

	"Test for ]sqStyle[ tag"
	peek _ stream skipSeparatorsAndPeekNext.
	peek = $] ifFalse: [^ aString asText].  "no tag"
	(stream upTo: $[) = ']sqStyle' ifFalse: [^ aString asText].  "different tag"

	"Read and decode the style chunk"
	runsRaw _ stream upTo: $].	"style encoding"
	runStream _ ReadStream on: runsRaw from: 1 to: runsRaw size.
	runs _ RunArray scanFrom: runStream.

	^ Text basicNew setString: stream upToEnd setRunsChecking: runs.


"	t _ self content.
	t class == String ifTrue: [^t].
	t runs coalesce.
	(t runs values = (OrderedCollection with: (Array with: TextFontChange font1))) ifTrue: [^t asString]. // no style, save as string
	^ String streamContents: [:stream | 
		stream nextPutAll: ']sqStyle['.
		t runs writeScanOn: stream.
		stream nextPutAll: ']'.
		stream nextPutAll: t asString].
"
! !


!Node methodsFor: 'moms' stamp: 'ms 7/2/1999 22:16'!
addMom: aNewMom
	(self moms includes: aNewMom) ifTrue: [^ self error: 'cannot add', aNewMom printString, 'as mom to ', self printString, 'since it is already my mom'].
	self moms addLast: aNewMom! !

!Node methodsFor: 'moms' stamp: 'mich 10/4/1999 14:45'!
ancestor
	| curMom  |
	curMom _ self.
	[curMom primaryMom = nil] whileFalse: [
		curMom _ curMom primaryMom].
	^ curMom! !

!Node methodsFor: 'moms' stamp: 'ms 7/2/1999 19:04'!
indexInMom: aMom
	^ aMom daughterIndex: self ! !

!Node methodsFor: 'moms' stamp: 'miso 10/8/1999 21:24'!
isInside: aPutativeAncestor
"this is used during mv operations to check that we are not mving into something inside ourselves... (or into ourselves). Walk all moms up from aPutativeAncestor, if I can reach nil without meeting it, I am not in there"

	aPutativeAncestor = self ifTrue: [^true].
	self moms do: [: m | (m isInside: aPutativeAncestor) ifTrue: [^true]].
	^ false! !

!Node methodsFor: 'moms' stamp: 'miso 11/2/1999 17:26'!
killMom: aMom

	self moms remove: aMom ifAbsent: [self error: 'cannot kill mom, ',  aMom printString, ', coz it is not one of my moms....'].! !

!Node methodsFor: 'moms' stamp: 'mich 10/4/1999 17:05'!
primaryMom
"there is no real primary mom (all are equivalent), but some rare cases need to get just one mom (eg. url formation, ancestor search): give them the first"

	^ self moms isEmpty ifTrue: [^nil]
						ifFalse: [^self moms first]! !

!Node methodsFor: 'moms' stamp: 'miso 7/4/1999 18:51'!
secondaryMoms
	^ self moms copyWithout: self primaryMom! !


!Node methodsFor: 'daughters' stamp: 'mich 10/5/1999 14:06'!
countDaughtersRecursively

	| n |
	n _ self daughters size.
	self daughters do: [:d|
		n _ n + (d countDaughtersRecursively)].
	^ n
! !

!Node methodsFor: 'daughters' stamp: 'miso 10/6/1999 00:00'!
countPrimaryDaughtersRecursively

	| n |
	n _ self primaryDaughters size.
	self primaryDaughters do: [:d|
		n _ n + (d countPrimaryDaughtersRecursively)].
	^ n! !

!Node methodsFor: 'daughters' stamp: 'miso 10/30/1999 20:18'!
daughterAfter: aDaughter

	^ self daughterAtIndex: (self daughterIndex: aDaughter) + 1! !

!Node methodsFor: 'daughters' stamp: 'miso 10/30/1999 20:20'!
daughterAtIndex: anInteger

	anInteger < 1 ifTrue: [ ^ #root ].
	anInteger > daughters size ifTrue: [ ^ #last ].
	^ daughters at: anInteger.! !

!Node methodsFor: 'daughters' stamp: 'miso 10/30/1999 20:17'!
daughterBefore: aDaughter

	^ self daughterAtIndex: (self daughterIndex: aDaughter) - 1
! !

!Node methodsFor: 'daughters' stamp: 'miso 10/30/1999 19:46'!
daughterIndex: d
"returns 0 if d is not my daughter"
	^ daughters indexOf: d! !

!Node methodsFor: 'daughters' stamp: 'mich 10/4/1999 08:56'!
isPrimaryDaughter: d

	^ d primaryMom = self! !

!Node methodsFor: 'daughters' stamp: 'mich 10/4/1999 08:53'!
primaryDaughters
"answer with those daughters for whom I am a primaryMom"

	^ self daughters select: [:d| d primaryMom = self] ! !

!Node methodsFor: 'daughters' stamp: 'miso 10/6/1999 00:03'!
walkDaughtersWith: aOneArgumentBlock
"the block is evaluated with each daughters in turn as the argument"

	aOneArgumentBlock value: self.
	self daughters do: [:s | s walkDaughtersWith: aOneArgumentBlock]! !

!Node methodsFor: 'daughters' stamp: 'miso 10/6/1999 00:03'!
walkPrimaryDaughtersWith: aOneArgumentBlock
"the block is evaluated with each primaryDaughter in turn as the argument"

	aOneArgumentBlock value: self.
	self primaryDaughters do: [:s | s walkPrimaryDaughtersWith: aOneArgumentBlock]! !


!Node methodsFor: '  add/delete' stamp: 'ms 7/2/1999 23:23'!
createDaughterAfter: existingNode
"return nil if do not accept creation. Remember that existingNode can take some Symbol values. will need to be augmented to infer the type of node to create"

	| newMeme typeOfNode |
	"first decide what kind of meme should be created"
	existingNode = #root
		ifTrue: [typeOfNode _ self class]
		ifFalse: [typeOfNode _ existingNode class].
	newMeme _ typeOfNode new.

	newMeme putSelfInto:  self after: existingNode.
	^ newMeme.! !

!Node methodsFor: '  add/delete' stamp: 'miso 10/30/1999 19:46'!
deregisterDaughter: aDaughter

	| daughterIndex |
	(daughterIndex _ self daughterIndex: aDaughter) = 0 ifTrue: [^false].

	self daughters removeAt: daughterIndex.
	aDaughter killMom: self.
	^ true.! !

!Node methodsFor: '  add/delete' stamp: 'miso 10/30/1999 19:55'!
registerIncomingDaughter: aNewDaughter after: daughterOrSymbol
"The most primitive verb to add meme someplace, set both the mom and daughter sides. Building block for the self verbs. Returns the index of the newly added meme, and < 1 if something went wrong."

	| index |
	index _ nil.
	(self daughters includes: aNewDaughter) ifTrue: [^0].

	daughterOrSymbol ifNil: [
		self daughters addFirst: aNewDaughter. 
		index _ 1].
	(daughterOrSymbol = #root) ifTrue: [
		self daughters addFirst: aNewDaughter..
		index _ 1].
	(daughterOrSymbol = #last) ifTrue: 
		[ self daughters addLast: aNewDaughter. index _ self daughters size ].
	(index == nil) ifTrue: [
		"paranoia" (self daughters includes: daughterOrSymbol) ifFalse: [^0]. 
		self daughters add: aNewDaughter after: daughterOrSymbol.
		index _ (self daughters indexOf: daughterOrSymbol)+1. "there are 2 occurences of newM now"].

	aNewDaughter addMom: self.

	^ index! !


!Node methodsFor: 'moving' stamp: 'miso 11/2/1999 17:29'!
moveSelfOutOf: anOldMom
"if anOldMom is my only mom, this is = suicide. In that case I also tell all my daughters to stop hanging on to me (in case of them survives because it has several moms)"

	(anOldMom deregisterDaughter: self) ifFalse: [^ false]. "I wasn't in oldMomNode"
	self moms isEmpty ifTrue: [self daughters do: [: d | d killMom: self]].

	self dataReaders do: [:r| r dataGotOutOf: anOldMom].
	^ true! !

!Node methodsFor: 'moving' stamp: 'miso 10/30/1999 20:29'!
moveSelfOutOf: oldMomNode into: newMomNode after: indexOrSymbolOrMeme
"First transform daughterDescriptor into an index-independent descriptr, so that we can delete/add things safely (changing indexes). Notify both the mover and the new host of the movement. Return nil if cannot do it."

	| memeOrSymbol oldSisterBefore success |
	(newMomNode isInside: self) ifTrue: [^ false].

	"make sure indexOrSymbolOrMeme is not an index, so we can add/delete without obsoleting it"
	(indexOrSymbolOrMeme isKindOf: Number) 
		ifTrue: [memeOrSymbol _ newMomNode daughterAt: indexOrSymbolOrMeme]
		ifFalse: [memeOrSymbol _ indexOrSymbolOrMeme].

	"keep track of index in old mom, incase smthng goes wrong and we need to put it back there"
	oldSisterBefore _ oldMomNode daughterBefore: self.

	success _ oldMomNode deregisterDaughter: self.
		success ifFalse: [^ false]. "I wasn't in oldMomNode"
	success _ newMomNode registerIncomingDaughter: self after: memeOrSymbol.
		success = 0 ifTrue: [ "wasn't added. repair and tell user smthg is wrong"
			oldMomNode registerIncomingDaughter: self after: oldSisterBefore.
			self notify: 'I couldn''t be added to ', newMomNode printString, '. Nothing is lost in your data, but please contact the author abut this bug'.
			^ false].

	self dataReaders do: [:r| r dataMovedOutOf: oldMomNode into: newMomNode after: memeOrSymbol].	
	newMomNode dataReaders do: [:r| r dataHasNewDaughter: self]. "in case someone views newMom with me"

	^ true

"need to deregister *before* registering in the new place (against robustness) to avoid big complications when mving within same mom, especially when mving up (this would change our old index)."
! !

!Node methodsFor: 'moving' stamp: 'miso 10/8/1999 21:29'!
putSelfInto: newMom after: existingDaughter
"like moveSelfInto excep that it does not undo a previous state, it just adds itself to a new mom. Used for newly created memes."

	(newMom isInside: self) ifTrue: [^ false].
	newMom registerIncomingDaughter: self after: existingDaughter.
	newMom dataReaders do: [:d | d dataHasNewDaughter: self].
	^ true "might want to check index returned by register"
! !


!Node methodsFor: 'converting' stamp: 'miso 7/4/1999 19:02'!
asParensString
	^ String streamContents: [:s | self asParensStringOn: s]! !

!Node methodsFor: 'converting' stamp: 'miso 11/1/1999 11:09'!
asShortString
	| maxLength s |
	maxLength _ 20.
	s _ self contentString.
	s size > maxLength ifTrue: [s _ (s copyFrom: 1 to: maxLength), ' ...'].
	^s ! !

!Node methodsFor: 'converting' stamp: 'miso 7/5/1999 13:04'!
asString
	^ String streamContents: [:s | self asStringOn: s  
									withPrimaryMomRef: true 
									withDaughtersRef: true]! !

!Node methodsFor: 'converting' stamp: 'miso 7/5/1999 13:05'!
asStringWithoutDaughters

	^ String streamContents: [:s | self asStringOn: s
									withPrimaryMomRef: true 
									withDaughtersRef: false]! !


!Node methodsFor: '  onto stream' stamp: 'miso 11/1/1999 20:47'!
asParensStringOn: aStream
"a representation of an Array. each item of the array is a representation of a meme"

	^ self asParensStringOn: aStream withPrimaryMomRef: false! !

!Node methodsFor: '  onto stream' stamp: 'miso 10/12/1999 11:01'!
asParensStringOn: aStream withPrimaryMomRef: putPrimaryMom
"do not export daughters which are aliases/links, or else we will export them several times, creating confusion on import. These daughters have links to us in their mom fields, this will be used on import to restore the link"

	aStream nextPutAll: '('.
	self asStringOn: aStream withPrimaryMomRef: putPrimaryMom withDaughtersRef: false.

	aStream nextPutAll: '('. 
	self daughters do: [: d | 
		(self isPrimaryDaughter: d )
			ifTrue: [d asParensStringOn: aStream]
			ifFalse: [d internalPath storeOn: aStream. aStream space]].
	aStream nextPutAll: ')'.

	aStream nextPutAll: ')'.
! !

!Node methodsFor: '  onto stream' stamp: 'miso 10/31/1999 17:54'!
asStringOn: aStream withPrimaryMomRef: putPrimMom withDaughtersRef: putDaughters
"a simple non-recursive flattening of myself."

	"aStream nextPut: $'; nextPutAll: self contentAsFlatText; nextPut: $'; space."
	| theMoms |
	self contentAsFlatText storeOn: aStream.
	putPrimMom ifTrue: [theMoms _ self moms]
				ifFalse: [theMoms _ self secondaryMoms].
		aStream nextPutAll: '('.
		theMoms do: [: m | m internalPathAsArray isEmpty ifFalse: [ m internalPath storeOn: aStream. aStream space]].
		aStream nextPutAll: ')'.
	aStream space; nextPutAll: self semanticType printString; space.
	putDaughters ifTrue: [
		self daughters do: [: d | d internalPath storeOn: aStream. aStream space]].! !

!Node methodsFor: '  onto stream' stamp: 'mich 10/5/1999 13:01'!
printOn: aStream
	"used in inspectors, debuggers, etc."

	^ aStream nextPutAll: '#' , self asShortString, ' (', self identityHash printString, ')'! !

!Node methodsFor: '  onto stream' stamp: 'miso 7/5/1999 01:25'!
storeOn: aStream
	"for file out. note that this files out not only this meme but all its daughters"
	self asParensStringOn: aStream
! !


!Node methodsFor: 'backup/unpack' stamp: 'miso 11/1/1999 21:50'!
asCompilableString
"a (string-)representation of a representation of an array. After being evaluated by the compiler (Compiler evaluate:), this produces a string which represents an array. This latter string can then be scanned to obtain the actual array. Useful for fileIns: those get evaluated, and we funnel that evaluation through a scanner in fromString:. (Used when creating a file that can be filedIn to reconstruct all data in an img, as opposed to backup files which are directly read with 'fromBackupFile:')"

	^ self asScannableString fullPrintString! !

!Node methodsFor: 'backup/unpack' stamp: 'miso 11/1/1999 21:50'!
asScannableString
"a (string-)representation of an array. After being scanned (Scanner new scanTokens:), this produces the actual array."

	^ (String streamContents: [: strm | self fileOutOn: strm]) ! !

!Node methodsFor: 'backup/unpack' stamp: 'miso 10/31/1999 01:19'!
backup

	| file fileName |
	fileName _ self externalName.
	Cursor write showWhile: [
		file _ FileStream newFileNamed: fileName.
		self fileOutOn: file.
		file close].
	^ fileName! !

!Node methodsFor: 'backup/unpack' stamp: 'miso 11/1/1999 21:45'!
fileOutOn: aStream

	aStream nextPutAll: self stats asString.
	self asParensStringOn: aStream! !

!Node methodsFor: 'backup/unpack' stamp: 'miso 11/1/1999 21:28'!
fileOutString
"a (string-)representation of a representation of an array. After being evaluated by teh compiler (Compiler evaluate: ), this produces an string which represents an array. This latter string can then be scanned to obtain the actual array. Useful for fileIns: those get evaluated, and we funnel that evaluation through a scanner in fromString:. (This is used when created a file that can be filedIn to reconstruct all data in an img, as opposed to backup files which are directly read with 'fromBackupFile:')"

	^ (String streamContents: [: strm | self fileOutOn: strm]) fullPrintString! !

!Node methodsFor: 'backup/unpack' stamp: 'miso 10/12/1999 00:23'!
isShadow

	^ self semanticType = #shadow! !

!Node methodsFor: 'backup/unpack' stamp: 'miso 10/12/1999 00:27'!
removeShadows
"remove all shadow memes from the tree below me. this can be pretty drastic: if a shadow links to subtrees, one of the two will be lost after this!!"

	self isShadow ifTrue: [
		self moms do: [: m | m  deregisterDaughter: self].
		self daughters do: [: d | self deregisterDaughter: d]].
	self daughters do: [: d | d removeShadows]! !

!Node methodsFor: 'backup/unpack' stamp: 'miso 10/31/1999 17:53'!
unpackCreateShadowWithMeat: meatString mom: m

	| curNode |
	curNode _ (Meme ofType: 'shadow') contentFromFlattenedText: meatString.
	m ifNotNil: [curNode putSelfInto: m after: #last].
	^ curNode
! !

!Node methodsFor: 'backup/unpack' stamp: 'mich 10/5/1999 18:53'!
unpackCreateShadowsForUrl: url relativeTo: topMeme
"construct a series of shadow memes mimicking the url, one for each path segment"

	| prevMom |
	prevMom _ topMeme.
	url do: [: s | prevMom _ self unpackCreateShadowWithMeat: s mom: prevMom].
	^ prevMom! !

!Node methodsFor: 'backup/unpack' stamp: 'miso 10/12/1999 00:24'!
unpackResolveUrlsForMomOrDaughter: doMom

	| myCollec herCollec e theNode |
	doMom ifTrue: [myCollec _ self moms] ifFalse: [myCollec _ self daughters].
	1 to: myCollec size do: [: k | 
		e _ myCollec at: k.
		(e isKindOf: String) ifTrue: [
"self halt."
			k=1 ifTrue: [myCollec at: k put: nil]. 		"preventive, in case this is the first mom and we need to call things like 'ancestor' or 'internalUrl' "
			theNode _ self unpackSearchForShadowAndCreateIfNotFound: e.
			myCollec at: k put: theNode. 				"link me to it"
			doMom ifTrue: [herCollec _ theNode daughters] "link it to me"
				ifFalse: [herCollec _ theNode moms].
			theNode isShadow 
				ifTrue: [herCollec addLast: self]			"order irrelevant in shadows"
				ifFalse: [herCollec at: (herCollec indexOf: self internalPath) put: self]]].
! !

!Node methodsFor: 'backup/unpack' stamp: 'mich 10/5/1999 18:57'!
unpackSearchForShadowAndCreateIfNotFound: url
"find the object, or construct it with its moms"

	| urlParts |
	urlParts _ self unpackSearchForUrl: (self stringurl2array: url). "this searches for a preexisting shadow url"

	urlParts second ifNil: [^urlParts first]. 	"found a shadow"
	^ self unpackCreateShadowsForUrl: urlParts second relativeTo: urlParts first.
! !

!Node methodsFor: 'backup/unpack' stamp: 'miso 10/6/1999 15:42'!
unpackSearchForUrl: url
"if not found but found a partial path, return an array with the lowermost element found and the url relative to that. Ie, searching for 'a/b/c/d', if a and b exist, return [b, 'c/d'}. So this is really a 'makeAsRelativeToMyTreeAsYouCan' method'. Url is already an array of localParts "

	| ancestor foundObject theObject urlParts |
	ancestor _ self ancestor.

	(ancestor name sameAs: url first) ifFalse: [^Array with: nil with: url].

	urlParts _ url.
	foundObject _ ancestor.
	"urlParts _ urlParts copyWithout: urlParts first."

	[foundObject = nil] whileFalse: [
		urlParts _ urlParts copyWithout: urlParts first. 
		urlParts isEmpty ifTrue: [^ Array with: foundObject with: nil].
		theObject _ foundObject.
		foundObject _ theObject submemeFromRelativePath: (Array with: urlParts first).
		].

	^ Array with: theObject with:  urlParts.
! !


!Node methodsFor: 'statistics' stamp: 'miso 11/1/1999 21:20'!
showStats 
"sizeStats"

	| stats |
	stats _ self stats.
	Transcript show: 'The node called ', self name, ' has: '; cr.
	Transcript show: '   ', (stats second) printString, ' primary daughters'; cr.
	Transcript show: '   ', (stats third) printString, ' simple daughters'; cr.
	Transcript show: '   and contains ', (stats fourth) printString, ' characters'; cr; cr.

	Transcript show: '   If counted with the walking methode, I have: '; cr.
	Transcript show: '   ', (stats fifth) printString, ' primary daughters +self'; cr.
	Transcript show: '   ', (stats sixth) printString, ' simple daughters +self'; cr.

! !

!Node methodsFor: 'statistics' stamp: 'miso 11/1/1999 20:43'!
stats 
"sizeStats"

	| resu |
	resu _ Array with: 1. "versionNumber of statsSerialisation convention"
	resu _ resu copyWith: (self countPrimaryDaughtersRecursively).
	resu _ resu copyWith: (self countDaughtersRecursively).
	resu _ resu copyWith: (self countCharsInSelfAndDaughters).
	resu _ resu copyWith: (self countPrimaryDaughtersByWalking).
	resu _ resu copyWith: (self countDaughtersByWalking).

	^ resu

! !


!Node methodsFor: 'private' stamp: 'mich 10/4/1999 21:44'!
initDaughtersAndMoms

	daughters _ OrderedCollection new.
	moms _ OrderedCollection new.! !

!Node methodsFor: 'private' stamp: 'mich 10/4/1999 21:44'!
initialize

	self initDaughtersAndMoms! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Node class
	instanceVariableNames: ''!

!Node class methodsFor: 'creation' stamp: 'miso 11/1/1999 21:59'!
fromBackupFile: aFileRef

	^ self fromStream: (FileStream readOnlyFileNamed: aFileRef).! !

!Node class methodsFor: 'creation' stamp: 'miso 10/12/1999 00:16'!
fromRecursiveArray: theArray

	^ self fromRecursiveArray: theArray removingShadow: false! !

!Node class methodsFor: 'creation' stamp: 'miso 10/31/1999 17:51'!
fromRecursiveArray: theArray curMom: mom
"fill in those values that come from structure of array: main mom and non-url daughters, and keep urls raw, they will be dealt with in a second pass"

	| curNode e |
	theArray size ~= 4 ifTrue: [
		^ self error: 'cannot create memes from this array, it has a wrong format'].

	curNode _ Meme ofType: theArray third.
	curNode contentFromFlattenedText: theArray first.
	mom ifNotNil: [mom registerIncomingDaughter: curNode after: #last].
	"do not use putSelfInto:after:, we might have urls as moms and that would choke on the isInside: check"

	theArray second do: [: k | curNode moms add: k]. 			"add 2nd-ary moms as urls"
	1 to: theArray fourth size do: [: k | 							"daughters"
		e _  theArray fourth at: k.
		(e isKindOf: String) 
			ifTrue: [curNode daughters add: e]
			ifFalse: [self fromRecursiveArray: e curMom: curNode]].

	^ curNode! !

!Node class methodsFor: 'creation' stamp: 'miso 10/12/1999 00:28'!
fromRecursiveArray: theArray removingShadow: keepShadows
"import a monolithic (recursive) array in standard format: 'content (secondaryMoms) type (daughters). Do a first pass ignoring secondary moms, and a second pass resolving them once all is in."

	| tree |
	tree _ self fromRecursiveArray: theArray curMom: nil.
	tree walkPrimaryDaughtersWith: [: n |
		n unpackResolveUrlsForMomOrDaughter: true.
		n unpackResolveUrlsForMomOrDaughter: false].
	keepShadows ifFalse: [tree removeShadows].

	^ tree "ancestor. in case my top node has shadow moms"
! !

!Node class methodsFor: 'creation' stamp: 'miso 11/1/1999 21:59'!
fromStream: aFileStream

	^ self fromString: aFileStream contentsOfEntireFile.! !

!Node class methodsFor: 'creation' stamp: 'miso 11/1/1999 22:32'!
fromString: aParensString
"Node fromString: Soups first asScannableString"

	^ self privFromTokenisedString: (Scanner new scanTokens: aParensString)
! !

!Node class methodsFor: 'creation' stamp: 'miso 10/30/1999 16:43'!
new
	^ super new initialize.! !

!Node class methodsFor: 'creation' stamp: 'miso 11/2/1999 00:35'!
privCompareNewStats: newStats toOld: oldStats 
"check that the stats before teh export are the same as those after the export. Interrupt with an error if not, else do nothing.
Format: #(versionFormat=1 primaryDaughterNum daughterNum charNum primaryDaughterNumWalking daughterNumWalking"

	newStats first = oldStats first ifFalse: ["not the same format of stats..." ^self].
	2 to: 6 do: [:i | (newStats at: i) = (oldStats  at: i) ifFalse: [^self error: 'the stats of the new file do not correspond to the old file...']]! !

!Node class methodsFor: 'creation' stamp: 'miso 11/1/1999 22:29'!
privFromTokenisedString: arrayOfTokens
"format of tokenisedString = #(stats parensString)"

	arrayOfTokens at: 2 put: (self fromRecursiveArray: arrayOfTokens second).
	self privCompareNewStats: arrayOfTokens second stats toOld: arrayOfTokens first.
	^ arrayOfTokens second! !


!Node class methodsFor: 'misc' stamp: 'miso 11/1/1999 21:07'!
testTheBackupProcess

	| m lsd |
	m _ MemeSoup mainSoup.

	m showStats. "so that we know what we are backing up"
	lsd _ m backup.

	Transcript 	cr; cr; 
				show: ' I have now been backed up into: ', lsd printString; cr;
				show: '  --  restoring  --'; cr.
	lsd _ MemeSoup fromBackupFile: lsd.

	Transcript show: ' And now the same stats after a restore from the backup: -- '; cr; cr.
	lsd showStats.
	Golgi view: lsd.
	^ lsd
! !


Node subclass: #Meme
	instanceVariableNames: ''
	classVariableNames: 'EmptyArray '
	poolDictionaries: ''
	category: 'Golgi-Basics'!
!Meme commentStamp: '<historical>' prior: 0!
I represent a piece of data. A text by default, but my subclasses can override that.

!!!!!! I am not allowed to have any code-as-outline. During file in, I am needed to construct these, so I must be there prior to any of them !!!!!!!!

[the saving mechanism, the diff between containsDirt & isDirty, the cmd/cntrl options.
]!


!Meme methodsFor: 'name & address' stamp: 'miso 10/5/1999 22:32'!
daughterCalled: nameAsString
	self daughters do: [
		:a  |
		(a name sameAs: nameAsString) ifTrue: [
			^ a]].
	^ nil! !

!Meme methodsFor: 'name & address' stamp: 'miso 6/12/1999 22:49'!
daughterNames
	^ self daughters collect: [:a  | a name]
! !

!Meme methodsFor: 'name & address' stamp: 'miso 10/13/1999 15:30'!
externalName

	^ self name , FileDirectory dot , Utilities dateTimeSuffix, '.meme'
! !

!Meme methodsFor: 'name & address' stamp: 'mich 10/5/1999 18:19'!
internalPath
	
	| p |
	p _ ''.
	self internalPathAsArray do: [: pathItem | p _ p, pathItem, self internalPathSeparator].
	(p endsWith: self internalPathSeparator) ifTrue: [p _ p copyFrom: 1 to: p size - 1].
	^p
! !

!Meme methodsFor: 'name & address' stamp: 'mich 10/5/1999 18:46'!
internalPathAsArray
	^  self primaryMom
		ifNil: [Array with: self localPath]
		ifNotNil: [ self primaryMom internalPathAsArray copyWith: self localPath]
! !

!Meme methodsFor: 'name & address' stamp: 'mich 10/5/1999 18:41'!
internalPathSeparator
	
	^ '!!'
! !

!Meme methodsFor: 'name & address' stamp: 'mich 10/5/1999 18:17'!
internalUrl

	^ self class name, '/', self internalPath! !

!Meme methodsFor: 'name & address' stamp: 'mich 10/5/1999 18:25'!
localPath
"my own contribution to the url, the part of the path that I represent"

	^ self name encodeForHTTP

	"^ self meatString"! !

!Meme methodsFor: 'name & address' stamp: 'miso 11/1/1999 10:56'!
name

	^ self contentString withSeparatorsCompacted truncateTo: 64 " asLegalSelector"

	"what you really want is String translateWith: table, making all spaces into underscores, instead of asLegalSelector" 
 ! !

!Meme methodsFor: 'name & address' stamp: 'mich 10/5/1999 18:26'!
shortName

	^ self name truncateTo: 32! !

!Meme methodsFor: 'name & address' stamp: 'miso 10/11/1999 14:56'!
stringurl2array: stringUrl

	^ (stringUrl findTokens: self internalPathSeparator) collect: [: e | e unescapePercents]
! !

!Meme methodsFor: 'name & address' stamp: 'miso 10/28/1999 13:06'!
submemeFromRelativePath: aPathArray	
"by the time we get it, aPathArray is relative to us"

	| next nextPathArray |
	aPathArray isEmpty ifTrue: [^self].
	next _ aPathArray first.
	nextPathArray _ aPathArray copyWithout: next.
	next _ self daughterCalled: next asString.
	next ifNil: [^nil].
	^ next submemeFromRelativePath: nextPathArray.! !


!Meme methodsFor: 'create/copy' stamp: 'ms 7/3/1999 23:30'!
becomeLike: originMeme

	self content: originMeme content copy.
	self semanticType: originMeme semanticType.! !

!Meme methodsFor: 'create/copy' stamp: 'ms 11/4/1998 11:47'!
copy

	^self class new becomeLike: self.
! !

!Meme methodsFor: 'create/copy' stamp: 'ms 3/6/1999 20:45'!
copyWithDaughters

	| copyOfSelf |
	copyOfSelf _ self copy.
	self daughters do: [:d| 
		copyOfSelf registerIncomingDaughter: d copyWithDaughters after: #last].
	^ copyOfSelf! !

!Meme methodsFor: 'create/copy' stamp: 'ms 3/9/1999 01:40'!
initialize
	super initialize.
	content _ Text fromString: ''. 
! !


!Meme methodsFor: 'statistics' stamp: 'miso 11/1/1999 10:56'!
countCharsInSelfAndDaughters

	| n |
	n _ self contentString size.
	self daughters do: [:d|
		n _ n + (d countCharsInSelfAndDaughters)].
	^ n
! !

!Meme methodsFor: 'statistics' stamp: 'miso 10/6/1999 19:30'!
countDaughtersByWalking
"temp - double check with the direct recursion verbs"

	Smalltalk at: #GolgiTempCountingTest put: 0.
	self walkDaughtersWith: [: n |
		Smalltalk at: #GolgiTempCountingTest put: (Smalltalk at: #GolgiTempCountingTest)+1 ].
	^ Smalltalk at: #GolgiTempCountingTest! !

!Meme methodsFor: 'statistics' stamp: 'miso 10/6/1999 19:30'!
countPrimaryDaughtersByWalking
"temp - double check with the direct recursion verbs"

	Smalltalk at: #GolgiTempCountingTest put: 0.
	self walkPrimaryDaughtersWith: [: n |
		Smalltalk at: #GolgiTempCountingTest put: (Smalltalk at: #GolgiTempCountingTest)+1 ].
	^ Smalltalk at: #GolgiTempCountingTest! !

!Meme methodsFor: 'statistics' stamp: 'miso 10/6/1999 13:49'!
printSecondaryDaughtersRecursively
"see a list of secondary links in the transcript. some appear twice if they are under a shared tree. will appear only once in primaryTree"

	| sDaughter |
	
	sDaughter _ self daughters select: [:d| (self isPrimaryDaughter: d) not].

	sDaughter do: [: d | 
		Transcript show: (self shortName), ' -> ', (d shortName), ' [', ((d countDaughtersRecursively + 1) printString), ']'; cr].

	self daughters do: [:d | d printSecondaryDaughtersRecursively].
! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Meme class
	instanceVariableNames: ''!

!Meme class methodsFor: 'convertFrom' stamp: 'mich 10/2/1999 23:53'!
fromDotHeadFile: f

	| s |
	s _ (FileStream readOnlyFileNamed: f) contentsOfEntireFile.
	s _ s copyFrom: 1 to: (
		s findString: (26 asCharacter asString) startingAt: 1 caseSensitive: true)-1.
	^ Golgi view: (
		self fromDotHeadString: s title: (FileDirectory on: f) pathName )! !

!Meme class methodsFor: 'convertFrom' stamp: 'ms 3/6/1999 22:00'!
fromDotHeadString: s title: t

	| theAncestor lastMeme headerArray nextLevel i oldLevel |
	headerArray _ self substringsOf: s.
	lastMeme _ theAncestor _ Meme withMeat: t asText.
	oldLevel _ 0.

	headerArray do: [:aDot|
		(aDot beginsWith: '.HEAD ') ifTrue: ["should be case-insensitive"
			aDot _ aDot copyFrom: 7 to: aDot size. "pop prefix"
			"now search for level"
			i_1.
			[(aDot at: i) isDigit] whileTrue: [i_i+1].
			nextLevel _ (aDot copyFrom: 1 to: i-1) asNumber.
			aDot _ aDot copyFrom: i+3 to: aDot size "skip +/-"].

		"now find mom for this level."
		lastMeme _ self privInsertText: aDot asText
					afterMeme: lastMeme
					ofLevel: oldLevel
					asNewLevel: nextLevel
					givenAncestor: theAncestor.
		oldLevel _ nextLevel].

	^ theAncestor
	"open it!!"! !

!Meme class methodsFor: 'convertFrom' stamp: 'mich 10/4/1999 14:04'!
fromParensString: s
	"why is there this additional array??"
	^ self fromRecursiveArray: (Scanner new scanTokens: s) first! !

!Meme class methodsFor: 'convertFrom' stamp: 'miso 10/9/1999 09:19'!
fromTabbedString: theString
	"return a CodeMemeTree mirroring the tab structure in s. do not set the commented/semanticType attribute, it just create generic CodeMeme"
	| theMom oldLevel newLevel lastMeme ancestor sentenceArray  |
	sentenceArray _ self substringsOf: theString.
	theMom _ ancestor _ lastMeme _ self new.
	oldLevel _ 0.
	sentenceArray do: [
		:s  |
		newLevel _ 0.
		[s first == Character tab] whileTrue: [
			newLevel _ newLevel + 1.
			s _ s copyFrom: 2 to: s size].
		newLevel > oldLevel ifTrue: [
			theMom _ lastMeme].
		newLevel < oldLevel ifTrue: [
			"find the relevant oldLevel!!"
			"use as a counter, we don't need it anymore"
			oldLevel _ 0.
			theMom _ ancestor.
			[oldLevel < newLevel] whileTrue: [
				theMom _ theMom daughters last.
				oldLevel _ oldLevel + 1]].
		lastMeme _ self string: s mom: theMom after: #last.
		oldLevel _ newLevel].
	^ ancestor
	"this parses level 0 as ancestor"
		"mom _ nil"
		"newLevel _ 0"
		"oldLevel _ nil.
memeArray do: [: s |
	[s first == Character tab] whileTrue: [
		newLevel _ newLevel + 1.
		s _ s copyFrom: 2 to: s size].

	newLevel = 0 ifTrue: [
		mom	ifNil: [oldLevel _ 0]
				ifNotNil: [^ self error: 'more than one ancestor']].
	newLevel > oldLevel	ifTrue: [mom _ lastMeme].
	newLevel < oldLevel	ifTrue: [mom _ mom owner].
	mom	ifNil: [ancestor _ lastMeme _ MemeAncestor new]
			ifNotNil: [lastMeme _  Meme addWithString: s mom: mom after: #last].
	lastMeme sisterBefore: s.

	oldLevel _ newLevel.
].
^ ancestor"! !

!Meme class methodsFor: 'convertFrom' stamp: 'miso 10/9/1999 09:18'!
privInsertText: t afterMeme: m ofLevel: lastLevel asNewLevel: newLevel givenAncestor: a

	| theMom i |
	newLevel > lastLevel ifTrue: [
		theMom _ m].
	newLevel <= lastLevel ifTrue: [
		"find the relevant oldLevel!!!!!!!!"
		"use as a counter, we don't need it anymore"
		i _ 1.
		theMom _ a.
		[i < newLevel] whileTrue: [
			theMom _ theMom daughters last.
			i _ i + 1]].
	^ self text: t mom: theMom after: #last.! !

!Meme class methodsFor: 'convertFrom' stamp: 'ms 12/21/1998 21:52'!
substringsOf: s
"Like string.substrings but separator list is smaller: tab and space do not count, only cr, lf. Answer an array of the substrings that compose the receiver."

	| result aStream char lineEnders |
	lineEnders _ Array with: 10 with: 12 with: 13. "line feed, form feed, cr"
	result _ WriteStream on: (Array new: 10).
	aStream _ WriteStream on: (String new: 16).
	1 to: s size do: [:i |
		char _ s at: i.
		(lineEnders includes: char asciiValue)
		 ifTrue: [aStream isEmpty ifFalse: [result nextPut: aStream contents. aStream reset]]
		 ifFalse: [aStream nextPut: char]].
	aStream isEmpty ifFalse: [result nextPut: aStream contents].
	^ result contents! !


!Meme class methodsFor: 'priv' stamp: 'miso 10/28/1999 13:41'!
initialize
	"Meme initialize. Run every time start a new golgi?"

	"this empty array object is shared by all memes with no daughters"
	EmptyArray _ OrderedCollection new.

! !


!Meme class methodsFor: 'creation' stamp: 'miso 10/9/1999 09:21'!
content: aText type: aSymbolOrNil

	^ (self ofType: aSymbolOrNil) content: aText asText! !

!Meme class methodsFor: 'creation' stamp: 'miso 10/9/1999 09:21'!
ofType: aSymbolOrNil

	aSymbolOrNil = #soup ifTrue: [^ MemeSoup new].
	^ self new semanticType: aSymbolOrNil! !

!Meme class methodsFor: 'creation' stamp: 'miso 10/9/1999 09:18'!
string: aString mom: aMom after: aMeme
	
	^ self text: aString asText
				mom: aMom 
				after: aMeme 
! !

!Meme class methodsFor: 'creation' stamp: 'miso 10/9/1999 09:18'!
text: aText mom: aMom after: aMeme
	
	^ self new 
		putSelfInto: aMom after: aMeme;
		content: aText! !

!Meme class methodsFor: 'creation' stamp: 'miso 10/29/1999 13:09'!
withMeat: theContent

	^ self new content: theContent asText.! !

!Meme class methodsFor: 'creation' stamp: 'miso 10/28/1999 13:39'!
withMom: aMom
	| m |
	m _ self new.
	m putSelfInto: aMom after: #last.
	^ m! !


Meme initialize!


Meme subclass: #MemeSoup
	instanceVariableNames: 'jumpPointsHolder '
	classVariableNames: 'LoneSoup '
	poolDictionaries: ''
	category: 'Golgi-Basics'!
!MemeSoup commentStamp: '<historical>' prior: 0!
I am the container of all memes (idealy there should be only one such container. to implement that, all methods are on the class side, and i have no instances). I exist in order to:
- maintain info about the meme (eg. important entry points, aka areas)
- (in the future) to allow the meme pool to have a non-unique entry (ie not be a tree with a single root node)by allowing memes to have multiple moms (= an info that belongs to several topics). [if there was only one root node, i wouldn' t be needed: a pointer to that node would suffice.]
- categ 'backup support' is forced to duplicate conversion verbs from meme. how avoid that?!


!MemeSoup methodsFor: 'name & address' stamp: 'miso 10/12/1999 10:39'!
externalName

	^ self name , FileDirectory dot , Utilities dateTimeSuffix, '.soup'
! !

!MemeSoup methodsFor: 'name & address' stamp: 'miso 4/18/1999 10:52'!
path
	^ {}! !

!MemeSoup methodsFor: 'name & address' stamp: 'miso 10/28/1999 13:02'!
submemeFromPath: aPathArray	
"path is absolute"

	aPathArray isEmpty ifTrue: [^ nil ].
	(self name sameAs: aPathArray first) ifFalse: [^ nil].
	^ self submemeFromRelativePath: ( aPathArray copyWithout: aPathArray first)! !


!MemeSoup methodsFor: 'create/copy' stamp: 'miso 10/29/1999 13:36'!
initialize

	super initialize.
	self semanticType: #soup.
	content _ 'Gazpacho' asText.
	jumpPointsHolder _ Meme withMeat: 'jumpPoints'.! !


!MemeSoup methodsFor: 'fileout' stamp: 'miso 11/1/1999 21:42'!
fileOutOn: aStream
"be careful that we remain a single chunk"

	super fileOutOn: aStream.
	aStream cr.
	"now save our jumpPoints, creating alist of stringPaths"
	aStream nextPutAll: '('.
	self jumpPoints do: [: m | aStream nextPutAll: m internalPath printString; space].
	aStream nextPut: $).
	aStream nextChunkPut: ' '. "make the whole Soup a chunk for import"
	"aStream nextChunkPut: (self jumpPoints collect: [: m | m internalPath ]) asString."
! !

!MemeSoup methodsFor: 'fileout' stamp: 'miso 11/1/1999 21:41'!
fileOutOn: aStream as: formatSymbolOrNil
"be careful that we remain a single chunk"

	formatSymbolOrNil ifNil: [^ self fileOutOn: aStream].

	^ self error: 'cannot fileOut in this format because it is not implemented yet'! !


!MemeSoup methodsFor: 'jumpPoints' stamp: 'miso 10/29/1999 13:36'!
addJumpPoint: aMeme
	"no check for overwrite or for Meme-ness of value "

	aMeme putSelfInto: jumpPointsHolder after: #last.
	^ true! !

!MemeSoup methodsFor: 'jumpPoints' stamp: 'miso 10/29/1999 13:36'!
deleteJumpPoint: aMeme

	^ aMeme moveSelfOutOf: jumpPointsHolder! !

!MemeSoup methodsFor: 'jumpPoints' stamp: 'miso 10/29/1999 13:36'!
jumpPoints

	^ jumpPointsHolder daughters! !

!MemeSoup methodsFor: 'jumpPoints' stamp: 'miso 10/29/1999 13:39'!
jumpPointsHolder

	^ jumpPointsHolder! !

!MemeSoup methodsFor: 'jumpPoints' stamp: 'miso 10/29/1999 13:25'!
jumppointNamed: nameAsString
	self jumpPoints do: [
		:a  |
		(a name sameAs: nameAsString) ifTrue: [
			^ a]].
	^ nil! !

!MemeSoup methodsFor: 'jumpPoints' stamp: 'miso 10/29/1999 13:33'!
theIncomingArea

	^ (self jumppointNamed: #incoming) ifNil: [self addJumpPoint: (Meme withMeat: 'incoming')]! !


!MemeSoup methodsFor: 'menu & menuItems' stamp: 'miso 10/30/1999 16:52'!
menuForDelete
	"propose a menu of available outlines to delete."
	| choice h  |
	self outlines size = 0 ifTrue: [
		^ false].
	choice _ MenuMorph new.
	choice addTitle: 'delete'.
	self outlines do: [
		:d  |
		choice add: d content target: d selector: #wannaSuicide].
	h _ World hands first.
	choice popUpAt: h position forHand: h! !

!MemeSoup methodsFor: 'menu & menuItems' stamp: 'miso 10/30/1999 16:51'!
newOutline
"menu item for external caller who want to create and view a new root daughter"

	Golgi view: (Meme string: ('outline #', (self daughters size + 1) asString) mom: self after: #last).! !

!MemeSoup methodsFor: 'menu & menuItems' stamp: 'miso 11/1/1999 10:57'!
worldMenu: requestingHand
"Build a menu with all jumpPoints"
	| menu nextSoup |
	menu _ MenuMorph new defaultTarget: Golgi.
	menu addTitle: 'open'.
	menu addStayUpItem.
	menu addLine.
	self jumpPoints do: [:a|
		menu add: a contentString selector: #view: argument: a].
	menu addLine.
	self daughters do: [:a|
		menu add: a contentString selector: #view: argument: a].
	menu addLine.
	"menu add: 'root' selector: #view: argument: self."
	menu add: 'new outline' target: self action: #newOutline.
	(MemeSoup fridge size > 1) & (MemeSoup fridge last ~= self)
		ifTrue: [
			nextSoup _ MemeSoup fridge after: self. 
			menu add: 'next soup...(', nextSoup name, ')' target: nextSoup selector: #worldMenu: argument: requestingHand].

	^ menu popUpAt: requestingHand position forHand: requestingHand
! !


!MemeSoup methodsFor: 'experimental' stamp: 'miso 10/9/1999 09:19'!
addIncomingString: theString

	(theString findString: 'freshmeat daemon' startingAt: 1 caseSensitive: false) ~~ 0
		ifTrue: [^ self massageIncomingFreshmeat: theString].
	^ Meme	string: theString 
			mom: self theIncomingArea
			after: nil "#last"! !

!MemeSoup methodsFor: 'experimental' stamp: 'miso 10/9/1999 09:21'!
massageIncomingFreshmeat: fString
"theMom _ linuxArea"
	| b e cleanString descrString name |
	b _ fString findString: 'subject:' startingAt: 1.
	b=0 ifTrue: [b_1] ifFalse: [b_b+10].
	e _ fString findString: 'added by:' startingAt: 1.
	name _ fString copyFrom: b to: e-2.

	b _ fString findString: 'license:' startingAt: e.
	e _ fString findString: 'category:' startingAt: b.
	cleanString _ (fString copyFrom: b to: e-2), String cr.

	b _ fString findString: 'homepage:' startingAt: e.
	e _ fString findString: 'download:' startingAt: b.
	cleanString _ cleanString, (fString copyFrom: b to: e-2), String cr.

	b _ fString findString: 'description:' startingAt: e.
	e _ fString findString: 'changes:' startingAt: b.
	e=0 ifTrue: [e _ fString findString: 'changes:' startingAt: b].
	e=0 ifTrue: [e _ fString findString: 'urgency:' startingAt: b].
	e=0 ifTrue: [e _ fString findString: 'freshmeat daemon' startingAt: b].
	descrString _ fString copyFrom: b+13 to: e-2.
	descrString _ descrString copyReplaceAll: (String cr, String cr) with: '' asTokens: false.
	cleanString _ descrString, cleanString.

	b _ fString findString: 'freshmeat daemon' startingAt: b.
	cleanString _ cleanString, (fString copyFrom: b to: e).

	name _ Meme string: name 
			mom: self theIncomingArea
			after: nil "#last".
	Meme string: cleanString 
			mom: name
			after: nil "#last".

	^ true "we dealt with it"! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

MemeSoup class
	instanceVariableNames: ''!

!MemeSoup class methodsFor: 'rpc support' stamp: 'miso 10/6/1999 07:27'!
addIncomingString: theString
	^ self mainSoup addIncomingString: theString
! !


!MemeSoup class methodsFor: 'reaching' stamp: 'miso 10/11/1999 14:55'!
memeFromAddress: stringAddress

	| s |
	s _ self mainSoup.
	^ s submemeFromRelativePath: (s stringurl2array: stringAddress)! !


!MemeSoup class methodsFor: 'backup' stamp: 'miso 11/2/1999 14:25'!
privFromTokenisedString: arrayOfTokens
"format of tokenisedString = #(stats parensString jumpPoints)"

	| theSoup |
	super privFromTokenisedString: arrayOfTokens. "transforms the second element into a tree"
	theSoup _ arrayOfTokens second.
	arrayOfTokens third do: [: p | theSoup addJumpPoint: (theSoup submemeFromPath: (theSoup stringurl2array: p))].
	^ theSoup "don't close the stream, might still be needed"

! !


!MemeSoup class methodsFor: 'the fridge containing all soups' stamp: 'miso 10/12/1999 00:30'!
checkFridgeIsNotEmpty

	self fridge isEmpty ifTrue: [self fridge add: MemeSoup new]
! !

!MemeSoup class methodsFor: 'the fridge containing all soups' stamp: 'miso 10/6/1999 08:10'!
fridge


	^ Smalltalk at: #Soups ifAbsent: [Smalltalk at: #Soups put: OrderedCollection new]
! !

!MemeSoup class methodsFor: 'the fridge containing all soups' stamp: 'miso 10/12/1999 00:31'!
mainSoup

	self checkFridgeIsNotEmpty.
	^ self fridge first! !

!ScrollPane methodsFor: 'golgi' stamp: 'miso 10/22/1999 12:29'!
getMenuSelector: s
	getMenuSelector _ s! !

!MenuMorph methodsFor: 'golgi' stamp: 'miso 10/18/1999 08:46'!
addSmartList: listOfDescriptors
"add a list of menuItemMorphs, where each menuItem is described by a descriptor in listOfDescriptors, possibly recursively. Descriptors can have several forms:
	(menuString selectorSymbol)
	(menuString selectorSymbol argument)
	(menuString selectorSymbol argumentList)
	'-'
	(menuString #submenu selectorForMethodBuildingSubmenuInTarget) 		_ here '#submenu' is a keyword
	(menuString descriptorOfSubItem descriptorOfSubItem ... )
Where the fourth puts a separator in the menu, and the last two build submenus, either via a method or via a recursive array"


	listOfDescriptors do: [: descr | self privParseMenuItemDescriptor: descr]! !

!MenuMorph methodsFor: 'golgi' stamp: 'miso 10/29/1999 13:56'!
privParseMenuItemDescriptor: aDescriptor
"see comment in addList:"

	(aDescriptor = #-) ifTrue: [^ self addLine].

	(aDescriptor second = #subMenu) ifTrue: [ "a submenu constructed by a method in the target" 
		^ self add: aDescriptor first  subMenu: 
			((MenuMorph new defaultTarget: defaultTarget) addSmartList: (defaultTarget perform: aDescriptor last))].

	(aDescriptor second isKindOf: Array) ifTrue: [ "a submenu specified in array"
		^ self	add: aDescriptor first 
				subMenu: ((MenuMorph new defaultTarget: defaultTarget) addSmartList: (aDescriptor copyWithout: aDescriptor first))].

	aDescriptor size = 2 ifTrue: [^ self add: aDescriptor first action: aDescriptor last].
	aDescriptor size = 3 ifTrue: [ "has arguments, either just one, or a list of them"
		^ (aDescriptor last isKindOf: Array)
			ifTrue: [self add: aDescriptor first  target: defaultTarget  
						selector: aDescriptor second   argumentList: aDescriptor last]
			ifFalse: [self add: aDescriptor first selector: aDescriptor second 
						argument: aDescriptor last] ]! !

!MenuMorph methodsFor: 'menu' stamp: 'miso 10/28/1999 13:48'!
setInvokingView: invokingView
	"Re-work every menu item of the form
		<target> perform: <selector>
	to the form
		<target> perform: <selector> orSendTo: <invokingView>.
	This supports MVC's vectoring of non-model messages to the editPane."
	self items do:
		[:item |
		item arguments ifNotNil: [
			item arguments isEmpty ifTrue:  "only the simple messages"
				[item arguments: (Array with: item selector with: invokingView).
				item selector: #perform:orSendTo:]]]! !

!ScrollPane methodsFor: 'scroll bar events' stamp: 'miso 10/22/1999 12:03'!
scrollBarValue: scrollValue
	scroller hasSubmorphs ifFalse: [^ self].
	scroller offset: scroller offset x @ (self leftoverScrollRange * scrollValue)! !

!ScrollPane methodsFor: 'initialization' stamp: 'miso 10/22/1999 10:52'!
setScrollDeltas
	| range |
	scroller hasSubmorphs ifFalse: [scrollBar interval: 1.0.  ^ self].
	range _ self leftoverScrollRange.
	range = 0 ifTrue: [^ scrollBar scrollDelta: 0.02 pageDelta: 0.2; interval: 1.0].
	"Set up for one line (for arrow scrolling), or a full pane less one line (for paging)."
	scrollBar scrollDelta: (self scrollDeltaHeight / range) asFloat 
			pageDelta: ((self innerBounds height - self scrollDeltaHeight) / range) asFloat.
	scrollBar interval: ((self innerBounds height - self scrollDeltaHeight) / self totalScrollRange) asFloat.

	scrollBar value: scroller offset y / range.  "in case there is no scrolling action accompanying the change of range, update scroll value so that next click in teh scrollbar is correct <miso>"
! !



"-=-=-=-= begin golgi postscript -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-="
" first make classes usable for things below: init globals, etc. Call this after having imported soups/outlines"
Golgi checkGlobals.
Golgi version: '0.58p7'. 
(Meme fromString: '(1 323 323 44680 324 324 )(''golgi documentation''() nil ((''What is the Golgi project all about?''() nil ((''Ideally, Golgi is about helping ''''thought''''. About helping making sense of the world inside and around us, about making creative intellectual explorations easier. In the best of worlds, it would become akin to a sculpture tool, used in sculpting the memes flying around - and in - the user: it should make it easy to visualise and visually manipulate content in hope of facilitating the discovery of elegant and productive conceptualisations. In short, if Squeak is about being "an exquisite personal computing environment", Golgi is about being ''''an exquisite personal meme-sculptor''''.''() nil ())(''It is important to me that Golgi become both a practical everyday tool and an insightful research tool. The practical side is fairly obvious: it allows easy note-taking and generic info-handling (I already use it for all my note-taking, and for much of the process of shaping articles for my academic work, as well as for lecture preparation). The research side is more intriguing: there is relatively little work in cognitive science about the way people shape their thoughts, how generalisations emerge, how things get (re)conceptualised. Similarly, there is relatively little serious work in philosphy of science about how theories evolve in day-to-day work, how abstractions emerge from data, how data get reordered by available concepts. (Not to speak of the dismal track-record of research in education about how children come to represent the world, and how that can be influenced by interaction with teachers/care-takers.) Golgi is a tool that allows me to observe parts of this in real time, recording its evolution as necessary and investigating hypotheses about it.''() nil ())(''In my long-time quest for medium/large-scale manipulation of personal information, I have found that outliners, despite all their limitations, are the best available approximation of the Golgi ideal. They allow one to visualise and manipulate not only the bits of information themselves, but the very structure relating memes. A natural starting point for Golgi is thus to write a solid outliner. But of course this is only a weak starting point. Traditional ''''outliners'''' have serious flaws (some inherent, some are inherited from the environment in which they operate) which make them unfit for real note-taking use: ''() nil ((''First, by their very design, outliners force each piece of information - each meme - to be visually under one and only one topic (symbolised by the header immediately above). This visual rendering is obviously misleading, we don''''t conceptualise the world that way. Typically, a meme is relevant to several different topics. This does not mean that we should throw out the baby with the bathwater and give up the whole idea of representing memes hierarchicaly: The fact that a meme can participate in multiple hierarchies does not entail that there are no hierarchies. In fact there is plenty of psychological evidence that we do categorise things hierarchically. 
  So the first flaw to rectify is to allow for multiple ''''mothers'''' of a meme. This is easy to approximate in the data-structure, by simply declaring a list of ''''mothers'''' (topics) for each meme. It is very hard however to come up with an adequate visualisation of those structures. This is maybe the single most important place to investigate for data viewers, which makes it important for the outliner to be malleable: it must be as easy as possible to ''''rewire'''' its internals in search of different visualisations.''() nil ())(''And this is the second (maybe minor) flaw of all available outliners: they are all either close-source, so that no experimentation is possible at all, or written in ungodly low-level languages, where simply changing the behaviour of wedges takes three weeks of hard work.''() nil ())(''A more subtle, and easily mendable flaw comes from the fact that all existing outliners try to play nice with an OS filestructure, itself organised in terms of folders/directories. This leads them to entirely miss the point of meme-manipulation by confining it to a set of small and unrelated chunks. There are two sides to this. On the one hand, the cohabitation with a filesystem forces them to view each outline as an island: there is one entrypoint (the filename) and a bunch of memes under it, but each entrypoint is mostly a closed door. A meme in one outline (say, about politics in Israel) has no connection to another outline (say, the structure of the american electoral system). An obviously false assumption, of which any serious note-taker knows the crippling effect. But maybe the worst aspect is that it entirely misses the similarity between the directory structure outside the outline, and the internal structure of the outline. Filesystem viewers such as the Macintosh ''''list'''' view, or Windows Explorer make it obvious that directories are the same type of hierarchies as notes in outlines. By separating the two, one ends up imposing two entirely different systems on one hierarchy, with absurd results: filesystem memes are arbitrarily limited in their length, type of content, etc. while outliner memes are forced to be islands (some existing outliners even reinvent a file structure internally, so that they end up having three distinct hierarchies of memes...). This flaw is almost trivial to remedy, by simply eliminating the filesystem. All we need are hierarchically connected objects, with each object keeping track of its parent and daughter nodes. ''() nil ())(''A related difficulty is that classical outliners keep their data imprisonned. No way you can access the data independently of the viewer itself, since they don''''t separate the two. Since golgi aims at reaching out to all sorts of data in the user''''s environment, it cannot afford this limitation. The data-structure must be independent. (Golgi''''s ''''native'''' data-structure is currently represented by objects called Memes, which are simply a subclass of Node, and are indendent of the viewer itself). 
(Of course the usual issues about storage arise: it should be versionable, searchable, atomic, etc. None of this is addressed here. The reason for that is that there are plently of competent people already working on such objects, in various frameworks. On the other hand, I''''ve seen relatively few relevant UI and semantic explorations. I''''ll therefore first focus on the latter, with a simple storage backend, with the hope that a sophisticated repository (eg. IronDoc) can be plugged into whatever UI arises, at a later stage.''() nil ())(''We also want a sculptor who is not semantically blind. Traditionally outliners have no capactiy to differentiate headers. Everything is just text. But different types of text have very different requirements: a todo item, an email, a quote, and an article, although they are all candidates for headers, have very different properties. The connection between headers and data they represent must thus be flexible enough to handle each type of meme differently. (This also means that Golgi will ideally come to tread on domains which are traditionally disjunct from ''''outliners'''', such as ''''organisers'''', ''''agendas'''', ''''email readers'''' and more: todo items are intimately tied to note-taking, as are parts of email handling, etc.)''() nil ())))(''Finally, to make such a sculptor practical, one also needs a set of ''''input helpers'''' which help the transfer of relevant information (bits of emails, note-taking, quotes from web-pages, etc.) into Golgi. There must be a way to say ''''take this highlighted part, and put it into golgi, preserving all relevant properties''''. A non-trivial task for Squeak-external readers such as the Netscape Browser, and various mail-readers.''() nil ())(''On a side note, an ''''hierarchy viewer'''' has all sorts of practical uses in making the Squeak environment itself more friendly: viewing code as outlines is very helpful (somewhat less so in smalltalk where methods tend to be very short), viewing the object hierarchy, etc. This is somewhat secondary to the general plot, but to the extent that it makes the environment more productive, it is positive feedback into the project itself (besides being a more direct way to give back to the Squeak community).''() nil ())))(''Acknowledgements & Trivia about Golgi''() nil ((''why is it called Golgi?''() nil ((''Golgi is named after Camillo Golgi, the Italian researcher who discovered for the first time a way to visualise the "web" of neurons in brains (a technique now called ''''Golgi staining''''). Thanks to him, an important but invisible structure suddenly became visible and researchable. You get the analogy...
[Actually, Golgi also discovered what is now called ''''the Golgi apparatus'''' inside cells, and my biology friends tell me that the latter is also a good metaphor for a viewer of meme-structures. I''''ll have to dig this more before putting it here though...]''() nil ())))))(''Copyright''() nil ((''if it is possible to release something built on top of squeak as GPL, this is GPL. It is important to me to contribute to the free software community, if possible at all. Apparently the squeak licence, for all its merits, is not DebianFreeSoftwareGuidelines-compliant, and any soft under Squeak licence thus cannot contribute to that community.  Have to investigate the issue. If it''''s not possible (ie GPL code cannot use squeak code), then this is to be put under the same licence as squeak has.''() nil ())))(''''() nil ())(''User docs''() nil ((''QuickStart / Basics''() nil ((''how to open an outline? ''() nil ((''easiest is to evaluate ''''Golgi start'''' (or: ''''Golgi view: MemeSoup mainSoup'''')''() nil ())))(''create/delete headers''() nil ((''alt-Return creates a header below the current header''() nil ())(''alt-Delete deletes the current header ''() nil ())(''(on the mac, alt-* -> cmd-*)''() nil ())))(''reorganise headers''() nil ((''once a header is selected (ie. has been clicked into):''() nil ())(''alt-Arrow will move it arround: alt-leftArrow, alt-rightArrow, alt-arrowUp, alt-arrowDown will behave as you expect (on the mac, alt-* -> cmd-*)''() nil ())(''otherwise, golgi also implements the standard reorg keys found in MORE, Frontier, Leo, etc:''() nil ((''alt-R : move current header to the right, if possible (''''demote'''') ''() nil ())(''alt-L : move current header to the left, if possible (''''promote'''') ''() nil ())(''alt-U : move current header up, if possible''() nil ())(''alt-D : move current header down, if possible''() nil ())(''tab key: like alt-R, demote. And shift-tab promotes. (To get a normal tab, do cntrl-Tab)''() nil ())))))(''you can also reorganise header by drag&drop''() nil ((''to drag a header, use the middle-button (mac: option-click) to drag its wedge to the destination. A yellow spot appears, giving feedback on where the header would be dropped. ''() nil ())(''Notice that you can decide whether the header will end up as a sister of the landing site or as a daughter of the landing site, with visual feedback of the yellow spot: ''() nil ((''if you keep the mouse in the left periphery of the host-header (ie. roughly witin it wedge), the yellow spot is at the left edge fo the host, and the drop will place the dragged element as a sister of the host.''() nil ())(''if you drag the mouse more towards the right of the host header (roughly within its content-part) the yellow spot jumps to the right, indicating that dropping here woould place the dragged element as a daughter of the host.''() nil ())))))(''selecting a header for cut/paste''() nil ((''on the mac, option-click on the wedge to select the entire header (with all subheaders). Cut/paste will then operate on this entire header.''() nil ())))))(''wedges - you do not need to click precisely on the image of the wedge to make it react (eg. expand). Anywhere around it will do.''() nil ())(''menus''() nil ((''each header has its own menu that you obtain by shift-clicking on (around!!) the wedge. There you find options that apply to that particular header (eg hoisting).
[right now this menu is heavily debug-oriented, and chaotic]''() nil ())(''there is a general menu for the whole outline, at the top of the scrollBar, in the usual morphic place: click in the little rectangle above the up-arrow in the scrollbar.
This menu contains global commands and preferenes.''() nil ())))(''more kb-shortcuts''() nil ((''alt-E : expand current header''() nil ())(''alt-shift-E : contract current header''() nil ())))))(''Dev docs [a few preliminary pieces]''() nil ((''1. overall architecture''() nil ((''The basic architecture of a Golgi viewer is a sandwich of 3 layers: an abstract viewer layer, a ''''translator'''' layer which adapts the viewer-vocabulary to the viewed-data vocabulary (allowing the viewer to remain clean while still viewing many different types of things; and finally there is the viewed data itself, which can be many different things in principle, by default it is a Meme. 
   
In the viewer, each header is an independent object, representing an independent piece of info, which could be local data, or an email stored in your mail-reader''''s folder, or a text file in a filesystem, or whatever is structured and adressable. The translator is what gives the system flexibility: if you want to view the same data in a different way, just plug in a different translator between the data and the GoHeader. So for instance if you might want to view a Meme object qua object during debugging (like in an inspector), but like a content-thing during normal use. Or you might want to swap the Smalltalk rules for Python rules for a particular (set of) CodeMemes.''() nil ((''headers are linked to their translators both ways: the header keeps a reference to its translator in an instVar (translator), and the translator registers the viewer as a dependent. Both links get done in goHeader.translator:. There is a 1-1 relation between headers and translator (translators are understood as a subpart of the header, owned by it).
 The unlinking occurs in ''''forgetHeaderAndMeme'''' for the translator->header link, the other direction is left as a dangling link (in principle the translator->header link could be left dangling too since translators and headers die together)''() nil ())(''translators are linked to memes both ways: translators keep a reference to their meme in a ''''meme'''' instVar, and memes register translators as dependents (both operations occur in translator.meme:). The unlinking occurs in translator.forgetHeaderAndMeme, and just consists in the meme unregistering the translator from its dependents instVar (the tr->meme link is left dangling).''() nil ())))(''Apart from these basics, there are some important helper objects:''() nil ((''The Sniffer.''() nil ((''[speed-up helper so that expanding a header which was never expanded before is not slowed down too much by the time used up to collect data about its daughters]''() nil ())))(''The HeaderBank.''() nil ())(''Soups''() nil ())(''GolgiGlobals''() nil ())))))(''2. the viewer''() nil ((''Each header is a separate object (GoHeader), and a viewer is basically just a recursive bunch of headers. Everything should be pretty straightforward, except one subtelty: there is an invisible ''''bigBrother'''' header containing all top-level headers (2.5). ''() nil ())(''2.1 Headers.''() nil ((''each header (GoHeader) contains three drawable objects: a wedge (GoWedge), a GoMeat (holding the content of the header) and a GoHeadersPane (holding subheaders, if any)''() nil ((''GoWedge, GoMeat & GoHeadersPane are private to GoHeader. so all interaction is between GoHeaders.''() nil ())))))(''2.2. Wedges''() nil ())(''2.3. The meat morph''() nil ())(''2.4. The subheader pane''() nil ())(''2.5. BigBrother''() nil ((''the top level headers are also inside a GoHeadersPane, and that GoHeadersPane is in an abstract header, bigBrother. (the content of bigBrother is the title of the outline). ''() nil ())))))(''3. the translators''() nil ((''they are the sole interlocutors of headers. Their main function now is (i) to provide access to the content of the meme, (ii) to determine which wedge-type is appropriate for that meme.''() nil ())))(''4. the memes''() nil ((''there are now two types of readable datas, both internal to squeak: Meme and CodeMeme. the first represents a general purpose string, the latter represents a string interpreted as part of code, with attributes such as isCommented, variableDeclaration, etc.''() nil ())))(''5. How movement works''() nil ((''The general picture''() nil ((''Moving a header is a long road of calls, starting in the GoHeader.wannaMoveSelf* methods (and their wrappers: goLeft, goUp, etc.). Here I give a bird''''s eye view of the path of calls, and expand on the details and rationale below. ''() nil ())('']sqStyle[(808 40 30)f1,f1i,f1]if the new mom is in the same Golgi viewThe wannaMoveSelf* methods ask the translator to reorganise the viewed data, by calling the GoTranslator.headerWantsTo* methods. The translator then arranges for the data to reorganise as requested. Once the data is done, one or more of GoTranslator.dataGotOutOf:, GoTranslator.dataMovedOutOf:into:after: & GoTranslator.dataHasNewDaughter: is called (either by the data if it has callback capacities, or by the translator itself). 
Now the real header movement can take place: the translator calls one of GoHeader.dataGotOutOfMom, GoHeader.dataMovedOutOfMomInto:afterSub:. What these methods do is to mimick the data mv: the former just kills the header, sinced it is not viewed anymore, while dataMovedOutOfMomInto:afterSub: moves it into the relevant new mom-header if the new mom is in the same Golgi view (see below for more on this).''() nil ())(''The two GoHeader.data* methods relay things to the two core movement methods: GoHeader.corePutSelfOutOfMom & GoHeader.corePutSelfIntoHeader:afterSub:.
These then do the internal cooking of contacting the old mom & new mom with: releaseOneSubheader:, addSubHeader:after:''() nil ())(''The new/old mom then deal with their subheaderpanes to do the actual adding/removal through GoHeadersPane.paneReleaseHeader:, GoHeadersPane.paneAddHeader:after:''() nil ())(''The chain of calls can thus be paraphrased like this (the central steps are in bold):''() nil (('']sqStyle[(1 19 38)f1,f1b,f1][header.wannaMvSelf* > translator.headerWantsToMvSelf*] > ''() nil ())('']sqStyle[(14 3)f1b,f1]data.moveSelf* > ''() nil ())('']sqStyle[(25 17 23)f1,f1b,f1][translator.dataMoved* > header.dataMoved* > header.coreMove*] > ''() nil ())(''[momHeader.addOrDelSubheader > headerPane.addOrDelSubheader]''() nil ())))(''with four major steps: header > data > header > momHeader. The bracketed operations are essentially one-step, divided only for proper encapsulation.''() nil ())))(''Motivation for separating each step:''() nil ((''The four major steps:''() nil ((''Thee first three steps (header > data > header) are the standard view/model dichotomy: the view (a header) calls its model (the data) to request a change, and only after the data accepts the change, does the header actually do the change. ''() nil ())(''Furthermore, the first set of header methods (wanna*) are distinct from the second set (data*) so that if the data reorganised independently of the viewer (maybe someone else viewing them and changing them), it can call back into the golgi viewer to tell us so. In other words, it allows us to distinguish between viewer-triggered movement and data-triggered movement.''() nil ())(''The reason to distinguish the headerData* step from the momHeader step is basic object design: you want to be able to tell a header to move itself, not just call it''''s owners to do the job.''() nil ())))(''What about the substeps, why those?''() nil (('']sqStyle[(105 3 171)f1,f1i,f1]In the first and third step, header* methods are always mimicked by translator* methods. This is because all communication between a header and its data is mediated by a translator. The reason for this is that it makes it easy to plug in ne w types of data to be viewed by Golgi.''() nil ())(''Another straightforward one is the distintion between momAddOrDel and subPaneAddOrDel in the fourth step: the subpane is private to the momheader, so there is no way the moving header can call it directly. Again, basic encapsulation.''() nil ())(''Finally, there remains only one distinction to motivate: why are header.dataMoved* methods distinct from header.coreMove*? This is slightly more subtle: dataMovedOutOfInto and dataGotOutOf share their first step (coreMoveOutOf) but not the second step (coreMoveInto). Furthermore, the first step is slightly different in the two cases: it is bare-bone for ''''move'''', but it needs to additionally check for things like focus in ''''getOut''''. The solution is that they share the bare-bone version in core* but each adds their higher-level checks for focus/etc.''() nil ())))))(''Some precisions about the sets classes of header.mv methods''() nil ((''Concentrating on the moving header, there are thus three classes of methods, from higher level to lower level: wanna* methods for movement originating in golgi, dataMoved* methods for callbacks once the data has moved, and coreMove* methods that do the grunt work. ''() nil ())(''These three sets differ with respect to two other important properties:''() nil ())(''Focus: ''() nil ((''core* methods never care about focus.''() nil ())(''dataMoved* methods in principle don''''t care about focus, except when they delete a header which contains focus. If so, they ask who should inherit the focus and pass it on. (so that if a golgi reorganises because of external data reorganisation, this doesn''''t disrupt work on the current view, unless absolutely necessary)''() nil ())(''wannaMoveSelf* methods always influence focus.''() nil ())))(''Movement across viewers:''() nil ((''A wannaMoveSelf method can move a header into a different viewer (a different window), eg. during drag&drop. The callbacks however will never do so. Ie the header.dataMoved* will only move within the same viewer. 
Why? Because any given meme can be viewed by many viewers. Suppose we move from mom1 to mom2, and mom1 is viewed by 3 viewers and mom2 by 7 viewers. Except for the teh instance of mom1/2 that we dragged from/to, how do we decide which mom1-viewer gets paired with which mom2-viewer during the reorg? To avoid big complications, the policiy is simple: if they are within the same viewer they get moved. Otherwise the viewers under of mom1 are destroyed and viewers under mom2 are created. The logic for this occurs in translator.dataMovedOutOf:into:after:.
[The simplest and most elegant solution would be infact to never move: always delete the moving header and recreate one in the arrival position. This is not done yet for speed reasons, but might be switched to in the future.]''() nil ())))))))(''6. How drag&drop works''() nil ((''1. sending the request to GoHeaderAlias:''() nil ((''when the user requests a drag (by clicking on wedge w/ appropriate keyCombo) the wedge tells its Header to beGrabbedByEvt:. The header does nothing, it just asks GoHeaderAlias (class) to ''''visualiseDragOf: thatHeader fromEvent: theEvent''() nil ())))(''2. creating a GoHeaderAlias: ''() nil ((''In response GoHeaderAlias class creates an invisible class, positions it and attaches it to the header (through the class ''''target'''' instVar). It then tells me to ''''beGrabbedBy: aHand''''. In response I become visible and ask the hand to contact me at each step.''() nil ())))(''3. following the mouse:''() nil ((''at each step, the hand informs of ''''mouseMove:'''', at which point i remind myself tha i should ''''zieutezLeSeducteur: givenTheEvent'''' (ie. calculate which header would attract me into it). I do that by asking the mouse coordinates,''() nil ())))(''4. dropping''() nil ((''...''() nil ())))))(''How import/export of outlines works''() nil ((''explain the gotchas of secondary moms exported or not''() nil ())(''parensString: ''() nil ((''format - (meat (moms) type (daughters))''() nil ((''moms does not contain primary mom, unless i am the top exported meme and i have a mom''() nil ())(''daughters does not contains full primary daughters, and just name of secondary ones.''() nil ())))(''HOW IMPORT WORKS''() nil ())(''incomingNode:''() nil ((''''() nil ())))))))(''How menu invocation works''() nil ((''There are two types of menus: the ones associated with each header, obtained by yellow-clicking on its wedge, and a general menu for the Golgi pane, obtained by clicking in the menu-button above the scrollbar. The menus are handled by translators, so that each type of headers can have different menus.''() nil ())(''Wedge-menus: get invoked by mouseDown: sent to the wedge. The wedge sends cmdMouseDownIn:while: to the header (its ''''target''''), which relays it to translator.headerMenu''() nil ())(''Scrollbar-menus: the scrollPane.getMenu. calls translator(itsModel).buildGolgiMenu:given:, which relays to tr.golgiMenu''() nil ())))(''How cut&paste and selection of an entire header works''() nil ((''the difference between selecting a header and selecting the content of the header is implemented via focus: the entire header is ''''selected'''' iff it hasFocus, meat selection is active iff ''''theMeatMorph hasFocus''''.''() nil ((''hasFocus is currently implemented by asking the hand who is the keyboardFocus.''() nil ())))))))(''Version history & future steps''() nil ((''current state and next steps: The 0.5 series is the first Squeak implementation of the general meme-sculpting idea (after various experiments in different frameworks). The goal of the 0.5 series is to have a solid/basic outliner and data-structure, including some relatively advanced features such as dnd, hoisting, etc. We''''re approaching the end of 0.5 series: 0.57 was a pass at fixing all the known bugs (one remains with large paragraph but that seems to belong to the deep internals of PluggableTextMorph) . The last iteration should be 0.58, which is an ongoing cleaning up of the Golgi guts, cluttered by layers upon layers of experimentations with different architectural solutions. 
The 0.6 series will be adding some basic bells and whistles useful in day-to-day work such as 1-line views of headers (very helpful with lot of big headers), arrow-keys''() nil ())(''0.5.8 - ''() nil ((''p7 - minor: followup on cleanInstall''() nil ())(''p6 - jumpPoints instead of areas (& concomittant cleanInstall)''() nil ((''soups: cleanedUp methods, and started reorganising jumpPoints, experiment with main (world) menu''() nil ())(''lots of tweaks to adapt/facilitate cleanInstall in new image, to accomodate the change of memeSoup structure. + lot of bugFix/minorCleans''() nil ())))(''p5 - cleanUp GoHeader''() nil ((''slimmed down r(header,subpane)''() nil ())(''made r(header,translator) count on a 1/1 relationship''() nil ((''Why? Squeak seems to wavers between models as data that can be viewed by many viewers and ''''behaviour-encapsulators'''' that rely on 1-1 (such as in windowClosed, okToChange, etc.). We have best of both worlds by having Translators as ''''behaviour-encapsulators'''' and Memes are pure data. Stick to this, as it makes the world simple. 
(Although it did have appeal to have just one translator (of a given type) per meme...)''() nil ())))(''menus: into translators rather than headers, trimmed down itemsFor* (put a big list instead)''() nil ())))(''p4 - fix sys bugs''() nil ((''instead of working workaround the setInvokingView: bug, fix it...''() nil ())(''fixed a bug in ScrollPane when changing the size of the scroller without scrolling. The onyl way to update the values in scrollbar is a call to ScrollPane.setScrollDeltas, but the latter refreshed deltas but ''''value''''. Added a refresher for ''''value''''''() nil ())))(''p3 - movement-of-header bettering''() nil ((''For better focus-deletion handling, distinguished between header.dataMoved* and header.coreMvSelf*. Both are called after data is reorganised, and data* is a wrapper around core* that takes care of focus and suicide if need arises. No more focus-jumping on indenting.''() nil ())(''wrote a tutorial on how mv works, in the outline distributed with golgi''() nil ())(''To stop the confusion between becomeOrphan (release mom but not data) and suicide (release mom and data), moved to a regime where all movements to outside-golgi are movement of meme + deletion of header. This way there is no more ''''orphaning'''', every loss of mom triggers a suicide of the header [!!].''() nil ((''this is a step towards homogeneification of mv as del+creation. The only remaining part is the we keep mv within viewer as a true movement of headers.''() nil ())))))(''p2 - change menu-building back to standard squeak menus & workarounds for setInvokingView bug''() nil ())(''p1 - misc small cleanups:''() nil ((''fixed a bug where mving a header which was also a bigBrother somewhere else complained. ( GoTranslator.mvFrom:to:)''() nil ())(''simplified quickContents in MichTextMorph''() nil ())(''began to simplify access to the owner/paneLink/bb trio in headerPane''() nil ())(''fixed a visual glitch when reorganising with tab.''() nil ())(''to get normal tabs in headers (as opposed to tab-qua-reorgKey), switched to cntrl-tab, because alt/cmd-tab is used to cycle windows in many window/dsktp managers.''() nil ())(''fixed the macOptionKey issue in 2.6''() nil ())))))(''0.5.7 - clean-up & fix most annoying bugs, for a minimal release; switch to 2.5, , etc. [Oct99]''() nil ((''p12 - fixed focus bugs introduced by previous bug fix. Keyboard shortcuts for windows.''() nil ((''the p11 bug fix for unregistering golg from sniffer changed the ''''header.world'''' reporting. this had nasty effects on ''''header.hasFocus'''' which in turn completly breaks movement. Fixed header.world to report the world of bigBrother, if any.''() nil ())(''Testing this uncovered another focus-bug: when collapsed, headers are out of world (world=nil), so hasFocus needs to answer false there instead of breaking. Decided to switch to an encapsulated focus-strategy: hasFocus now consults bigBrother rather than hand. Should be more friendly to future potential multiple hands working on a view.''() nil ())(''Kludge the window-no-alt problem by making windows use the control key (cmdShift) for arrows and return, and thus made cmdShift-actions equivalent to cmd actions for the four arrows and for return.''() nil ())(''translators 1-1: changed tr.key:combo:for: to key:combo: and concommitant in caller''() nil ())))(''p11 - patched various loose ends to facilitate a quick&dirty release.''() nil ((''fixed bug when checking for null outline''() nil ())(''fixed bug that closing a golg would not unregister it in sniffer.bigBrothers''() nil ())(''simplified sniffer.suicide verbs''() nil ())))(''p10 - fixed scrollBar / slider''() nil ((''removal of GoScrollPane introduced a couple of bugs, eg. we were not even linked to the TransformMorph correctly. ''() nil ())(''need to fix better the feedback to scrollbar for slider-size change upon expand/contract: now done thru horrible tweak in fullExtent. what we want is a way to say: do the expand/contract - including drawing - and only sometime after that, when all is peaceful, tell scrollbar to recalc.''() nil ())))(''p9 - mv became solid''() nil ((''fixed tons of squirks in movement operations related to the existence of multiple views on a meme. Everything is now dynamically updated, without polling, via meme callbacks.''() nil ())(''streamlined translator and node mv methods.''() nil ())(''added an instVar to headerPanes so that they know to whom they belong, so that we can ask them about their header when they are hidden. (This made it possible to eliminate the subheaderPane instVar in GoHeader, and was needed in order to check they are viewed under the relevant mom in viewer before adding them in during mv)''() nil ())(''reput in checks for null outlines, but instead of forbidding the deletion of the last header (which breaks when a meme is multiply viewed, sometimes as root and sometimes not), we allow it but insert a dummy header after it left. Works beautifully even in harsh conditions. (But the dummy remains floating around. See notes for improving this by using a dummyTranslator not linked to any meme.)''() nil ())(''updated the focus mechanism to reset focus automatically when nilled, and wanna* verbs to explicitly ask for focus preservation"''() nil ())))(''p8 - fixed the dnd bug when the cursor was over the drag-halo.''() nil ())(''p7 - wrote some statistics for memes/soups and used them to uncover nasty little bugs in import/exports. Tracked them down.''() nil ())(''p6 - allow multiple soups, and thus change the interaction of soup w/ Smalltalk -> tentative fridge concept''() nil ())(''p5 - reorganise categories in the browser and import/export cleanup''() nil ((''Clean ups:
- stuff related to import/export such as internalUrl renaming, high-level method tweaking. throw lots of now-unused import out methods
- reorganise all object into simpler categories in the browser and throw out some unnecessary ones.
etc.''() nil ())))(''p4 - lot of reorg and throw-out of methods mostly in Golgi and GoTranslator''() nil ())(''p3 - memeAccessor becomes memeTranslator and also becomes a 1-1 relationship with meme''() nil ())(''p2 - remove the GoPane class and clean up. Required adding an accessor to ScrollPane though.''() nil ())(''p1 - remove the GoWindow class and put everything into GoBigBro, who becomes ''''Golgi''''. Requires yet another rework of the ''''die''''-process.''() nil ())))(''0.5.6 - live-updates & aliases & new importExport [june99/October99]''() nil ((''p4 - re-rewrite of import/export. Previous still barfed on ordering of secondary daughters.''() nil ((''now does it almost trivially: exports both secondary daughters and moms as urls, and imports in 2 steps. First as before, it just brings in all the recursive structure, second it resolve all urls.''() nil ())(''notice that it allows malformed urls, since these could be good urls for things outside of current import. It reconstructs ''''shadow memes'''' for those. (Explaining all this in docs should wait until the atomicParensString is written).''() nil ())))(''p3 - support for import/export of the new meme structure''() nil ((''rewrote core import/export methods. Only parensString format is fully supported now''() nil ())(''added a 2-pass import technique, so we can import memes in any order even though they have references to each other (and thus to non-existing objects)''() nil ())(''primitive support for moving out of world again.''() nil ())))(''p2 - multiple moms (=aliases/links)''() nil ((''rewrote Node so that the default is multiMom, and monoMom is subclass special-cas-ing moms to be single.''() nil ())(''the instVar is now ''''moms'''' and is an OrderedCollection. The moveSelfInto verbs became mvSelfOutOf:Into:, etc.''() nil ())(''To facilitate callbacks, complete overhaul of subheader creation. 
Up to now was done by directly telling mom header to create its daughters (dress* and paneDress*), silently. Manual creation of a subheader (non-silent) was done elsewhere, duplicating the logic of whichAccessor-finding, etc. 
New logic: when want to view some data, momHeader first asks GoTranslator to [arrangeNewHeaderFor:viewedInside:] glue the correct type of accessor onto it, glue the correct type of header onto that accessor and return that header. Then momHeader asks the new header to put itself into dest. 
This is encapsulated into the one-stop-shop #GoHeader.dressSubmeme:silently:''() nil ())(''added a callback for change of content in meme. Since this conflicted with our caching subsAreDirty in all moms of a dirty header (if a header gets new clean content, you don''''t know if its moms are still dirty or not), removed that caching entirely (and its associated instVar). No noticeable performance degradations.''() nil ((''Note: trouble getting PluggableTextMorph to refresh. &%*-ing text classes again. Solved by flushing ''''paragraph''''''() nil ())))))(''p1 - meme callbacks into translators''() nil ((''make golgi sensitive to independent changes in the model, so that: i. not only golgi-initiated changes are seen in golg, ii. hoists make live-update of data. This required:''() nil ())(''making translators dependent upon meme''() nil ((''changed Object.Node to Object.Model.Node to have efficient dependencies. (not essential, can easily revert)''() nil ())(''add mechanism for translators to un/subscribe from memes: in translator>meme: (ie. when translator gets first linked to the meme) and added a recursive header.getReadyToDie msg (+overrode accessor.removeDependent so that if this is last dependent, we also remove accessor from meme dependent-list)''() nil ())(''streamlined the ''''die'''' mechanism which now just consists of window.delete -> pane/bigBro.die; the latter going via self.canYouSaveImportantChanges to make sure we are allowed to die)''() nil ())))(''putting callbacks from meme (Node) into dependents''() nil ())))))(''0.5.5 - rpc & GoExporter''() nil ((''0.55.4 - sundry changes''() nil ((''return of the openGolg... menu, with additon of areas as options''() nil ())(''addIncomingMeme can now specialCase freshmeat''() nil ())(''changed printOn: to print just local meat, non-recursively. Otherwise inspecting/debugging very full memes slowed to a crawl. Maybe upgrade this later to print some daughters, up to fixed stringsize-limit.''() nil ())(''moved wedges out of pools into class instvars''() nil ())(''related changes to exporter/internalUrl.wedgeDictUrl''() nil ())(''upgraded export/import to allow customisations to run before import''() nil ((''importer: runs all root cs/st before install-files''() nil ())(''importer: imports changesSets creating new ones.''() nil ())(''exporter.mich: exports my pws/customise changesets''() nil ())))(''misc improvement to importing script''() nil ())))(''0.55.3 - basics of an export system''() nil ((''wrote the basics of an export system: allows specification of a certain number of elements through a simple string-descriptor (url). exports them carefully.''() nil ())(''takes care of not exporting same thing twice.''() nil ())(''bases itself on internalUrls, which are object standing for internal objects, and which know how to externalize them, given that objects externalise themselves in very different ways.''() nil ())(''also has provision for startUp and cleanUp items.''() nil ())))(''0.55.2 - CGI-RPC: tweaked PWS to script memes through HTTP''() nil ((''added methods to SinglePlugServerAction to respond rpc-style. first through GET msgs, but that is impractical, so switch to CGI-like POSTs. (with one click in Eudora on the duo the selection in the current msg gets sent to squeak  through http on the serial cable, via frontier, and shows up in golgi as a new header :-)''() nil ())))(''0.55.1 - adapted the Action to call MemeSoup.incomingString''() nil ((''GoTopHeader becomes GoBigBrother''() nil ())))))(''0.5.4 - memeSoup (for future protoScripting) & architecture simplification - [march99]''() nil ((''0.5.4p2 - GoSession radically trimmed down''() nil ((''transferred much of its content into the objects themselves, rather than having a session object managing those objects.''() nil ())(''outline-creation verbs now mostly reduce to GoWindow.view:''() nil ())(''sniffer became its own class, and connects to outlines directly, without being mediated by GoSession''() nil ())))(''0.5.4p1 - introduction of MemeSoup (and concomittant Meme changes)''() nil ((''has a dual task: first it corresponds to / on unix filesystems in being the container of all memes (at least of all memes for notes, not code-memes of outline-view squeak code), the root of the hierarchy. Second it acts as info-shop about the memePool, keeping a list of entry-points, and possibly other info about the memes.''() nil ())(''opens the way for scripting, ie. gives external interlocutors a way to ask for a certain meme to get the ball rolling for a transaction.''() nil ())(''(it really is a souped up MemeAncestor, deleted MemeAncestor.)''() nil ())))(''a couple of months pause for other rec, and to let the design mature.''() nil ())))(''0.5.3 - cut&paste, drag&drop and simplify guts''() nil ((''0.53a6 - bugfix & simplification''() nil ((''browser doesn''''t ask what to do with outOfSync golgs, just rebuilds them ''() nil ())))(''0.53a5 - general transfer of methods from ''''helpers'''' to ''''meme'''' to simplify''() nil ())(''0.53a4 - abandonned internal storage of golgified methods, rather store golgi in the style section of flattened text''() nil ())(''0.53a3 - cut/paste''() nil ())(''0.53a2 - drop-indicator for drag/drop''() nil ())(''0.53a1 - drag/drop''() nil ())))(''0.5.2 - switch to translator architecture (& golgi script editor attempt)  -[13/9-...] ''() nil ((''... lost track until christmas ... not much time to work on golgi ...''() nil ())(''0.52a11 [17-../10]''() nil ((''convert flat code to outlines: we now directly read the parseTree for the flat code, thereby producing  reliable translations. (unPrecompileNode: still incomplete, see todo)''() nil ())(''memeTree for code is now a copy of the real data. greatly simplifies normlisation and generation of code''() nil ())(''enhanced ''''magicRecognition'''' of headerType in smalltalkOutlines. ''() nil ())(''you can now view the parseTree for any message as an outline. There is a menu item in the msg-list menu to do that. Or evaluate:
GoBrowser parseTreeForMsg: m inClass: c''() nil ())(''fixed a longStanding bug where clicking on an inert wedge would start a complaint about zapOwner...''() nil ())(''GoMenu: if a menuAction is nil, do nothing (no need noop:)''() nil ())(''windows workaround _ cmdB to create header coz cmdReturns disappears''() nil ())(''mini fix to error-location finding''() nil ())(''outlines now live in Golgi.Outlines, the Golgi global is the new home for all user-related data (eg. preferences)''() nil ((''[brief experiment with putting them in GoSession.Outlines but led to complications on clean reinstalls of Golgi. Stick with separation of user data and Golgi methods]''() nil ())))(''goMsgs in shared pools can now be arrays. (converted to memeTree on first use). greatly simplifies fileIn/Out.''() nil ())(''wizz installer:''() nil ((''compute which folder the user chose (so that user can fileIn from wherever wanted)''() nil ())(''create a small root install.st, programmatically create golgi project and outlines in it open at start.''() nil ())(''display just one progress bar''() nil ())(''kill all golgi sessions before installing''() nil ())))))(''0.52a10 [11-15/10] compile error msgs, bug fix festival.''() nil ((''rewrote the meat-collecting stuff so that it keeps track of the relative onset of each header in the total string (for error notifications) and so that it keeps the changes in a temp meme (in the ''''cache'''' variable of memeAccessor) before compilation. This opens the door to error-notification and cured a couple of refresh-bugs.''() nil ((''the trick with error-notification is that the visible content of header does not correspond to the actual compiled code since punctuation is silently added. whence the caches table of onset of positions of each header in the general compiled string. that way it is quick and easy to find the header and the position within the header corresponding to the compile-error position. ''() nil ())))(''cured focus bugs''() nil ((''bigBrother now keeps track of last focus bearer and restores it upon mouseEnter.''() nil ())(''worked around strange bug: w/out the workaround compile-error notification get inserted but not highlighted (selected), even though the header does become focus. see GoTranslateSmalltalk.notify:at:in & GoHeader.showSelectionBugWorkaround''() nil ())(''initialize GoMeat.selectionInterval or else nothing is visible on first mouseEnter/becomeFocus. This also solves the no-foc-propagatin-on-delete problem.''() nil ())))(''fixed discards in goBrowser cached golgiPanes: before showing a cached pane, call refreshFromMemes, which will check for discarded dirt (hasHiddenDirt, which reuses the meatIsDirty var in bigBrother) and and if has any will reset dirty headers from meme content. [partially - and temporarily - rebroken by menuBehaviour changes]''() nil ())(''fixed the ''''can i discard'''' dialog to be informative''() nil ())(''morphic patch: morphic menus appearing on the right edge are unusable since they are sensitive to mouseUp, but appear under the mouse. therefore a single click on a menu-bringing item in a right-peripheral browser (eg. a can-i-discard warning) will automatically chose a menu item where the user does''''nt even have the time to see the menu...''() nil ())(''after each loading of a goScript compare the stamp the one in the changeFile to controle they are in sync.''() nil ())(''made breakPoints and reorgs feedback visually that they dirtied header''() nil ())(''changed uniform ''''variables'''' type to  to blockVar & mainVar
(misc: importer improvements - registers wedges in globals, recreating goMsgs changes #nil to nil)''() nil ())))(''0.52a9 [10/10] fixes: better punctuation guessing, class msgs, bug squash''() nil ((''worked around the absence of shared pools in metaclass (which meant that class msgs could not be outlines). added a second dict to  shared pools, which holds the class msgs. meta then asks class for this dict. adapted the import/export procedures to this.''() nil ((''note that there would be on radical alternative t all this: to somehow hide the outline-info in the text-attributes of the source code in the change.file. This has the advantage of not keeping two versions of the source code around. but the disadvantages that: messing with the change.file is dangerous; and it would make things even slower to load, since we would need to construct not only the golgi panes, but also the memes...''() nil ())))(''the algorithm that inserts punctuation into outline-msgs is now much better (which also helps for importing flatcode). 
Counterpart: indenting has now relatively strict rules: if the mom-header ends with '''':'''' the subheaders are interpreted as a block, else the subheaders are interpreted as part of the mom statement. ''() nil ((''this allows to code like this:''() nil ((''#nil = nil''() nil ((''ifTrue:''() nil ((''blablabla''() nil ())))(''ifFalse:''() nil ((''blablabla''() nil ())))))))(''and this:''() nil ((''someObject''() nil ((''param1: x''() nil ())(''param2: y''() nil ())(''param3: z''() nil ())))))(''but note that you cannot say this:''() nil ((''g _ (GoSession on: ''() nil ((''(MemeConverter new fromTabbedCodeString: s))''() nil ())))(''because the second line will be interpreted as a block...''() nil ())))(''you instead have to say:''() nil ((''g _ (GoSession on: (''() nil ((''MemeConverter new fromTabbedCodeString: s))''() nil ())))))(''or:''() nil ((''g _ (GoSession''() nil ((''on: (MemeConverter new fromTabbedCodeString: s))''() nil ())))))))(''fixed freeze-bug: if you commented out a header containing subheaders, you would corrupt the display in such a way that you had to force-quit squeak. was due to a bug in calculating the list of accessors associated to subheaders whereby the subs were replaced by the accessors.... ''() nil ())(''fixed a cosmetic bug showing up when uncommenting wedges''() nil ())(''demo/docs - the entire GoBrowser class now consists of outlines, including fairly complex scripts (and including class msgs). they were all guessed >95% automatically.''() nil ())))(''rewrote the meat-collecting stuff so that it keeps track of the relative onset of each header in the total string (for error notifications) and so that it keeps the changes in a temp meme (in the ''''cache'''' variable of memeAccessor) before compilation. This opens the door to error-notification and cured a couple of refresh-bugs.''() nil ())(''0.52a8 [9/10] final step to make GoBrowser minimally usable: golgified msgs survive file-in/out ''() nil ((''hack to allow file-out of memes in dicts, so that shared pools are not lost over file-in/outs any more. meaning that golgified scripts are not lost anymore.''() nil ())(''wacked a file format for fileOuts of codeMeme so that we can preserve the ''''commented'''' and ''''semanticType'''' info.''() nil ())(''better msg-list menus for GoBrowser''() nil ())(''added a rudimentary menu item allowing you to guess the outline-version of an existing flat code. will only work if tabs are set right for now. the algorithm sucks but serves it purpose of adapting the bulk of currently existing msgs.''() nil ())(''fixed a small bug which prevented from uncollapsing ''() nil ())))(''0.52a7 [8/10] basic documentation, dev-doc & version history''() nil ())(''0.52a6 [6-7/10] installer and fixes for 2.2. First version (semi) released''() nil ())(''0.52a5 [4-6/10] speed up''() nil ())(''0.52a4 - real smalltalk translator, wedge imgs and bug fixes''() nil ())(''0.52a3 [21-23/9] reworked architecture to have translators''() nil ())(''0.52a2 [20/9] - cleaned wedge with working pluggable images''() nil ())(''0.52a1 [13-18.9] basic functionning goScript''() nil ())))(''0.5.1 - first squeak version  - [8?/8-12/9]''() nil ((''pretty complete outliner w/ multi-line text, auto-grow, reorg by key, hoisting, menus on each wedge, global menu, saves to several formats (xml, dotHead, tab, parens).''() nil ())(''0.51a1 [8?/8-18/8] first collapsable headers, with promote/demote, reorg, backup.''() nil ())))(''versions 0.1-04''() nil ((''misc attempts at intelligent info-manager, including tcl/tk builds, complex systems of word-macros, a frontier script/op-system, a java build, an html-based solution, etc. ''() nil ())))))))') putSelfInto: MemeSoup mainSoup after: #last.!

Project current isMorphic ifTrue: ["do nothing if installed from an mvc project" 
	Golgi view: MemeSoup mainSoup].
"-=-=-=-= end golgi postscript -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-="



